# Bonito.jl

![CI](https://github.com/SimonDanisch/Bonito.jl/workflows/CI/badge.svg) [![Codecov](https://codecov.io/gh/SimonDanisch/Bonito.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SimonDanisch/Bonito.jl)
[![Docs - stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://simondanisch.github.io/Bonito.jl/stable/)

**Build interactive web applications, dashboards, and visualizations entirely in Julia.**

Bonito.jl enables you to create rich, reactive web applications using Julia's [Observables](https://juliagizmos.github.io/Observables.jl/stable/) for state management and a simple HTML/DOM API. 
Observables can communicate with the Frontend via a performance optimized WebSocket connection, allowing you to build anything from data exploration dashboards to interactive documentation—all without being locked into a specific frontend framework.

## Key Features

- **Reactive & Interactive**: Built on Observables.jl for automatic UI updates when data changes, only sending the minimal amount of data possible via a fast binary serialization protocol
- **Rich Component Library**: Buttons, sliders, tables, code editors, and easy to build custom widgets
- **Seamless Plotting**: Deeply integrated with WGLMakie, plus support for Plotly, Gadfly, and more
- **Deploy Anywhere**: Works in VSCode, Jupyter, Pluto, web servers, or export to static HTML
- **Javascript When You Need It**: Easy ES6 module integration and Javascript execution
- **Pure Julia Development**: Write your entire application in Julia, with optional Javascript for client side rendering
- **Extensible Handlers**: Wrap and compose handlers for authentication, logging, static files, and custom middleware
- **Use Any Existing JS/CSS/HTML**: Bonito provides no opinionated styling by default. Combined with straightforward external dependency integration, this gives you complete access to the entire JS/CSS/HTML ecosystem from within Julia.

## Quick Example

```julia
using Bonito
# Create a reactive counter app
app = App() do session
    count = Observable(0)
    button = Button("Click me!")
    on(click-> (count[] += 1), button)
    return DOM.div(button, DOM.h1("Count: ", count))
end
display(app) # display it in browser or plotpane
export_static("app.html", app) # generated self contained HTML file from App
export_static("folder", Routes("/" => app)) # Export static site (without Julia connection)
# Or serve it on a server
server = Server(app, "127.0.0.1", 8888)
# add it as different route
# regex, and even custom matchers are possible for routes, read more in the docs!
route!(server, "/my-route" => app)
```

## Examples Built with Bonito

### [makie.org](https://makie.org/)

The Makie website is using Bonito's static site generator

### [WGLMakie](https://docs.makie.org/dev/explanations/backends/wglmakie#WGLMakie)

Interactive WebGL-accelerated plotting library

https://github.com/user-attachments/assets/0d13b88b-5a34-4785-91a2-c1d8a1304074

[taken from ClimaAtmos.jl](https://github.com/CliMA/ClimaAtmos.jl)

### [BonitoBook](https://bonitobook.org/)

A customizable, Jupyter-like notebook environment

https://github.com/user-attachments/assets/ad8bd118-1a82-4799-b1ba-6220072557c7

https://github.com/user-attachments/assets/55e110c8-c144-41ab-8537-65cbc17a63e0

## [NetworkDynamicsInspector](https://github.com/JuliaDynamics/NetworkDynamics.jl/tree/main/NetworkDynamicsInspector)

NetworkDynamicsInspector.jl is an extension package to NetworkDynamics.jl which provides a WebApp based on Bonito.jl and WGLMakie.jl for interactive visualization of solutions to systems based on network dynamics.

https://github.com/user-attachments/assets/064a6138-610f-48d7-8e2e-d174fa710ddb

### [Example folder](https://github.com/SimonDanisch/Bonito.jl/tree/master/examples)

Have a look at some of the usage examples for Bonito, like the [interactive markdown rendering support](https://github.com/SimonDanisch/Bonito.jl/blob/master/examples/markdown.jl):

https://github.com/user-attachments/assets/e8120b9c-ddfb-4f6f-bea8-97ee56ee646d


## Sponsors

<img src="https://github.com/user-attachments/assets/7fa49123-eb57-47eb-b8f9-caa887df725c" width="300"/>
Förderkennzeichen: 01IS10S27, 2020

Base.showable(::Union{MIME"text/html", MIME"application/prs.juno.plotpane+html"}, ::App) = true

const CURRENT_SESSION = Ref{Union{Nothing,Session}}(nothing)

"""
    Page(;
        offline=false, exportable=true,
        connection::Union{Nothing, FrontendConnection}=nothing,
        server_config...
    )

A Page can be used for resetting the Bonito state in a multi page display outputs, like it's the case for Pluto/IJulia/Documenter.
For Documenter, the page needs to be set to `exportable=true, offline=true`, but doesn't need to, since Page defaults to the most common parameters for known Packages.
Exportable has the effect of inlining all data & js dependencies, so that everything can be loaded in a single HTML object.
`offline=true` will make the Page not even try to connect to a running Julia
process, which makes sense for the kind of static export we do in Documenter.
For convenience, one can also pass additional server configurations, which will directly
get put into `configure_server!(;server_config...)`.
Have a look at the docs for `configure_server!` to see the parameters.
"""
function Page(;
        offline::Union{Bool,Nothing}=nothing,
        exportable::Union{Bool,Nothing}=nothing,
        connection::Union{Nothing, FrontendConnection}=nothing,
        current_page_dir = abspath(pwd()), # For documenter server
        server_config...
        )
    old_session = CURRENT_SESSION[]
    if !isempty(server_config)
        configure_server!(; server_config...)
    end
    if !isnothing(old_session)
        close(old_session)
    end
    CURRENT_SESSION[] = nothing
    if isnothing(offline) # do nothing
    elseif offline
        force_connection!(NoConnection)
    else
        force_connection!()
    end

    if isnothing(exportable) # do nothing
    elseif exportable
        force_asset_server!(NoServer)
    else
        force_asset_server!()
    end
    if !isnothing(connection)
        force_connection!(typeof(connection))
    end
    asset_server = default_asset_server()
    if asset_server isa DocumenterAssets
        asset_server.folder[] = current_page_dir
    end
    force_subsession!(true)
    return
end

get_io_context(io::IO) = nothing
get_io_context(io::IOContext) = io

function show_html(io::IO, app::App; parent=CURRENT_SESSION[])
    ctx = get_io_context(io)
    session = nothing
    sub = nothing
    try
        if !isnothing(parent)
            # We render in a subsession
            sub = Session(parent; title=app.title)
            sub.io_context[] = ctx
            dom = session_dom(sub, app)
        else
            session = Session(title=app.title)
            if _use_parent_session(session)
                CURRENT_SESSION[] = session
                # Use indicator from user's app on parent wrapper (only root has indicator)
                empty_app = App(nothing; indicator=app.indicator)
                sub = Session(session)
                sub.io_context[] = ctx
                init_dom = session_dom(session, empty_app)
                sub_dom = session_dom(sub, app)
                # first time rendering in a subsession, we combine init of parent session
                # with the dom we're rendering right now
                dom = DOM.div(init_dom, sub_dom)
                session.status = DISPLAYED
            else
                sub = session
                sub.io_context[] = ctx
                dom = session_dom(session, app)
            end
        end
        show(io, dom)
        mark_displayed!(sub)
        isnothing(session) || mark_displayed!(session)
        return sub
    catch err
        # Use unified error handling - closes app session to prevent wait_for_ready hang
        error_html = handle_app_error!(err, app, nothing)
        show(io, error_html)
        return sub
    end
end

function Base.show(io::IO, ::Union{MIME"text/html", MIME"application/prs.juno.plotpane+html"}, app::App)
    show_html(io, app)
end

function print_as_page(io::IO, dom::Node)
    println(io, "<!doctype html>")
    # use Hyperscript directly to avoid the additional Bonito attributes
    show(io, MIME"text/html"(), dom)
    return
end

"""
    page_html(session::Session, html_body)

Embeds the html_body in a standalone html document!
"""
function page_html(io::IO, session::Session, app_node::Union{Node, App})
    dom = session_dom(session, app_node; html_document=true)
    print_as_page(io, dom)
    return
end

function Base.show(io::IOContext, ::MIME"application/vnd.Bonito.application+html", dom::App)
    show(io.io, MIME"text/html"(), dom)
end

function Base.show(io::IO, m::MIME"application/vnd.Bonito.application+html", app::App)
    show(IOContext(io), m, app)
end

function Base.show(io::IO, ::MIME"juliavscode/html", app::App)
    # If we clean up sessions immediately and disallow reconnect
    # We might as well display the app directly!
    if !allow_soft_close()
        show(io, MIME"text/html"(), app)
    else
        try
            session = Session(title=app.title)
            sub = Session(session)
            sub.current_app[] = app
            sub.io_context[] = get_io_context(io)
            fetch_app = App() do s
                dom_node = DOM.div()
                request = js"""
                    Bonito.send_to_julia({
                        msg_type: "13",
                        session: $(sub.id),
                        replace: $(uuid(sub, dom_node)),
                    });
                """
                return DOM.div(request, dom_node)
            end
            dom = session_dom(session, fetch_app)
            show(io, dom)
            mark_displayed!(session)
            mark_displayed!(sub)
        catch err
            error_html = handle_app_error!(err, app, nothing)
            show(io, error_html)
        end
    end
end

@testset "WebSocket Connection Closing Tests" begin
    @testset "Connection State After Browser Close" begin
        app = App() do session, request
            return DOM.div(
                "WebSocket Close Test",
                dataTestId="websocket-test"
            )
        end
        display(edisplay, app)
        session = app.session[]

        # Wait for connection to be established
        success = Bonito.wait_for(timeout=5) do
            result = run(edisplay.window, "window.WEBSOCKET && window.WEBSOCKET.isopen()")
            return result == true
        end
        @test success == :success
    end

    @testset "Direct WebSocket Close Behavior" begin
        app = App() do session, request
            return DOM.div(
                "Direct Close Test",
                dataTestId="direct-close-test"
            )
        end
        display(edisplay, app)
        session = app.session[]

        # Wait for connection
        Bonito.wait_for(timeout=5) do
            run(edisplay.window, "window.WEBSOCKET && window.WEBSOCKET.isopen()")
        end

        # Close the websocket directly
        wsopen = run(edisplay.window, """
            window.WEBSOCKET.close();
            window.WEBSOCKET.isopen();
        """)
        # Check that websocket is closed after direct close
        @test false == wsopen
        success = Bonito.wait_for(timeout=5) do
            # Test reconnect!
            return run(edisplay.window, "window.WEBSOCKET.isopen()")
        end
        @test success == :success
        @test isopen(session)
        @test isopen(Bonito.root_session(session))
        @test isready(Bonito.root_session(session))
    end
end

using Markdown
using Bonito, Observables
using WGLMakie

app = App() do
    cmap_button = Button("change colormap")
    algorithms = ["mip", "iso", "absorption"]
    algorithm_drop = Dropdown(algorithms)

    data_slider = Slider(LinRange(1f0, 10f0, 100))
    iso_value = Slider(LinRange(0f0, 1f0, 100))
    N = 100
    slice_idx = Slider(1:N)

    signal = map(data_slider.value) do α
        a = -1; b = 2
        r = LinRange(-2, 2, N)
        z = ((x,y) -> x + y).(r, r') ./ 5
        me = [z .* sin.(α .* (atan.(y ./ x) .+ z.^2 .+ pi .* (x .> 0))) for x=r, y=r, z=r]
        return me .* (me .> z .* 0.25)
    end

    slice = map(signal, slice_idx) do x, idx
        view(x, :, idx, :)
    end

    fig = Figure(; size=(900, 400))

    vol = volume(fig[1,1], signal; algorithm=map(Symbol, algorithm_drop.value), isovalue=iso_value.value, axis=(;show_axis=false))

    colormaps = collect(Makie.all_gradient_names)
    cmap = map(cmap_button) do click
        return colormaps[rand(1:length(colormaps))]
    end

    heat = heatmap(fig[1, 2], slice, colormap=cmap)

    # Conditionally show ISO value slider only when algorithm is "iso"
    iso_control = map(algorithm_drop.value) do alg
        if alg == "iso"
            return DOM.div("ISO value: ", iso_value)
        else
            return DOM.div()
        end
    end

    dom = md"""
    # Interactive 3D Volume Visualization

    This example demonstrates **Bonito.jl**'s ability to combine markdown content with interactive widgets and 3D visualizations using WGLMakie.

    ## About This Demo

    Below you'll find interactive controls that manipulate a 3D volume rendering in real-time. This showcases:

    * Reactive programming with `Observable`s
    * Integration between markdown and Julia widgets
    * Real-time 3D visualization with WGLMakie
    * Clean, styled presentation using Bonito's layout system

    ## Visualization Controls

    Use the controls below to explore the 3D volume data:

    **Data Parameter**: Adjust the mathematical function generating the volume data

    $(DOM.div("Data parameter: ", data_slider))

    **Algorithm**: Choose the volume rendering algorithm

    $(DOM.div("Algorithm: ", algorithm_drop))

    $(iso_control)

    **Y-Slice**: Select which slice to display in the heatmap

    $(DOM.div("Y slice: ", slice_idx))

    **Colormap**: Randomize the heatmap colors

    $(cmap_button)

    ---

    ## The Visualization

    $(fig)

    ---

    ## Markdown Features

    Bonito supports GitHub-flavored Markdown including:

    1. **Formatted text**: *italic*, **bold**, and `inline code`
    2. **LaTeX equations** via KaTeX
    3. **Tables** for structured data
    4. **Embedded widgets** as shown above

    ### LaTeX Support

    Bonito renders beautiful mathematical expressions:

    ```latex
    \int_{-\infty}^{\infty} e^{-x^2} dx = \sqrt{\pi}

    \mathbf{A} = \begin{pmatrix}
    a_{11} & a_{12} \\
    a_{21} & a_{22}
    \end{pmatrix}
    ```

    ### Tables

    | Feature        | Status        | Priority |
    | -------------- |:-------------:| --------:|
    | 3D Rendering   | ✓ Implemented | High     |
    | Interactivity  | ✓ Implemented | High     |
    | Styling        | ✓ Implemented | Medium   |

    > **Note**: This entire page is generated from a single Julia file, combining markdown prose with interactive computational content!
    """
    # Create a styled container with max-width and centered content
    container_style = Styles(
        "max-width" => "900px",
        "margin" => "0 auto",
        "padding" => "2rem",
        "background-color" => "#ffffff",
        "box-shadow" => "0 1px 3px rgba(0, 0, 0, 0.1)",
        "border-radius" => "8px",
        "line-height" => "1.6"
    )

    content = DOM.div(Bonito.MarkdownCSS, Bonito.Styling, dom; style=container_style)

    # Wrap in outer container for centering
    outer_style = Styles(
        "background-color" => "#f5f5f5",
        "min-height" => "100vh",
        "padding" => "2rem 1rem"
    )

    return DOM.div(content; style=outer_style)
end

struct NoConnection <: FrontendConnection end

function Base.write(connection::NoConnection, data::AbstractVector{UInt8})
    error("Can't communicate with Frontend with no Connection")
end

Base.isopen(::NoConnection) = false
Base.close(::NoConnection) = nothing # nothing to close

function setup_connection(session::Session{NoConnection})
    # Notify JavaScript that this is a no-connection session
    # so the indicator can show the appropriate status
    return js"""
    if (typeof Bonito !== 'undefined' && Bonito.set_no_connection) {
        Bonito.set_no_connection();
    }
    """
end

"""
Functor to update JS part when an observable changes.
We make this a Functor, so we can clearly identify it and don't sent
any updates, if the JS side requires to update an Observable
(so we don't get an endless update cycle)
"""
struct JSUpdateObservable
    session::Session
    id::String
end

# Somehow, showing JSUpdateObservable end up in a stackoverflow...
# Not sure why, but hey, overloading show isn't a bad idea anyways, isn't it?
function Base.show(io::IO, up::JSUpdateObservable)
    print(io, "JSUpdateObservable($(typeof(up.session)), $(repr(up.id)))")
end

struct LargeUpdate
    data::Any
end

function (x::JSUpdateObservable)(@nospecialize(value))
    try
        # Sent an update event
        if !isclosed(x.session)
            is_large = value isa LargeUpdate
            data = is_large ? value.data : value
            msg = Dict(:payload=>data, :id=>x.id, :msg_type=>UpdateObservable)
            send(x.session, msg; large=is_large)
        end
    catch e
        @debug "Error while sending update for JSUpdateObservable" exception=e
    end
end


"""
Update the value of an observable, without sending changes to the JS frontend.
This will be used to update updates from the forntend.
"""
function update_nocycle!(obs::Observable, @nospecialize(value))
    obs.val = value
    for (prio, f) in Observables.listeners(obs)
        if !(f isa JSUpdateObservable)
            Base.invokelatest(f, value)
        end
    end
    return
end

# on & map versions that deregister when session closes!
function Observables.on(f, session::Session, observable::Observable; update=false)
    to_deregister = on(f, observable; update=update)
    push!(session.deregister_callbacks, to_deregister)
    return to_deregister
end

function Observables.onany(f, session::Session, observables::Observable...)
    to_deregister = onany(f, observables...)
    append!(session.deregister_callbacks, to_deregister)
    return to_deregister
end

@inline function Base.map!(@nospecialize(f), session::Session, result::AbstractObservable, os...; update::Bool=true)
    # note: the @inline prevents de-specialization due to the splatting
    callback = Observables.MapCallback(f, result, os)
    for o in os
        o isa AbstractObservable && on(callback, session, o)
    end
    update && callback(nothing)
    return result
end

@inline function Base.map(f::F, session::Session, arg1::AbstractObservable, args...; ignore_equal_values=false) where {F}
    # note: the @inline prevents de-specialization due to the splatting
    obs = Observable(f(arg1[], map(Observables.to_value, args)...); ignore_equal_values=ignore_equal_values)
    map!(f, session, obs, arg1, args...; update=false)
    return obs
end

function jsrender(session::Session, obs::Observable)
    root_node = DOM.div()
    old_sub, html = render_subsession(session, obs[]; init=true)
    mark_displayed!(old_sub)
    on(session, obs) do data
        new_sub = update_session_dom!(session, uuid(session, root_node), data; replace=false)
        if new_sub !== old_sub
            close(old_sub)
            old_sub = new_sub
        end
        return
    end
    push!(children(root_node), html)
    return jsrender(session, root_node)
end

# Fast path for simple types
function jsrender(session::Session, obs::Observable{T}) where {T <: Union{Number, String, Symbol}}
    root_node = DOM.span(string(obs[]))
    obs_js = map(string, session, obs)
    onjs(
        session,
        obs_js,
        js"""(val)=> {
            $(root_node).innerText = val
        }"""
    )
    return root_node
end


function jsrender(session::Session, obs::Observable{<:HTML})
    root_node = DOM.span(obs[])
    onjs(
        session,
        obs,
        js"""(val)=> {
            $(root_node).replaceChildren(val);
        }"""
    )
    return root_node
end

const THREE = ES6Module(joinpath(@__DIR__, "three.js"))

function export_test_app(session, request)
    result = DOM.div("failed"; dataTestId="result")
    return DOM.div(
        result,
        js"""
            $(THREE).then(three=> {
                if ('AdditiveAnimationBlendMode' in three) {
                    $(result).innerText = "passed"
                }
            });
        """
    )
end

connections = [
    (:NoConnection, () -> NoConnection()),
    (:WebSocketConnection, () -> WebSocketConnection()),
    (:DualWebsocket, () -> Bonito.DualWebsocket()),
]
servers = [(:NoServer, () -> NoServer()), (:HTTPAssetServer, () -> HTTPAssetServer())]

path = joinpath(@__DIR__, "test.html")

# We need to use a proxy url to not have relative URLS for HTTPAssetServer, when serving from a file.
s = Bonito.get_server()
Bonito.configure_server!(proxy_url="http://localhost:$(s.port)")

@testset "connection $(c) server: $(s)" for ((c, connection), (s, server)) in Iterators.product(connections, servers)
    app = App(export_test_app)
    session = Session(connection(); asset_server=server())
    sess = export_static(path, app; session=session)
    # We need to drop a bit lower and cant use `testapp` here, since that uses fixed connection + asset server
    window = TestWindow(URI("file://" * path))
    result = Bonito.wait_for() do
        run(window, "$(query_testid("result")).innerText") == "passed"
    end
    @test result == :success
    close(window)
    close(app)
end
rm(path; force=true)
Bonito.configure_server!(proxy_url=nothing)


# Finalizers and other problems have been closing our connection unintentional,
# So we do this little stress test:
@testset "GC connection test" begin
    app = App(export_test_app)
    @testset for i in 1:50
        display(edisplay, app)
        s = app.session[]
        p = parent(s)
        success = Bonito.wait_for(timeout=5) do
            result = run(edisplay.window, "$(query_testid("result")).innerText")
            return result == "passed"
        end
        @test success == :success
        GC.gc()
    end
    session = app.session[]
    @test session.connection isa Bonito.SubConnection
    @test parent(session).connection isa Bonito.WebSocketConnection
    @test isready(parent(session))
end

struct TrivialCleanupPolicy <: Bonito.CleanupPolicy end
Bonito.should_cleanup(::TrivialCleanupPolicy, ::Session) = true
Bonito.allow_soft_close(::TrivialCleanupPolicy) = false

function test_cleanup_policy(Connection)

    policy = Bonito.DefaultCleanupPolicy(30, 2.0)
    # New session shouldn't be cleaned up
    session = Session(Connection())
    @test !Bonito.should_cleanup(policy, session)

    # Displayed session that hasn't connected shouldn't be cleaned up immediately
    session.status = Bonito.DISPLAYED
    session.closing_time = time()
    @test !Bonito.should_cleanup(policy, session)

    # Displayed session that hasn't connected should be cleaned up after wait time
    session.closing_time = time() - 31
    @test Bonito.should_cleanup(policy, session)

    # Soft closed session shouldn't be cleaned up immediately
    session.status = Bonito.SOFT_CLOSED
    session.closing_time = time()
    @test !Bonito.should_cleanup(policy, session)

    # Soft closed session should be cleaned up after cleanup time
    session.closing_time = time() - 3 * 60 * 60  # 3 hours
    @test Bonito.should_cleanup(policy, session)

    # allow_soft_close should return true when cleanup_time > 0
    @test Bonito.allow_soft_close(policy)

    # allow_soft_close should return false when cleanup_time = 0
    zero_policy = Bonito.DefaultCleanupPolicy(30, 0.0)
    @test !Bonito.allow_soft_close(zero_policy)

    original_cleanup_policy = Bonito.CLEANUP_POLICY[]
    try
        Bonito.set_cleanup_policy!(TrivialCleanupPolicy())

        session = Session(Connection())
        @test Bonito.should_cleanup(Bonito.CLEANUP_POLICY[], session)
    finally
        Bonito.set_cleanup_policy!(original_cleanup_policy)
    end
end

@testset "websocket cleanup policy test" begin
    test_cleanup_policy(WebSocketConnection)
    test_cleanup_policy(Bonito.DualWebsocket)
end

@testset "evaljs order" begin
    rm(Bonito.BonitoLib.bundle_file)
    app = App() do session
        obs = Observable(false)
        on(println, obs)
        but = DOM.button("CLICK", onclick=js"$(obs).notify(true)")

        jss = js"""
        $(but).addEventListener("click", () => {
            console.log("Button clicked!");
            $(obs).notify(true);
        });
        """

        return DOM.div(
            jss,
            DOM.h1("Session Test"),
            but,
            obs,
        )
    end
    export_static("test.html", app)
end

module HTTPServer

using HTTP
using HTTP: Response, Request
using HTTP.Streams: Stream
import Sockets: send, TCPServer
using Sockets
using ..Bonito: App, update_app!, get_server

include("helper.jl")
include("implementation.jl")
include("browser-display.jl")
include("mimetypes.jl")

export route!, has_route, get_route, Server, html, file_mimetype

end

"""
    App(callback_or_dom; title="Bonito App")
    App((session, request) -> DOM.div(...))
    App((session::Session) -> DOM.div(...))
    App((request::HTTP.Request) -> DOM.div(...))
    App(() -> DOM.div(...))
    App(DOM.div(...))

Usage:
```julia
using Bonito
app = App() do
    return DOM.div(DOM.h1("hello world"), js\"\"\"console.log('hello world')\"\"\")
end
```

If you depend on global observable, make sure to bind it to the session.
This is pretty important, since every time you display the app, listeners will get registered to it, that will just continue staying there until your Julia process gets closed.
`bind_global` prevents that by binding the observable to the life cycle of the session and cleaning up the state after the app isn't displayed anymore.
If you serve the `App` via a `Server`, be aware, that those globals will be shared with everyone visiting the page, so possibly by many users concurrently.
```julia
global some_observable = Observable("global hello world")
App() do session::Session
    bound_global = bind_global(session, some_observable)
    return DOM.div(bound_global)
end
```
"""
App

"""
    handle_app_error!(err, app::App, parent_session=nothing)

Unified error handling for App rendering errors.
- Logs the error
- Closes the app's session if it was created (prevents wait_for_ready hanging)
- If session was never set, creates a closed dummy session (prevents wait_for_ready hanging)
- Returns error HTML node
- If parent_session is provided and ready, sends error to browser via evaljs
"""
function handle_app_error!(err, app::Union{App, Nothing}, parent_session=nothing)
    bt = Base.catch_backtrace()
    @error "Error rendering app" exception = (err, bt)

    # Handle app session to prevent wait_for_ready from hanging
    if !isnothing(app)
        if !isnothing(app.session[])
            # Close the session if it was created
            try
                close(app.session[])
            catch close_err
                @debug "Error closing session" exception = close_err
            end
        else
            # Session was never set - create a closed dummy session
            # so wait_for_ready doesn't wait forever
            try
                dummy = Session(NoConnection())
                dummy.status = CLOSED
                app.session[] = dummy
            catch
                # If even creating a dummy session fails, wait_for_ready will timeout
            end
        end
    end

    # Generate error HTML
    error_html = HTTPServer.err_to_html(err, bt)

    # If we have a ready parent session, try to send error to browser via evaljs
    # This bypasses the rendering pipeline that might be broken
    if !isnothing(parent_session) && isready(parent_session)
        try
            error_html_str = sprint(io -> show(io, MIME"text/html"(), error_html))
            # Construct JSCode manually since @js_str isn't defined yet at include time
            js_code = JSCode([
                JSString("const target = document.getElementById('subsession-application-dom'); if (target) { target.innerHTML = "),
                error_html_str,
                JSString("; }")
            ])
            evaljs(parent_session, js_code)
        catch err2
            @error "Failed to display error in browser" exception = (err2, Base.catch_backtrace())
        end
    end

    return error_html
end

function update_app!(parent::Session, new_app::App)
    root = root_session(parent)
    @assert root === parent "never call this function with a subsession"
    try
        update_session_dom!(parent, "subsession-application-dom", new_app)
    catch err
        handle_app_error!(err, new_app, parent)
    end
end


function rendered_dom(session::Session, app::App, target=HTTP.Request(); apply_jsrender=true)
    app.session[] = session
    session.current_app[] = app
    try
        dom = Base.invokelatest(app.handler, session, target)
        if apply_jsrender
            dom = Base.invokelatest(jsrender, session, dom)
        end
        # Only render indicator for root sessions (not subsessions)
        if isroot(session) && !isnothing(app.indicator)
            indicator_dom = jsrender(session, app.indicator)
            dom = DOM.div(dom, indicator_dom)
        end
        return dom
    catch err
        html = HTTPServer.err_to_html(err, Base.catch_backtrace())
        return jsrender(session, html)
    end
end

function bind_global(session::Session, var::AbstractObservable{T}) where T
    # preserve eltype:
    result = Observable{T}(var[])
    map!(identity, session, result, var)
    return result
end

# Enable route!(server, "/" => app)
function HTTPServer.apply_handler(app::App, context)
    server = context.application
    session = HTTPSession(server)
    session.title = app.title
    html_dom = rendered_dom(session, app, context.request)
    html_str = sprint() do io
        page_html(io, session, html_dom)
    end
    mark_displayed!(session)
    return html(html_str)
end

function Base.close(app::App)
    session = app.session[]
    # Needs to be async because of finalizers (todo, figure out better ways!)
    !isnothing(session) && free(session)
    app.session[] = nothing
end

mutable struct DisplayHandler
    session::Session
    server::HTTPServer.Server
    route::String
    current_app::App
end

function Base.close(handler::DisplayHandler)
    close(handler.session)
end

function HTTPSession(server::HTTPServer.Server)
    asset_server = HTTPAssetServer(server)
    Conn = FORCED_CONNECTION[]
    if !isnothing(Conn) && Conn <: AbstractWebsocketConnection
        connection = Conn(server)
    else
        connection = WebSocketConnection(server)
    end
    return Session(connection; asset_server=asset_server)
end

function DisplayHandler(server::HTTPServer.Server, app::App; route="/browser-display")
    session = HTTPSession(server)
    handler = DisplayHandler(session, server, route, app)
    route!(server, route => handler)
    return handler
end

function update_app!(handler::DisplayHandler, app::App)
    # the connection is open, so we can just use it to update the dom!
    old_session = handler.current_app.session[]
    handler.current_app = app
    if isready(handler.session)
        if !isnothing(old_session)
            close(old_session)
        end
        update_app!(handler.session, app)
        return false
    else
        # Need to wait for someone to actually visit http://.../browser-display
        return true # needs loading!
    end
end

function HTTPServer.apply_handler(handler::DisplayHandler, context)
    try
        # we only allow one open tab/browser to show the browser display
        # Multiple sessions wouldn't be too hard, but that means we'd need manage multiple right here
        # And this is already complicated enough!
        # so, if we serve the display handler url, it means to start fresh
        # But if UNINITIALIZED, it's simply the first request to the page!
        parent = handler.session
        not_initialized = parent.status != UNINITIALIZED
        changed_compression = parent.compression_enabled != default_compression()
        ForcedCon = FORCED_CONNECTION[]
        changed_connection = !isnothing(ForcedCon) && !(parent.connection isa ForcedCon)
        # We need to create a new session if either of these happen
        if not_initialized || changed_compression || changed_connection
            @debug("creating new Session for unititialized display handler")
            parent = HTTPSession(handler.server) # new session
            handler.session = parent
        end
        sub = Session(parent)
        # Use indicator from user's app on the parent wrapper (only root has indicator)
        parent_dom = session_dom(parent, App(nothing; indicator=handler.current_app.indicator); html_document=true)
        sub_dom = session_dom(sub, handler.current_app)

        # first time rendering in a subsession, we put the
        # subsession dom as a bonito fragment into the parent body
        _, parent_body, _ = find_head_body(parent_dom)
        push!(children(parent_body), sub_dom)
        html_str = sprint(io -> print_as_page(io, parent_dom))
        # The closing time is calculated from here
        # If after 20s after rendering and sending the HTML to the browser
        # no connection is established, it will be assumed that the browser never connected
        mark_displayed!(parent)
        mark_displayed!(sub)
        return html(html_str)
    catch err
        # Use unified error handling - closes app session to prevent wait_for_ready hang
        error_html = handle_app_error!(err, handler.current_app, nothing)
        html_str = sprint(io -> print_as_page(io, error_html))
        return html(html_str)
    end
end

function wait_for_ready(app::App; timeout=100)
    success = wait_for(()-> !isnothing(app.session[]); timeout=timeout)
    success !== :success && return nothing
    isclosed(app.session[]) && return nothing
    wait_for(timeout=timeout) do
        isready(app.session[]) || isclosed(app.session[])
    end
end

function jsrender(session::Session, app::App)
    return rendered_dom(session, app; apply_jsrender=false)
end

@testset "Retain + Observable + Session cleanup" begin
    global_obs = Bonito.Retain(Observable{Any}("hiii"))
    for i in 1:5
        dom_obs1 = Observable{Any}(DOM.div("12345", js"$(global_obs).notify('hello')"))
        app = App() do s
            return DOM.div(dom_obs1)
        end
        display(edisplay, app)
        app_id = app.session[].id
        obs_id = first(app.session[].children)[2].id
        session = app.session[]
        @test length(session.children) == 1
        @test Bonito.wait_for(()-> global_obs.value[] == "hello") == :success
        obs_sub = last(first(session.children)) # the session used to render dom_obs1
        @test isnothing(obs_sub.session_objects[global_obs.value.id])
        root = Bonito.root_session(session)
        @test root.session_objects[global_obs.value.id] == global_obs
        @test length(session.children) == 1

        dom_obs1[] = DOM.div("95384", js"""$(global_obs).notify('melo')""")

        @test Bonito.wait_for(() -> global_obs.value[] == "melo") == :success

        # Sessions should be closed!
        @test isempty(obs_sub.session_objects)
        @test obs_sub.status == Bonito.CLOSED
        @test !isopen(obs_sub)
        @test length(session.children) == 1 # there should be a new session though
        obs_sub = last(first(session.children)) # the session used to render dom_obs1
        @test isnothing(obs_sub.session_objects[global_obs.value.id])
        @test haskey(session.parent.session_objects, global_obs.value.id)
    end
    @testset "no residuals" begin
        app = App(nothing)
        display(edisplay, app)
        result = Bonito.wait_for() do
            js_sessions = run(edisplay.window, "Bonito.Sessions.SESSIONS")
            Set([app.session[].id, app.session[].parent.id]) == keys(js_sessions)
        end
        @test result == :success
        js_objects = run(edisplay.window, "Bonito.Sessions.GLOBAL_OBJECT_CACHE")
        @test keys(js_objects) == Set([global_obs.value.id]) # we used Retain for global_obs, so it should stay as long as root session is open
    end
end
Bonito.set_cleanup_time!(0.0)
@testset "server cleanup" begin
    # Close edisplay to remove Retain (gotta add a functionality to do this nonviolently)
    # But this is also a good chance to test server cleanup :)
    close(edisplay.window)
    server = edisplay.browserdisplay.server
    # It may take a while for close(edisplay.window) to remove the websocket route (by closing the socket)
    success = Bonito.wait_for(() -> isempty(server.websocket_routes.table); timeout=6)
    for (r, handler) in server.websocket_routes.table
        @show handler.session
    end
    @test success == :success
    # browser display route & asset server
    @test Set(first.(server.routes.table)) == Set(["/browser-display", r"\Q/assets/\E(?:(?:(?:[\da-f]){40})(?:-.*))"])
    asset_server = server.routes.table[2][2]
    @test isempty(asset_server.registered_files)
end
Bonito.set_cleanup_time!(30/60/60)

# Re-Create edisplay for other tests
edisplay = Bonito.use_electron_display(devtools=true, options=ELECTRON_OPTIONS)

@testset "subsession & freing" begin
    server = Server("0.0.0.0", 9433)
    session = Bonito.HTTPSession(server)
    sub1 = Session(session)
    sub2 = Session(session)
    subsub = Session(sub1)
    obs1 = Observable(1)
    obs2 = Observable(2)
    obs3 = Observable(3)
    obs4 = Observable(4)
    add_cached!(s, obs) = Bonito.add_cached!(() -> obs, s, Dict{String,Any}(), obs)
    add_cached!(sub1, obs1)
    add_cached!(sub1, obs3)
    add_cached!(sub2, obs2)
    add_cached!(sub2, obs3)

    add_cached!(subsub, obs1)
    add_cached!(subsub, obs2)
    add_cached!(subsub, obs3)

    for obs in [obs1, obs2, obs3]
        @test session.session_objects[obs.id] == obs
        @test subsub.session_objects[obs.id] == nothing
    end

    @test length(sub1.session_objects) == 2
    for obs in [obs1, obs3]
        @test sub1.session_objects[obs.id] == nothing
    end
    @test length(sub2.session_objects) == 2
    for obs in [obs2, obs3]
        @test sub2.session_objects[obs.id] == nothing
    end

    add_cached!(subsub, obs4)
    @test session.session_objects[obs4.id] == obs4
    @test subsub.session_objects[obs4.id] == nothing
    @test length(sub1.session_objects) == 2
    @test length(sub2.session_objects) == 2

    close(sub2)

    for obs in [obs1, obs2, obs3]
        @test session.session_objects[obs.id] == obs
        @test subsub.session_objects[obs.id] == nothing
    end

    @test length(sub1.session_objects) == 2
    for obs in [obs1, obs3]
        @test sub1.session_objects[obs.id] == nothing
    end

    @test isempty(sub2.session_objects)

    close(sub1)
    @test isempty(session.session_objects)
    @test isempty(sub1.session_objects)
    @test isempty(sub2.session_objects)
    @test isempty(subsub.session_objects)

    @test isempty(session.asset_server.parent.registered_files)

end

@testset "cleanup comm" begin
    app = App() do s
        return DOM.div()
    end
    display(edisplay, app)
    @test !isnothing(app.session[])
    @test isready(app.session[])
    Bonito.wait_for(() -> run(edisplay.window, "Object.keys(Bonito.Sessions.SESSIONS).length") == 2)
    @test run(edisplay.window, "Object.keys(Bonito.Sessions.SESSIONS).length") == 2
    root = Bonito.root_session(app.session[])
    @test root !== app.session[]
    @test run(edisplay.window, "Object.keys(Bonito.Sessions.GLOBAL_OBJECT_CACHE).length") == 0
    @test isempty(root.session_objects)
    close(app.session[])
    Bonito.wait_for(() -> run(edisplay.window, "Object.keys(Bonito.Sessions.SESSIONS).length") == 1)
    @test run(edisplay.window, "Object.keys(Bonito.Sessions.SESSIONS).length") == 1
end


@testset "Async evaljs_value" begin
    test_obs = Observable(0)
    app = App() do session
        obs = Observable(0)

        script = js"""
        window.obs_value = 0;
        for(let i = 0; i < 20; i++) {
            $(obs).notify(i);
        }
        """
        # on(obs_triggered_from_js)
        # with evaljs_value requires messages to be processed
        # async, since evaljs_value waits for a message from JS
        # while being triggered
        on(obs) do val
            @async begin
                jsval = evaljs_value(session, js"window.obs_value = $(val)"; timeout=1)
                test_obs[] = test_obs[] + 1
                return
            end
        end
        return DOM.div("Value: ", obs, script)
    end
    display(edisplay, app)
    Bonito.wait_for(() -> test_obs[] == 20)
    @test test_obs[] == 20
    @test run(edisplay.window, "window.obs_value") == 19
end

using Bonito
using Observables
# Example usage function

App() do
    # sample options
    fruits = ["Cherry", "Apple", "Banana", "Date", "Elderberry",  "Fig", "Grape"]

    # Configure Choices.js parameters
    params = ChoicesJSParams(
        searchPlaceholderValue="Type to search fruits...",
        itemSelectText= "Press this fruit to select",
        searchEnabled=true,
        shouldSort=false,
        searchResultLimit=3,
        renderChoiceLimit=10,
        placeholder = true,
        placeholderValue = "--"
    )
    choicesbox = ChoicesBox(fruits; choicejsparams=params)

    # Display selected value
    selected_display = map(choicesbox.value) do value
        "Selected: $value"
    end

    # Handle value changes
    on(choicesbox.value) do value
        @info "ChoicesBox value changed to: $value"
    end
    return Card(
        DOM.div(
        DOM.h2("ChoicesBox Example"),
        DOM.p("This box allows you to select from predefined option list:"),
        choicesbox,
        DOM.p(selected_display, style="margin-top: 20px; font-weight: bold;");
        )
    )
end

# Needs to be done before loading Bonito
include("test-bundles.jl")
using Bonito
# ENV["JULIA_DEBUG"] = Bonito
using Hyperscript, Markdown, Test, RelocatableFolders
using Observables
using Bonito: Session, evaljs, linkjs, div

using Bonito: onjs, JSString, Asset, jsrender
using Bonito: @js_str, uuid, SerializationContext, serialize_binary
using Bonito.DOM
using Bonito.HTTP
using Electron
using URIs
using Random
using Hyperscript: children
using Bonito.MsgPack
using Bonito.CodecZlib
using Test
using Bonito: jsrender
include("ElectronTests.jl")

function wait_on_test_observable()
    global test_observable
    test_channel = Channel{Dict{String,Any}}(1)
    f = on(test_observable) do value
        put!(test_channel, value)
    end
    val = take!(test_channel)
    off(test_observable, f)
    return val
end

"""
    test_value(app, statement)
Executes statemen (js code, or julia function with 0 args),
And waits on `test_observable` to push a new value!
Returns new value from `test_observable`
"""
function test_value(app, statement)
    # First start waiting on the test communication channel
    # We do this async before scheduling the js, since otherwise there is a
    # chance, that the event gets triggered before we have a chance to wait for it
    # which would make use wait forever
    val_t = @async wait_on_test_observable()
    # eval our js expression that is supposed to write something to test_observable
    if statement isa Bonito.JSCode
        Bonito.evaljs(app.session, statement)
    else
        statement()
    end
    return fetch(val_t) # fetch the value!
end

function OfflineSession()
    return Session(NoConnection(); asset_server=NoServer())
end

global ELECTRON_OPTIONS = Dict{String, Any}(
    "show" => true,  # Don't show the window immediately
    "focusOnWebView" => false,  # Don't focus the webview
)

function TestWindow(args...)
    return Bonito.EWindow(args...; options=ELECTRON_OPTIONS)
end

@testset "Bonito" begin
    global edisplay = Bonito.use_electron_display(; options=ELECTRON_OPTIONS, devtools=true)
    @testset "Default Connection" begin
        @testset "websocket-closing" begin
            include("websocket-closing.jl")
        end
        @testset "components" begin
            include("components.jl")
        end
        @testset "styling" begin
            include("styling.jl")
        end
        @testset "threading" begin
            include("threading.jl")
        end
        @testset "server" begin
            include("server.jl")
        end
        @testset "subsessions" begin
            include("subsessions.jl")
        end
        @testset "connection-serving" begin
            include("connection-serving.jl")
        end
        @testset "serialization" begin
            include("serialization.jl")
        end
        @testset "widgets" begin
            include("widgets.jl")
        end
        # @testset "various" begin; include("various.jl"); end
        @testset "markdown" begin
            include("markdown.jl")
        end
        @testset "basics" begin
            include("basics.jl")
        end
        @testset "handlers" begin
            include("handlers.jl")
        end
    end
    close(edisplay)
    global edisplay = Bonito.use_electron_display(; options=ELECTRON_OPTIONS, devtools=true)
    @testset "Compression true + DualWebsocket" begin
        @testset "Compression + DualWebsocket" begin
            Bonito.use_compression!(true)
            Bonito.force_connection!(Bonito.DualWebsocket)
            @testset "components" begin
                include("components.jl")
            end
            @testset "threading" begin
                include("threading.jl")
            end
            @testset "server" begin
                include("server.jl")
            end
            @testset "subsessions" begin
                include("subsessions.jl")
            end
            @testset "serialization" begin
                include("serialization.jl")
            end
            @testset "widgets" begin
                include("widgets.jl")
            end
            @testset "markdown" begin
                include("markdown.jl")
            end
        end
    end
end

######
######
#### Register default asset servers and connections
####


function register_type!(condition::Function, ::Type{T}, available_types::Vector{Pair{DataType, Function}}) where T
    index = findfirst(((type, c),)-> type == T, available_types)
    # constructing Pair like this prevents it from getting converted to the abstract Pair{DataType, Function} type
    pair = Pair{DataType, Function}(T, condition)
    if isnothing(index)
        push!(available_types, pair)
    else
        # connections shouldn't be overwritten, but this is handy for development!
        @warn("replacing existing type for $(T)")
        available_types[index] = pair
    end
    return
end

function force_type!(conn, forced_types::Base.RefValue)
    forced_types[] = conn
end

function force_type(f, conn, forced_types::Base.RefValue)
    try
        force_connection!(conn, forced_types)
        f()
    finally
        force_connection!(nothing, forced_types)
    end
end

function default_type(forced::Base.RefValue, available::Vector{Pair{DataType, Function}})
    if !isnothing(forced[])
        return forced[]()
    else
        for i in length(available):-1:1 # start from last inserted
            type_or_nothing = available[i][2]()# ::Union{FrontendConnection, AbstractAssetServer, Nothing}
            isnothing(type_or_nothing) || return type_or_nothing
        end
        error("No type found. This can only happen if someone messed with `$(available)`")
    end
end

const AVAILABLE_ASSET_SERVERS = Pair{DataType, Function}[]

"""
    register_asset_server!(condition::Function, ::Type{<: AbstractAssetServer})

Registers a new asset server type.
`condition` is a function that should return `nothing`, if the asset server type shouldn't be used, and an initialized asset server object, if the conditions are right.
E.g. The `Bonito.NoServer` be used inside an IJulia notebook so it's registered like this:
```julia
register_asset_server!(NoServer) do
    if isdefined(Main, :IJulia)
        return NoServer()
    end
    return nothing
end
```
The last asset server registered takes priority, so if you register a new connection last in your Package, and always return it,
You will overwrite the connection type for any other package.
If you want to force usage temporary, try:
```julia
force_asset_server(YourAssetServer) do
    ...
end
# which is the same as:
force_asset_server!(YourAssetServer)
...
force_asset_server!()
```
"""
function register_asset_server!(condition::Function, ::Type{C}) where C <: AbstractAssetServer
    register_type!(condition, C, AVAILABLE_ASSET_SERVERS)
    return
end

const FORCED_ASSET_SERVER = Base.RefValue{Union{Nothing, Type{<:AbstractAssetServer}}}(nothing)

function force_asset_server!(conn::Union{Nothing,Type{<:AbstractAssetServer}}=nothing)
    force_type!(conn, FORCED_ASSET_SERVER)
end

function force_asset_server(f, conn::Union{Nothing,Type{<:AbstractAssetServer}})
    force_type(f, conn, FORCED_ASSET_SERVER)
end

function default_asset_server()
    return default_type(FORCED_ASSET_SERVER, AVAILABLE_ASSET_SERVERS)
end


const AVAILABLE_CONNECTIONS = Pair{DataType, Function}[]

"""
    register_connection!(condition::Function, ::Type{<: FrontendConnection})

Registers a new Connection type.

condition is a function that should return `nothing`, if the connection type shouldn't be used, and an initialized Connection, if the conditions are right.
E.g. The IJulia connection should only be used inside an IJulia notebook so it's registered like this:
```julia
register_connection!(IJuliaConnection) do
    if isdefined(Main, :IJulia)
        return IJuliaConnection()
    end
    return nothing
end
```
The last connection registered take priority, so if you register a new connection last in your Package, and always return it,
You will overwrite the connection type for any other package.
If you want to force usage temporary, try:
```julia
force_connection(YourConnectionType) do
    ...
end
# which is the same as:
force_connection!(YourConnectionType)
...
force_connection!()
```
"""
function register_connection!(condition::Function, ::Type{C}) where C <: FrontendConnection
    register_type!(condition, C, AVAILABLE_CONNECTIONS)
    return
end

const FORCED_CONNECTION = Base.RefValue{Union{Nothing, Type{<:FrontendConnection}}}(nothing)

function force_connection!(conn::Union{Nothing,Type{<:FrontendConnection}}=nothing)
    force_type!(conn, FORCED_CONNECTION)
end

function force_connection(f, conn::Union{Nothing,Type{<:FrontendConnection}})
    force_type(f, conn, FORCED_CONNECTION)
end

const FORCE_SUBSESSION_RENDERING = Base.RefValue(false)

function force_subsession!(use_subsession::Bool=false)
    FORCE_SUBSESSION_RENDERING[] = use_subsession
end

function _use_parent_session(session::Session)
    if FORCE_SUBSESSION_RENDERING[]
        return true
    else
        return use_parent_session(session)
    end
end

function default_connection()
    return default_type(FORCED_CONNECTION, AVAILABLE_CONNECTIONS)
end

use_parent_session(::Session) = false
use_parent_session(::Session{IJuliaConnection}) = true
use_parent_session(::Session{PlutoConnection}) = true
use_parent_session(::Session{WebSocketConnection}) = false

# HTTPAssetServer is the fallback, so it's registered first (lower priority),
# and never returns nothing
register_asset_server!(HTTPAssetServer) do
    return HTTPAssetServer()
end

register_asset_server!(NoServer) do
    if isdefined(Main, :IJulia) || isdefined(Main, :PlutoRunner) | isdefined(Main, :Documenter)
        return NoServer()
    else
        return  nothing
    end
end

# Needs to be globally shared while building the docs
# TODO, reuse the same DocumenterAssets instance more cleanly
const DOCUMENTER_ASSETS = DocumenterAssets()
register_asset_server!(DocumenterAssets) do
    if isdefined(Main, :Documenter)
        return DOCUMENTER_ASSETS
    else
        return nothing
    end
end

# Websocket is the fallback, so it's registered first (lower priority),
# and never returns nothing
register_connection!(WebSocketConnection) do
    return WebSocketConnection()
end

register_connection!(NoConnection) do
    if isdefined(Main, :Documenter)
        force_subsession!(true)
        return NoConnection()
    end
    return nothing
end

register_connection!(IJuliaConnection) do
    isdefined(Main, :IJulia) && return IJuliaConnection()
    return nothing
end

register_connection!(PlutoConnection) do
    isdefined(Main, :PlutoRunner) && return PlutoConnection()
    return nothing
end


const COMPRESSION_ENABLED = RefValue{Bool}(false)

default_compression() = COMPRESSION_ENABLED[]
use_compression!(enable) = (COMPRESSION_ENABLED[] = enable)

module Bonito

import Sockets
using Sockets: send

using OrderedCollections
using Dates
using UUIDs
using Hyperscript
using Hyperscript: Node, children, tag
using Observables
using Markdown
using HTTP
using Base64
using MsgPack
using WidgetsBase
using WidgetsBase: vertical, horizontal
using SHA
using Tables
using Colors
using LinearAlgebra
using CodecZlib
using RelocatableFolders: @path, Path, getroot
using URIs

using Base: RefValue

# these are used in HTTPServer and need to be defined already
function update_app! end
function get_server end
function wait_for end
function wait_for_ready end

include("deno.jl")
include("types.jl")
include("HTTPServer/HTTPServer.jl")
include("HTTPServer/folderserver.jl")
include("HTTPServer/protectedroute.jl")
include("app.jl")

function HTTPServer.route!(server::HTTPServer.Server, routes::Routes)
    for (key, app) in routes.routes
        HTTPServer.route!(server, key => app)
    end
end


import .HTTPServer: browser_display, EWindow
using .HTTPServer: Server, html, online_url, route!, file_mimetype, delete_websocket_route!, delete_route!, use_electron_display

include("js_source.jl")
include("session.jl")

include("rendering/rendering.jl")

include("asset-serving/asset-serving.jl")
include("connection/connection.jl")
include("registry.jl")

using JSON
include("server-defaults.jl")

include("serialization/serialization.jl")

include("util.jl")
include("widgets.jl")
include("display.jl")
include("export.jl")
include("components.jl")
include("connection_indicator.jl")
include("tailwind-dashboard.jl")

include("interactive.jl")

# Core functionality
export Page, Session, App, DOM, SVG, @js_str, ES6Module, Asset, CSS
export Slider, Button, TextField, NumberInput, Checkbox, RangeSlider, CodeEditor
export browser_display, configure_server!, Server, show_html, html, route!, online_url, use_electron_display
export Observable, on, onany, bind_global
export linkjs, evaljs, evaljs_value, onjs
export NoServer, AssetFolder, HTTPAssetServer, DocumenterAssets
export NoConnection, IJuliaConnection, PlutoConnection, WebSocketConnection
export export_static, Routes, interactive_server
export Card, Grid, FileInput, Dropdown, Styles, Col, Row
export Labeled, StylableSlider, Centered
export interactive_server
export ChoicesBox, ChoicesJSParams
export ProtectedRoute, User, SingleUser, AbstractPasswordStore, FolderServer
export ConnectionIndicator, AbstractConnectionIndicator
export get_metadata, set_metadata!

function has_html_display()
    for display in Base.Multimedia.displays
        # Ugh, why would textdisplay say it supports HTML??
        display isa TextDisplay && continue
        displayable(display, MIME"text/html"()) && return true
    end
    return false
end

function __init__()
    # Use browser display if no HTML display is available
    if !has_html_display()
        browser_display()
    end
    atexit() do
        for (server, (task, close_ref)) in Bonito.SERVER_CLEANUP_TASKS
            close_ref[] = false
        end
        empty!(Bonito.SERVER_CLEANUP_TASKS)
        Bonito.CURRENT_SESSION[] = nothing
        if !isnothing(Bonito.GLOBAL_SERVER[])
            close(Bonito.GLOBAL_SERVER[])
        end
        Bonito.GLOBAL_SERVER[] = nothing
    end
end

end # module

function html(body)
    return HTTP.Response(200, ["Content-Type" => "text/html", "charset" => "utf-8"], body=body)
end

function response_404(body="Not Found")
    return HTTP.Response(404, [
        "Content-Type" => "text/html",
        "charset" => "utf-8",
        # Avoids throwing lots of errors in the devtools console when
        # VSCode tries to load non-existent resources from the plots pane.
        "Access-Control-Allow-Origin" => "*",
    ], body=body)
end

function response_500(html)
    return HTTP.Response(500, [
        "Content-Type" => "text/html",
        "charset" => "utf-8",
        # Avoids throwing lots of errors in the devtools console when
        # VSCode tries to load non-existent resources from the plots pane.
        "Access-Control-Allow-Origin" => "*",
        ];
        body=html,
    )
end

# TODO, how to do this without pircay? THis happens inside HTTP, so we can't just use try & catch in our own code
# WIthout this overload, we'll get a `cant convert Exception to HTTP.Response` error, without seeing the error.
Base.convert(::Type{HTTP.Response}, s::Exception) = response_500(s)

using WGLMakie, Bonito
using Colors, ImageTransformations, Markdown
using Bonito: styled_slider

folder = joinpath(@__DIR__, "simulation")

volume_frames = map(readdir(folder)) do file
    open(joinpath(folder, file)) do io
        data = Array{Float32, 3}(undef, 130, 258, 65)
        read!(io, data)
        return data
    end
end

struct Flip <: Bonito.WidgetsBase.AbstractWidget{Bool}
    label::String
    value::Observable{Bool}
end
Flip(label) = Flip(label, Observable(false))
# Implement interface for Flip to work with offline mode
Bonito.is_widget(::Flip) = true
Bonito.value_range(flip::Flip) = (true, false)
Bonito.update_value!(flip::Flip, value) = (flip.value[] = value)

function Bonito.jsrender(flip::Flip)
    return DOM.input(
        type = "button",
        value = flip.label,
        onclick = js"{
            const value = this.last_value;
            $(flip.value).notify(!value);
            this.last_value = !value;
        }";
        class="p-1 rounded m-2"
    )
end

function handler(s, r)
    sl = Bonito.Slider(1:64)
    absorption = Bonito.Slider(range(1f0, stop=10f0, step=0.1))
    flip_colormap = Flip("flip colormap")
    absorption.value[] = 5
    v = map(sl) do idx
        # make volumes a bit smaller!
        restrict(volume_frames[idx])
    end
    clims = (8, 12)
    cmapa = RGBAf.(to_colormap(:thermal), 1.0)
    cmap1 = vcat(fill(RGBAf(0,0,0,0), 20), cmapa)
    cmap2 = vcat(cmapa, fill(RGBAf(0,0,0,0), 20))
    cmap = map(flip_colormap) do x
        return x ? copy(cmap1) : copy(cmap2)
    end

    scene = volume(v;
        colorrange=clims, algorithm=:absorption, absorption=absorption, colormap=cmap, show_axis=false,
        resolution=(600, 600))

    markdown = md"""

    # Ocean Simulation

    Simulation of instability of a horizontal density gradient in a rotating channel using 256x512x128 grid points running on a GPU. A similar process called baroclinic instability acting on basin-scale temperature gradients fills the oceans with eddies, especially in regions with large temperature gradients. These eddies are the primary way the ocean transports heat, carbon dioxide, organic matter, and nutrients on a large scale.

    Simulation created with [Oceananigans.jl](https://github.com/CliMA/Oceananigans.jl/) which is part of the [CliMA](https://github.com/CliMA) project.

    [source code](https://github.com/SimonDanisch/Bonito.jl/blob/master/examples/oceananigans.jl)

    ---

    absorption: $(styled_slider(absorption, absorption.value))
    time: $(styled_slider(sl, sl.value))

    $(flip_colormap)

    $(scene)

    """
    dom = DOM.div(Bonito.MarkdownCSS, Bonito.Styling, Bonito.TailwindCSS, markdown)
    # return dom
    return Bonito.record_state_map(s, dom).dom
end

# Either serve
# app = Bonito.Server(handler, "0.0.0.0", 8083)

export_path = "dev/WGLDemos/oceananigans/"
# or export to e.g. github IO
Bonito.export_standalone(handler, export_path, clear_folder=true)

struct Routes
    table::Vector{Pair{Any, Any}}
    lock::Base.ReentrantLock
end


"""
HTTP server with websocket & http routes
"""
mutable struct Server
    url::String
    port::Int
    # If behind a proxy, this is the url content is served after the proxy
    # "." -> relative urls to the site it's served to
    # "" -> use local url (e.g 0.0.0.0:8081)
    proxy_url::Union{String, Nothing}
    server::Union{Nothing, HTTP.Servers.Server}
    routes::Routes
    websocket_routes::Routes
    protocol::String
end

Routes(pairs::Pair...) = Routes(Pair{Any, Any}[pairs...], Base.ReentrantLock())

# Priorities, so that e.g. r".*" doesn't catch absolut matches by e.g a string
pattern_priority(x::Pair) = pattern_priority(x[1])
pattern_priority(x::String) = 1
pattern_priority(x::Tuple) = 2
pattern_priority(x::Regex) = 3

delete_route!(server::Server, pattern) = delete_route!(server.routes, pattern)
delete_websocket_route!(server::Server, pattern) = delete_route!(server.websocket_routes, pattern)

function delete_route!(routes::Routes, pattern)
    lock(routes.lock) do
        filter!(((key, f),) -> !(key == pattern), routes.table)
    end
    return
end

function get_route(routes::Routes, pattern)
    lock(routes.lock) do
        for (key, route) in routes.table
            key == pattern && return route
        end
        return nothing
    end
end

function has_route(routes::Routes, pattern)
    lock(routes.lock) do
        return any(x -> x[1] == pattern, routes.table)
    end
end

function route!(routes::Routes, pattern_func::Pair)
    pattern, func = pattern_func
    return lock(routes.lock) do
        idx = findfirst(pair-> pair[1] == pattern, routes.table)
        old = nothing
        if idx !== nothing
            old = routes.table[idx][2]
            routes.table[idx] = pattern_func
        else
            push!(routes.table, pattern_func)
        end
        # Sort for priority so that exact string matches come first
        sort!(routes.table, by = pattern_priority)
        # return old route (nothing if new)
        return old
    end
end

function route!(application::Server, pattern_func::Pair)
    return route!(application.routes, pattern_func)
end

function websocket_route!(application::Server, pattern_func::Pair)
    route!(application.websocket_routes, pattern_func)
end

function route!(func, application::Server, pattern)
    route!(application, Pair{Any, Any}(pattern, func))
end

apply_handler(f, args...) = f(args...)

function apply_handler(chain::Tuple, context, args...)
    f = first(chain)
    result = f(args...)
    return apply_handler(Base.tail(chain), context, result...)
end

function linkify_stacktrace(error_msg, bt::String)
    lines = split(bt, '\n'; keepempty=false)  # Split stack trace into lines
    elements = []

    for line in lines
        # Match both Windows (C:\path\file.jl:123) and Unix (/path/file.jl:123) paths
        m = match(r"^(.*?)([A-Za-z]:[\\/][^\s]+\.jl|\.[\\/][^\s]+\.jl):(\d+)(.*)", line)
        if m !== nothing
            prefix, file, line_num, suffix = m.captures
            normalized_file = replace(file, "\\" => "/")  # Convert Windows paths to `/`
            vscode_url = "vscode://file/" * normalized_file * ":" * line_num  # VS Code link
            push!(
                elements,
                DOM.span(
                    String(prefix),
                    DOM.a(file * ":" * line_num; href=vscode_url),
                    String(suffix),
                ),
                DOM.br(),
            )
        else
            m2 = match(r"^(.*?)(\[\d+\])", line)
            if !isnothing(m2)
                prefix, suffix = m2.captures
                push!(
                    elements,
                    DOM.span(String(line); style="color: darkred; font-weight: bold;"),
                    DOM.br(),
                )  # Normal line
            else
                push!(elements, DOM.span(String(line)), DOM.br())  # Normal line
            end
        end
    end
    return DOM.pre(
        DOM.h3(error_msg; style="color: red;"),
        elements...;
        class="backtrace",
        style="overflow-x: auto;",
    )
end

function err_to_html(err, stacktrace)
    error_msg = sprint() do io
        Base.showerror(io, err)
    end
    stacktrace_msg = sprint() do io
        iol = IOContext(io, :stacktrace_types_limited => Base.RefValue(true))
        Base.show_backtrace(iol, stacktrace)
    end
    return linkify_stacktrace(error_msg, stacktrace_msg)
end

function delegate(routes::Routes, application, request::Request, args...)
    try
        for (pattern, f) in routes.table
            match = match_request(pattern, request)
            if match !== nothing
                context = (
                    routes = routes,
                    application = application,
                    request = request,
                    match = match
                )
                return apply_handler(f, context, args...)
            end
        end
        # If no route is found we have a classic case of 404!
        # What a classic this response!
        return response_404("Didn't find route for $(request.target)")
    catch e
        stacktrace = Base.catch_backtrace()
        err = CapturedException(e, stacktrace)
        Base.showerror(stderr, err)
        html = err_to_html(e, stacktrace)
        html_str = sprint() do io
            Bonito.print_as_page(io,  html)
        end
        return response_500(html_str)
    end
end

function match_request(pattern::String, request)
    request.target == pattern && return pattern
    uri = URI(request.target)
    uri.path == pattern && return pattern
    return nothing
end

function match_request(pattern::Regex, request)
    return match(pattern, request.target)
end

"""
    local_url(server::Server, url)

The local url to reach the server, on the server
"""
function local_url(server::Server, url)
    # TODO, tell me again, why electron only accepts localhost in the url?
    # And is there a clean way to "normalize" an url like that, so that no one complains?
    base_url = replace(server.url, r"(127.0.0.1)|(0.0.0.0)" => "localhost")
    return string(server.protocol, base_url, ":", server.port, url)
end

function join_url(base, url)
    base = rstrip(base, '/')
    url = lstrip(url, '/')
    return base * "/" * url
end

"""
    online_url(server::Server, url)

The url to connect to the server from the internet.
Needs to have `server.proxy_url` set to the IP or dns route of the server
"""
function online_url(server::Server, url)
    proxy_url = server.proxy_url
    # Relative urls or
    if proxy_url in (".", "")
        return local_url(server, url)
    else
        return join_url(proxy_url, url)
    end
end

function relative_url(server::Server, url)
    proxy_url = server.proxy_url
    if proxy_url == ""
        # Absolute URLS!
        return online_url(server, url)
    else
        # absolute proxy URLS
        return join_url(proxy_url, url)
    end
end

function stream_handler(application::Server, stream::Stream)
    if HTTP.WebSockets.isupgrade(stream.message)
        try
            HTTP.WebSockets.upgrade(stream; binary=true) do ws
                delegate(
                    application.websocket_routes, application, stream.message, ws
                )
            end
            return
        catch e
            # When browser closes we may get an io error here!
            if !(e isa Base.IOError)
                rethrow(e)
            end
        end
    end
    http_handler = HTTP.streamhandler() do request
        delegate(
            application.routes, application, request,
        )
    end
    try
        http_handler(stream)
    catch e
        # we expect the IOError to happen, if either the page gets closed
        # or we close the server!
        if !(e isa Base.IOError)
            rethrow(e)
        end
    end
end

"""
Server(
        dom, url::String, port::Int;
        verbose = -1
    )

Creates an application that manages the global server state!
"""
function Server(
        url::String, port::Int;
        verbose = -1,
        proxy_url = "",
        routes = Routes(),
        websocket_routes = Routes(),
        listener_kw...
    )
    server = Server(
        url, port, proxy_url,
        nothing,
        routes,
        websocket_routes,
        haskey(listener_kw, :sslconfig) ? "https://" : "http://"
    )

    try
        start(server; verbose=verbose, listener_kw...)
    catch e
        close(server)
        rethrow(e)
    end
    return server
end

function Server(
        app::Union{Function, App},
        url::String, port::Int;
        verbose=-1, proxy_url="",
        listener_kw...
    )
    server = Server(url, port; verbose=verbose, proxy_url=proxy_url, listener_kw...)
    route!(server, "/" => app)
    return server
end

function isrunning(server::Server)
    return !isnothing(server.server) && !istaskdone(server.server.task)
end

function Base.close(server::Server)
    isnothing(server.server) && return
    for (k, web_handler) in server.websocket_routes.table
        try
            close(web_handler)
        catch e
            @warn "Error while closing websocket handler for route $(k)" exception=(e, Base.catch_backtrace())
        end
    end
    close(server.server)
end


function try_listen(url, port, server, verbose; listener_kw...)
    try
        httpserver = HTTP.listen!(url, port; verbose=verbose, listener_kw...) do stream::Stream
            Base.invokelatest(stream_handler, server, stream)
        end
        return port, httpserver
    catch e
        if e isa Base.IOError
            #address already in use
            if e.code == Base.UV_EADDRINUSE
                return try_listen(url, port+1, server, verbose; listener_kw...)
            end
        end
        rethrow(e)
    end
end

function start(server::Server; verbose=-1, listener_kw...)
    isrunning(server) && return
    newport, http_server = try_listen(server.url, server.port, server, verbose; listener_kw...)
    if server.port != newport
        @warn "Port in use, using different port. New port: $(newport)"
        server.port = newport
    end
    server.server = http_server
    return
end

"""
    wait(server::Server)

Wait on the server task, i.e. block execution by bringing the server event loop to the foreground.
"""
function Base.wait(server::Server)
    wait(server.server.task)
end

function get_error(server::Server)
    # Running server has no problems!
    isrunning(server) && return nothing
    !istaskfailed(server.server.task) && return nothing
    try
        return fetch(server.server.task)
    catch e
        return e
    end
end

function show_server(io::IO, server::Server)
    println(io, "Server:")
    println(io, "  isrunning: $(isrunning(server))")
    println(io, "  listen_url: $(local_url(server, ""))")
    println(io, "  online_url: $(online_url(server, ""))")
    println(io, "  http routes: ", length(server.routes.table))
    if !isempty(server.routes.table)
        for (route, app) in server.routes.table
            println(io, "    ", route, " => ", typeof(app))
        end
    end
    println(io, "  websocket routes: ", length(server.websocket_routes.table))
    if !isempty(server.websocket_routes.table)
        for (route, app) in server.websocket_routes.table
            println(io, "    ", route, " => ", typeof(app))
        end
    end
    err = get_error(server)
    if !isnothing(err)
        print(io, "  error: ")
        Base.showerror(io, err)
        println(io)
    end
end

Base.show(io::IO, ::MIME"text/plain", server::Server) = show_server(io, server)
Base.show(io::IO, server::Server) = show_server(io, server)

function styleable_slider_app(s, r)
    a = StylableSlider(1:4; value=1)
    b = StylableSlider(1:4; index=2)
    c = StylableSlider(["a", "b"]; value="b")
    return DOM.div(a, b, c)
end

@testset "StylableSlider" begin
    testsession(styleable_slider_app; port=8555) do app
        dom = app.dom
        a = children(dom)[1]
        @test a.value[] == 1
        @test a.index[] == 1
        b = children(dom)[2]
        @test b.value[] == 2
        @test b.index[] == 2
        c = children(dom)[3]
        @test c.value[] == "b"
        @test c.index[] == 2
    end
end

@testset "Class with observable" begin
    app = App() do session
        class = Observable("no-test")
        evaljs(session, js"""
            $(class).notify("test");
        """)
        DOM.div(DOM.div("HEY HEY"; class=class))
    end
    display(edisplay, app)
    Bonito.wait_for_ready(app)
    success = Bonito.wait_for() do
        class = evaljs_value(app.session[], js"""(()=>{
            const b = document.querySelector(".test");
            if (!b) return "no class";
            return b.className;
        })()""")
        return class == "test"
    end
    @test success == :success
end

# Save some bytes by using ints for switch variable
const UpdateObservable = "0"
const OnjsCallback = "1"
const EvalJavascript = "2"
const JavascriptError = "3"
const JavascriptWarning = "4"
const RegisterObservable = "5"
const JSDoneLoading = "8"
const FusedMessage = "9"
const CloseSession = "10"
const PingPong = "11"
const UpdateSession = "12"
const GetSessionDOM = "13"

"""
    process_message(session::Session, bytes::AbstractVector{UInt8})

Handles the incoming websocket messages from the frontend.
Messages are expected to be gzip compressed and packed via MsgPack.
"""
function process_message(session::Session, bytes::AbstractVector{UInt8})
    if isempty(bytes)
        @warn "empty message received from frontend"
        return
    end
    data = deserialize_binary(bytes, session.compression_enabled)
    typ = data["msg_type"]
    if typ == UpdateObservable
        obs = get(session.session_objects, data["id"], nothing)
        if isnothing(obs)
            # this is usually non fatal and may happen when old exported HTML gets reconnected
            @debug "Observable $(data["id"]) not found"
        else
            # Observable can be wrapped inside Retain
            _obs = obs isa Retain ? obs.value : obs
            Base.invokelatest(update_nocycle!, _obs, data["payload"])
        end
    elseif typ == JavascriptError
        show(stderr, JSException(session, data))
    elseif typ == JavascriptWarning
        @warn "Error in Javascript: $(data["message"])\n)"
    elseif typ == JSDoneLoading
        if data["exception"] != "nothing"
            exception = JSException(session, data)
            show(stderr, exception)
            session.init_error[] = exception
        else
            sub = get_session(session, data["session"])
            if !isnothing(sub)
                # this may block the connection!
                @async try
                    sub.on_connection_ready(sub)
                catch e
                    @warn "error while processing on_connection_ready" exception = (e, Base.catch_backtrace())
                end
            else
                # This can happen for IJulia output after kernel restart,
                # since the loaded html will try to init + connect back
                # TODO, there should be a better way to prevent them from reconnecting
                @debug("Sub session with id $(data["session"]) not found")
            end
        end
    elseif typ == CloseSession
        sub = get_session(session, data["session"])
        if !isnothing(sub)
            if data["subsession"] != "root"
                close(sub)
            else
                # We only empty root sessions, since they will be reused
                @assert root_session(sub) === sub
                empty!(sub)
            end
        else
            @debug("Close request not succesful, can't find sub session with id $(data["session"])")
        end
    elseif typ == PingPong
        # Ping back that pong!!
        isready(session) && send(session, msg_type=PingPong)
    elseif typ == GetSessionDOM
        # this may block the connection!
        @async try
            sub = get_session(session, data["session"])
            if !isnothing(sub)
                app = sub.current_app[]
                if isnothing(app)
                    @warn "requesting dom for uninitialized app"
                else
                    free(sub)
                    session.children[sub.id] = sub
                    empty!(session.session_objects)
                    open!(sub.connection)
                    sub.status = OPEN
                    update_subsession_dom!(sub, data["replace"], app)
                end
            else
                @warn "cant update session is nothing"
            end
        catch e
            @warn "error while processing update App message" exception = (e, Base.catch_backtrace())
        end
    else
        @error "Unrecognized message: $(typ) with type: $(typeof(typ))"
    end
end

using Bonito, WGLMakie
using GeometryBasics
using FileIO
using Bonito: @js_str, onjs, App, Slider
using Bonito.DOM
Bonito.browser_display()

set_theme!(size=(1200, 800))

hbox(args...) = DOM.div(args...)
vbox(args...) = DOM.div(args...)

app = App() do
    return hbox(
        vbox(
            scatter(1:4, color=1:4),
            scatter(1:4, color=rand(RGBAf, 4)),
            scatter(1:4, color=rand(RGBf, 4)),
            scatter(1:4, color=:red),
            scatter(1:4)
        ),
        vbox(
            scatter(1:4, marker='☼'),
            scatter(1:4, marker=['☼', '◒', '◑', '◐']),
            scatter(1:4, marker=rand(RGBf, 10, 10), markersize=20),
            scatter(1:4, markersize=20),
            scatter(1:4, markersize=20, markerspace=:pixel),
            scatter(1:4, markersize=LinRange(20, 60, 4), markerspace=:pixel),
            scatter(1:4, marker='▲', markersize=0.3, markerspace=:data, rotation=LinRange(0, pi, 4)),
        )
    )
end

app = App() do
    return DOM.div(
        meshscatter(1:4, color=1:4),
        meshscatter(1:4, color=rand(RGBAf, 4)),
        meshscatter(1:4, color=rand(RGBf, 4)),
        meshscatter(1:4, color=:red),
        meshscatter(rand(Point3f, 10), color=rand(RGBf, 10)),
        meshscatter(rand(Point3f, 10), marker=Pyramid(Point3f(0), 1f0, 1f0)),
    )
end



app = App() do
    x = Point2f[(1, 1), (2, 2), (3, 2), (4, 4)]
    points = connect(x, LineFace{Int}[(1, 2), (2, 3), (3, 4)])
    return DOM.div(
        linesegments(1:4),
        linesegments(1:4, linestyle=:dot),
        linesegments(1:4, linestyle=[0.0, 1.0, 2.0, 3.0, 4.0]),
        linesegments(1:4, color=1:4),
        linesegments(1:4, color=rand(RGBf, 4), linewidth=10),
        linesegments(points)
    )
end


app = App() do
    x = Point2f[(1, 1), (2, 2), (3, 2), (4, 4)]
    points = connect(x, LineFace{Int}[(1, 2), (2, 3), (3, 4)])
    return DOM.div(
        lines(1:4),
        lines(1:4, linestyle=:dot),
        lines(1:4, linestyle=[0.0, 1.0, 2.0, 3.0, 4.0]),
        lines(1:4, color=1:4),
        lines(1:4, color=rand(RGBf, 4), linewidth=10),
        lines(points)
    )
end

app = App() do
    data = Makie.peaks()
    return hbox(vbox(
        surface(-10..10, -10..10, data, axis=(; show_axis=false)),
        surface(-10..10, -10..10, data, color=rand(size(data)...))),
        vbox(surface(-10..10, -10..10, data, color=rand(RGBf, size(data)...)),
        surface(-10..10, -10..10, data, colormap=:magma, colorrange=(0.0, 2.0)),
    ))
end

app = App() do
    return vbox(
        image(rand(10, 10)),
        heatmap(rand(10, 10)),
        image(rand(RGBAf, 10, 10)),
        heatmap(rand(RGBAf, 10, 10)),
        image(rand(RGBf, 10, 10)),
        heatmap(rand(RGBf, 10, 10)),
    )
end

using WGLMakie: volume

app = App() do
    return hbox(vbox(
        volume(rand(4, 4, 4), isovalue=0.5, isorange=0.01, algorithm=:iso),
        volume(rand(4, 4, 4), algorithm=:mip),
        volume(1..2, -1..1, -3..(-2), rand(4, 4, 4), algorithm=:absorption)),
        vbox(
        volume(rand(4, 4, 4), algorithm=Int32(5)),
        volume(rand(RGBAf, 4, 4, 4), algorithm=:absorptionrgba),
        contour(rand(4, 4, 4)),
    ))
end

app = App() do
    cat = FileIO.load(Makie.assetpath("cat.obj"))
    tex = FileIO.load(Makie.assetpath("diffusemap.png"))
    return hbox(vbox(
        Makie.mesh(Circle(Point2f(0), 1f0)),
        Makie.poly(decompose(Point2f, Circle(Point2f(0), 1f0)))), vbox(
        Makie.mesh(cat, color=tex),
        Makie.mesh([(0.0, 0.0), (0.5, 1.0), (1.0, 0.0)]; color=[:red, :green, :blue], shading=false)
    ))
end

function n_times(f, n=10, interval=1)
    obs = Observable(f(1))
    @async for i in 2:n
        try
            obs[] = f(i)
            sleep(interval)
        catch e
            @warn "Error!" exception=CapturedException(e, Base.catch_backtrace())
        end
    end
    return obs
end

app = App() do
    s1 = text(n_times(i-> map(j-> ("$j", Point2f(j*30, 0)), 1:i)), fontsize=20,
                      axis=(;limits=(30, 320, -5, 5)))
    s2 = scatter(n_times(i-> Point2f.((1:i).*30, 0)), markersize=20,
                  axis=(;limits=(30, 320, -5, 5)))
    s3 = linesegments(n_times(i-> Point2f.((2:2:2i).*30, 0)), axis=(;limits=(30, 620, -5, 5)))
    s4 = lines(n_times(i-> Point2f.((2:2:2i).*30, 0)), axis=(;limits=(30, 620, -5, 5)))
    return hbox(s1, s2, s3, s4)
end

app = App() do
    outer_padding = 30
    fig = Figure(
        figure_padding =outer_padding, resolution=(1200, 700),
        backgroundcolor = RGBf(0.98, 0.98, 0.98)
    )
    ax1 = Axis(fig[1,1], title="Sine")
    xx = 0:0.2:4pi
    line1 = lines!(ax1, sin.(xx), xx, color=:red)
    scat1 = scatter!(ax1, sin.(xx) .+ 0.2 .* randn.(), xx,
        color=(:red, 0.5), markersize=15, marker='■')
    return fig
end

app = App() do
    sl = Bonito.Slider(1:10)
    rect = Rect2f(0, -5, 1025, 10)
    chars = [collect('a':'z'); 0:9;]
    char2 = [collect('A':'Z'); 0:9;]
    tex1 = map(x->map(j-> ("$(chars[rand(1:length(chars))])", Point2f(j*30, 0)), 1:36), sl)
    on(println, tex1)
    tex2 = map(x->map(j-> ("$(char2[rand(1:length(char2))])", Point2f(j*30, 1)), 1:36), sl)
    fig, ax, pl = text(tex1, fontsize=20)
    text!(ax, tex2; fontsize=20)
    return DOM.div(sl, fig)
end

@testset "serialization" begin

    xx = "hey"; some_js = js"var"; x = [1f0, 2f0]

    js_str = js"console.log($xx); $x; $((2, 4)); $(some_js) hello = 1; console.log(`${hello}`);"

    expect = "console.log('hey'); Bonito.deserialize_js({\"__javascript_type__\":\"TypedVector\",\"payload\":[1.0,2.0]}); Bonito.deserialize_js([2,4]); var hello = 1; console.log(`\${hello}`)"
    @test string(js_str) == expect

    asset = Bonito.Asset("file.dun_exist"; check_isfile=false)
    test_throw() = Bonito.include_asset(Bonito.Asset("file.dun_exist"))
    Test.@test_throws ErrorException("Unrecognized asset media type: dun_exist") test_throw()

    function test_handler(session, request)
        obs1 = Observable(Float16(2.0))
        obs2 = Observable(DOM.div("Data: ", obs1, dataTestId="hey"))
        return DOM.div(obs2)
    end
    testsession(test_handler, port=8555) do app
        hey = query_testid("hey")
        @test evaljs(app, js"$(hey).innerText") == "Data: 2.0"
        float16_obs = children(children(app.dom)[1][])[2]
        float16_obs[] = Float16(77)
        @test evaljs(app, js"$(hey).innerText") == "Data: 77"
    end
end

@testset "http" begin
    @test_throws ErrorException("Invalid sessionid: lol") Bonito.request_to_sessionid((target="lol",))
    @test Bonito.request_to_sessionid((target="lol",), throw=false) === nothing
end

@testset "hyperscript" begin
    function handler(session, request)
        the_script = DOM.script("window.testglobal = 42")
        s1 = Hyperscript.Style(css("p", fontWeight="bold"), css("span", color="red"))
        the_style = DOM.style(Hyperscript.styles(s1))
        return DOM.div(:hello, the_style, the_script, dataTestId="hello")
    end

    testsession(handler) do app
        @test evaljs(app, js"window.testglobal")  == 42
        hello_div = query_testid("hello")
        @test evaljs(app, js"$(hello_div).innerText")  == "hello"
        @test evaljs(app, js"$(hello_div).children.length") == 3
        @test evaljs(app, js"$(hello_div).children[0].tagName") == "P"
        @test evaljs(app, js"$(hello_div).children[1].tagName") == "STYLE"
        @test evaljs(app, js"$(hello_div).children[2].tagName") == "SCRIPT"
    end
end

@testset "async messages" begin
    obs = Observable(0); counter = Observable(0)
    testing_started = Ref(false)
    function handler(session, request)
        # Dont start this!
        testing_started[] && return DOM.div()
        onjs(session, obs, js"""function (v) {
            var t = $(counter).notify($(counter).value + 1);
        }""")

        for i in 1:2
            obs[] += 1
        end
        @async begin
            yield()
            for i in 1:2
                obs[] += 1
                yield()
            end
        end
        @async begin
            yield()
            for i in 1:2
                obs[] += 1
                yield()
            end
        end
        return DOM.div(obs, counter)
    end
    # Ugh, ElectronTests loads the handler multiple times to make sure it works
    # and doesn't get stuck, so we need to do this manually
    @isdefined(app) && close(app)
    app = Bonito.Server(handler, "0.0.0.0", 8558)
    try
        window = TestWindow()
        try
            @test obs[] == 0
            @test counter[] == 0
            testing_started[] = true
            Electron.load(window.window, URI(string("http://localhost:", 8558)))
            @wait_for counter[] == obs[]
        finally
            close(window)
        end
    finally
        close(app)
    end
end

@testset "Dependencies" begin
    jss = js"""function (v) {
        console.log($(Bonito.BonitoLib));
    }"""
    app = App() do
        DOM.div(onclick=jss)
    end
    s = OfflineSession()
    dom = sess
    Bonito.serialize_binary(s, div)
    @test JSTest in values(s.session_objects)
end

@testset "relocatable" begin
    deps = [
        Bonito.MsgPackLib => "js",
        Bonito.PakoLib => "js",
        Bonito.BonitoLib => "js",
        Bonito.MarkdownCSS => "css",
        Bonito.TailwindCSS => "css",
        Bonito.Styling => "css",
    ]
    for (asset, ext) in deps
        @test asset isa Asset
        @test isempty(asset.online_path)
        @test getfield(asset, :local_path) isa RelocatableFolders.Path
        @test asset.local_path isa String
        @test ispath(asset.local_path)
        @test asset.media_type == Symbol(ext)
    end

    # make sure that assets with `String` or with `RelocatableFolders.Path` behave consistently
    libpath1 = joinpath(@__DIR__, "..", "js_dependencies", "styled.css")
    libpath2 = @path libpath1
    asset1, asset2 = Asset(libpath1), Asset(libpath2)
    for key in (:media_type, :online_path, :local_path, :onload)
        @test getproperty(asset1, key) == getproperty(asset2, key)
    end
end

@testset "range slider" begin
    function test_handler(session, req)
        rslider = Bonito.RangeSlider(1:100; value=[10, 80])
        start = map(first, rslider)
        stop = map(last, rslider)
        return DOM.div(rslider, start, stop, id="rslider")
    end
    testsession(test_handler, port=8555) do app
        # Lets not be too porcelainy about this ...
        rslider = getfield(app.dom, :children)[1]
        @test rslider[] == [10, 80]
        rslider_html = js"document.getElementById('rslider')"
        @test evaljs(app, js"$(rslider_html).children.length") == 3
        @test evaljs(app, js"$(rslider_html).children[1].innerText") == "10"
        @test evaljs(app, js"$(rslider_html).children[2].innerText") == "80"
        rslider[] = [20, 70]
    end
end

# Render the widgets from WidgetsBase.jl

const BUTTON_STYLE = Styles(
    CSS(
        "font-weight" => 600,
        "border-width" => "1px",
        "border-color" => "#9CA3AF",
        "border-radius" => "0.25rem",
        "padding-left" => "0.75rem",
        "padding-right" => "0.75rem",
        "padding-top" => "0.25rem",
        "padding-bottom" => "0.25rem",
        "margin" => "0.25rem",
        "cursor" => "pointer",
        "min-width" => "8rem",
        "font-size" => "1rem",
        "background-color" => "white",
        "box-shadow" => "rgba(0, 0, 0, 0) 0px 0px 0px 0px, rgba(0, 0, 0, 0) 0px 0px 0px 0px, rgba(0, 0, 0, 0.1) 0px 1px 3px 0px, rgba(0, 0, 0, 0.1) 0px 1px 2px -1px";
    ),
    CSS(
        ":hover",
        "background-color" => "#F9FAFB",
        "box-shadow" => "rgba(0, 0, 0, 0) 0px 0px 0px 0px, rgba(0, 0, 0, 0) 0px 0px 0px 0px, rgba(0, 0, 0, 0.1) 0px 1px 3px 0px, rgba(0, 0, 0, 0.1) 0px 1px 2px -1px",
    ),
    CSS(
        ":focus",
        "outline" => "1px solid transparent",
        "outline-offset" => "1px",
        "box-shadow" => "rgba(66, 153, 225, 0.5) 0px 0px 0px 1px",
    ),
)

const BUTTON_EXAMPLE = """
App() do
    style = Styles(
        CSS("font-weight" => "500"),
        CSS(":hover", "background-color" => "silver"),
        CSS(":focus", "box-shadow" => "rgba(0, 0, 0, 0.5) 0px 0px 5px"),
    )
    button = Button("Click me"; style=style)
    on(button.value) do click::Bool
        @info "Button clicked!"
    end
    return button
end
"""

"""
    Button(name; style=Styles(), dom_attributes...)

A simple button, which can be styled a `style::Styles`. Set kwarg `style=nothing` to turn
off the default Bonito styling.

### Example

```julia
$(BUTTON_EXAMPLE)
```
"""
Button

function jsrender(session::Session, button::Button)
    style = get(button.attributes, :style, Styles())
    css = isnothing(style) ? Styles() : Styles(BUTTON_STYLE, style)
    button_dom = DOM.button(
        button.content[];
        onclick=js"event=> $(button.value).notify(true);",
        button.attributes...,
        style=css
    )
    onjs(session, button.content, js"x=> $(button_dom).innerText = x")
    return jsrender(session, button_dom)
end


const TEXTFIELD_EXAMPLE = """
App() do
    style = Styles(
        CSS("font-weight" => "500"),
        CSS(":hover", "background-color" => "silver"),
        CSS(":focus", "box-shadow" => "rgba(0, 0, 0, 0.5) 0px 0px 5px"),
    )
    textfield = TextField("write something"; style=style)
    on(textfield.value) do text::String
        @info text
    end
    return textfield
end
"""

"""
    TextField(default_text; style=Styles(), dom_attributes...)

A simple TextField, which can be styled via the `style::Styles` attribute, `style=nothing`
turns off the default Bonito styling.

### Example

```julia
$(TEXTFIELD_EXAMPLE)
```
"""
TextField

function jsrender(session::Session, tf::TextField)
    style = get(tf.attributes, :style, Styles())
    css = isnothing(style) ? Styles() : Styles(BUTTON_STYLE, style)
    autocomplete = get(tf.attributes, :autocomplete, "off")
    return jsrender(
        session,
        DOM.input(;
            type="textfield",
            value=tf.value,
            onchange=js"event => $(tf.value).notify(event.srcElement.value);",
            tf.attributes...,
            style=css,
            autocomplete=autocomplete,
        ),
    )
end

const NUMBERINPUT_EXAMPLE = """
App() do
    style = Styles(
        CSS("font-weight" => "500"),
        CSS(":hover", "background-color" => "silver"),
        CSS(":focus", "box-shadow" => "rgba(0, 0, 0, 0.5) 0px 0px 5px"),
    )
    numberinput = NumberInput(0.0; style=style)
    on(numberinput.value) do value::Float64
        @info value
    end
    return numberinput
end
"""

"""
    NumberInput(default_value; style=Styles(), dom_attributes...)

A simple NumberInput, which can be styled via the `style::Styles` attribute, `style=nothing`
turns off the default Bonito styling.

### Example

```julia
$(NUMBERINPUT_EXAMPLE)
```
"""
NumberInput

function jsrender(session::Session, ni::NumberInput)
    style = get(ni.attributes, :style, Styles())
    css = isnothing(style) ? Styles() : Styles(BUTTON_STYLE, style)
    autocomplete = get(ni.attributes, :autocomplete, "off")
    return jsrender(
        session,
        DOM.input(;
            type="number",
            value=ni.value,
            onchange=js"event => {
                const new_value = parseFloat(event.srcElement.value);
                if ($(ni.value).value != new_value) {
                    $(ni.value).notify(new_value);
                }
            }",
            ni.attributes...,
            style=css,
            autocomplete=autocomplete,
        ),
    )
end

const DROPDOWN_EXAMPLE = """
App() do
    style = Styles(
        CSS("font-weight" => "500"),
        CSS(":hover", "background-color" => "silver"),
        CSS(":focus", "box-shadow" => "rgba(0, 0, 0, 0.5) 0px 0px 5px"),
    )
    dropdown = Dropdown(["a", "b", "c"]; index=2, style=style)
    on(dropdown.value) do value
        @info value
    end
    return dropdown
end
"""

"""
    Dropdown(options; index=1, option_to_string=string, style=Styles(), dom_attributes...)

A simple Dropdown, which can be styled via the `style::Styles` attribute, `style=nothing`
turns off the default Bonito styling.

### Example

```julia
$(DROPDOWN_EXAMPLE)
```
"""
struct Dropdown
    options::Observable{Vector{Any}}
    value::Observable{Any}
    option_to_string::Function
    option_index::Observable{Int}
    attributes::Dict{Symbol,Any}
    style::Styles
end

function Dropdown(options; index=1, option_to_string=string, style=Styles(), attributes...)
    option_index = convert(Observable{Int}, index)
    options = convert(Observable{Vector{Any}}, options)
    option = Observable{Any}(options[][option_index[]])
    onany(option_index, options) do index, options
        option[] = options[index]
        return nothing
    end
    css = isnothing(style) ? Styles() : Styles(BUTTON_STYLE, style)
    return Dropdown(
        options, option, option_to_string, option_index, Dict{Symbol,Any}(attributes), css
    )
end

function jsrender(session::Session, dropdown::Dropdown)
    string_options = map(x-> map(dropdown.option_to_string, x), session, dropdown.options)
    onchange = js"""
    function onload(element) {
        function onchange(e) {
            if (element === e.srcElement) {
                ($(dropdown.option_index)).notify(element.selectedIndex + 1);
            }
        }
        element.addEventListener("change", onchange);
        element.selectedIndex = $(dropdown.option_index[] - 1)
        function set_option_index(index) {
            if (element.selectedIndex === index - 1) {
                return
            }
            element.selectedIndex = index - 1;
        }
        $(dropdown.option_index).on(set_option_index);
        function set_options(opts) {
            element.selectedIndex = 0;
            // https://stackoverflow.com/questions/3364493/how-do-i-clear-all-options-in-a-dropdown-box
            element.options.length = 0;
            opts.forEach((opt, i) => element.options.add(new Option(opts[i], i)));
        }
        $(string_options).on(set_options);
    }
    """
    option2div(x) = DOM.option(x)
    dom = map(options -> map(option2div, options), session, string_options)[]

    autocomplete = get(dropdown.attributes, :autocomplete, "off")
    select = DOM.select(dom; style=dropdown.style, dropdown.attributes..., autocomplete=autocomplete)
    Bonito.onload(session, select, onchange)
    return jsrender(session, select)
end


abstract type AbstractSlider{T} <: WidgetsBase.AbstractWidget{T} end

struct Slider{T} <: AbstractSlider{T}
    values::Observable{Vector{T}}
    value::Observable{T}
    index::Observable{Int}
    attributes::Dict{Symbol,Any}
end

function Slider(values::AbstractArray{T}; value=first(values), kw...) where {T}
    values_obs = convert(Observable{Vector{T}}, values)
    initial_idx = findfirst((==)(value), values_obs[])
    index = Observable(initial_idx)
    value_obs = Observable(values_obs[][initial_idx])
    return Slider(values_obs, value_obs, index, Dict{Symbol,Any}(kw))
end

function jsrender(session::Session, slider::Slider)
    # Hacky, but don't want to Pr WidgetsBase yet
    values = slider.values
    index = slider.index
    onjs(
        session,
        index,
        js"""(index) => {
            const values = $(values).value
            $(slider.value).notify(values[index - 1])
        }
        """,
    )

    autocomplete = get(slider.attributes, :autocomplete, "off")
    return jsrender(
        session,
        DOM.input(;
            type="range",
            min=1,
            max=map(length, values),
            value=index,
            step=1,
            oninput=js"""(event)=> {
                const idx = event.srcElement.valueAsNumber;
                if (idx !== $(index).value) {
                    $(index).notify(idx)
                }
            }""",
            style=styles,
            slider.attributes...,
            autocomplete=autocomplete,
        ),
    )
end

function Base.setindex!(slider::AbstractSlider, value)
    # should be only numbers right now, which should also be sorted
    # This may change once we allow `Slider(array)` in WidgetsBase
    values = slider.values
    idx = findfirst(x -> x >= value, values[])

    if isnothing(idx)
        @warn(
            "Value $(value) out of range for the values of slider (highest value: $(last(values[]))). Setting to highest value!"
        )
        idx = length(values[])
    end
    slider.index[] = idx
    return idx
end


const CHECKBOX_EXAMPLE = """
App() do
    style = Styles(
        CSS(":hover", "background-color" => "silver"),
        CSS(":focus", "box-shadow" => "rgba(0, 0, 0, 0.5) 0px 0px 5px"),
    )
    checkbox = Checkbox(true; style=style)
    on(checkbox.value) do value::Bool
        @info value
    end
    return checkbox
end
"""

"""
    Checkbox(default_value; style=Styles(), dom_attributes...)

A simple Checkbox, which can be styled via the `style::Styles` attribute.
"""
Checkbox

function jsrender(session::Session, tb::Checkbox)
    default_style = Styles(
        BUTTON_STYLE, Styles("min-width" => "auto", "transform" => "scale(1.5)")
    )
    css = Styles(default_style, get(tb.attributes, :style, Styles()))
    autocomplete = get(tb.attributes, :autocomplete, "off")
    return jsrender(
        session,
        DOM.input(;
            type="checkbox",
            checked=tb.value,
            onchange=js"""event=> $(tb.value).notify(event.srcElement.checked);""",
            tb.attributes...,
            style=css,
            autocomplete=autocomplete,
        ),
    )
end

# TODO, clean this up
const noUiSlider = ES6Module(dependency_path("nouislider.min.js"))
const noUiSliderCSS = Asset(dependency_path("noUISlider.css"))

function jsrender(session::Session, slider::RangeSlider)
    args = (slider.range, slider.connect, slider.orientation, slider.tooltips, slider.ticks)
    style = map(session, args...) do range, connect, orientation, tooltips, ticks
        value = slider.value[]
        return Dict(
            "range" => Dict("min" => range[1], "max" => range[end]),
            "step" => step(range),
            # Too strongly typed and we get a TypedArray in JS which doesn't work with noUiSlider
            "start" => Any[value...],
            "connect" => connect,
            "tooltips" => tooltips,
            "direction" => "ltr",
            "orientation" => string(orientation),
            "pips" => isempty(ticks) ? nothing : ticks,
        )
    end
    rangediv = DOM.div()

    create_slider = js"""
    function create_slider(style){
        const range = $(rangediv);
        range.noUiSlider.updateOptions(style, true);
    }"""
    on_range = js"""function onload(range){
        const style = $(style[]);
        $(noUiSlider).then(NUS=> {
            NUS.create(range, style);
            range.noUiSlider.on('update', function (values, handle, unencoded, tap, positions){
                $(slider.value).notify([parseFloat(values[0]), parseFloat(values[1])]);
            });
        })
    }"""
    onload(session, rangediv, on_range)
    onjs(session, style, create_slider)
    return DOM.div(jsrender(session, noUiSliderCSS), rangediv)
end

"""
A simple wrapper for types that conform to the Tables.jl Table interface,
which gets rendered nicely!
"""
struct Table
    table
    class::String
    row_renderer::Function  # For backwards compatibility - kept but deprecated
    class_callback::Function
    style_callback::Function
    allow_row_sorting::Bool
    allow_column_sorting::Bool
end

render_row_value(x) = x
render_row_value(x::Missing) = "n/a"

# Default color callback - returns neutral for all cells
default_class_callback(table, row, col, val) = "table-cell cell-neutral"

function Table(table;
               class="",
               row_renderer=render_row_value,  # Kept for backwards compatibility
               class_callback=(args...) -> "cell-default",
               style_callback=(args...) -> "",
               allow_row_sorting=true,
               allow_column_sorting=true)
    return Table(table, class, row_renderer, class_callback, style_callback, allow_row_sorting, allow_column_sorting)
end

const TableStyles = Styles(
    CSS(
        ".comparison-table",
        "border-collapse" => "collapse",
        "width" => "100%",
        "font-family" => "Arial, sans-serif",
    ),
    CSS(
        ".table-header",
        "background-color" => "#f5f5f5",
        "border" => "1px solid #ddd",
        "padding" => "8px",
        "text-align" => "left",
        "font-weight" => "bold",
        "cursor" => "pointer",
        "user-select" => "none",
    ),
    CSS(
        ".table-header:hover",
        "background-color" => "#e9e9e9",
    ),
    CSS(
        ".table-cell",
        "border" => "1px solid #ddd",
        "padding" => "8px",
        "text-align" => "left",
    ),
    CSS(
        ".table-row:hover .table-cell",
        "background-color" => "#f9f9f9",
    ),
    CSS(
        ".cell-good",
        "background-color" => "#d4edda",
        "color" => "#155724",
    ),
    CSS(
        ".cell-bad",
        "background-color" => "#f8d7da",
        "color" => "#721c24",
    ),
    CSS(
        ".cell-neutral",
        "background-color" => "#fff3cd",
        "color" => "#856404",
    ),
    CSS(
        ".cell-default",
        "background-color" => "white",
        "color" => "black",
    ),
    CSS(
        ".table-container",
        "overflow-x" => "auto",
    ),
)

function jsrender(session::Session, table::Table)
    # Get table structure
    schema = Tables.schema(table.table)
    rows_data = collect(Tables.rows(table.table))

    # Get column names - handle case when schema is nothing
    column_names = if schema !== nothing && schema.names !== nothing
        schema.names
    elseif !isempty(rows_data)
        keys(first(rows_data))
    else
        ()  # Empty table
    end

    # Create header row with optional click handlers for column sorting
    header_cells = []
    for (col_idx, col_name) in enumerate(column_names)
        push!(header_cells, DOM.th(col_name; class = "table-header", dataColumn = col_idx - 1))
    end
    header_row = DOM.tr(header_cells...)

    # Create data rows
    data_rows = []
    for (row_idx, row) in enumerate(rows_data)
        cells = []
        for (col_idx, val) in enumerate(values(row))
            # Apply formatter callback (preferred) or fall back to row_renderer for backwards compatibility
            formatted_val = table.row_renderer(val)
            # Determine cell class using color callback
            cell_class = table.class_callback(table.table, row_idx, col_idx, val)
            style = table.style_callback(table.table, row_idx, col_idx, val)
            push!(cells, DOM.td(formatted_val; class = "table-cell $cell_class", dataValue = val, style=style))
        end
        push!(data_rows, DOM.tr(cells...; dataRow = row_idx-1, class="table-row"))
    end

    # Create the complete table
    table_dom = DOM.table(
        DOM.thead(header_row),
        DOM.tbody(data_rows...),
        class="comparison-table $(table.class)"
    )

    table_container = DOM.div(
        TableStyles,
        table_dom,
        class="table-container"
    )

    # JavaScript for interactive sorting
    sort_script = if table.allow_row_sorting || table.allow_column_sorting
        js"""
        (function() {
            const container = $(table_container);
            let sort_directions = {};
            const table = container.querySelector('.comparison-table');
            const tbody = table.querySelector('tbody');
            const thead = table.querySelector('thead');

            function sort_table_by_column(column_index) {
                if (!$(table.allow_column_sorting)) return;

                const current_direction = sort_directions['col_' + column_index] || 'asc';
                const new_direction = current_direction === 'asc' ? 'desc' : 'asc';
                sort_directions['col_' + column_index] = new_direction;

                const rows = Array.from(tbody.children);
                rows.sort((a, b) => {
                    const a_value = a.children[column_index].getAttribute('data-value');
                    const b_value = b.children[column_index].getAttribute('data-value');

                    if (!a_value || a_value === '') return 1;
                    if (!b_value || b_value === '') return -1;

                    const a_num = parseFloat(a_value);
                    const b_num = parseFloat(b_value);

                    let comparison = 0;
                    if (!isNaN(a_num) && !isNaN(b_num)) {
                        comparison = a_num - b_num;
                    } else {
                        comparison = a_value.localeCompare(b_value);
                    }

                    return new_direction === 'asc' ? comparison : -comparison;
                });

                tbody.innerHTML = '';
                rows.forEach(row => tbody.appendChild(row));
            }

            function sort_row_by_values(row_index) {
                if (!$(table.allow_row_sorting)) return;

                const current_direction = sort_directions['row_' + row_index] || 'asc';
                const new_direction = current_direction === 'asc' ? 'desc' : 'asc';
                sort_directions['row_' + row_index] = new_direction;

                const data_row = tbody.children[row_index];
                const header_row = thead.querySelector('tr');

                const cells = Array.from(data_row.children);
                const attribute_cell = cells[0];
                const data_cells = cells.slice(1);

                const header_cells = Array.from(header_row.children);
                const attribute_header = header_cells[0];
                const data_headers = header_cells.slice(1);

                const cell_header_pairs = data_cells.map((cell, idx) => ({
                    cell: cell,
                    header: data_headers[idx],
                    value: cell.getAttribute('data-value')
                }));

                cell_header_pairs.sort((a, b) => {
                    const a_value = a.value;
                    const b_value = b.value;

                    if (!a_value || a_value === '') return 1;
                    if (!b_value || b_value === '') return -1;

                    const a_num = parseFloat(a_value);
                    const b_num = parseFloat(b_value);

                    let comparison = 0;
                    if (!isNaN(a_num) && !isNaN(b_num)) {
                        comparison = a_num - b_num;
                    } else {
                        comparison = a_value.localeCompare(b_value);
                    }

                    return new_direction === 'asc' ? comparison : -comparison;
                });

                data_row.innerHTML = '';
                header_row.innerHTML = '';

                data_row.appendChild(attribute_cell);
                header_row.appendChild(attribute_header);

                cell_header_pairs.forEach(pair => {
                    data_row.appendChild(pair.cell);
                    header_row.appendChild(pair.header);
                });

                // Update all other rows to match the new column order
                Array.from(tbody.children).forEach((row, idx) => {
                    if (idx !== row_index) {
                        const row_cells = Array.from(row.children);
                        const row_attribute_cell = row_cells[0];
                        const row_data_cells = row_cells.slice(1);

                        const reordered_cells = cell_header_pairs.map(pair => {
                            const original_index = data_cells.indexOf(pair.cell);
                            return row_data_cells[original_index];
                        });

                        row.innerHTML = '';
                        row.appendChild(row_attribute_cell);
                        reordered_cells.forEach(cell => row.appendChild(cell));
                    }
                });
            }

            // Add column header click listeners
            if ($(table.allow_column_sorting)) {
                Array.from(thead.querySelectorAll('.table-header')).forEach((header, index) => {
                    header.addEventListener('click', function() {
                        sort_table_by_column(index);
                    });
                });
            }

            // Add row sorting listeners (first cell of each row)
            if ($(table.allow_row_sorting)) {
                Array.from(tbody.children).forEach((row, row_index) => {
                    const first_cell = row.children[0];
                    if (first_cell) {
                        first_cell.style.cursor = 'pointer';
                        first_cell.style.userSelect = 'none';
                        first_cell.addEventListener('click', function() {
                            sort_row_by_values(row_index);
                        });
                    }
                });
            }
        })();
        """
    else
        nothing
    end

    return jsrender(session, DOM.div(
        table_container,
        sort_script
    ))
end

struct CodeEditor
    theme::String
    language::String
    options::Dict{String,Any}
    onchange::Observable{String}
    element::Hyperscript.Node{Hyperscript.HTMLSVG}
end

"""
    CodeEditor(language::String; initial_source="", theme="chrome", editor_options...)

Defaults for `editor_options`:
```
(
    autoScrollEditorIntoView = true,
    copyWithEmptySelection = true,
    wrapBehavioursEnabled = true,
    useSoftTabs = true,
    enableMultiselect = true,
    showLineNumbers = false,
    fontSize = 16,
    wrap = 80,
    mergeUndoDeltas = "always"
)
```
The content of the editor (as a string) is updated in `editor.onchange::Observable`.
"""
function CodeEditor(
    language::String;
    height=500,
    initial_source="",
    theme="chrome",
    style=Styles(),
    editor_options...,
)
    defaults = Dict(
        "autoScrollEditorIntoView" => true,
        "copyWithEmptySelection" => true,
        "wrapBehavioursEnabled" => true,
        "useSoftTabs" => true,
        "enableMultiselect" => true,
        "showLineNumbers" => false,
        "fontSize" => 16,
        "vScrollBarAlwaysVisible" => false,
        "hScrollBarAlwaysVisible" => false,
        "wrap" => 80,
        "mergeUndoDeltas" => "always",
        "showGutter" => false,
        "highlightActiveLine" => false,
        "displayIndentGuides" => false,
        "showPrintMargin" => false,
    )
    user_opts = Dict{String,Any}(string(k) => v for (k, v) in editor_options)
    options = Dict{String,Any}(merge(defaults, user_opts))
    onchange = Observable(initial_source)
    style = Styles(
        Styles(
            "position" => "relative",
            "height" => "$(height)px",
        ),
        style,
    )
    element = DOM.div(""; style=style)
    return CodeEditor(theme, language, options, onchange, element)
end

function jsrender(session::Session, editor::CodeEditor)
    theme = "ace/theme/$(editor.theme)"
    language = "ace/mode/$(editor.language)"
    ace = Asset("https://cdn.jsdelivr.net/gh/ajaxorg/ace-builds/src-min/ace.js")
    setup = js"""
        $(ace).then((ace) => {
            const element = $(editor.element);
            const editor = ace.edit(element, {
                mode: $(language)
            });
            editor.setTheme($theme);
            editor.getSession().setUseWrapMode(true)
            // use setOptions method to set several options at once
            editor.setOptions($(editor.options));

            editor.session.on('change', function(delta) {
                $(editor.onchange).notify(editor.getValue());
            });
            editor.session.setValue($(editor.onchange).value);
            function resizeEditor() {
                const height = editor.getSession().getScreenLength() *
                    (editor.renderer.lineHeight + editor.renderer.scrollBar.getWidth());
                editor.container.style.height = `${height}px`;
            }
            // Resize the editor initially
            resizeEditor();
        });
    """
    return jsrender(session, DOM.div(editor.element, setup))
end

# Ok, this is bad piracy, but I donno how else to make the display nice for now!
function Base.show(io::IO, m::MIME"text/html", widget::WidgetsBase.AbstractWidget)
    return show(io, m, App(widget))
end


struct FileInput <: Bonito.WidgetsBase.AbstractWidget{String}
    value::Observable{Vector{String}}
    multiple::Bool
end

FileInput(value::Observable{Vector{String}}; multiple = true) = FileInput(Observable([""]), multiple)
FileInput(; kws...) = FileInput(Observable([""]); kws...)

function Bonito.jsrender(session::Session, fi::FileInput)
    onchange = js"""event => {
        if (event.target.files) {
            const files = [];
            for (const file of event.target.files) {
                files.push(URL.createObjectURL(file))
            }
            $(fi.value).notify(files);
        }
    }"""
    return DOM.input(; type="file", onchange=onchange, multiple=fi.multiple)
end

# ChoicesBox

const CHOICESBOX_EXAMPLE = """
App() do
    # Create a combo box with some sample options
    fruits = ["Apple", "Banana", "Cherry", "Date", "Elderberry", "Fig", "Grape"]

    # Configure Choices.js parameters
    params = ChoicesJSParams(
        searchPlaceholderValue="Type to search fruits...",
        searchEnabled=true,
        shouldSort=true,
        searchResultLimit=5
    )
    combobox = ChoicesBox(fruits;
        initial_value="Apple",
        choicejsparams=params
    )

    # Display selected value
    selected_display = map(combobox.value) do value
        isnothing(value) ? "No selection" : "Selected: \$value"
    end

    # Handle value changes
    on(combobox.value) do value
        @info "ComboBox value changed to: \$value"
    end

    return DOM.div(
        DOM.h2("Choices.js ComboBox Example"),
        DOM.p("This combo box allows you to select from predefined options or type your own:"),
        combobox,
        DOM.p(selected_display, style="margin-top: 20px; font-weight: bold;")
    )
end

"""

# External JavaScript library assets
# https://github.com/Choices-js/Choices/blob/main/README.md
const ChoicesJS = ES6Module(dependency_path("choices.min.js"))
const ChoicesCSS = Asset(dependency_path("choices.min.css"))

"""
    ChoicesJSParams(; kwargs...)

Wrapper struct for parameters to the ChoicesJS `Choices` constructor.

Parameters include search functionality, rendering options, and behavior settings
for the Choices.js library. See the official documentation for complete parameter
reference: https://github.com/Choices-js/Choices/blob/main/README.md

# Fields
- `addItems::Bool`: Allow adding of items (default: true)
- `itemSelectText::String`: Text shown when hovering over selectable items
- `placeholder::Bool`: Show placeholder text (default: true)
- `placeholderValue::String`: Placeholder text to display
- `removeItemButton::Bool`: Show remove button on items (default: false)
- `renderChoiceLimit::Int`: Limit choices rendered (-1 for no limit)
- `searchEnabled::Bool`: Enable search functionality (default: true)
- `searchPlaceholderValue::String`: Search input placeholder text
- `searchResultLimit::Int`: Limit search results (default: 4)
- `shouldSort::Bool`: Sort choices alphabetically (default: true)
"""
Base.@kwdef struct ChoicesJSParams
    addItems::Bool = true
    itemSelectText::String = "Press to select"
    placeholder::Bool = true
    placeholderValue::String = ""
    removeItemButton::Bool = false
    renderChoiceLimit::Int = -1
    searchEnabled::Bool = true
    searchPlaceholderValue::String = ""
    searchResultLimit::Int = 4
    shouldSort::Bool = true
end

function (c::ChoicesJSParams)()
    return js"""
    {
        addItems: $(c.addItems),
        itemSelectText: $(c.itemSelectText),
        placeholder: $(c.placeholder),
        placeholderValue: $(c.placeholderValue),
        removeItemButton: $(c.removeItemButton),
        renderChoiceLimit: $(c.renderChoiceLimit),
        searchEnabled: $(c.searchEnabled),
        searchPlaceholderValue: $(c.searchPlaceholderValue),
        searchResultLimit: $(c.searchResultLimit),
        shouldSort: $(c.shouldSort),
        // fixed params
        items: [],
        choices: []

    }
    """
end

"""
    ChoicesBox(options; initial_value="", choicejsparams=ChoicesJSParams(...), attributes...)

A combo box widget using the Choices.js library that allows both text input and selection from predefined options.
Users can either select from the dropdown list or type their own custom values.

# Fields
- `options::Observable{Vector{String}}`: Available dropdown options
- `value::Observable{String}`: Current selected or typed value
- `choicejsparams::ChoicesJSParams`: Choices.js configuration parameters
- `attributes::Dict{Symbol, Any}`: DOM attributes applied to the element

    ChoicesBox(options; initial_value="", choicejsparams=ChoicesJSParams(...), attributes...)

Constructor for creating a ChoicesBox widget.

# Arguments
- `options`: Vector or Observable of string options for the dropdown
- `initial_value=""`: Initial selected value
- `choicejsparams=ChoicesJSParams(searchPlaceholderValue="Type here...")`: Choices.js configuration
- `attributes...`: Additional DOM attributes

# Returns
- `ChoicesBox`: A configured combo box widget instance

# Example

```julia
$(CHOICESBOX_EXAMPLE)
```
"""
struct ChoicesBox
    options::Observable{Vector{String}}
    value::Observable{Union{Nothing,String}}
    choicejsparams::ChoicesJSParams
    attributes::Dict{Symbol, Any}
end


function ChoicesBox(options; choicejsparams = ChoicesJSParams(), attributes...)
    options = convert(Observable{Vector{String}}, options)
    value = Observable{Union{Nothing,String}}(nothing)

    return ChoicesBox(
        convert(Observable{Vector{String}}, options),
        value,
        choicejsparams,
        attributes
    )
end

function jsrender(session::Session, choicesbox::ChoicesBox)
    # Map options to option elements
    option_elements = map(choicesbox.options) do options
        return map(o->DOM.option(o, value = o), options)
    end
    selectDOM = map(opts->DOM.select(opts..., class = "choicesbox"), option_elements)[]

    # Choices.js initialization and event handling
    choices_script = js"""
        function initChoices(selectElement) {
            // Wait for Choices.js to load
            if (typeof Choices === 'undefined') {
                // console.log("Wait for Choices.js to load")
                setTimeout(() => initChoices(selectElement), 100);
                return;
            }
            const choices = new Choices(selectElement, $(choicesbox.choicejsparams()));

            // Handle value changes
            selectElement.addEventListener('change', function(event) {
                // console.log("Handle value changes", event.detail.value || event.target.value)
                $(choicesbox.value).notify(event.detail.value || event.target.value);
            });

            // Update choices when options change
            $(choicesbox.options).on(function(newOptions) {
                // console.log("Update choices when options change", newOptions)
                choices.clearStore();
                newOptions.forEach(option => {
                    choices.setChoices([{value: option, label: option}], 'value', 'label', false);
                });
                $(choicesbox.value).notify(null);
            });

            // Update value when observable changes
            $(choicesbox.value).on(function(newValue) {
                // console.log("Update value when observable changes", newValue)
                if (choices.getValue(true) !== newValue) {
                    choices.setChoiceByValue(newValue);
                }
            });

        }

        initChoices($(selectDOM));
    """
    return Bonito.jsrender(
        session,
        DOM.div(ChoicesJS, ChoicesCSS, selectDOM, choices_script; choicesbox.attributes...),
    )
end

using Bonito, FileIO, Colors, Observables
using Bonito.DOM
using Bonito: App
Bonito.browser_display()
dir = mktempdir()
for i in 1:5
    save(joinpath(dir, "img$i.jpg"), rand(RGB{Colors.N0f8}, 200, 200))
end

app = App() do
    files = Bonito.Asset.(joinpath.(dir, filter(x-> endswith(x, ".jpg"), readdir(dir))))
    slider = Bonito.Slider(1:length(files))
    image_obs = Observable(first(files))
    img = DOM.img(src=image_obs, style="height: 200px;")
    on(slider) do idx
        image_obs[] = files[idx]
    end
    return DOM.div(slider, img)
end

using Deno_jll, Bonito
using Documenter

ci = get(ENV, "CI", "false") == "true"
makedocs(
    modules=[Bonito],
    sitename="Bonito",
    clean=false,
    format=Documenter.HTML(prettyurls=false, size_threshold=300000),
    authors="Simon Danisch and other contributors",
    pages=[
        "Home" => "index.md",
        "App" => "app.md",
        "Components" => [
            "Styling" => "styling.md",
            "Components" => "components.md",
            "Layouting" => "layouting.md",
            "Widgets" => "widgets.md",
            "Interactions" => "interactions.md",
        ],
        "Examples" => [
            "Plotting" => "plotting.md",
            "Wrapping JS libraries" => "javascript-libraries.md",
            "Assets" => "assets.md",
            "Extending" => "extending.md",
        ],
        "Handlers" => "handlers.md",
        "Deployment" => "deployment.md",
        "Static Sites" => "static.md",
        "Api" => "api.md",
    ]
)

if ci
    deploydocs(repo="github.com/SimonDanisch/Bonito.jl.git"; push_preview=true)
end

abstract type RunnerLike end

struct NoRunner <: RunnerLike end

struct ModuleRunner <: RunnerLike
    mod::Module
    current_session::Ref{Union{Session,Nothing}}
end
ModuleRunner(mod::Module) = ModuleRunner(mod, Ref{Union{Session,Nothing}}(nothing))

function Base.eval(md::ModuleRunner, expr)
    return md.mod.eval(md.mod, expr)
end

struct EvalMarkdown
    markdown::String
    runner::RunnerLike
    replacements::Dict{Any,Function}
end

function EvalMarkdown(
        markdown::String; runner=NoRunner(), replacements=Dict{Any,Function}()
    )
    return EvalMarkdown(markdown, runner, replacements)
end

function jsrender(session::Session, em::EvalMarkdown)
    runner = em.runner
    if hasproperty(runner, :current_session)
        runner.current_session[] = session
    end
    md = string_to_markdown(em.markdown, em.replacements; eval_julia_code=runner)
    if hasproperty(runner, :counter)
        runner.counter = 0 # reset counter if any present
    end
    return jsrender(session, md)
end

function jsrender(session::Session, md::Markdown.MD)
    md_div = DOM.div(md_html(md.content)...; class="markdown-body")
    return jsrender(session, md_div)
end

function md_html(content::Vector)
    return map(md_html, content)
end

function md_html(header::Markdown.Header{l}) where l
    title = header.text
    id = length(title) == 1 && title[1] isa String ? title[1] : ""
    return [DOM.m("h$l", htmlinline(header.text)...; id=id)]
end

function md_html(code::Markdown.Code)
    if code.language == "latex"
        return [KaTeX(code.code)]
    end
    maybe_lang = !isempty(code.language) ? Any[:class=>"language-$(code.language)"] : []
    return [DOM.m("pre", DOM.m("code", code.code; maybe_lang...))]
end

function md_html(md::Markdown.Paragraph)
    return [DOM.p(htmlinline(md.content)...)]
end

function md_html(md::Markdown.BlockQuote)
    return [DOM.m("blockquote", md_html(md.content)...)]
end

function md_html(f::Markdown.Footnote)
    return [DOM.div(DOM.p(f.id; class="footnote-title"), md_html(f.text)...;
                          class="footnote", id="footnote-$(f.id)")]
end

function md_html(md::Markdown.Admonition)
    title = DOM.p(md.title; class="admonition-title")
    return [DOM.div(title; class="admonition $(md.category)")]
end

function md_html(md::Markdown.List)
    maybe_attr = md.ordered > 1 ? Any[:start => string(md.ordered)] : []
    tag = Markdown.isordered(md) ? "ol" : "ul"
    style = Styles("list-style-type" => "disc")
    return [DOM.m(
        tag, maybe_attr...,
        map(md.items) do item
            DOM.m("li", md_html(item)...)
        end...
        ; style=style)]
end

function md_html(md::Markdown.HorizontalRule)
    return [DOM.m_unesc("hr")]
end

function md_html(md::Markdown.Table)
    content = map(enumerate(md.rows)) do (i, row)
        tr_content = map(enumerate(md.rows[i])) do (j, c)
            alignment = md.align[j]
            alignment = alignment === :l ? "left" : alignment === :r ? "right" : "center"
            return DOM.m(i == 1 ? "th" : "td", htmlinline(c)...; align=alignment)
        end
        return DOM.m("tr", tr_content...)
    end
    return [DOM.m("table", content...)]
end

function htmlinline(content::Vector)
    return [htmlinline.(content)...]
end

function htmlinline(code::Markdown.Code)
    return [DOM.m("code", code.code)]
end

function htmlinline(md::Union{Symbol, AbstractString})
    return [md]
end

function htmlinline(md::Markdown.Bold)
    return [DOM.m("strong", htmlinline(md.text)...)]
end

function htmlinline(md::Markdown.Italic)
    return [DOM.m("em", htmlinline(md.text)...)]
end

function htmlinline(md::Markdown.Image)
    file, ext = splitext(md.url)
    if ext in (".mp4", ".webm", ".ogg")
        return [DOM.m("video", DOM.m("source"; src=md.url, type="video/$(ext[2:end])"), autoplay=true, controls=true)]
    end
    return [DOM.m("img"; src=md.url, alt=md.alt)]
end

function htmlinline(f::Markdown.Footnote)
    return [DOM.m("a", string("[", f.id, "]"); href="#footnote-$(f.id)", class="footnote")]
end

function htmlinline(link::Markdown.Link)
    return [DOM.m("a", href = link.url, htmlinline(link.text)...)]
end

function htmlinline(latex::Markdown.LaTeX)
    return [KaTeX(latex.formula)]
end


function htmlinline(br::Markdown.LineBreak)
    return [DOM.m("br")]
end

htmlinline(x) = [x]
md_html(x) = [x]

function render_result(result)
    if Tables.istable(result)
        return Table(result)
    else
        return DOM.span(result)
    end
end

"""
    replace_expressions(markdown, context)
Replaces all expressions inside `markdown` savely, by only supporting
getindex/getfield expression that will index into `context`
"""
function replace_expressions(markdown::MT, replacements::Dict, runner::RunnerLike) where {MT}
    if haskey(replacements, MT)
        return replacements[MT](markdown)
    end
    if markdown isa Union{Expr, Symbol}
        return markdown
    end
    if hasproperty(markdown, :content)
        markdown.content .= replace_expressions.(markdown.content, (replacements,), (runner,))
    elseif hasproperty(markdown, :text)
        markdown.text .= replace_expressions.(markdown.text, (replacements,), (runner,))
    elseif hasproperty(markdown, :rows)
        # Those are some deeply nested rows!
        map!(markdown.rows, markdown.rows) do row
            map(r-> replace_expressions.(r, (replacements,), (runner,)), row)
        end
    end
    return markdown
end

function parseall(str)
    pos = firstindex(str)
    exs = []
    while pos <= lastindex(str)
        ex, pos = Meta.parse(str, pos)
        push!(exs, ex)
    end
    if length(exs) == 0
        throw(Base.ParseError("end of input"))
    elseif length(exs) == 1
        return exs[1]
    else
        return Expr(:block, exs...)
    end
end



function replace_expressions(
        markdown::Markdown.Code, replacements::Dict, runner::RunnerLike
    )
    if haskey(replacements, Markdown.Code)
        return replacements[Markdown.Code](markdown)
    end
    if markdown.language == "julia" && !(runner isa NoRunner)
        hide = occursin("# hide", markdown.code)
        no_eval = occursin("# no-eval", markdown.code)
        md_expr = hide ? "" : markdown
        if no_eval
            markdown.code = replace(markdown.code, "# no-eval" => "")
            evaled = nothing
        else
            expr = parseall(markdown.code)
            evaled = Base.eval(runner, expr)
        end
        if !isnothing(evaled)
            return Markdown.MD([md_expr, evaled])
        else
            return md_expr
        end
    else
        return markdown
    end
end

"""
    string_to_markdown(source::String; eval_julia_code=false)

Replaces all interpolation expressions inside `markdown` savely, by only supporting
getindex/getfield expression that will index into `context`.
You can eval Julia code blocks by setting `eval_julia_code` to a Module, into which
the code gets evaluated!
"""
function string_to_markdown(source::String, replacements=Dict{Any, Function}(); eval_julia_code=NoRunner())
    if eval_julia_code == false
        runner = NoRunner()
    elseif eval_julia_code isa Module
        runner = ModuleRunner(eval_julia_code)
    elseif eval_julia_code isa RunnerLike
        runner = eval_julia_code
    else
        error("Unsupported type for `eval_julia_code`: $(eval_julia_code). Supported are `false`, a Module to eval in, or a `Bonito.RunnerLike`.")
    end
    markdown = Markdown.parse(source)
    return replace_expressions(markdown, replacements, runner)
end

debugser(x, level) = nothing;#println(" "^level, typeof(x))
debugser(x::Observable, level) = nothing# println(" "^level, x.id)

function debugser(node::Node, level)
    # return println(" "^level, "DOM")
end

function debugser(x::Vector{T}, level) where {T<:Number}
    # return println(" "^level, "TypedVector: ", T)
end

function debugser(x::Union{AbstractArray, Tuple}, level)
    return foreach(x-> debugser(x, level+1), x)
end

function debugser(dict::AbstractDict, level)
    if haskey(dict, "__javascript_type__")
        print(" "^level, dict["__javascript_type__"])
        if dict["__javascript_type__"] == "Reference"
            println(dict["payload"])
        else
            println()
        end
    else
        for (k, v) in dict
            # println(" "^level, k, ":")
            debugser(v, level + 1)
        end
    end
end

debugser(jss::JSString, level) = nothing#println(" "^level, "JSCode")

function debugser(jsc::JSCode, level)
    # println(" "^level, "JSCode")
end

function debugser(asset::Asset, level)
    # println(" "^level, "Asset")
end


function printsize(name, x)
    sz = Base.summarysize(x)
    if sz/10^6 > 0.01
        @info(name, " > ", Base.format_bytes(sz))
    end
end

debug_size(x, level) = printsize(typeof(x), x);#println(" "^level, typeof(x))
debug_size(x::Observable, level) = nothing# println(" "^level, x.id)

function debug_size(node::Node, level)
    # return println(" "^level, "DOM")
end

function debug_size(x::Vector{T}, level) where {T<:Number}
    printsize(typeof(x), x)
end

function debug_size(x::Union{AbstractArray, Tuple}, level)
    return foreach(x-> debug_size(x, level+1), x)
end

function debug_size(dict::AbstractDict, level)
    if haskey(dict, "__javascript_type__")
        printsize(dict["__javascript_type__"], dict["payload"])
    else
        for (k, v) in dict
            # println(" "^level, k, ":")
            debug_size(v, level + 1)
        end
    end
end

debug_size(jss::JSString, level) = nothing#println(" "^level, "JSCode")

function debug_size(jsc::JSCode, level)
    # println(" "^level, "JSCode")
end

function debug_size(asset::Asset, level)
    # println(" "^level, "Asset")
end

using Bonito: Observable, Retain, CacheKey, decode_extension_and_addbits
using Bonito: SerializationContext, serialize_cached, SessionCache
using Bonito, MsgPack, Test

@testset "nested observable serialization order" begin
    # Test that nested observables are serialized in dependency order:
    # inner observables must come before outer observables that reference them via CacheKey.
    # This is critical for static export where JS deserializes the cache and needs to
    # resolve CacheKey references during unpacking.

    session = Bonito.Session(Bonito.NoConnection(); asset_server=Bonito.NoServer())

    inner_a = Observable(rand(3))
    inner_b = Observable(rand(3))
    outer_obs = Observable(Dict("a" => inner_a, "b" => inner_b))

    # Serialize JSCode that references the outer observable
    jscode = js"const x = $(outer_obs)"
    ctx = SerializationContext(session)
    serialize_cached(ctx, jscode)

    # Create SessionCache and do MsgPack round-trip
    cache = SessionCache(session, ctx.message_cache)
    packed = MsgPack.pack(cache)
    unpacked_ext = MsgPack.unpack(packed)
    # Structure: [session_id, session_status, packed_objects_ext]
    # packed_objects_ext is Extension(18) containing packed bytes
    session_id, session_status, packed_objects_ext = MsgPack.unpack(unpacked_ext.data)
    objs_array = MsgPack.unpack(packed_objects_ext.data)

    # objs_array is [value, ...] where values are Observable extensions.
    # Extract the observable id from each extension's data.
    function get_obs_id(ext::MsgPack.Extension)
        # Observable extension data is packed [id, value]
        id_value = MsgPack.unpack(ext.data)
        return id_value[1]
    end

    # Verify order: inner observables should come before outer
    inner_ids = Set([inner_a.id, inner_b.id])
    outer_id = outer_obs.id

    obs_ids = [get_obs_id(obj) for obj in objs_array if obj isa MsgPack.Extension && obj.type == Int8(101)]
    inner_positions = [i for (i, id) in enumerate(obs_ids) if id in inner_ids]
    outer_position = findfirst(id -> id == outer_id, obs_ids)

    @test length(inner_positions) == 2
    @test !isnothing(outer_position)
    @test all(p < outer_position for p in inner_positions)

    close(session)
end

@testset "MsgPack" begin
    data = [
        Observable([1, Dict("a" => rand(1000))]),
        Dict(:a => rand(Float32, 1000), "b" => rand(Float16, 10^6)),
        rand(Int, 100),
        [rand(12), Retain(Observable([2,3,4])), CacheKey("kdjaksjd")]
    ]

    unpacked = Bonito.decode_extension_and_addbits(MsgPack.unpack(MsgPack.pack(data)))
    @test data[1].val == unpacked[1].val
    @test data[2][:a] == unpacked[2]["a"]
    @test data[2]["b"] == unpacked[2]["b"]

    @test data[3] == unpacked[3]
    @test data[4][1] == unpacked[4][1]
    @test data[4][2].value.val == unpacked[4][2].value.val
    @test data[4][3] == unpacked[4][3]
end

# Arrays

@testset "typed array serialization" begin
    data = Dict{String, Array}()
    for T in [Int8, UInt8, Int16, UInt16, Int32, UInt32, Float16, Float32, Float64]
        data["vec_$(T)"] = rand(T, 100)
        data["mat_$(T)"] = rand(T, 100, 100)
        data["vol_$(T)"] = rand(T, 100, 100, 100)

        data["v_vec_$(T)"] = view(data["vec_$(T)"], 5:10)
        data["v_mat_$(T)"] = view(data["mat_$(T)"], 5:10, 5:10)
        data["v_vol_$(T)"] = view(data["vol_$(T)"], 5:10, 5:10, 5:10)
    end
    @testset "round tripping arrays in Julia" begin
        round_tripped = MsgPack.unpack(MsgPack.pack(data))
        for (key, value) in round_tripped
            @test value isa MsgPack.Extension
            if occursin("vec", key)
            else
                @test value.type == 99
            end
        end
    end

    @testset "round tripping arrays in JS" begin
        handler(args...) = DOM.div()
        testsession(handler, port=8558) do app
            roundtripped_js = evaljs(app, js"""$data""")

            for (key, value) in roundtripped_js
                @test value isa MsgPack.Extension
                if !occursin("vec", key)
                    @test value.type == 99
                end
            end
            decoded = decode_extension_and_addbits(roundtripped_js)
            @test decoded == data
        end
    end
end

include("types.jl")
include("msgpack.jl")
include("caching.jl")
include("protocol.jl")

function SerializedMessage(session::Session, data)
    return lock(root_session(session).deletion_lock) do
        ctx = SerializationContext(session)
        message_data = serialize_cached(ctx, data)
        return SerializedMessage(SessionCache(session, ctx.message_cache), message_data, session.compression_enabled)
    end
end

function serialize_binary(sm::SerializedMessage)
    bytes = MsgPack.pack(sm)
    if sm.compression
        bytes = transcode(GzipCompressor, bytes)
    end
    return bytes
end

function BinaryMessage(session::Session, data)
    sm = SerializedMessage(session, data)
    bytes = MsgPack.pack(sm)
    return BinaryMessage(bytes)
end

function serialize_binary(session::Session, msg::BinaryMessage)
    bytes = msg.bytes
    if session.compression_enabled
        bytes = transcode(GzipCompressor, bytes)
    end
    return bytes
end

function serialize_binary(session::Session, data)
    return serialize_binary(session, BinaryMessage(session, data))
end

function deserialize_binary(bytes::AbstractVector{UInt8}, compression_enabled::Bool=false)
    if compression_enabled
        bytes = transcode(GzipDecompressor, bytes)
    end
    return MsgPack.unpack(bytes)
    # return decode_extension_and_addbits()
end

function deserialize(msg::BinaryMessage)
    MsgPack.unpack(msg.bytes)
end

function serialize_string(session::Session, @nospecialize(obj))
    binary = serialize_binary(session, obj)
    return Base64.base64encode(binary)
end

function deserialize_string(b64str::String)
    bytes = Base64.base64decode(b64str)
    return deserialize_binary(bytes)
end

# MsgPack doesn't natively support Float16
MsgPack.msgpack_type(::Type{Float16}) = MsgPack.FloatType()
MsgPack.to_msgpack(::MsgPack.FloatType, x::Float16) = Float32(x)


MsgPack.msgpack_type(::Type{<: AbstractVector{<: JSTypedNumber}}) = MsgPack.ExtensionType()

function real_unsafe_write(io::IOBuffer, data::Array{T}) where T
    @assert isbitstype(T)
    nbytes = sizeof(data)
    Base.ensureroom(io, nbytes)
    ptr = (io.append ? io.size + 1 : io.ptr)
    written = Int(min(nbytes, Int(length(io.data))::Int - ptr + 1))
    GC.@preserve data begin
        Base.unsafe_copyto!(pointer(io.data, ptr), Ptr{UInt8}(pointer(data)), nbytes)
    end
    io.size = max(io.size, ptr - 1 + written)
    if !io.append
        io.ptr += written
    end
    return written
end

convert_for_write(x::Array) = x
convert_for_write(x::Base.ReinterpretArray) = x.parent
convert_for_write(x::AbstractArray) = collect(x)
convert_for_write(x::AbstractArray{Float16,N}) where {N} = convert(Array{Float32,N}, x)
convert_for_write(x::Array{Float16,N}) where {N} = convert(Array{Float32,N}, x)

array_tag(::Type{<: Float16}) = array_tag(Float32)

for (IDX, T) in enumerate(JSTypedArrayEltypes)
    @eval begin
        array_tag(::Type{$T}) = $(Int8(IDX + 0x10))
        function MsgPack.pack_type(io, ::MsgPack.ExtensionType, x::AbstractVector{$T})
            type = $(Int8(IDX + 0x10))
            array = convert_for_write(x)::Vector
            MsgPack.write_extension_header(io, sizeof(array), type)
            real_unsafe_write(io, array)
        end
    end
end

MsgPack.msgpack_type(::Type{<: AbstractVector{Float16}}) = MsgPack.ExtensionType()

function MsgPack.pack_type(io, ext::MsgPack.ExtensionType, x::AbstractVector{Float16})
    return MsgPack.pack_type(io, ext, convert(Vector{Float32}, x))
end

const ARRAY_TAG = Int8(99)
MsgPack.msgpack_type(::Type{<: AbstractArray{<: Union{Float16, JSTypedNumber}}}) = MsgPack.ExtensionType()

_eltype(x) = eltype(x) == Float16 ? Float32 : Float16


function MsgPack.pack_type(io, ::MsgPack.ExtensionType, x::AbstractArray{<:Union{Float16,JSTypedNumber}})
    array = convert_for_write(x)
    dims = pack(UInt32[size(x)...])
    f = MsgPack.ArrayFixFormat(MsgPack.magic_byte_min(MsgPack.ArrayFixFormat) | UInt8(2))
    tagtype = array_tag(eltype(x))
    # Size of the final binary array we attach to the extension
    nbytes = sizeof(f.byte) + sizeof(dims) + MsgPack.ext_header_size(sizeof(array)) + sizeof(array)
    MsgPack.write_extension_header(io, nbytes, ARRAY_TAG)
    write(io, f.byte)
    real_unsafe_write(io, dims)
    MsgPack.write_extension_header(io, sizeof(array), tagtype)
    real_unsafe_write(io, array)
end

const OBSERVABLE_TAG = Int8(101)
const JSCODE_TAG = Int8(102)
const RETAIN_TAG = Int8(103)
const CACHE_KEY_TAG = Int8(104)
const DOM_NODE_TAG = Int8(105)
const SESSION_CACHE_TAG = Int8(106)
const SERIALIZED_MESSAGE_TAG = Int8(107)
const RAW_HTML_TAG = Int8(108)
const TRACKING_ONLY_TAG = Int8(109)

MsgPack.msgpack_type(::Type{<: SerializedObservable}) = MsgPack.ExtensionType()

function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::SerializedObservable)
    return MsgPack.Extension(OBSERVABLE_TAG, pack([x.id, x.value]))
end

MsgPack.msgpack_type(::Type{<: Observable}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::Observable)
    return MsgPack.Extension(OBSERVABLE_TAG, pack([x.id, x[]]))
end

MsgPack.msgpack_type(::Type{SerializedJSCode}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::SerializedJSCode)
    return MsgPack.Extension(JSCODE_TAG, pack([x.interpolated_objects, x.source, x.julia_file]))
end

MsgPack.msgpack_type(::Type{Retain}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::Retain)
    return MsgPack.Extension(RETAIN_TAG, pack(x.value))
end

MsgPack.msgpack_type(::Type{CacheKey}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::CacheKey)
    return MsgPack.Extension(CACHE_KEY_TAG, pack(x.key))
end

MsgPack.msgpack_type(::Type{TrackingOnly}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::TrackingOnly)
    return MsgPack.Extension(TRACKING_ONLY_TAG, pack(x.key))
end

MsgPack.msgpack_type(::Type{SerializedNode}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::SerializedNode)
    return MsgPack.Extension(DOM_NODE_TAG, pack([x.tag, x.children, x.attributes]))
end

MsgPack.msgpack_type(::Type{Base.HTML{String}}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::Base.HTML)
    return MsgPack.Extension(RAW_HTML_TAG, pack(x.content))
end

MsgPack.msgpack_type(::Type{SessionCache}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::SessionCache)
    # Pack: [session_id, session_status, pack(objects)]
    # This lets JS extract session info first, create context, then decode objects
    objects_array = [v for (k, v) in x.objects]
    return MsgPack.Extension(SESSION_CACHE_TAG, pack([x.session_id, x.session_type, pack(objects_array)]))
end

MsgPack.msgpack_type(::Type{BinaryMessage}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::BinaryMessage)
    return MsgPack.Extension(SERIALIZED_MESSAGE_TAG, x.bytes)
end

MsgPack.msgpack_type(::Type{SerializedMessage}) = MsgPack.ExtensionType()
function MsgPack.to_msgpack(::MsgPack.ExtensionType, x::SerializedMessage)
    # Pack: [session_id, session_status, pack(cache), pack(data)]
    # Session info is extracted first to create context, then cache and data are decoded.
    # Cache must be decoded before data so observables are registered.
    session_id = x.cache.session_id
    session_status = x.cache.session_type
    return MsgPack.Extension(SERIALIZED_MESSAGE_TAG, pack([session_id, session_status, pack(x.cache), pack(x.data)]))
end


# The other side does the same (/frontend/common/MsgPack.js), and we decode it here:
function decode_extension_and_addbits(ext::MsgPack.Extension)
    if ext.type == 0x0d
        # the datetime type
        millisecs_since_1970_because_thats_how_computers_work = reinterpret(Int64, ext.data)[1]
        Dates.DateTime(1970) + Dates.Millisecond(millisecs_since_1970_because_thats_how_computers_work)
        # TODO? Dates.unix2datetime does exactly this ?? - DRAL
    else
        if OBSERVABLE_TAG == ext.type
            id_value = MsgPack.unpack(ext.data)
            return Observable(decode_extension_and_addbits(id_value[2]))
        elseif CACHE_KEY_TAG == ext.type
            key = MsgPack.unpack(ext.data)
            return CacheKey(key)
        elseif RETAIN_TAG == ext.type
            value = MsgPack.unpack(ext.data)
            return Retain(decode_extension_and_addbits(value))
        elseif SESSION_CACHE_TAG == ext.type
            value = decode_extension_and_addbits(MsgPack.unpack(ext.data))
            return SessionCache(value...)
        elseif JSCODE_TAG == ext.type
            value = decode_extension_and_addbits(MsgPack.unpack(ext.data))
            # MsgPack.Extension(JSCODE_TAG, pack([x.interpolated_objects, x.source, x.julia_file]))
            return JSCode([JSString(value[2])], value[3])
        elseif DOM_NODE_TAG == ext.type
            tag, children, attributes = decode_extension_and_addbits(MsgPack.unpack(ext.data))
            return Hyperscript.Node{Hyperscript.HTMLSVG}(Hyperscript.DEFAULT_HTMLSVG_CONTEXT, tag, children, attributes)
        elseif ARRAY_TAG == ext.type
            data = MsgPack.unpack(ext.data)
            unpacked = decode_extension_and_addbits(data)
            return reshape(unpacked[2], map(Int, unpacked[1])...)
        else
            idx = Int(ext.type - 0x10)
            if checkbounds(Bool, JSTypedArrayEltypes, idx)
                ElType = JSTypedArrayEltypes[idx]
                return reinterpret(ElType, ext.data)
            else
                return ext
            end
        end
    end
end

function decode_extension_and_addbits(x::Dict)
    # we mutate the dictionary, that's fine in our use case and saves memory?
    for (k, v) in x
        x[k] = decode_extension_and_addbits(v)
    end
    x
end
decode_extension_and_addbits(x::Array) = map(decode_extension_and_addbits, x)

# We also convert everything (except the JS typed arrays) to 64 bit numbers, just to make it easier to work with.
decode_extension_and_addbits(x::T) where T <: Union{Signed,Unsigned} = Int64(x)
decode_extension_and_addbits(x::T) where T <: AbstractFloat = Float64(x)
decode_extension_and_addbits(x::Any) = x

using Markdown
md"""
# What is Bonito?

* a connection between Julia & Javascript
* a reactive DOM
* a server with routing
* can be used for dashboards, wrapping JS libraries & writing webpages
* Similar to React.js in some ways
"""

using Bonito, Observables
using Bonito: @js_str, Session, App, onjs, onload, Button
using Bonito: TextField, Slider, linkjs
Bonito.browser_display()

app = App(DOM.h1("Hello World"))
display(app)


md"""
# Interaction with observables
"""

color = Observable("red")
color_css = map(x-> "color: $(x)", color)

app = App() do
    return DOM.h1("Hello World", style=map(x-> "color: $(x)", color))
end
display(app)

color[] = "green"

app = App() do
    color = Observable("red")
    on(println, color)
    button = DOM.div("click me", onclick=js"""(e)=> {
        const color = '#' + ((1<<24)*Math.random() | 0).toString(16)
        console.log(color)
        $(color).notify(color)
    }""")
    style = map(x-> "color: $(x)", color)
    return DOM.div(
        button, DOM.h1("Hello World", style=style)
    )
end
display(app)

md"""
# Other ways to execute Javascript
"""

app = App() do session::Session
    color = Observable("red")
    button = DOM.div("click me", onclick=js"e=> $(color).notify('blue')")
    onload(session, button, js"""function load(button){
        window.alert('Hi from JavaScript');
    }""")

    onjs(session, color, js"""function update(value){
        window.alert(value);
        // throw "heey!"
    }""")

    return DOM.div(
        button, DOM.h1("Hello World", style=map(x-> "color: $(x)", color))
    )
end
display(app)

md"""
# Including assets & Widgets
"""

MUI = Bonito.Asset("https://cdn.muicss.com/mui-0.10.1/css/mui.min.css")
sliderstyle = Bonito.Asset(joinpath(@__DIR__, "sliderstyle.css"))
image = Bonito.Asset(joinpath(@__DIR__, "assets", "julia.png"))
s = Bonito.get_server();

app = App() do
    button = Bonito.Button("hi", class="mui-btn mui-btn--primary")
    slider = Bonito.Slider(1:10, class="slider")

    on(button) do click
        @show click
    end

    on(slider) do slidervalue
        @show slidervalue
    end
    link = DOM.a(href="/example1", "GO TO ANOTHER WORLD")
    return DOM.div(MUI, sliderstyle, link, button, slider, DOM.img(src=image))
end
display(app)

md"""
# Can also use regex here!
# ctx contains route, match,
"""

app = App() do
    color = Observable("red")
    on(println, color)
    button = DOM.div("click me", onclick=js"""(e)=> {
        const color = '#' + ((1<<24)*Math.random() | 0).toString(16)
        console.log(color)
        $(color).notify(color)
    }""")
    style = map(x-> "color: $(x)", color)
    return DOM.div(
        button, DOM.h1("Hello World", style=style)
    )
end
display(app)

Bonito.route!(Bonito.get_server(), "/example1" => app)

app = App() do session::Session
    slider = Bonito.Slider(1:10, class="slider m-4")
    squared = map(slider) do slidervalue
        return slidervalue^2
    end
    class = "p-2 rounded border-2 border-gray-600 m-4"
    v1 = DOM.div(slider.value, class=class)
    v2 = DOM.div(squared, class=class)
    dom = DOM.div(Bonito.TailwindCSS, "Hello", slider, sliderstyle, v1, v2)
    # statemap for static serving
    # return dom
    return Bonito.record_states(session, dom)
end;

export_path = joinpath(@__DIR__, "demo")
mkdir(export_path)
routes = Bonito.Routes()
routes["/"] = app
Bonito.export_static(export_path, routes)

# Or just `Bonito.export_static("index.html", app)` to export the app to a single file!

# Then one can use liveserver to host the static export:
using LiveServer
cd(export_path)
LiveServer.serve()

import Observables: observe

is_independant(x) = true
is_widget(x) = false
needs_post_notify(x) = false
function post_notify_callback end
function value_range end
function update_value!(x, value) end

function extract_widgets(dom_root)
    result = Base.IdSet()
    post_notify = Base.IdSet()
    walk_dom(dom_root) do x
        is_widget(x) && push!(result, x)
        needs_post_notify(x) && push!(post_notify, x)
    end
    return collect(result), collect(post_notify)
end

to_watch(x) = observe(x)

# Implement interface for slider!
is_widget(::Slider) = true
value_range(slider::Slider) = slider.values[]
to_watch(slider::Slider) = slider.value

# Implement interface for Dropdown

is_widget(::Dropdown) = true
value_range(d::Dropdown) = 1:length(d.options[])
to_watch(d::Dropdown) = d.option_index

is_widget(::Checkbox) = true
value_range(::Checkbox) = [true, false]
to_watch(d::Checkbox) = d.value

function do_session(f, session)
    s = session
    while !isnothing(s.parent)
        f(s)
        s = s.parent
    end
    f(s)
    # if we're recording for a subsession, we need to apply the operations to both sessions
    for (id, c) in session.children
        f(c)
    end
end

struct IgnoreObsUpdates <: Function
    widget_ids::Set{String}
end

function (ignore::IgnoreObsUpdates)(msg)
    if msg[:msg_type] == UpdateObservable
        # Ignore all messages that directly update the observable we watch
        # because otherwise, that will trigger itself recursively, once those messages are applied
        # via `$(wid).on(x=> ....)`
        msg[:id] in ignore.widget_ids && return true
    end
    return false
end

function record_values(f, session, widget_ids)
    ignore = IgnoreObsUpdates(widget_ids)
    do_session(session) do s
        s.ignore_message[] = ignore
        empty!(s.message_queue)
    end
    try
        f()
        yield()
        messages = SerializedMessage[]
        do_session(session) do s
            append!(messages, s.message_queue)
        end
        return messages
    catch e
        Base.showerror(stderr, e)
    finally
        do_session(session) do s
            s.ignore_message[] = (msg)-> false
            empty!(s.message_queue) # remove all recorded messages
        end
    end
end

function while_disconnected(f, session::Session)
    if isopen(session)
        error("Session shouldn't be open")
    end
    f()
end


"""
    generate_state_key(values)

Generate a consistent key for state values that works identically in Julia and JavaScript.
Handles Float64 values specially to ensure consistent string representation.
"""
function generate_state_key(v)
    if v isa AbstractFloat
        # Format floats to ensure consistency between Julia and JavaScript
        # Round to 6 significant digits and remove trailing zeros
        if isnan(v)
            return "NaN"
        elseif isinf(v)
            return v > 0 ? "Infinity" : "-Infinity"
        else
            # Format with up to 6 decimal places, removing trailing zeros
            formatted = string(round(v, digits=6))
            # Remove trailing zeros after decimal point
            if occursin(".", formatted)
                formatted = rstrip(rstrip(formatted, '0'), '.')
            end
            return formatted
        end
    else
        # For other types, use string representation
        return string(v)
    end
end

"""
    record_states(session::Session, dom::Hyperscript.Node)

Records widget states and their UI updates for offline/static HTML export. This function captures how the UI changes in response to widget interactions, allowing exported HTML to remain interactive without a Julia backend.

## How it works

Each widget's states are recorded independently:
- The function finds all widgets in the DOM that implement the widget interface
- For each widget, it records the UI updates triggered by each possible state
- The resulting state map is embedded in the exported HTML

## Widget Interface

To make a widget recordable, implement these methods:

```julia
is_widget(::YourWidget) = true                    # Marks the type as a recordable widget
value_range(w::YourWidget) = [...]                 # Returns all possible states
to_watch(w::YourWidget) = w.observable             # Returns the observable to monitor
```

## Limitations

!!! warning "Experimental Feature"
    - **Large file sizes**: Recording all states can significantly increase HTML size
    - **Independent states only**: Widgets are recorded independently. Computed observables that depend on multiple widgets won't update correctly in the exported HTML
    - **Performance**: Not optimized for large numbers of widgets or states

## Example

```julia
# This will work - independent widgets
s = Slider(1:10)
c = Checkbox(true)
record_states(session, DOM.div(s, c))

# This won't fully work - dependent computed observable
combined = map((s,c) -> "Slider: \$s, Checkbox: \$c", s.value, c.value)
record_states(session, DOM.div(s, c, combined))  # combined won't update
```
"""
function record_states(session::Session, dom::Hyperscript.Node)
    widgets, post_notify = extract_widgets(dom)
    rendered = jsrender(session, dom)
    # We'll mess with the message_queue to record the statemap
    # So we copy the current message queue and disconnect the session!
    # we need to serialize the message so that all observables etc are registered
    # TODO, this is a bit of a bad design, since we mixed serialization with session resource registration
    # Which makes sense in most parts, but breaks together, e.g. here
    session_states = Dict{String, SerializedMessage}()
    do_session(session) do s
        session_states[s.id] = SerializedMessage(s, fused_messages!(s))
    end

    # Record states for each widget independently
    widget_observables = to_watch.(widgets)
    post_notify_callbacks = post_notify_callback.(post_notify)
    widget_statemaps = Dict{String, Dict{String, Vector{SerializedMessage}}}()

    while_disconnected(session) do
        for (widget_idx, (widget, obs)) in enumerate(zip(widgets, widget_observables))
            widget_id = obs.id
            widget_statemap = Dict{String, Vector{SerializedMessage}}()
            widget_id_set = Set([widget_id])

            # Save current states of all widgets

            # Record each state for this widget
            for state in value_range(widget)
                # Set this widget to the state we want to record
                obs.val = state
                # Use generate_state_key for consistency with JavaScript
                key = generate_state_key(state)
                try
                    widget_statemap[key] = record_values(session, widget_id_set) do
                        notify(obs)
                        for f in post_notify_callbacks
                            f()
                        end
                    end
                catch e
                    @warn "Error while recording state $key for widget $widget_id" exception=(e, Base.catch_backtrace())
                    continue
                end
            end

            widget_statemaps[widget_id] = widget_statemap
        end
    end

    do_session(session) do s
        if haskey(session_states, s.id)
            push!(s.message_queue, session_states[s.id])
        end
    end
    asset = BinaryAsset(session, widget_observables)
    statemap_script = js"""
    $(asset).then(binary => {
        const widget_statemaps = $(widget_statemaps)
        console.log('Widget statemaps:', widget_statemaps)
        const observables = Bonito.decode_binary(binary, $(session.compression_enabled));
        // Set up individual listeners for each observable
        observables.forEach((obs, idx) => {
            obs.on(value => {
                const obs_states = widget_statemaps[obs.id]
                const key = Bonito.generate_state_key(value);
                const messages = obs_states[key];
                if (messages){
                    messages.forEach(Bonito.process_message)
                }
            });
        });

    })
    """
    evaljs(session, statemap_script)
    return rendered
end

"""
    export_standaloneexport_standalone(
        app::App, folder::String;
        clear_folder=false, write_index_html=true,
        absolute_urls=false, content_delivery_url="file://" * folder * "/",
        single_html=false)

Exports the app defined by `app::Application` with all its assets to `folder`.
Will write the main html out into `folder/index.html`.
Overwrites all existing files!
If this gets served behind a proxy, set `absolute_urls=true` and
set `content_delivery_url` to your proxy url.
If `clear_folder=true` all files in `folder` will get deleted before exporting again!
`single_html=true` will write out a single html instead of writing out JS depencies as separate files.
"""
function export_standalone(app::App, folder::String;
        clear_folder=false, write_index_html=true,
        absolute_urls=false, content_delivery_url="file://" * folder * "/",
        single_html=false
    )
    error("export_standalone is deprecated, please use export_static")
end

function create_session(connection, asset_server, session::Nothing)
    actual_connection = connection === nothing ? NoConnection() : connection
    actual_asset_server = asset_server === nothing ? NoServer() : asset_server
    return Session(actual_connection; asset_server=actual_asset_server)
end

create_session(::Nothing, ::Nothing, session::Session) = session

function create_session(connection, asset_server, session::Session)
    error("If providing a session, you can't provide connection or asset_server!
        Found: $(typeof(connection)), $(typeof(asset_server))")
end


"""
    export_static(html_file::Union{IO, String}, app::App)
    export_static(folder::String, routes::Routes)

Exports the app defined by `app` with all its assets a single HTML file.
Or exports all routes defined by `routes` to `folder`.
"""
function export_static(html_file::String, app::App;
        asset_server=nothing,
        connection=nothing,
        session=nothing)

    # Create session if not provided, ignoring asset_server and connection when session is given
    actual_session = create_session(connection, asset_server, session)
    try
        open(html_file, "w") do io
            export_static(io, app; session=actual_session)
        end
    finally
        # Only close session if we created it ourselves
        if session === nothing
            close(actual_session)
        end
    end
    return actual_session
end

function export_static(html_io::IO, app::App;
        asset_server=nothing,
        connection=nothing,
        session=nothing)
    # Create session if not provided, ignoring asset_server and connection when session is given
    actual_session = create_session(connection, asset_server, session)
    try
        actual_session.title = app.title
        page_html(html_io, actual_session, app)
    finally
        # Only close session if we created it ourselves and there's an error
        if session === nothing
            close(actual_session)
        end
    end

    return actual_session
end

function export_static(folder::String, routes::Routes; connection=nothing, asset_server=nothing)
    isdir(folder) || mkpath(folder)

    # Set defaults for routes export
    actual_connection = connection === nothing ? NoConnection() : connection
    actual_asset_server = asset_server === nothing ? AssetFolder(folder, "") : asset_server

    for (route, app) in routes.routes
        startswith(route, "/") && (route = route[2:end])
        dir = joinpath(folder, route)
        html_file = normpath(joinpath(dir, "index.html"))
        isdir(dirname(html_file)) || mkpath(dirname(html_file))

        try
            # Update asset server directory if it's an AssetFolder
            if actual_asset_server isa AssetFolder
                actual_asset_server.current_dir = dir
            end

            # Create session for this route
            route_session = Session(actual_connection; asset_server=actual_asset_server)
            export_static(html_file, app; session=route_session)
        catch e
            @error "Failed to export route $route" exception=(e, Base.catch_backtrace())
            continue
        end
    end
end

module DOM

using Hyperscript

for node in [:a, :abbr, :address, :area, :article, :aside, :audio, :b,
    :base, :bdi, :bdo, :blockquote, :body, :br, :button, :canvas,
    :code, :col, :colgroup, :data, :datalist, :caption, :cite,
    :dd, :del, :details, :dfn, :dialog, :div, :dl, :dt, :em, :embed,
    :figcaption, :figure, :footer, :form, :h1, :h2, :fieldset,
    :h3, :h4, :h5, :h6, :head, :header, :hgroup, :hr, :html, :i, :iframe,
    :input, :ins, :kbd, :label, :legend, :li, :link, :img,
    :main, :map, :mark, :math, :menu, :menuitem, :meta, :meter, :nav,
    :object, :ol, :optgroup, :option, :output, :p, :param, :noscript,
    :picture, :pre, :progress, :q, :rb, :rp, :rt, :rtc, :ruby, :s, :samp,
    :section, :select, :slot, :small, :source, :span,
    :strong, :sub, :summary, :sup, :svg, :table, :tbody, :td, :template,
    :textarea, :tfoot, :th, :thead, :time, :title, :tr,
    :track, :u, :ul, :var, :video, :wbr, :font]

    node_name = string(node)
    unesc = Symbol(node_name * "_unesc")
    @eval $(node)(args...; kw...) = m($(node_name), args...; kw...)
    @eval $(unesc)(args...; kw...) = m(Hyperscript.NOESCAPE_HTMLSVG_CONTEXT, $(node_name), args...; kw...)
end

style(args...; kw...) = m(Hyperscript.NOESCAPE_HTMLSVG_CONTEXT, "style", args...; kw...)
script(args...; kw...) = m(Hyperscript.NOESCAPE_HTMLSVG_CONTEXT, "script", args...; kw...)
Base.@deprecate um(tag, args...; kw...) m(tag, args...; kw...)

function m_unesc(tag, args...; kw...)
    m(Hyperscript.NOESCAPE_HTMLSVG_CONTEXT, tag, args...; kw...)
end

end

using .DOM

module SVG
# Sadly, SVG isn't that easy to serialize, since it shares tags with HTML,
# but needs to be created via createElementNS. See: http://zhangwenli.com/blog/2017/07/26/createelementns/
# Since it's hard to recognize when to use `createElementNS`, we just make users use `SVG.tagname` to create SVG,
# so we can deserialize it correctly in JS!

using Hyperscript

const SVG_TAGS = [
    :a, :animate, :animateMotion, :animateTransform, :circle, :clipPath, :defs, :desc,
    :discard, :ellipse, :feBlend, :feColorMatrix, :feComponentTransfer, :feComposite, :feConvolveMatrix, :feDiffuseLighting,
    :feDisplacementMap, :feDistantLight, :feDropShadow, :feFlood, :feFuncA, :feFuncB, :feFuncG, :feFuncR,
    :feGaussianBlur, :feImage, :feMerge, :feMergeNode, :feMorphology, :feOffset, :fePointLight, :feSpecularLighting, :feSpotLight,
    :feTile, :feTurbulence, :filter, :foreignObject, :g, :image, :line, :linearGradient,
    :marker, :mask, :metadata, :mpath, :path, :pattern, :polygon, :polyline,
    :radialGradient, :rect, :script, :set, :stop, :style, :svg, :switch, :symbol, :text, :textPath, :title, :tspan, :use, :view,
]

# Tags deprecated by W3 spec
const DEPRECATED_TAGS = [
    :altGlyph, :altGlyphDef, :altGlyphItem, :cursor, Symbol("font-face-format"), Symbol("font-face-name"), Symbol("font-face-src"),
    Symbol("font-face-uri"), Symbol("font-face"), :font, :glyphRef, :hkern, :glyph, Symbol("missing-glyph"), :tref, :vkern,
]

for tag in SVG_TAGS
    @eval $(tag)(args...; kw...) = m($(string(tag)), args...; juliasvgnode=true, kw...)
end

for tag in DEPRECATED_TAGS
    @eval function $(tag)(args...; kw...)
        @warn($("tag $(tag) is deprecated by the SVG standard. It's highly recommend to avoid it."))
        return m($(string(tag)), args...; juliasvgnode=true, kw...)
    end
end

end

using .SVG

function selector(node)
    query_string = "[data-jscall-id=$(repr(uuid(node)))]"
    return js"(document.querySelector($(query_string)))"
end

# default turn attributes into strings
attribute_render(session::Session, parent, attribute::String, x) = string(x)
attribute_render(session::Session, parent, attribute::String, x::Nothing) = x
attribute_render(session::Session, parent, attribute::String, x::Bool) = x


function attribute_render(session::Session, parent, attribute::String, obs::Observable)
    rendered = map(session, obs) do value
        attribute_render(session, parent, attribute, value)
    end
    onjs(session, rendered, js"""value => {
        Bonito.update_node_attribute($(parent), $attribute, value);
    }""")
    return rendered[]
end

struct DontEscape
    x::Any
end

function Hyperscript.printescaped(io::IO, x::DontEscape, escapes)
    print(io, x.x)
end

function attribute_render(session::Session, parent, attribute::String, jss::JSCode)
    # add js after parent gets loaded
    func = js"""(() => {
        $(parent)[$attribute] = $(jss)
    })()"""
    # preserve func.file
    evaljs(session, JSCode(func.source, jss.file))
    return ""
end

function attribute_render(session::Session, parent, ::String, asset::AbstractAsset)
    if parent isa Hyperscript.Node{Hyperscript.CSS}
        # css seems to require an url object
        return "url($(url(session, asset)))"
    else
        return url(session, asset)
    end
end

render_node(session::Session, x) = x

const BOOLEAN_ATTRIUTES = Set([
    "allowfullscreen",
    "allowpaymentrequest",
    "async",
    "autofocus",
    "autoplay",
    "checked",
    "controls",
    "default",
    "defer",
    "disabled",
    "formnovalidate",
    "hidden",
    "ismap",
    "itemscope",
    "loop",
    "multiple",
    "muted",
    "nomodule",
    "novalidate",
    "open",
    "readonly",
    "required",
    "reversed",
    "selected",
    "typemustmatch"
])

is_boolean_attribute(attribute::String) = attribute in BOOLEAN_ATTRIUTES

function render_node(session::Session, node::Node)
    # give each node a unique id inside the dom
    node_children = children(node)
    # this could be uuid!, since it adds a uuid if not present
    # we didn't add a `!` since from the user perspective it should be treated as non mutating
    # Anyways, calling it here makes sure, that every rendered node has a unique id we can
    # use for e.g. `evaljs(session, js"$(node)")`
    # It's important that the uuid gets added before rendering because otherwise `evaljs(session, js"$(node)")`
    # won't work in a dynamic context
    uuid(session, node)
    node_attrs = Hyperscript.attrs(node)
    isempty(node_children) && isempty(node_attrs) && return node

    new_attributes = Dict{String,Any}()
    newchildren = []
    for elem in node_children
        new_elem = jsrender(session, elem)
        !isnothing(new_elem) && push!(newchildren, new_elem)
    end
    new_attributes["data-jscall-id"] = uuid(session, node)
    new_node = Node(Hyperscript.context(node),
                    Hyperscript.tag(node),
                    newchildren,
                    new_attributes)
    for (k, v) in node_attrs
        rendered = attribute_render(session, new_node, k, v)
        # We code nothing to mean omitting the attribute!
        if is_boolean_attribute(k)
            if rendered isa Bool
                if rendered
                    # only add attribute if true!
                    new_attributes[k] = true
                end
            else
                error("Boolean attribute $(k) expects a boolean! Found: $(typeof(rendered))")
            end
        else
            new_attributes[k] = rendered
        end
    end
    return new_node
end

# jsrender(session, x) will be called anywhere...
# if there is nothing sessions specific in the dom, fallback to jsrender without session
function jsrender(session::Session, node::Node)
    render_node(session, node)
end

function uuid(session::Union{Nothing,Session}, node::Node)
    return get!(Hyperscript.attrs(node), "data-jscall-id") do
        if isnothing(session)
            return string(rand(UInt64))
        else
            root = root_session(session) # counter needs to be unique to root session
            root.dom_uuid_counter += 1
            return string(root.dom_uuid_counter)
        end
    end
end

jsrender(x::Hyperscript.Styled) = x

struct SerializedNode
    tag::String
    children::Vector{Any}
    attributes::Dict{String,Any}
end

function SerializedNode(session::Session, any)
    node = jsrender(session, any)
    if node isa Node
        return SerializedNode(session, node)
    else
        return node
    end
end

function SerializedNode(session::Session, node::Node)
    # give each node a unique id inside the dom
    node_children = children(node)
    uuid(session, node)
    node_attrs = Hyperscript.attrs(node)

    tag = Hyperscript.tag(node)

    isempty(node_children) && isempty(node_attrs) && return SerializedNode(tag, node_children, node_attrs)

    new_attributes = Dict{String,Any}()
    newchildren = []
    for child in node_children
        node = jsrender(session, child)
        if node isa Node
            push!(newchildren, SerializedNode(session, node))
        elseif !isnothing(node)
            push!(newchildren, node)
        end
    end
    for (k, v) in node_attrs
        rendered = attribute_render(session, node, k, v)
        # We code nothing to mean omitting the attribute!
        if is_boolean_attribute(k)
            if rendered isa Bool
                if rendered
                    # only add attribute if true!
                    new_attributes[k] = true
                end
            else
                error("Boolean attribute $(k) expects a boolean! Found: $(typeof(rendered))")
            end
        else
            new_attributes[k] = rendered
        end
    end
    return SerializedNode(tag, newchildren, new_attributes)
end

"""
The string part of JSCode.
"""
struct JSString
    source::String
end

"""
Javascript code that supports interpolation of Julia Objects.
Construction of JSCode via string macro:
```julia
jsc = js"console.log(\$(some_julia_variable))"
```
This will decompose into:
```julia
jsc.source == [JSString("console.log("), some_julia_variable, JSString("\"")]
```
"""
struct JSCode
    source::Vector{Union{JSString, Any}}
    file::String # location of the js string, a la "path/to/file:line"
end

JSCode(source) = JSCode(source, "")

abstract type AbstractAsset end

"""
    AbstractConnectionIndicator

Abstract type for connection indicators. Custom indicators should subtype this.
Implementations should define `jsrender(session::Session, indicator::T)` where T is the subtype.
"""
abstract type AbstractConnectionIndicator end

"""
    Asset(path_or_url; name=nothing, es6module=false, check_isfile=false, bundle_dir=nothing, mediatype=:inferred)

Represent an asset (JavaScript, CSS, image, etc.) that can be included in a Bonito DOM.

# Arguments
- `path_or_url`: Local file path or URL to the asset
- `name`: Optional name for the asset. For JS assets, this becomes the global variable name when loaded.
          Defaults to the filename without extension for JS files (e.g., "ace.js" → "ace")
- `es6module`: Whether this is an ES6 module that needs bundling (default: false)
- `check_isfile`: Verify that local files exist (default: false)
- `bundle_dir`: Directory for bundled ES6 modules (default: inferred)
- `mediatype`: Media type symbol (:js, :css, :png, etc.). Auto-detected from extension if not specified

# JavaScript Asset Loading

## Non-module scripts (es6module=false)

For non-module JavaScript assets, interpolating the asset in JS code creates a Promise
that resolves with the global object:

```julia
ace_asset = Asset("https://cdn.jsdelivr.net/gh/ajaxorg/ace-builds/src-min/ace.js")
# name defaults to "ace" (inferred from filename)

js\"""
    \$(ace_asset).then(ace => {
        // ace object is now available
        const editor = ace.edit(element);
    });
\"""
```

To override the global name:
```julia
Asset("https://example.com/mylibrary.js"; name="MyLib")
```

## ES6 modules (es6module=true)

For ES6 modules, use the `ES6Module(path)` constructor which automatically sets `es6module=true` and
bundles the module with its dependencies. ES6 modules also support the `.then()` syntax:

```julia
mod = ES6Module("path/to/module.js")  # name defaults to "module"

js\"""
    \$(mod).then(exports => {
        // ES6 module exports are now available
        exports.someFunction();
    });
\"""
```

# Fields
- `name::Union{Nothing, String}`: Asset name (used as global variable name for JS assets)
- `es6module::Bool`: Whether this is an ES6 module
- `media_type::Symbol`: Type of asset (:js, :css, :png, etc.)
- `online_path::String`: URL if asset is hosted online
- `local_path::Union{String, Path}`: Local file system path
- `bundle_file::Union{String, Path}`: Path to bundled file (ES6 modules only)
- `bundle_data::Vector{UInt8}`: Bundled file contents (ES6 modules only)
- `content_hash::RefValue{String}`: Hash of bundled content (ES6 modules only)

# See Also
- `ES6Module(path)`: Convenience constructor for ES6 modules with automatic bundling
"""
struct Asset <: AbstractAsset
    name::Union{Nothing, String}
    es6module::Bool
    media_type::Symbol
    # We try to always have online & local files for assets
    # If you only give an online resource, we will download it
    # to also be able to host it locally
    online_path::String
    local_path::Union{String, Path}

    # only used if es6module
    bundle_file::Union{String, Path}
    bundle_data::Vector{UInt8}
    content_hash::RefValue{String}
end


struct Link <: AbstractAsset
    target::String
end

struct JSException <: Exception
    exception::String
    message::String
    stacktrace::Vector{String}
end

js_to_local_stacktrace(asset_server, matched_url) = matched_url

function Base.show(io::IO, exception::JSException)
    println(io, "An exception was thrown in JS: $(exception.exception)")
    println(io, "Additional message: $(exception.message)")
    println(io, "Stack trace:")
    for line in exception.stacktrace
        println(io, "    ", line)
    end
end

abstract type FrontendConnection end
abstract type AbstractAssetServer end

mutable struct SubConnection <: FrontendConnection
    connection::FrontendConnection
    isopen::Bool
end

struct SessionCache
    session_id::String
    # Must preserve insertion order for nested observable serialization.
    # Inner observables must be deserialized before outer observables that reference them.
    objects::OrderedDict{String, Any}
    session_type::String
end

struct SerializedMessage
    cache::SessionCache
    data::Any
    compression::Bool
end

struct BinaryMessage
    bytes::Vector{UInt8}
end

@enum SessionStatus UNINITIALIZED RENDERED DISPLAYED OPEN CLOSED SOFT_CLOSED

struct CSS
    selector::String
    # TODO use some kind of immutable Dict
    attributes::Dict{String, Union{CSS, String, Asset}}
    # We assume attributes to be immutable, so we calculate the hash once
    hash::UInt64
    function CSS(selector, attributes::Dict{String,T}) where T <: Any
        css = Dict{String,Union{CSS,String,Asset}}()
        # Need to sort to always get the same hash!
        sorted_keys = sort!(collect(keys(attributes)))
        h = hash(selector, UInt64(0))
        h = hash(sorted_keys, h)
        for k in sorted_keys
            converted = convert_css_attribute(attributes[k])
            css[String(k)] = converted
            h = hash(converted, h)
        end
        return new(selector, css, h)
    end
end

Base.hash(css::CSS, h::UInt64) = hash(css.hash, h)
Base.:(==)(css1::CSS, css2::CSS) = css1.hash == css2.hash

"""
    Styles(css::CSS...)

Creates a Styles object, which represents a Set of CSS objects.
You can insert the Styles object into a DOM node, and it will be rendered as a `<style>` node.
If you assign it directly to `DOM.div(style=Style(...))`, the styling will be applied to the specific div.
Note, that per `Session`, each unique css object in all `Styles` across the session will only be rendered once.
This makes it easy to create Styling inside of components, while not worrying about creating lots of Style nodes on the page.
There are a two more convenience constructors to make `Styles` a bit easier to use:
```julia
Styles(pairs::Pair...) = Styles(CSS(pairs...))
Styles(priority::Styles, defaults...) = merge(Styles(defaults...), priority)
```
For styling components, it's recommended, to always allow user to merge in customizations of a Style, like this:
```julia
function MyComponent(; style=Styles())
    return DOM.div(style=Styles(style, "color" => "red"))
end
```
All Bonito components are stylable this way.

!!! info
    Why not `Hyperscript.Style`? While the scoped styling via `Hyperscript.Style` is great, it makes it harder to create stylable components, since it doesn't allow the deduplication of CSS objects across the session.
    It's also significantly slower, since it's not as specialized on the deduplication and the camelcase keyword to css attribute conversion is pretty costly.
    That's also why `CSS` uses pairs of strings instead of keyword arguments.

"""
struct Styles
    # OrderedDict(selector => CSS) - preserves insertion order for media queries
    styles::OrderedDict{String, CSS}
end

const HTMLElement = Node{Hyperscript.HTMLSVG}

"""
    ConnectionIndicator <: AbstractConnectionIndicator

Default connection indicator showing connection status as an LED-like circle.
See the full documentation with `?ConnectionIndicator` after loading Bonito.
"""
struct ConnectionIndicator <: AbstractConnectionIndicator
    connected_color::String
    connecting_color::String
    disconnected_color::String
    no_connection_color::String
    size::Int
    position::String
    top::String
    right::String
    style::Styles
end

function ConnectionIndicator(;
    connected_color::String="#22c55e",
    connecting_color::String="#eab308",
    disconnected_color::String="#ef4444",
    no_connection_color::String="#6b7280",
    size::Int=10,
    position::String="fixed",
    top::String="10px",
    right::String="10px",
    style::Styles=Styles(),
)
    return ConnectionIndicator(
        connected_color,
        connecting_color,
        disconnected_color,
        no_connection_color,
        size,
        position,
        top,
        right,
        style,
    )
end

"""
A web session with a user
"""
mutable struct Session{Connection <: FrontendConnection}
    status::SessionStatus
    closing_time::Float64
    parent::Union{Session, Nothing}
    children::Dict{String, Session{SubConnection}}
    id::String
    # The connection to the JS frontend.
    # Currently can be IJuliaConnection, WebsocketConnection, PlutoConnection, NoConnection
    connection::Connection
    # The way we serve any file asset
    asset_server::AbstractAssetServer
    message_queue::Vector{SerializedMessage}
    # Code that gets evalued last after all other messages, when session gets connected
    on_document_load::Vector{JSCode}
    connection_ready::Channel{Bool}
    on_connection_ready::Function
    # Should be checkd on connection_ready to see if an error occured
    init_error::RefValue{Union{Nothing,JSException}}
    js_comm::Observable{Union{Nothing, Dict{String, Any}}}
    on_close::Observable{Bool}
    deregister_callbacks::Vector{Observables.ObserverFunction}
    session_objects::Dict{String, Any}
    # For rendering Hyperscript.Node, and giving them a unique id inside the session
    dom_uuid_counter::Int
    # For rendering Styles
    style_counter::Int
    ignore_message::RefValue{Function}
    imports::OrderedSet{Asset}
    global_stylesheets::OrderedSet{Styles}
    title::String
    compression_enabled::Bool
    deletion_lock::Base.ReentrantLock
    current_app::RefValue{Any}
    io_context::RefValue{Union{Nothing, IOContext}}
    stylesheets::OrderedDict{HTMLElement, OrderedSet{CSS}}
    inbox::Channel{Vector{UInt8}}
    threadid::Int
    # User metadata storage - accessed via root session
    metadata::Dict{Symbol, Any}

    function Session(
            parent::Union{Session, Nothing},
            children::Dict{String, Session{SubConnection}},
            id::String,
            connection::Connection,
            asset_server::AbstractAssetServer,
            message_queue::Vector{SerializedMessage},
            on_document_load::Vector{JSCode},
            connection_ready::Channel{Bool},
            on_connection_ready::Function,
            init_error::Ref{Union{Nothing, JSException}},
            js_comm::Observable{Union{Nothing, Dict{String, Any}}},
            on_close::Observable{Bool},
            deregister_callbacks::Vector{Observables.ObserverFunction},
            session_objects::Dict{String, Any},
            dom_uuid_counter::Int,
            ignore_message::RefValue{Function},
            imports::OrderedSet{Asset},
            title::String,
            compression_enabled::Bool,
            n_inbox = Inf
        ) where {Connection}
        inbox = Channel{Vector{UInt8}}(n_inbox)
        session = new{Connection}(
            UNINITIALIZED,
            time(),
            parent,
            children,
            id,
            connection,
            asset_server,
            message_queue,
            on_document_load,
            connection_ready,
            on_connection_ready,
            init_error,
            js_comm,
            on_close,
            deregister_callbacks,
            session_objects,
            dom_uuid_counter,
            1,
            ignore_message,
            imports,
            OrderedSet{Styles}(),
            title,
            compression_enabled,
            Base.ReentrantLock(),
            RefValue{Any}(nothing),
            RefValue{Union{Nothing,IOContext}}(nothing),
            OrderedDict{HTMLElement,OrderedSet{CSS}}(),
            inbox,
            Threads.threadid(),
            Dict{Symbol, Any}()
        )

        task = Task() do
            for message in inbox
                @async try
                    process_message(session, message)
                catch e
                    @warn "error while processing received msg" exception = (
                        e, Base.catch_backtrace()
                    )
                end
            end
        end
        bind(inbox, task)
        schedule(task)
        return session
    end
end

struct BinaryAsset <: AbstractAsset
    data::Vector{UInt8}
    mime::String
end

function BinaryAsset(session::Session, @nospecialize(data))
    BinaryAsset(serialize_binary(session, data), "application/octet-stream")
end

function Base.show(io::IO, asset::BinaryAsset)
    print(io, "BinaryAsset($(asset.mime)) with $(length(asset.data)) bytes")
end

"""
Creates a Julia exception from data passed to us by the frondend!
"""
function JSException(session::Session, js_data::AbstractDict)
    stacktrace = String[]
    if js_data["stacktrace"] != "nothing"
        for line in split(js_data["stacktrace"], "\n")
            push!(stacktrace, js_to_local_stacktrace(session.asset_server, line))
        end
    end
    return JSException(js_data["exception"], js_data["message"], stacktrace)
end

function Session(connection=default_connection();
                id=string(uuid4()),
                asset_server=default_asset_server(),
                message_queue=SerializedMessage[],
                on_document_load=JSCode[],
                connection_ready=Channel{Bool}(1),
                on_connection_ready=init_session,
                init_error=Ref{Union{Nothing, JSException}}(nothing),
                js_comm=Observable{Union{Nothing, Dict{String, Any}}}(nothing),
                on_close=Observable(false),
                deregister_callbacks=Observables.ObserverFunction[],
                session_objects=Dict{String, Any}(),
                imports=OrderedSet{Asset}(),
                title="Bonito App",
                compression_enabled=default_compression())

    return Session(
        nothing,
        Dict{String, Session{SubConnection}}(),
        id,
        connection,
        asset_server,
        message_queue,
        on_document_load,
        connection_ready,
        on_connection_ready,
        init_error,
        js_comm,
        on_close,
        deregister_callbacks,
        session_objects,
        0,
        RefValue{Function}(x-> false),
        imports,
        title,
        compression_enabled,
    )
end

function Session(parent_session::Session;
    asset_server=similar(parent_session.asset_server),
    on_connection_ready=init_session, title=parent_session.title)
    root = root_session(parent_session)
    return lock(root.deletion_lock) do
        connection = SubConnection(root)
        session = Session(connection; asset_server=asset_server, on_connection_ready=on_connection_ready, title=title)
        session.parent = parent_session
        parent_session.children[session.id] = session
        return session
    end
end

mutable struct App
    handler::Function
    session::Base.RefValue{Union{Session,Nothing}}
    title::String
    indicator::Union{Nothing, AbstractConnectionIndicator}
    function App(handler::Function;
            title::AbstractString="Bonito App",
            indicator::Union{Nothing, AbstractConnectionIndicator}=nothing,
            threaded=nothing)

        if threaded isa Bool
            @warn "The `threaded` argument is deprecated and has no effect. Each App is run in a thread created by HTTP.jl."
        end
        session = Base.RefValue{Union{Session, Nothing}}(nothing)
        if hasmethod(handler, Tuple{Session, HTTP.Request})
            app = new(handler, session, title, indicator)
        elseif hasmethod(handler, Tuple{Session})
            app = new((session, request) -> handler(session), session, title, indicator)
        elseif hasmethod(handler, Tuple{HTTP.Request})
            app = new((session, request) -> handler(request), session, title, indicator)
        elseif hasmethod(handler, Tuple{})
            app = new((session, request) -> handler(), session, title, indicator)
        else
            error("""
            Handler function must have the following signature:
                handler() -> DOM
                handler(session::Session) -> DOM
                handler(request::Request) -> DOM
                handler(session, request) -> DOM
            """)
        end
        finalizer(close, app)
        return app
    end
    function App(dom_object;
            title="Bonito App",
        indicator::Union{Nothing,AbstractConnectionIndicator}=nothing,
            threaded=nothing)
        if threaded isa Bool
            @warn "The `threaded` argument is deprecated and has no effect. Each App is run in a thread created by HTTP.jl."
        end
        session = Base.RefValue{Union{Session,Nothing}}(nothing)
        app = new((s, r) -> dom_object, session, title, indicator)
        finalizer(close, app)
        return app
    end
end

struct Routes
    routes::Dict{String, App}
end

Routes() = Routes(Dict{String, App}())
Routes(pairs::Pair{String, App}...) = Routes(Dict{String, App}(pairs))
Base.setindex!(routes::Routes, app::App, key::String) = (routes.routes[key] = app)

using HTTP, URIs

"""
    FolderServer(folder::String)
A simple file server that serves files from the specified folder.
Example with a static site generated with Bonito:
```julia
# Build a static site
app = App(()-> DOM.div("Hello World"));
routes = Routes(
    "/" => app
    # Add more routes as needed
)
export_static("build", routes)
# Serve the static site from the build folder
server = Bonito.Server("0.0.0.0", 8982)
route!(server, r".*" => FolderServer("build"))
```
"""
struct FolderServer
    folder::String
end

function longest_common_prefix(a::AbstractString, b::AbstractString)
    len = min(length(a), length(b))
    for i in 1:len
        if a[i] != b[i]
            return a[1:(i-1)]
        end
    end
    return a[1:len]
end

# Enable route!(server, "/" => app)
function Bonito.HTTPServer.apply_handler(app::FolderServer, context)
    request = context.request
    uri = URI(request.target)
    # The full request path is in uri.path
    # We need to figure out what prefix to strip based on the route pattern
    # For regex routes like r"/public.*", we want to strip "/public" (the static prefix)
    # For string routes like "/api", we strip that exact string
    relative_path = uri.path
    context_match = context.match
    if context.match isa RegexMatch
        # For regex matches, find the common prefix between the pattern and the actual path
        # This naturally excludes regex metacharacters
        # e.g., pattern="/public/.*" and path="/public/index.html" -> common prefix="/public/"
        pattern_str = context.match.regex.pattern
        context_match = longest_common_prefix(pattern_str, relative_path)
    end
    # For string matches, strip the matched string
    if startswith(relative_path, context_match)
        relative_path = relative_path[(length(context_match) + 1):end]
    end
    # Remove leading '/' if present
    if startswith(relative_path, "/")
        relative_path = relative_path[2:end]
    end

    path = joinpath(app.folder, relative_path)
    if !isfile(path)
        path = joinpath(path, "index.html")
    end
    if isfile(path)
        header = [
            "Access-Control-Allow-Origin" => "*",
            "Content-Type" => Bonito.file_mimetype(path),
        ]
        return HTTP.Response(200, header, body = read(path))
    else
        return HTTP.Response(404, "File not found")
    end
end

const PLUGIN_NAME = :Bonito
const IJULIA_PKG_ID = Base.PkgId(Base.UUID("7073ff75-c697-5162-941a-fcdaad2a7d2a"), "IJulia")
const IJULIA_REF = Ref{Module}()

function IJulia()
    if !isassigned(IJULIA_REF)
        if !haskey(Base.loaded_modules, IJULIA_PKG_ID)
            error("Trying to setup IJulia state, without IJulia being loaded.")
        end
        IJULIA_REF[] = Base.loaded_modules[IJULIA_PKG_ID]
    end
    return IJULIA_REF[]
end

# IJulia.CommManager.Comm
const IJuliaComm = Any

mutable struct IJuliaConnection <: FrontendConnection
    comm::Union{Nothing, IJuliaComm, WebSocketConnection}
end

function IJuliaConnection()
    # This ENV var gets inserted only for jupyterlab, so we should be on `notebook`
    # Which we can use the IJulia connection for!
    if !haskey(ENV, "JPY_SESSION_NAME")
        # If empty, we can use the IJulia Connection
        return IJuliaConnection(nothing)
    else
        # we fall back to create a websocket connection via a proxy url, figured out in `server-defaults.jl`
        ws_conn = WebSocketConnection()
        return IJuliaConnection(ws_conn)
    end
end

_write(connection::WebSocketConnection, bytes) = Base.write(connection, bytes)
_write(comm, bytes) = IJulia().send_comm(comm, Dict("data" => Base64.base64encode(bytes)))

function Base.write(connection::IJuliaConnection, bytes::AbstractVector{UInt8})
    return _write(connection.comm, bytes)
end

_isopen(connection::WebSocketConnection) = isopen(connection)
_isopen(comm) = haskey(IJulia().CommManager.comms, comm.id)

function Base.isopen(connection::IJuliaConnection)
    isnothing(connection.comm) && return false
    return _isopen(connection.comm)
end

_close(connection::WebSocketConnection) = close(connection)
_close(connection) = IJulia().close_comm(connection.comm)
_close(::Nothing) = nothing
Base.close(connection::IJuliaConnection) = _close(connection.comm)

function setup_connection(session::Session{IJuliaConnection})
    setup_connection(session, session.connection.comm)
end

# implemented in websocket.jl
# function setup_connection(session::Session, connection::WebSocketConnection)
# end

function setup_connection(session::Session, ::Nothing)
    # For nothing, we open a new IJuliaConnection
    IJulia().eval(quote
        function CommManager.register_comm(comm::CommManager.Comm{$(QuoteNode(PLUGIN_NAME))}, message)
            session = $(session)
            session.connection.comm = comm
            comm.on_msg = function (msg)
                data_b64 = msg.content["data"]
                bytes = $(Base64).base64decode(data_b64)
                put!(session.inbox, bytes)
            end
            comm.on_close = (args...) -> close(session)
        end
    end)
    id = session.id
    return js"""
    (() => {
        console.log("setting up IJulia");
        if (!window.Jupyter) {
            throw new Error("Jupyter not loaded");
        }
        const plugin_name = $(Bonito.PLUGIN_NAME);
        const comm_manager = Jupyter.notebook.kernel.comm_manager;
        comm_manager.unregister_target(plugin_name);
        comm_manager.register_target(plugin_name, () => {});
        const comm = comm_manager.new_comm(
            plugin_name, // target_name
            {session_id: $(session.id)}, // data
            undefined, // callbacks
            undefined, // metadata
            undefined, // comm_id
            undefined, // buffers
        );
        comm.on_msg((msg) => {
            Bonito.decode_base64_message(msg.content.data.data, $(session.compression_enabled)).then(Bonito.process_message)
        });

        Bonito.on_connection_open((binary) => {
            Bonito.base64encode(binary).then(x=> comm.send(x))
        }, $(session.compression_enabled));
    })()
    """
end

mediatype(asset::Asset) = asset.media_type

function get_path(asset::Asset)
    isempty(asset.online_path) ? asset.local_path : asset.online_path
end

hash_content(x) = bytes2hex(sha1(x))

function unique_file_key(path::String)
    return hash_content(abspath(path)) * "-" * Bonito.URIs.escapeuri(basename(path))
end
unique_file_key(path) = unique_file_key(string(path))
function unique_key(asset::Asset)
    if isempty(asset.online_path)
        path = asset.local_path
        # Hide file structure from users
        return unique_file_key(normpath(abspath(expanduser(path))))
    else
        return asset.online_path
    end
end

mediatype(asset::BinaryAsset) = Symbol(HTTPServer.mimetype_to_extension(asset.mime))

function unique_file_key(asset::Asset)
    file = local_path(asset)
    return unique_file_key(normpath(abspath(expanduser(file))))
end

function unique_file_key(asset::BinaryAsset)
    key = unique_file_key(string(hash(asset.data)))
    ext = mediatype(asset)
    return "$key.$ext"
end

url(session::Session, asset::AbstractAsset) = url(session.asset_server, asset)
function url(::Nothing, asset::Asset)
    # Allow to use nothing for specifying an online url
    return asset.online_path
end

function render_asset(session::Session, asset_server, asset::Asset)
    @assert mediatype(asset) in (:css, :js, :mjs) "Found: $(mediatype(asset)))"
    ref = url(session, asset)
    if mediatype(asset) == :js
        if asset.es6module
            return DOM.script(src=ref; type="module")
        else
            return DOM.script(src=ref)
        end
    elseif mediatype(asset) == :css
        return DOM.link(href=ref, rel="stylesheet", type="text/css")
    end
end

function jsrender(session::Session, asset::Asset)
    if mediatype(asset) in (:jpeg, :jpg, :png, :svg, :gif)
        return jsrender(session, DOM.img(src=url(session, asset)))
    elseif mediatype(asset) in (:mp4, :webm, :ogg)
        vid = DOM.video(
            DOM.source(; src=url(session, asset), type="video/$(mediatype(asset))"), autoplay=true, controls=true
        )
        return jsrender(session, vid)
    elseif mediatype(asset) in (:css, :js)
        # We include css/js assets with the above `render_asset` in session_dom
        # So that we only include any depency one time
        push!(session.imports, asset)
        return nothing
    elseif mediatype(asset) == :html
        html = read(asset.local_path, String)
        return HTML{String}(html)
    else
        error("Unrecognized asset media type: $(mediatype(asset))")
    end
end

"""
    is_online(path)

Determine whether or not the specified path is a local filesystem path (and not
a remote resource that is hosted on, for example, a CDN).
"""
is_online(path::AbstractString) = any(startswith.(path, ("//", "https://", "http://", "ftp://")))
is_online(path::Path) = false # RelocatableFolders is only used for local filesystem paths
is_online(asset::Asset) = isempty(local_path(asset))
is_online(asset::BinaryAsset) = false
is_online(asset::Link) = true

online_path(asset::Link) = asset.target
online_path(asset::Asset) = asset.online_path
online_path(::BinaryAsset) = ""

function normalize_path(path::AbstractString; check_isfile=false)
    local_path = normpath(abspath(expanduser(path)))
    if check_isfile && !isfile(local_path)
        error("File $(local_path) does not exist!")
    end
    return local_path
end

# `Path` type handles all normalizations and checks
normalize_path(path::Path; check_isfile=false) = path

"""
    getextension(path)
Get the file extension of the path.
The extension is defined to be the bit after the last dot, excluding any query
string.
# Examples
```julia-repl
julia> Bonito.getextension("foo.bar.js")
"js"
julia> Bonito.getextension("https://my-cdn.net/foo.bar.css?version=1")
"css"
```
Taken from WebIO.jl
"""
function getextension(path::AbstractString)
    sym = lowercase(last(split(first(split(path, "?")), ".")))
    sym == "mjs" && return "js"
    return sym
end
getextension(path::Path) = getextension(getroot(path))

function Base.show(io::IO, asset::Asset)
    print(io, get_path(asset))
end

function bundle_folder(bundle_dir, local_path, name, media_type)
    bundle_dir = if !isnothing(bundle_dir) && !isempty(bundle_dir)
        bundle_dir
    elseif isempty(local_path)
        get_deps_path(name)
    else
        dirname(local_path)
    end
    isdir(bundle_dir) || mkpath(bundle_dir)
    return joinpath(bundle_dir, string(name, ".bundled.", media_type))
end


function generate_bundle_file(file, bundle_file)
    # If it's an URL we assume it's bundled if the bundle file exists,
    # since the content of the url should not change (use versions in URLs!)
    isfile(bundle_file) && is_online(file) && return bundle_file
    if isfile(file) || is_online(file)
        if needs_bundling(file, bundle_file)
            bundled, err = deno_bundle(file, bundle_file)
            if !bundled
                if isfile(bundle_file)
                    @debug "Failed to bundle $file: $err"
                else
                    error("Failed to bundle $file: $err")
                end
            end
        end
        return bundle_file
    else
        return bundle_file
    end
end

function Asset(path_or_url::Union{String,Path}; name=nothing, es6module=false, check_isfile=false, bundle_dir::Union{Nothing,String,Path}=nothing, mediatype=Symbol(getextension(path_or_url)))
    local_path = ""; real_online_path = ""
    if is_online(path_or_url)
        local_path = ""
        real_online_path = path_or_url
    else
        local_path = normalize_path(path_or_url; check_isfile=check_isfile)
    end

    # For JS assets, default name to filename without extension (for global name inference)
    if isnothing(name)
        name = String(splitext(basename(path_or_url))[1])
    end

     if es6module
        path = bundle_folder(bundle_dir, local_path, name, mediatype)
        # We may need to bundle immediately, since otherwise the dependencies for bunddling may be gone!
        source = is_online(path_or_url) ? real_online_path : local_path
        bundle_file = generate_bundle_file(source, path)
        if !isfile(bundle_file)
            error("Failed to bundle $source: $path. bundle_dir: $(bundle_dir)")
        end
        bundle_data = read(bundle_file) # read the into memory to make it relocatable
        content_hash = RefValue{String}(hash_content(bundle_data))
    else

        bundle_file = ""
        bundle_data = UInt8[]
        content_hash = RefValue{String}("")
    end
    return Asset(name, es6module, mediatype, real_online_path, local_path, bundle_file, bundle_data, content_hash)
end


"""
    ES6Module(path)

Create an ES6 module asset that will be bundled using Deno.

ES6 modules are automatically bundled with their dependencies when first loaded.
Interpolating an ES6Module in JavaScript code returns a `Promise` that resolves
to the module's exports.

## Example

```julia
THREE = ES6Module("https://unpkg.com/three@0.136.0/build/three.js")

js\"\"\"
\$(THREE).then(module => {
    // Use the module
    const scene = new module.Scene();
})
\"\"\"
```

## Rebundling

Bonito tracks the timestamp of the main module file and will automatically
rebundle if it detects changes. However, changes to imported/included files
(e.g., `Session.js` imported by `Bonito.js`) are not tracked.

To force a rebundle when you've modified an included file, delete the bundle file:

```julia
mod = ES6Module("path/to/module.js")
rm(mod.bundle_file)  # Bonito will rebundle on next use
```

For Bonito's internal JavaScript:

```julia
rm(Bonito.BonitoLib.bundle_file)
```
"""
function ES6Module(path)
    name = String(splitext(basename(path))[1])
    asset = Asset(path; name=name, es6module=true)
    return asset
end

function CDNSource(name; user=nothing, version=nothing)
    url = "https://esm.sh/"
    if !isnothing(user)
        url = url * user * "/"
    end
    url = url * name
    if !isnothing(version)
        url = "$(url)@$(version)"
    end
    return Asset(url; name=name, es6module=true)
end

function to_data_url(file_path; mime = file_mimetype(file_path))
    isfile(file_path) || error("File not found: $(file_path)")
    return sprint() do io
        print(io, "data:$(mime);base64,")
        iob64_encode = Base64EncodePipe(io)
        open(file_path, "r") do io
            write(iob64_encode, io)
        end
        close(iob64_encode)
    end
end

function to_data_url(source::String, mime::String)
    return sprint() do io
        print(io, "data:$(mime);base64,")
        iob64_encode = Base64EncodePipe(io)
        print(iob64_encode, source)
        close(iob64_encode)
    end
end

function to_data_url(binary::Vector{UInt8}, mime="application/octet-stream")
    return sprint() do io
        print(io, "data:$(mime);base64,")
        iob64_encode = Base64EncodePipe(io)
        write(iob64_encode, binary)
        close(iob64_encode)
    end
end

function local_path(asset::Asset)
    if asset.es6module
        bundle!(asset)
        return bundle_path(asset)
    else
        return asset.local_path
    end
end

function get_deps_path(name)
    folder = abspath(first(Base.DEPOT_PATH), "Bonito")
    isdir(folder) || mkpath(folder)
    return joinpath(folder, name)
end

function bundle_path(asset::Asset)
    return asset.bundle_file
end

last_modified(path::Path) = last_modified(getroot(path))
function last_modified(path::String)
    Dates.unix2datetime(Base.Filesystem.mtime(path))
end

function needs_bundling(path, bundled)
    is_online(path) && return !isfile(bundled)
    !isfile(bundled) && return true
    # If bundled happen after last modification of asset
    return last_modified(path) > last_modified(bundled)
end

function needs_bundling(asset::Asset)
    asset.es6module || return false
    path = get_path(asset)
    bundled = bundle_path(asset)
    return needs_bundling(path, bundled)
end



bundle!(asset::BinaryAsset) = nothing

function bundle!(asset::Asset)
    needs_bundling(asset) || return
    bundle_file = String(bundle_path(asset))
    source = String(get_path(asset))
    has_been_bundled, err = deno_bundle(source, bundle_file)
    if isfile(bundle_file)
        data = read(bundle_file)
        resize!(asset.bundle_data, length(data))
        copyto!(asset.bundle_data, data)
        asset.content_hash[] = hash_content(data)
        # when shipping, we don't have the correct time stamps, so we can't accurately say if we need bundling :(
        # So we need to rely on the package authors to bundle before creating a new release!
        return
    end
    # if bundle_data is stored in the asset, we dont necessarily need to bundle
    # But it's likely outdated - which is fine for e.g. relocatable packages
    if !has_been_bundled && isempty(asset.bundle_data)
        # Not bundling if bundling is needed is an error...
        # In theory it could be a warning, but this way we make CI fail, so that
        # PRs that forget to bundle JS dependencies will fail!
        error("Asset $(asset) needs bundling.
            If you've edited the asset, please load `Deno_jll` (e.g. `using Deno_jll, Bonito`),
            which is an optional dependency needed for Developing Bonito Assets.
            After that, assets should be bundled on precompile and whenever they're used after editing the asset.
            If you're just using a package, please open an issue with the Package maintainers,
            they must have forgotten bundling.
            Error: $err")
    end
    if !isempty(asset.bundle_data) && !has_been_bundled && isfile(source)
        @warn "Asset $(asset) being served from memory, but failed to bundle with error: $(err)."
    end
    return
end

@testset "basic session rendering" begin
    # Use no connection, since otherwise the session will be added to
    # The global running HTTP server
    session = OfflineSession()
    obs1 = Observable(1)
    TestLib = Bonito.BonitoLib
    dom = App(DOM.div(test=obs1, onload=js"$(TestLib).lol()"))
    sdom = Bonito.session_dom(session, dom; init=false) # Init false to not inline messages
    msg = Bonito.fused_messages!(session)
    data = Bonito.SerializedMessage(session, msg)
    decoded = msg[:payload][1]
    mapped = obs1.listeners[1][2].result # we map(render, obs1) when rendering attributes, so only that will be in the session
    @test haskey(session.session_objects, mapped.id)
    # Obs registered correctly
    @test mapped.listeners[1][2] isa Bonito.JSUpdateObservable
    session_cache = decoded.cache
    @test session_cache isa Bonito.SessionCache
    @test haskey(session_cache.objects, mapped.id)
    @test haskey(session.session_objects, mapped.id)

    # Will deregisters correctly on session close
    @test length(session.deregister_callbacks) == 1
    @test session.deregister_callbacks[1].observable === obs1
    @test occursin("Bonito.update_node_attribute", string(decoded.data["payload"]))
    close(session)
    @test isempty(obs1.listeners)
    @test isempty(mapped.listeners)
end

struct DebugConnection <: Bonito.FrontendConnection
    io::IOBuffer
end

DebugConnection() = DebugConnection(IOBuffer())
Base.write(connection::DebugConnection, bytes::AbstractVector{UInt8}) = write(connection.io, bytes)
Base.isopen(connection::DebugConnection) = isopen(connection.io)
Base.close(connection::DebugConnection) = close(connection.io)
setup_connection(session::Session{DebugConnection}) = nothing

@testset "Session & Subsession rendering & cleanup" begin
    connection = DebugConnection()
    open_session = Bonito.Session(connection; asset_server=Bonito.NoServer())
    put!(open_session.connection_ready, true)
    @test isopen(open_session)
    Bonito.CURRENT_SESSION[] = open_session

    rslider = Bonito.RangeSlider(1:100; value=[10, 80])

    for obs_field in (:range, :value, :connect, :orientation, :tooltips, :ticks)
        obs = getfield(rslider, obs_field)
        @test isempty(obs.listeners)
    end

    sliderapp = Bonito.App(rslider);
    html = sprint() do io
        sub = Bonito.show(io, MIME"text/html"(), sliderapp)
        msg = Bonito.fused_messages!(sub)
        Bonito.serialize_binary(sub, msg)
    end

    @test length(open_session.children) == 1
    c_session = first(open_session.children)[2]
    # ID of div correctly set to child session
    @test occursin("id=\"$(c_session.id)\"", html)

    @testset "assets" begin
        @test length(c_session.session_objects) == 2
    end

    @testset "observable $(obs_field)" for obs_field in (:range, :value, :connect, :orientation, :tooltips, :ticks)
        obs = getfield(rslider, obs_field)
        @test length(obs.listeners) == 1
        if obs_field == :value
            @test haskey(open_session.session_objects, obs.id)
            @test obs.listeners[1][2] isa Bonito.JSUpdateObservable
        end
    end

    @testset "closing" begin
        close(c_session)
        # All listeners should get disconnected!
        for obs_field in (:range, :value, :connect, :orientation, :tooltips, :ticks)
            obs = getfield(rslider, obs_field)
            @test isempty(obs.listeners)
        end
        # all obs need to get removed
        @test isempty(c_session.session_objects)
        @test !haskey(open_session.children, c_session.id)
    end

    @testset "dependency second include" begin
        html2 = sprint() do io
            sub = Bonito.show(io, MIME"text/html"(), sliderapp)
            msg = Bonito.fused_messages!(sub)
            Bonito.serialize_binary(sub, msg)
        end
        # Test that dependencies only get loaded one time!
        @test !occursin("-nouislider.min.js", html2)
        @test !occursin("nouislider.min.css", html2)

        id, session = first(open_session.children)
        close(session)
        @test !haskey(open_session.children, session.id)
    end
end

function test_dangling_app()
    parent = OfflineSession()
    sub = Session(parent)
    init_dom = Bonito.session_dom(parent, App(nothing))
    app = App() do s
        obs = Observable(1)
        return evaljs(s, js"$(obs)")
    end
    sub_dom = Bonito.session_dom(sub, app)
    GC.gc(true)
    # If finalizer get triggered closing the session, there will be
    pso = parent.session_objects
    sso = sub.session_objects
    return !isempty(pso) && !isempty(sso) && all(v -> haskey(pso, v), collect(keys(sso)))
end

@testset "don't gc sessions for dangling apps" begin
    @test test_dangling_app()
    @test test_dangling_app()
end

@testset "observable update" begin
    obs1 = Observable(1)
    obs2 = Observable(2)
    obs3 = Observable(3)
    obs4 = Observable{Any}(4)

    function observable_update_app(s, r)
        evaljs(s, js"""
        $obs1.notify(0, true);
        $obs2.notify($obs1.value);
        $obs3.notify(12);
        $obs4.notify(null);
        """)
        return DOM.div()
    end

    testsession(observable_update_app; port=8555) do app
        @test obs1[] == 1
        @test obs2[] == 0
        @test obs3[] == 12
        @test obs4[] === nothing
    end
end

# @testset "" begin
#     obs2 = Observable("hey")
#     obs[] = App() do s
#         global sub = s
#         DOM.div("hehe", js"$(obs2).on(x=> console.log(x))")
#     end;

#     @test session.children[sub.id] === sub
#     @test sub.session_objects[obs2.id] == nothing
#     @test haskey(session.session_objects, obs2.id)
#     @test haskey(session.observables, obs2.id)
#     Bonito.evaljs_value(session, js"""(()=>{
#         return Bonito.Sessions.GLOBAL_OBJECT_CACHE[$(obs2.id)][1]
#     })()""")

#     obs[] = App(()-> DOM.div("hoehoe", js"console.log('please delete old session?')"));
#     @test !haskey(session.children, sub.id)
#     @test !haskey(session.session_objects, obs2.id)
#     @test !haskey(session.observables, obs2.id)

#     @test Bonito.evaljs_value(session, js"""(()=>{
#         const a = $(obs2.id) in Bonito.Sessions.GLOBAL_OBJECT_CACHE
#         const b = $(sub.id) in Bonito.Sessions.SESSIONS
#         return !a && !b
#     })()""")

#     session.observables

#     Bonito.evaljs_value(session, js"""(()=>{
#         return Bonito.Sessions.GLOBAL_OBJECT_CACHE.length
#     })()""")

#     color = Observable("color: red;")
#     text = Observable("hehe")
#     app = App() do
#         DOM.div(text; style=color)
#     end;

#     parent = Session()
#     Bonito.session_dom(parent, app)

#     @test haskey(parent.observables, color.id)
#     @test haskey(parent.observables, text.listeners[1][2].html.id)

#     session = Session(parent)

#     new_obs = Observable([1,23,])
#     app2 = App() do
#         DOM.div(js"$new_obs"; style=color)
#     end;
#     dom = Bonito.session_dom(session, app2)

#     msg = Bonito.fused_messages!(session)
#     ser_msg = Bonito.serialize_cached(session, msg)

#     @test Bonito.root_session(session) == parent
#     @test Bonito.root_session(session) !== session

#     # Session shouldn't own, color
#     @test !haskey(session.session_objects, color.id)
#     @test session.session_objects[new_obs.id] == nothing
#     @test haskey(parent.session_objects, new_obs.id)
#     close(session)

#     @test isempty(session.session_objects)
#     @test !isopen(session)
#     # New obs the session brought in should stay:
#     @test !haskey(parent.session_objects, new_obs.id)
#     @test haskey(parent.session_objects, color.id)

# end

struct SerializationContext
    # OrderedDict preserves insertion order, which ensures that dependencies (inner observables)
    # are serialized before their dependents (outer observables containing CacheKey references).
    # This is critical for static export where the JS side deserializes the cache dict
    # and needs to resolve CacheKey references during unpacking.
    message_cache::OrderedDict{String, Any}
    session::Session
end

function SerializationContext(session::Session)
    return SerializationContext(OrderedDict{String,Any}(), session)
end

object_identity(retain::Retain) = object_identity(retain.value)
object_identity(obs::Observable) = obs.id
object_identity(obj::Any) = string(hash(obj))


function register_observable!(session::Session, obs::Observable)
    # Always register with root session!
    # TODO, this may be a problem for Observable{Observable}
    # since the updates are serialized via the root session then, which means they will never get freed
    root = root_session(session)
    # Only register one time
    if !haskey(root.session_objects, obs.id)
        updater = JSUpdateObservable(session, obs.id)
        # Don't deregister on root / or session close
        # The updaters callbacks are freed manually in delete_cached!`
        on(updater, obs)
    end
    return
end


function serialize_cached(context::SerializationContext, retain::Retain)
    return add_cached!(context.session, context.message_cache, retain) do
        obs = retain.value
        register_observable!(context.session, obs)
        return Retain(SerializedObservable(obs.id, serialize_cached(context, obs[])))
    end
end

function serialize_cached(context::SerializationContext, obs::Observable)
    return add_cached!(context.session, context.message_cache, obs) do
        register_observable!(context.session, obs)
        return SerializedObservable(obs.id, serialize_cached(context, obs[]))
    end
end

function serialize_cached(context::SerializationContext, js::JSCode)
    jscontext = JSSourceContext(context.session)
    # Print code while collecting all interpolated objects in an IdDict
    code = sprint() do io
        print_js_code(io, js, jscontext)
    end
    # reverse lookup and serialize elements
    interpolated_objects = Dict{String,Any}(v => serialize_cached(context, k) for (k, v) in jscontext.objects)
    return SerializedJSCode(
        interpolated_objects,
        code,
        js.file
    )
end

function serialize_cached(context::SerializationContext, node::Node{Hyperscript.HTMLSVG})
    return SerializedNode(context.session, node)
end

function serialize_cached(context::SerializationContext, lu::LargeUpdate)
    return serialize_cached(context, lu.data)
end


serialize_cached(::SerializationContext, @nospecialize(obj)) = obj
serialize_cached(::SerializationContext, native::MSGPACK_NATIVE_TYPES) = native
serialize_cached(::SerializationContext, native::AbstractArray{<:Number}) = native

function serialize_cached(context::SerializationContext, x::Union{AbstractArray, Tuple})
    result = Vector{Any}(undef, length(x))
    @inbounds for (i, elem) in enumerate(x)
        result[i] = serialize_cached(context, elem)
    end
    return result
end

function serialize_cached(context::SerializationContext, dict::AbstractDict)
    result = Dict{String, Any}()
    for (k, v) in dict
        result[string(k)] = serialize_cached(context, v)
    end
    return result
end

"""
    add_cached!(create_cached_object::Function, session::Session, message_cache::AbstractDict{String, Any}, key::String)

Checks if key is already cached by the session or it's root session (we skip any child session between root -> this session).
If not cached already, we call `create_cached_object` to create a serialized form of the object corresponding to `key` and cache it.
We return nothing if already cached, or the serialized object if not cached.
We also handle the part of adding things to the message_cache from the serialization context.
"""
function add_cached!(create_cached_object::Function, session::Session, send_to_js::AbstractDict{String, Any}, @nospecialize(object))::CacheKey
    root = root_session(session)
    lock(root.deletion_lock) do
        key = object_identity(object)::String
        result = CacheKey(key)
        # If already in session, there's nothing we need to do, since we've done the work the first time we added the object
        if haskey(session.session_objects, key)
            return result
        end
        # Now, we have two code paths, depending on whether we have a child session or a root session
        # we are root, so we simply cache the object (we already checked it's not cached yet)
        if root === session
            send_to_js[key] = create_cached_object()
            session.session_objects[key] = object
            return result
        else
            # This session is a child session.
            # Now we need to figure out if the root session has the object cached already
            # The root session has our object cached already.
            session.session_objects[key] = nothing # session needs to reference this to "own" it
            if haskey(root.session_objects, key)
                # in this case, we just add the key to send to js, so that the JS side can associate the object with this session
                send_to_js[key] = TrackingOnly(key)
                return result
            end
            # Nobody has the object cached,
            # so we add this session as the owner, but also add it to the root session
            send_to_js[key] = create_cached_object()
            root.session_objects[key] = object
            return result
        end
    end
end

function child_has_reference(child::Session, key)
    haskey(child.session_objects, key) && return true
    return any(((id, s),)-> child_has_reference(s, key), child.children)
end

function remove_js_updates!(session::Session, observable::Observable)
    filter!(observable.listeners) do (prio, f)
        !(f isa JSUpdateObservable && f.session === session)
    end
end

function delete_cached!(root::Session, sub::Session, key::String)
    if !haskey(root.session_objects, key)
        # This should uncover any fault in our caching logic!
        @warn("Deleting key that doesn't belong to any cached object")
        return
    end
    # We only free Retain, when the root session is closing!
    root.session_objects[key] isa Retain && return
    # We don't do reference counting, but we check if any child still holds a reference to the object we want to delete
    has_ref = any(((id, s),)-> child_has_reference(s, key), root.children)
    if !has_ref
        # So only delete it if nobody has it anymore!
        object = pop!(root.session_objects, key)
        if object isa Observable
            # unregister all listeners updating the session
            remove_js_updates!(sub, object)
        end
    end
end


function force_delete!(root::Session, key::String)
    if !haskey(root.session_objects, key)
        # This should uncover any fault in our caching logic!
        @warn("Deleting key that doesn't belong to any cached object")
        return nothing
    end
    # We only free Retain, when the root session is closing!
    object = pop!(root.session_objects, key)
    if object isa Retain
        object = object.value
    end
    if object isa Observable
        # unregister all listeners updating the session
        remove_js_updates!(root, object)
    end
end

using Bonito
using Observables
using Hyperscript

app = App() do session::Session
    editor = CodeEditor("julia"; initial_source="""1 + 1""")
    eval_button = Button("eval")
    output = Observable(DOM.div())
    on(eval_button) do click
        src = editor.onchange[]
        result = eval(Bonito.parseall(src))
        output[] = DOM.div(result)
    end
    return DOM.div(editor, eval_button, output)
end

function SubConnection(parent::Session)
    return SubConnection(parent.connection, false)
end

function Base.write(connection::SubConnection, msg::SerializedMessage)
    write(connection.connection, msg)
end

function Base.write(connection::SubConnection, binary::AbstractVector{UInt8})
    write(connection.connection, binary)
end

Base.isopen(connection::SubConnection) = connection.isopen
Base.close(connection::SubConnection) = (connection.isopen = false)
open!(connection::SubConnection) = (connection.isopen = true)

setup_connection(::Session{SubConnection}) = nothing

struct Break end

function walk_dom(f, x::JSCode, visited = IdDict())
    f(x)
    walk_dom(f, x.source, visited)
end

walk_dom(f, x, visited = IdDict()) = f(x)

walk_dom(f, x::Markdown.MD, visited = IdDict()) = walk_dom(f, x.content, visited)
walk_dom(f, x::Markdown.Header, visited = IdDict()) = walk_dom(f, x.text, visited)
walk_dom(f, x::Markdown.Paragraph, visited = IdDict()) = walk_dom(f, x.content, visited)

function walk_dom(f, x::Union{Tuple, AbstractVector, Pair}, visited = IdDict())
    get!(visited, x, nothing) !== nothing && return
    for elem in x
        f(elem)
        res = walk_dom(f, elem, visited)
        res isa Break && return res
    end
end

function walk_dom(f, x::Node, visited = IdDict())
    get!(visited, x, nothing) !== nothing && return
    for elem in children(x)
        f(elem)
        res = walk_dom(f, elem, visited)
        res isa Break && return res
    end
    for (name, elem) in Hyperscript.attrs(x)
        f(elem)
        res = walk_dom(f, elem, visited)
        res isa Break && return res
    end
end

function find_head_body(dom::Node)
    head = nothing
    body = nothing
    walk_dom(dom) do x
        !(x isa Node) && return
        t = Hyperscript.tag(x)
        if t == "body"
            body = x
        elseif t == "head"
            head = x
        end
        # if we found head & body, we can exit!
        !isnothing(body) && !isnothing(head) && return Break()
    end

    return head, body, dom
end

const mime_order = MIME.((
    "text/html", "text/latex", "image/svg+xml", "image/png",
    "image/jpeg", "text/markdown", "application/javascript", "text/plain"
))

function richest_mime(val)
    for mimetype in mime_order
        showable(mimetype, val) && return mimetype
    end
    error("value with type $(typeof(val)) not writable for any mimetypes")
end

mime_string(::MIME{T}) where {T} = string(T)

function wait_for(condition; timeout=10)
    tstart = time()
    while true
        sleep(0.001)
        cond = condition()
        cond === true && return :success
        cond isa Symbol && return cond
        (time() - tstart > timeout) && return :timed_out
    end
    return
end

const PLUTO_PKG_ID = Base.PkgId(Base.UUID("c3e4b0f8-55cb-11ea-2926-15256bba5781"), "Pluto")

mutable struct PlutoConnection <: FrontendConnection
    connection::WebSocketConnection
end

PlutoConnection() = PlutoConnection(WebSocketConnection())

Base.isopen(pluto::PlutoConnection) = isopen(pluto.connection)

function Base.write(ws::PlutoConnection, binary::AbstractVector{UInt8})
    write(ws.connection, binary)
end

function Base.close(ws::PlutoConnection)
    close(ws.connection)
end

function setup_connection(session::Session{PlutoConnection})
    return setup_connection(session, session.connection.connection)
end

function jsrender(session::Session, indicator::ConnectionIndicator)
    # Build the default styles for the indicator LED
    default_style = Styles(
        "width" => "$(indicator.size)px",
        "height" => "$(indicator.size)px",
        "border-radius" => "50%",
        "position" => indicator.position,
        "top" => indicator.top,
        "right" => indicator.right,
        "background-color" => indicator.disconnected_color,
        "box-shadow" => "0 0 $(indicator.size ÷ 2)px $(indicator.disconnected_color)",
        "transition" => "background-color 0.3s ease, box-shadow 0.3s ease, transform 0.15s ease",
        "cursor" => "pointer",
        "z-index" => "9999",
        "user-select" => "none",
        "pointer-events" => "auto",
    )

    # CSS for hover effects
    indicator_css = Styles(
        CSS(
            ".bonito-indicator:hover",
            "transform" => "scale(1.3)",
            "filter" => "brightness(1.2)",
        ),
        CSS(
            ".bonito-indicator:active",
            "transform" => "scale(1.1)",
        ),
    )

    final_style = Styles(default_style, indicator.style)

    # Create the LED element
    led_element = DOM.div(;
        style=final_style,
        title="Disconnected",
        class="bonito-indicator",
    )

    # JavaScript to register the indicator and handle state changes
    # Use onload to ensure the LED element exists in the DOM
    indicator_script = js"""
    function initIndicator(led) {
        const colors = {
            connected: $(indicator.connected_color),
            connecting: $(indicator.connecting_color),
            disconnected: $(indicator.disconnected_color),
            no_connection: $(indicator.no_connection_color)
        };

        const tooltips = {
            connected: "Connected to Julia server",
            connecting: "Connecting to Julia server...",
            disconnected: "Disconnected from Julia server",
            no_connection: "No connection (static mode) - Julia interaction disabled"
        };

        const indicatorObj = {
            onStatusChange: function(status) {
                if (!led) return;
                // Map status to color
                const color = colors[status] || colors.disconnected;
                led.style.backgroundColor = color;
                led.style.boxShadow = '0 0 ' + ($(indicator.size) / 2) + 'px ' + color;

                // Update tooltip
                led.title = tooltips[status] || tooltips.disconnected;
            }
        };

        // Register with Bonito
        if (typeof Bonito !== 'undefined' && Bonito.register_connection_indicator) {
            Bonito.register_connection_indicator(indicatorObj);
        }
    }
    """

    # Use onload to ensure the element is in the DOM before registering
    onload(session, led_element, indicator_script)

    return jsrender(session, DOM.div(indicator_css, led_element))
end

# Allow jsrender to handle nothing (no indicator)
jsrender(session::Session, ::Nothing) = nothing

# Note: this file was originally part of https://github.com/JuliaWeb/HttpServer.jl
# released under the following license:
#
# The MIT License (MIT)
#
# Copyright (c) 2013 Daniel Espeset, Zach Allaun, Leah Hanson
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

const known_mimetypes = Dict([
    "semd" => "application/vnd.semd",
    "mrc" => "application/marc",
    "asc" => "application/pgp-signature",
    "fe_launch" => "application/vnd.denovo.fcselayout-link",
    "esa" => "application/vnd.osgi.subsystem",
    "sub" => "text/vnd.dvb.subtitle",
    "clkx" => "application/vnd.crick.clicker",
    "xdw" => "application/vnd.fujixerox.docuworks",
    "nsc" => "application/x-conference",
    "lostxml" => "application/lost+xml",
    "rsd" => "application/rsd+xml",
    "p8" => "application/pkcs8",
    "dra" => "audio/vnd.dra",
    "x3db" => "model/x3d+binary",
    "text" => "text/plain",
    "vox" => "application/x-authorware-bin",
    "bmi" => "application/vnd.bmi",
    "ma" => "application/mathematica",
    "xbd" => "application/vnd.fujixerox.docuworks.binder",
    "mgz" => "application/vnd.proteus.magazine",
    "pgm" => "image/x-portable-graymap",
    "xpi" => "application/x-xpinstall",
    "htm" => "text/html",
    "lasxml" => "application/vnd.las.las+xml",
    "ait" => "application/vnd.dvb.ait",
    "abw" => "application/x-abiword",
    "wm" => "video/x-ms-wm",
    "sdkd" => "application/vnd.solent.sdkm+xml",
    "swi" => "application/vnd.aristanetworks.swi",
    "iif" => "application/vnd.shana.informed.interchange",
    "bpk" => "application/octet-stream",
    "gxt" => "application/vnd.geonext",
    "wpl" => "application/vnd.ms-wpl",
    "sxd" => "application/vnd.sun.xml.draw",
    "ktx" => "image/ktx",
    "acc" => "application/vnd.americandynamics.acc",
    "mxml" => "application/xv+xml",
    "setpay" => "application/set-payment-initiation",
    "aac" => "audio/x-aac",
    "vsw" => "application/vnd.visio",
    "uris" => "text/uri-list",
    "mp4" => "video/mp4",
    "st" => "application/vnd.sailingtracker.track",
    "3ds" => "image/x-3ds",
    "sgm" => "text/sgml",
    "xwd" => "image/x-xwindowdump",
    "slt" => "application/vnd.epson.salt",
    "pya" => "audio/vnd.ms-playready.media.pya",
    "dir" => "application/x-director",
    "utz" => "application/vnd.uiq.theme",
    "z6" => "application/x-zmachine",
    "z4" => "application/x-zmachine",
    "xvm" => "application/xv+xml",
    "pki" => "application/pkixcmp",
    "vor" => "application/vnd.stardivision.writer",
    "vxml" => "application/voicexml+xml",
    "plb" => "application/vnd.3gpp.pic-bw-large",
    "tar" => "application/x-tar",
    "dmp" => "application/vnd.tcpdump.pcap",
    "gmx" => "application/vnd.gmx",
    "spf" => "application/vnd.yamaha.smaf-phrase",
    "susp" => "application/vnd.sus-calendar",
    "xlam" => "application/vnd.ms-excel.addin.macroenabled.12",
    "odf" => "application/vnd.oasis.opendocument.formula",
    "wspolicy" => "application/wspolicy+xml",
    "gml" => "application/gml+xml",
    "msl" => "application/vnd.mobius.msl",
    "mseq" => "application/vnd.mseq",
    "rmvb" => "application/vnd.rn-realmedia-vbr",
    "saf" => "application/vnd.yamaha.smaf-audio",
    "fh7" => "image/x-freehand",
    "uvvu" => "video/vnd.uvvu.mp4",
    "mpkg" => "application/vnd.apple.installer+xml",
    "shf" => "application/shf+xml",
    "org" => "application/vnd.lotus-organizer",
    "cpp" => "text/x-c",
    "deploy" => "application/octet-stream",
    "uvu" => "video/vnd.uvvu.mp4",
    "z3" => "application/x-zmachine",
    "application" => "application/x-ms-application",
    "wps" => "application/vnd.ms-works",
    "dtd" => "application/xml-dtd",
    "cww" => "application/prs.cww",
    "cmdf" => "chemical/x-cmdf",
    "mpe" => "video/mpeg",
    "sv4crc" => "application/x-sv4crc",
    "appcache" => "text/cache-manifest",
    "in" => "text/plain",
    "png" => "image/png",
    "wmv" => "video/x-ms-wmv",
    "aep" => "application/vnd.audiograph",
    "gim" => "application/vnd.groove-identity-message",
    "sdd" => "application/vnd.stardivision.impress",
    "ccxml" => "application/ccxml+xml",
    "sh" => "application/x-sh",
    "pptm" => "application/vnd.ms-powerpoint.presentation.macroenabled.12",
    "sdkm" => "application/vnd.solent.sdkm+xml",
    "ulx" => "application/x-glulx",
    "xbap" => "application/x-ms-xbap",
    "xlsm" => "application/vnd.ms-excel.sheet.macroenabled.12",
    "n-gage" => "application/vnd.nokia.n-gage.symbian.install",
    "stc" => "application/vnd.sun.xml.calc.template",
    "icc" => "application/vnd.iccprofile",
    "f4v" => "video/x-f4v",
    "mmr" => "image/vnd.fujixerox.edmics-mmr",
    "eml" => "message/rfc822",
    "rgb" => "image/x-rgb",
    "m3a" => "audio/mpeg",
    "cdbcmsg" => "application/vnd.contact.cmsg",
    "jlt" => "application/vnd.hp-jlyt",
    "xar" => "application/vnd.xara",
    "icm" => "application/vnd.iccprofile",
    "etx" => "text/x-setext",
    "iges" => "model/iges",
    "clkw" => "application/vnd.crick.clicker.wordbank",
    "uvva" => "audio/vnd.dece.audio",
    "pcurl" => "application/vnd.curl.pcurl",
    "rq" => "application/sparql-query",
    "azf" => "application/vnd.airzip.filesecure.azf",
    "gram" => "application/srgs",
    "jad" => "text/vnd.sun.j2me.app-descriptor",
    "mmf" => "application/vnd.smaf",
    "c4u" => "application/vnd.clonk.c4group",
    "mp4s" => "application/mp4",
    "jsonml" => "application/jsonml+json",
    "itp" => "application/vnd.shana.informed.formtemplate",
    "nc" => "application/x-netcdf",
    "qwd" => "application/vnd.quark.quarkxpress",
    "spp" => "application/scvp-vp-response",
    "pqa" => "application/vnd.palm",
    "uvv" => "video/vnd.dece.video",
    "pub" => "application/x-mspublisher",
    "gph" => "application/vnd.flographit",
    "rmp" => "audio/x-pn-realaudio-plugin",
    "ott" => "application/vnd.oasis.opendocument.text-template",
    "cdkey" => "application/vnd.mediastation.cdkey",
    "wqd" => "application/vnd.wqd",
    "gqf" => "application/vnd.grafeq",
    "sv4cpio" => "application/x-sv4cpio",
    "skm" => "application/vnd.koan",
    "swa" => "application/x-director",
    "html" => "text/html",
    "uvz" => "application/vnd.dece.zip",
    "p7s" => "application/pkcs7-signature",
    "uvvs" => "video/vnd.dece.sd",
    "p7r" => "application/x-pkcs7-certreqresp",
    "wrl" => "model/vrml",
    "f77" => "text/x-fortran",
    "uvvd" => "application/vnd.dece.data",
    "crt" => "application/x-x509-ca-cert",
    "ppt" => "application/vnd.ms-powerpoint",
    "smzip" => "application/vnd.stepmania.package",
    "osf" => "application/vnd.yamaha.openscoreformat",
    "c11amc" => "application/vnd.cluetrust.cartomobile-config",
    "m4u" => "video/vnd.mpegurl",
    "mpt" => "application/vnd.ms-project",
    "plf" => "application/vnd.pocketlearn",
    "cbt" => "application/x-cbr",
    "mseed" => "application/vnd.fdsn.mseed",
    "ecma" => "application/ecmascript",
    "srx" => "application/sparql-results+xml",
    "cxt" => "application/x-director",
    "mwf" => "application/vnd.mfer",
    "pkg" => "application/octet-stream",
    "ami" => "application/vnd.amiga.ami",
    "mvb" => "application/x-msmediaview",
    "xdssc" => "application/dssc+xml",
    "rss" => "application/rss+xml",
    "s" => "text/x-asm",
    "odp" => "application/vnd.oasis.opendocument.presentation",
    "mng" => "video/x-mng",
    "lvp" => "audio/vnd.lucent.voice",
    "mj2" => "video/mj2",
    "uvp" => "video/vnd.dece.pd",
    "dts" => "audio/vnd.dts",
    "tga" => "image/x-tga",
    "h263" => "video/h263",
    "mpp" => "application/vnd.ms-project",
    "xvml" => "application/xv+xml",
    "mdi" => "image/vnd.ms-modi",
    "fnc" => "application/vnd.frogans.fnc",
    "json" => "application/json",
    "otp" => "application/vnd.oasis.opendocument.presentation-template",
    "m4v" => "video/x-m4v",
    "oti" => "application/vnd.oasis.opendocument.image-template",
    "ps" => "application/postscript",
    "kpxx" => "application/vnd.ds-keypoint",
    "m13" => "application/x-msmediaview",
    "torrent" => "application/x-bittorrent",
    "shar" => "application/x-shar",
    "acutc" => "application/vnd.acucorp",
    "smil" => "application/smil+xml",
    "wcm" => "application/vnd.ms-works",
    "uvvt" => "application/vnd.dece.ttml+xml",
    "xop" => "application/xop+xml",
    "knp" => "application/vnd.kinar",
    "cpio" => "application/x-cpio",
    "mc1" => "application/vnd.medcalcdata",
    "svg" => "image/svg+xml",
    "blb" => "application/x-blorb",
    "u32" => "application/x-authorware-bin",
    "hlp" => "application/winhlp",
    "jpgv" => "video/jpeg",
    "onetmp" => "application/onenote",
    "flac" => "audio/x-flac",
    "ssdl" => "application/ssdl+xml",
    "sfs" => "application/vnd.spotfire.sfs",
    "sdc" => "application/vnd.stardivision.calc",
    "dotx" => "application/vnd.openxmlformats-officedocument.wordprocessingml.template",
    "uvvx" => "application/vnd.dece.unspecified",
    "uvvp" => "video/vnd.dece.pd",
    "atc" => "application/vnd.acucorp",
    "cfs" => "application/x-cfs-compressed",
    "mets" => "application/mets+xml",
    "wav" => "audio/x-wav",
    "mods" => "application/mods+xml",
    "thmx" => "application/vnd.ms-officetheme",
    "mbk" => "application/vnd.mobius.mbk",
    "cpt" => "application/mac-compactpro",
    "fzs" => "application/vnd.fuzzysheet",
    "mrcx" => "application/marcxml+xml",
    "mlp" => "application/vnd.dolby.mlp",
    "emma" => "application/emma+xml",
    "ecelp9600" => "audio/vnd.nuera.ecelp9600",
    "dvi" => "application/x-dvi",
    "lrm" => "application/vnd.ms-lrm",
    "mif" => "application/vnd.mif",
    "mcd" => "application/vnd.mcd",
    "cxx" => "text/x-c",
    "dist" => "application/octet-stream",
    "pml" => "application/vnd.ctc-posml",
    "t3" => "application/x-t3vm-image",
    "ots" => "application/vnd.oasis.opendocument.spreadsheet-template",
    "umj" => "application/vnd.umajin",
    "sit" => "application/x-stuffit",
    "pptx" => "application/vnd.openxmlformats-officedocument.presentationml.presentation",
    "css" => "text/css",
    "g2w" => "application/vnd.geoplan",
    "spx" => "audio/ogg",
    "eva" => "application/x-eva",
    "et3" => "application/vnd.eszigno3+xml",
    "dart" => "application/vnd.dart",
    "3gp" => "video/3gpp",
    "kne" => "application/vnd.kinar",
    "rnc" => "application/relax-ng-compact-syntax",
    "m14" => "application/x-msmediaview",
    "urls" => "text/uri-list",
    "vst" => "application/vnd.visio",
    "xslt" => "application/xslt+xml",
    "xspf" => "application/xspf+xml",
    "g3w" => "application/vnd.geospace",
    "mxs" => "application/vnd.triscape.mxs",
    "les" => "application/vnd.hhe.lesson-player",
    "txf" => "application/vnd.mobius.txf",
    "f" => "text/x-fortran",
    "ief" => "image/ief",
    "dxp" => "application/vnd.spotfire.dxp",
    "tsd" => "application/timestamped-data",
    "bed" => "application/vnd.realvnc.bed",
    "azs" => "application/vnd.airzip.filesecure.azs",
    "pfr" => "application/font-tdpfr",
    "seed" => "application/vnd.fdsn.seed",
    "mobi" => "application/x-mobipocket-ebook",
    "dsc" => "text/prs.lines.tag",
    "man" => "text/troff",
    "deb" => "application/x-debian-package",
    "asx" => "video/x-ms-asf",
    "xlsb" => "application/vnd.ms-excel.sheet.binary.macroenabled.12",
    "cb7" => "application/x-cbr",
    "weba" => "audio/webm",
    "fdf" => "application/vnd.fdf",
    "exi" => "application/exi",
    "otg" => "application/vnd.oasis.opendocument.graphics-template",
    "list" => "text/plain",
    "mus" => "application/vnd.musician",
    "cod" => "application/vnd.rim.cod",
    "qxb" => "application/vnd.quark.quarkxpress",
    "pot" => "application/vnd.ms-powerpoint",
    "mads" => "application/mads+xml",
    "cab" => "application/vnd.ms-cab-compressed",
    "fh" => "image/x-freehand",
    "xlm" => "application/vnd.ms-excel",
    "ogx" => "application/ogg",
    "pkipath" => "application/pkix-pkipath",
    "xaml" => "application/xaml+xml",
    "vtu" => "model/vnd.vtu",
    "fgd" => "application/x-director",
    "ngdat" => "application/vnd.nokia.n-gage.data",
    "scm" => "application/vnd.lotus-screencam",
    "txd" => "application/vnd.genomatix.tuxedo",
    "ptid" => "application/vnd.pvi.ptid1",
    "nnd" => "application/vnd.noblenet-directory",
    "nml" => "application/vnd.enliven",
    "x3d" => "model/x3d+xml",
    "cc" => "text/x-c",
    "mb" => "application/mathematica",
    "ahead" => "application/vnd.ahead.space",
    "sisx" => "application/vnd.symbian.install",
    "pas" => "text/x-pascal",
    "otf" => "application/x-font-otf",
    "tr" => "text/troff",
    "cdmia" => "application/cdmi-capability",
    "joda" => "application/vnd.joost.joda-archive",
    "tmo" => "application/vnd.tmobile-livetv",
    "dll" => "application/x-msdownload",
    "mesh" => "model/mesh",
    "geo" => "application/vnd.dynageo",
    "m3u8" => "application/vnd.apple.mpegurl",
    "p12" => "application/x-pkcs12",
    "acu" => "application/vnd.acucobol",
    "bat" => "application/x-msdownload",
    "wsdl" => "application/wsdl+xml",
    "cmp" => "application/vnd.yellowriver-custom-menu",
    "odft" => "application/vnd.oasis.opendocument.formula-template",
    "smv" => "video/x-smv",
    "dae" => "model/vnd.collada+xml",
    "efif" => "application/vnd.picsel",
    "aso" => "application/vnd.accpac.simply.aso",
    "cdf" => "application/x-netcdf",
    "gv" => "text/vnd.graphviz",
    "xls" => "application/vnd.ms-excel",
    "bdf" => "application/x-font-bdf",
    "gbr" => "application/rpki-ghostbusters",
    "evy" => "application/x-envoy",
    "stf" => "application/vnd.wt.stf",
    "onetoc" => "application/onenote",
    "oa2" => "application/vnd.fujitsu.oasys2",
    "jpeg" => "image/jpeg",
    "djv" => "image/vnd.djvu",
    "aifc" => "audio/x-aiff",
    "docm" => "application/vnd.ms-word.document.macroenabled.12",
    "stl" => "application/vnd.ms-pki.stl",
    "uvg" => "image/vnd.dece.graphic",
    "m21" => "application/mp21",
    "stw" => "application/vnd.sun.xml.writer.template",
    "p7b" => "application/x-pkcs7-certificates",
    "ai" => "application/postscript",
    "wmz" => "application/x-msmetafile",
    "pbm" => "image/x-portable-bitmap",
    "cbz" => "application/x-cbr",
    "mks" => "video/x-matroska",
    "mmd" => "application/vnd.chipnuts.karaoke-mmd",
    "p" => "text/x-pascal",
    "sitx" => "application/x-stuffitx",
    "xenc" => "application/xenc+xml",
    "jpg" => "image/jpeg",
    "clkp" => "application/vnd.crick.clicker.palette",
    "uvvg" => "image/vnd.dece.graphic",
    "cdx" => "chemical/x-cdx",
    "wad" => "application/x-doom",
    "yin" => "application/yin+xml",
    "emz" => "application/x-msmetafile",
    "stk" => "application/hyperstudio",
    "nlu" => "application/vnd.neurolanguage.nlu",
    "sig" => "application/pgp-signature",
    "opf" => "application/oebps-package+xml",
    "box" => "application/vnd.previewsystems.box",
    "log" => "text/plain",
    "dxr" => "application/x-director",
    "igm" => "application/vnd.insors.igm",
    "mag" => "application/vnd.ecowin.chart",
    "rep" => "application/vnd.businessobjects",
    "jpm" => "video/jpm",
    "std" => "application/vnd.sun.xml.draw.template",
    "clp" => "application/x-msclip",
    "cmx" => "image/x-cmx",
    "gif" => "image/gif",
    "ods" => "application/vnd.oasis.opendocument.spreadsheet",
    "z7" => "application/x-zmachine",
    "ssml" => "application/ssml+xml",
    "mfm" => "application/vnd.mfmp",
    "teacher" => "application/vnd.smart.teacher",
    "cat" => "application/vnd.ms-pki.seccat",
    "z5" => "application/x-zmachine",
    "kwt" => "application/vnd.kde.kword",
    "uvvh" => "video/vnd.dece.hd",
    "ei6" => "application/vnd.pg.osasli",
    "vcard" => "text/vcard",
    "ppm" => "image/x-portable-pixmap",
    "rtx" => "text/richtext",
    "opml" => "text/x-opml",
    "epub" => "application/epub+zip",
    "uvf" => "application/vnd.dece.data",
    "ksp" => "application/vnd.kde.kspread",
    "semf" => "application/vnd.semf",
    "sc" => "application/vnd.ibm.secure-container",
    "mpeg" => "video/mpeg",
    "qxt" => "application/vnd.quark.quarkxpress",
    "xif" => "image/vnd.xiff",
    "js" => "application/javascript",
    "ttl" => "text/turtle",
    "sti" => "application/vnd.sun.xml.impress.template",
    "sus" => "application/vnd.sus-calendar",
    "odb" => "application/vnd.oasis.opendocument.database",
    "qt" => "video/quicktime",
    "gca" => "application/x-gca-compressed",
    "g3" => "image/g3fax",
    "sid" => "image/x-mrsid-image",
    "ez2" => "application/vnd.ezpix-album",
    "xltm" => "application/vnd.ms-excel.template.macroenabled.12",
    "chm" => "application/vnd.ms-htmlhelp",
    "pyv" => "video/vnd.ms-playready.media.pyv",
    "kwd" => "application/vnd.kde.kword",
    "mid" => "audio/midi",
    "class" => "application/java-vm",
    "eol" => "audio/vnd.digital-winds",
    "uvh" => "video/vnd.dece.hd",
    "dd2" => "application/vnd.oma.dd2+xml",
    "dp" => "application/vnd.osgi.dp",
    "mp2" => "audio/mpeg",
    "zirz" => "application/vnd.zul",
    "ez" => "application/andrew-inset",
    "sldm" => "application/vnd.ms-powerpoint.slide.macroenabled.12",
    "roff" => "text/troff",
    "pnm" => "image/x-portable-anymap",
    "crd" => "application/x-mscardfile",
    "sxg" => "application/vnd.sun.xml.writer.global",
    "sgml" => "text/sgml",
    "uoml" => "application/vnd.uoml+xml",
    "uvi" => "image/vnd.dece.graphic",
    "daf" => "application/vnd.mobius.daf",
    "imp" => "application/vnd.accpac.simply.imp",
    "csp" => "application/vnd.commonspace",
    "t" => "text/troff",
    "dbk" => "application/docbook+xml",
    "c4f" => "application/vnd.clonk.c4group",
    "xlsx" => "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
    "dgc" => "application/x-dgc-compressed",
    "aab" => "application/x-authorware-bin",
    "svgz" => "image/svg+xml",
    "ras" => "image/x-cmu-raster",
    "ntf" => "application/vnd.nitf",
    "omdoc" => "application/omdoc+xml",
    "dtb" => "application/x-dtbook+xml",
    "odg" => "application/vnd.oasis.opendocument.graphics",
    "qxd" => "application/vnd.quark.quarkxpress",
    "mny" => "application/x-msmoney",
    "uvvf" => "application/vnd.dece.data",
    "musicxml" => "application/vnd.recordare.musicxml+xml",
    "yang" => "application/yang",
    "chrt" => "application/vnd.kde.kchart",
    "scd" => "application/x-msschedule",
    "ecelp4800" => "audio/vnd.nuera.ecelp4800",
    "kmz" => "application/vnd.google-earth.kmz",
    "cdxml" => "application/vnd.chemdraw+xml",
    "igl" => "application/vnd.igloader",
    "ufd" => "application/vnd.ufdl",
    "pbd" => "application/vnd.powerbuilder6",
    "dcurl" => "text/vnd.curl.dcurl",
    "sxc" => "application/vnd.sun.xml.calc",
    "mp3" => "audio/mpeg",
    "scq" => "application/scvp-cv-request",
    "igx" => "application/vnd.micrografx.igx",
    "onetoc2" => "application/onenote",
    "bmp" => "image/bmp",
    "ssf" => "application/vnd.epson.ssf",
    "tif" => "image/tiff",
    "dataless" => "application/vnd.fdsn.seed",
    "cmc" => "application/vnd.cosmocaller",
    "qbo" => "application/vnd.intu.qbo",
    "vcf" => "text/x-vcard",
    "str" => "application/vnd.pg.format",
    "c" => "text/x-c",
    "flx" => "text/vnd.fmi.flexstor",
    "gac" => "application/vnd.groove-account",
    "gxf" => "application/gxf",
    "zaz" => "application/vnd.zzazz.deck+xml",
    "h261" => "video/h261",
    "7z" => "application/x-7z-compressed",
    "dwg" => "image/vnd.dwg",
    "x32" => "application/x-authorware-bin",
    "ttc" => "application/x-font-ttf",
    "eot" => "application/vnd.ms-fontobject",
    "wdb" => "application/vnd.ms-works",
    "atomcat" => "application/atomcat+xml",
    "ddd" => "application/vnd.fujixerox.ddd",
    "ipfix" => "application/ipfix",
    "potm" => "application/vnd.ms-powerpoint.template.macroenabled.12",
    "dic" => "text/x-c",
    "xul" => "application/vnd.mozilla.xul+xml",
    "maker" => "application/vnd.framemaker",
    "x3dv" => "model/x3d+vrml",
    "rtf" => "application/rtf",
    "nzb" => "application/x-nzb",
    "fcs" => "application/vnd.isac.fcs",
    "gre" => "application/vnd.geometry-explorer",
    "woff" => "application/font-woff",
    "fh4" => "image/x-freehand",
    "obj" => "application/x-tgif",
    "aif" => "audio/x-aiff",
    "mxl" => "application/vnd.recordare.musicxml",
    "jpgm" => "video/jpm",
    "dxf" => "image/vnd.dxf",
    "car" => "application/vnd.curl.car",
    "xpl" => "application/xproc+xml",
    "tei" => "application/tei+xml",
    "paw" => "application/vnd.pawaafile",
    "plc" => "application/vnd.mobius.plc",
    "mqy" => "application/vnd.mobius.mqy",
    "m2v" => "video/mpeg",
    "tex" => "application/x-tex",
    "crl" => "application/pkix-crl",
    "xap" => "application/x-silverlight-app",
    "fvt" => "video/vnd.fvt",
    "mk3d" => "video/x-matroska",
    "wax" => "audio/x-ms-wax",
    "htke" => "application/vnd.kenameaapp",
    "cst" => "application/x-director",
    "i2g" => "application/vnd.intergeo",
    "webm" => "video/webm",
    "lwp" => "application/vnd.lotus-wordpro",
    "aiff" => "audio/x-aiff",
    "ink" => "application/inkml+xml",
    "eps" => "application/postscript",
    "clkt" => "application/vnd.crick.clicker.template",
    "p10" => "application/pkcs10",
    "csml" => "chemical/x-csml",
    "qxl" => "application/vnd.quark.quarkxpress",
    "vcd" => "application/x-cdlink",
    "pvb" => "application/vnd.3gpp.pic-bw-var",
    "smf" => "application/vnd.stardivision.math",
    "ivp" => "application/vnd.immervision-ivp",
    "listafp" => "application/vnd.ibm.modcap",
    "tpl" => "application/vnd.groove-tool-template",
    "gsf" => "application/x-font-ghostscript",
    "rlc" => "image/vnd.fujixerox.edmics-rlc",
    "unityweb" => "application/vnd.unity",
    "fxpl" => "application/vnd.adobe.fxp",
    "wri" => "application/x-mswrite",
    "rp9" => "application/vnd.cloanto.rp9",
    "so" => "application/octet-stream",
    "pfb" => "application/x-font-type1",
    "tcl" => "application/x-tcl",
    "scurl" => "text/vnd.curl.scurl",
    "vsd" => "application/vnd.visio",
    "rmi" => "audio/midi",
    "rdz" => "application/vnd.data-vision.rdz",
    "frame" => "application/vnd.framemaker",
    "mxf" => "application/mxf",
    "tfi" => "application/thraud+xml",
    "kon" => "application/vnd.kde.kontour",
    "ifm" => "application/vnd.shana.informed.formdata",
    "xbm" => "image/x-xbitmap",
    "pre" => "application/vnd.lotus-freelance",
    "c4d" => "application/vnd.clonk.c4group",
    "ipk" => "application/vnd.shana.informed.package",
    "ktr" => "application/vnd.kahootz",
    "z1" => "application/x-zmachine",
    "kia" => "application/vnd.kidspiration",
    "hal" => "application/vnd.hal+xml",
    "es3" => "application/vnd.eszigno3+xml",
    "xht" => "application/xhtml+xml",
    "uva" => "audio/vnd.dece.audio",
    "exe" => "application/x-msdownload",
    "cap" => "application/vnd.tcpdump.pcap",
    "pfm" => "application/x-font-type1",
    "xps" => "application/vnd.ms-xpsdocument",
    "clkk" => "application/vnd.crick.clicker.keyboard",
    "tra" => "application/vnd.trueapp",
    "vis" => "application/vnd.visionary",
    "osfpvg" => "application/vnd.yamaha.openscoreformat.osfpvg+xml",
    "pclxl" => "application/vnd.hp-pclxl",
    "oxt" => "application/vnd.openofficeorg.extension",
    "xlc" => "application/vnd.ms-excel",
    "vcx" => "application/vnd.vcx",
    "ace" => "application/x-ace-compressed",
    "wtb" => "application/vnd.webturbo",
    "cct" => "application/x-director",
    "scs" => "application/scvp-cv-response",
    "sxm" => "application/vnd.sun.xml.math",
    "mie" => "application/x-mie",
    "tsv" => "text/tab-separated-values",
    "f90" => "text/x-fortran",
    "fti" => "application/vnd.anser-web-funds-transfer-initiation",
    "c11amz" => "application/vnd.cluetrust.cartomobile-config-pkg",
    "sil" => "audio/silk",
    "vob" => "video/x-ms-vob",
    "gnumeric" => "application/x-gnumeric",
    "xdf" => "application/xcap-diff+xml",
    "gpx" => "application/gpx+xml",
    "fst" => "image/vnd.fst",
    "srt" => "application/x-subrip",
    "lrf" => "application/octet-stream",
    "chat" => "application/x-chat",
    "air" => "application/vnd.adobe.air-application-installer-package+zip",
    "psf" => "application/x-font-linux-psf",
    "hvp" => "application/vnd.yamaha.hv-voice",
    "src" => "application/x-wais-source",
    "fxp" => "application/vnd.adobe.fxp",
    "ecelp7470" => "audio/vnd.nuera.ecelp7470",
    "cii" => "application/vnd.anser-web-certificate-issue-initiation",
    "oxps" => "application/oxps",
    "cdmio" => "application/cdmi-object",
    "atx" => "application/vnd.antix.game-component",
    "wdp" => "image/vnd.ms-photo",
    "pic" => "image/x-pict",
    "qfx" => "application/vnd.intu.qfx",
    "mar" => "application/octet-stream",
    "3dml" => "text/vnd.in3d.3dml",
    "gtm" => "application/vnd.groove-tool-message",
    "wmd" => "application/x-ms-wmd",
    "xz" => "application/x-xz",
    "der" => "application/x-x509-ca-cert",
    "me" => "text/troff",
    "dssc" => "application/dssc+der",
    "smi" => "application/smil+xml",
    "nb" => "application/mathematica",
    "pdf" => "application/pdf",
    "atomsvc" => "application/atomsvc+xml",
    "mpc" => "application/vnd.mophun.certificate",
    "dotm" => "application/vnd.ms-word.template.macroenabled.12",
    "mp4v" => "video/mp4",
    "hvd" => "application/vnd.yamaha.hv-dic",
    "uu" => "text/x-uuencode",
    "afm" => "application/x-font-type1",
    "p7c" => "application/pkcs7-mime",
    "spq" => "application/scvp-vp-request",
    "tpt" => "application/vnd.trid.tpt",
    "twds" => "application/vnd.simtech-mindmapper",
    "vcs" => "text/x-vcalendar",
    "jisp" => "application/vnd.jisp",
    "mathml" => "application/mathml+xml",
    "sxw" => "application/vnd.sun.xml.writer",
    "x3dbz" => "model/x3d+binary",
    "x3dz" => "model/x3d+xml",
    "edm" => "application/vnd.novadigm.edm",
    "for" => "text/x-fortran",
    "wbxml" => "application/vnd.wap.wbxml",
    "pskcxml" => "application/pskc+xml",
    "gtw" => "model/vnd.gtw",
    "dcr" => "application/x-director",
    "ogv" => "video/ogg",
    "wmlsc" => "application/vnd.wap.wmlscriptc",
    "potx" => "application/vnd.openxmlformats-officedocument.presentationml.template",
    "mka" => "audio/x-matroska",
    "adp" => "audio/adpcm",
    "dna" => "application/vnd.dna",
    "mp4a" => "audio/mp4",
    "oas" => "application/vnd.fujitsu.oasys",
    "fcdt" => "application/vnd.adobe.formscentral.fcdt",
    "rms" => "application/vnd.jcp.javame.midlet-rms",
    "pcap" => "application/vnd.tcpdump.pcap",
    "rm" => "application/vnd.rn-realmedia",
    "csv" => "text/csv",
    "123" => "application/vnd.lotus-1-2-3",
    "rcprofile" => "application/vnd.ipunplugged.rcprofile",
    "msty" => "application/vnd.muvee.style",
    "sxi" => "application/vnd.sun.xml.impress",
    "xml" => "application/xml",
    "wmf" => "application/x-msmetafile",
    "psb" => "application/vnd.3gpp.pic-bw-small",
    "taglet" => "application/vnd.mynfc",
    "psd" => "image/vnd.adobe.photoshop",
    "mxu" => "video/vnd.mpegurl",
    "sql" => "application/x-sql",
    "ppd" => "application/vnd.cups-ppd",
    "odt" => "application/vnd.oasis.opendocument.text",
    "dms" => "application/octet-stream",
    "cer" => "application/pkix-cert",
    "mpy" => "application/vnd.ibm.minipay",
    "snf" => "application/x-font-snf",
    "uvvm" => "video/vnd.dece.mobile",
    "texi" => "application/x-texinfo",
    "bin" => "application/octet-stream",
    "h264" => "video/h264",
    "jam" => "application/vnd.jam",
    "cla" => "application/vnd.claymore",
    "xm" => "audio/xm",
    "dot" => "application/msword",
    "dwf" => "model/vnd.dwf",
    "ivu" => "application/vnd.immervision-ivu",
    "skd" => "application/vnd.koan",
    "mp2a" => "audio/mpeg",
    "tcap" => "application/vnd.3gpp2.tcap",
    "jnlp" => "application/x-java-jnlp-file",
    "cdy" => "application/vnd.cinderella",
    "ltf" => "application/vnd.frogans.ltf",
    "bz" => "application/x-bzip",
    "rar" => "application/x-rar-compressed",
    "cif" => "chemical/x-cif",
    "pfa" => "application/x-font-type1",
    "wma" => "audio/x-ms-wma",
    "fpx" => "image/vnd.fpx",
    "apk" => "application/vnd.android.package-archive",
    "dpg" => "application/vnd.dpgraph",
    "wvx" => "video/x-ms-wvx",
    "qps" => "application/vnd.publishare-delta-tree",
    "karbon" => "application/vnd.kde.karbon",
    "wml" => "text/vnd.wap.wml",
    "udeb" => "application/x-debian-package",
    "pgn" => "application/x-chess-pgn",
    "c4p" => "application/vnd.clonk.c4group",
    "uvvz" => "application/vnd.dece.zip",
    "nns" => "application/vnd.noblenet-sealer",
    "rl" => "application/resource-lists+xml",
    "docx" => "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
    "rif" => "application/reginfo+xml",
    "ms" => "text/troff",
    "cu" => "application/cu-seeme",
    "xfdl" => "application/vnd.xfdl",
    "uvvi" => "image/vnd.dece.graphic",
    "aam" => "application/x-authorware-map",
    "cdmic" => "application/cdmi-container",
    "odc" => "application/vnd.oasis.opendocument.chart",
    "boz" => "application/x-bzip2",
    "ram" => "audio/x-pn-realaudio",
    "asf" => "video/x-ms-asf",
    "uvd" => "application/vnd.dece.data",
    "ext" => "application/vnd.novadigm.ext",
    "swf" => "application/x-shockwave-flash",
    "msh" => "model/mesh",
    "hbci" => "application/vnd.hbci",
    "doc" => "application/msword",
    "davmount" => "application/davmount+xml",
    "wg" => "application/vnd.pmi.widget",
    "zmm" => "application/vnd.handheld-entertainment+xml",
    "tfm" => "application/x-tex-tfm",
    "iso" => "application/x-iso9660-image",
    "ggt" => "application/vnd.geogebra.tool",
    "fig" => "application/x-xfig",
    "bh2" => "application/vnd.fujitsu.oasysprs",
    "rip" => "audio/vnd.rip",
    "nnw" => "application/vnd.noblenet-web",
    "oa3" => "application/vnd.fujitsu.oasys3",
    "p7m" => "application/pkcs7-mime",
    "cryptonote" => "application/vnd.rig.cryptonote",
    "lnk" => "application/x-ms-shortcut",
    "gqs" => "application/vnd.grafeq",
    "flv" => "video/x-flv",
    "uvm" => "video/vnd.dece.mobile",
    "xyz" => "chemical/x-xyz",
    "qam" => "application/vnd.epson.quickanime",
    "nsf" => "application/vnd.lotus-notes",
    "oga" => "audio/ogg",
    "flo" => "application/vnd.micrografx.flo",
    "grv" => "application/vnd.groove-injector",
    "sru" => "application/sru+xml",
    "irm" => "application/vnd.ibm.rights-management",
    "wpd" => "application/vnd.wordperfect",
    "ppam" => "application/vnd.ms-powerpoint.addin.macroenabled.12",
    "fh5" => "image/x-freehand",
    "hh" => "text/x-c",
    "3g2" => "video/3gpp2",
    "kpt" => "application/vnd.kde.kpresenter",
    "uvvv" => "video/vnd.dece.video",
    "texinfo" => "application/x-texinfo",
    "zir" => "application/vnd.zul",
    "prf" => "application/pics-rules",
    "msi" => "application/x-msdownload",
    "uvs" => "video/vnd.dece.sd",
    "aas" => "application/x-authorware-seg",
    "qwt" => "application/vnd.quark.quarkxpress",
    "kpr" => "application/vnd.kde.kpresenter",
    "nitf" => "application/vnd.nitf",
    "ice" => "x-conference/x-cooltalk",
    "spl" => "application/x-futuresplash",
    "xlw" => "application/vnd.ms-excel",
    "ogg" => "audio/ogg",
    "obd" => "application/x-msbinder",
    "skt" => "application/vnd.koan",
    "distz" => "application/octet-stream",
    "msf" => "application/vnd.epson.msf",
    "prc" => "application/x-mobipocket-ebook",
    "bdm" => "application/vnd.syncml.dm+wbxml",
    "mpn" => "application/vnd.mophun.application",
    "fg5" => "application/vnd.fujitsu.oasysgp",
    "edx" => "application/vnd.novadigm.edx",
    "tao" => "application/vnd.tao.intent-module-archive",
    "ico" => "image/x-icon",
    "mdb" => "application/x-msaccess",
    "com" => "application/x-msdownload",
    "mov" => "video/quicktime",
    "sgi" => "image/sgi",
    "wbmp" => "image/vnd.wap.wbmp",
    "fhc" => "image/x-freehand",
    "sfd-hdstx" => "application/vnd.hydrostatix.sof-data",
    "cil" => "application/vnd.ms-artgalry",
    "xlt" => "application/vnd.ms-excel",
    "mpg" => "video/mpeg",
    "webp" => "image/webp",
    "pfx" => "application/x-pkcs12",
    "wks" => "application/vnd.ms-works",
    "aw" => "application/applixware",
    "hvs" => "application/vnd.yamaha.hv-script",
    "xhtml" => "application/xhtml+xml",
    "spc" => "application/x-pkcs7-certificates",
    "elc" => "application/octet-stream",
    "gex" => "application/vnd.geometry-explorer",
    "conf" => "text/plain",
    "cbr" => "application/x-cbr",
    "ktz" => "application/vnd.kahootz",
    "uri" => "text/uri-list",
    "ac" => "application/pkix-attr-cert",
    "ustar" => "application/x-ustar",
    "cml" => "chemical/x-cml",
    "ris" => "application/x-research-info-systems",
    "ics" => "text/calendar",
    "n3" => "text/n3",
    "vcg" => "application/vnd.groove-vcard",
    "dfac" => "application/vnd.dreamfactory",
    "install" => "application/x-install-instructions",
    "sdp" => "application/sdp",
    "mkv" => "video/x-matroska",
    "bz2" => "application/x-bzip2",
    "uvx" => "application/vnd.dece.unspecified",
    "sis" => "application/vnd.symbian.install",
    "mcurl" => "text/vnd.curl.mcurl",
    "xpw" => "application/vnd.intercon.formnet",
    "hps" => "application/vnd.hp-hps",
    "odi" => "application/vnd.oasis.opendocument.image",
    "dmg" => "application/x-apple-diskimage",
    "odm" => "application/vnd.oasis.opendocument.text-master",
    "onepkg" => "application/onenote",
    "xdp" => "application/vnd.adobe.xdp+xml",
    "irp" => "application/vnd.irepository.package+xml",
    "cba" => "application/x-cbr",
    "ppsx" => "application/vnd.openxmlformats-officedocument.presentationml.slideshow",
    "dtshd" => "audio/vnd.dts.hd",
    "dis" => "application/vnd.mobius.dis",
    "xltx" => "application/vnd.openxmlformats-officedocument.spreadsheetml.template",
    "xsl" => "application/xml",
    "rdf" => "application/rdf+xml",
    "mime" => "message/rfc822",
    "fsc" => "application/vnd.fsc.weblaunch",
    "mscml" => "application/mediaservercontrol+xml",
    "mjp2" => "video/mj2",
    "mbox" => "application/mbox",
    "pct" => "image/x-pict",
    "wgt" => "application/widget",
    "trm" => "application/x-msterminal",
    "rld" => "application/resource-lists-diff+xml",
    "roa" => "application/rpki-roa",
    "oprc" => "application/vnd.palm",
    "atom" => "application/atom+xml",
    "sm" => "application/vnd.stepmania.stepchart",
    "wmls" => "text/vnd.wap.wmlscript",
    "silo" => "model/mesh",
    "mpm" => "application/vnd.blueice.multipass",
    "xer" => "application/patch-ops-error+xml",
    "sdw" => "application/vnd.stardivision.writer",
    "z8" => "application/x-zmachine",
    "spot" => "text/vnd.in3d.spot",
    "hpgl" => "application/vnd.hp-hpgl",
    "bcpio" => "application/x-bcpio",
    "arc" => "application/x-freearc",
    "teicorpus" => "application/tei+xml",
    "nfo" => "text/x-nfo",
    "rs" => "application/rls-services+xml",
    "pcf" => "application/x-font-pcf",
    "xpm" => "image/x-xpixmap",
    "sse" => "application/vnd.kodak-descriptor",
    "gtar" => "application/x-gtar",
    "ifb" => "text/calendar",
    "kar" => "audio/midi",
    "c4g" => "application/vnd.clonk.c4group",
    "x3dvz" => "model/x3d+vrml",
    "kfo" => "application/vnd.kde.kformula",
    "m2a" => "audio/mpeg",
    "res" => "application/x-dtbresource+xml",
    "wmx" => "video/x-ms-wmx",
    "apr" => "application/vnd.lotus-approach",
    "movie" => "video/x-sgi-movie",
    "au" => "audio/basic",
    "ims" => "application/vnd.ms-ims",
    "s3m" => "audio/s3m",
    "igs" => "model/iges",
    "mp21" => "application/mp21",
    "ra" => "audio/x-pn-realaudio",
    "afp" => "application/vnd.ibm.modcap",
    "djvu" => "image/vnd.djvu",
    "pls" => "application/pls+xml",
    "meta4" => "application/metalink4+xml",
    "flw" => "application/vnd.kde.kivio",
    "cdmid" => "application/cdmi-domain",
    "book" => "application/vnd.framemaker",
    "gramps" => "application/x-gramps-xml",
    "oth" => "application/vnd.oasis.opendocument.text-web",
    "dvb" => "video/vnd.dvb.file",
    "fbs" => "image/vnd.fastbidsheet",
    "emf" => "application/x-msmetafile",
    "pgp" => "application/pgp-encrypted",
    "list3820" => "application/vnd.ibm.modcap",
    "pcl" => "application/vnd.hp-pcl",
    "wmlc" => "application/vnd.wap.wmlc",
    "svd" => "application/vnd.svd",
    "blorb" => "application/x-blorb",
    "oda" => "application/oda",
    "lha" => "application/x-lzh-compressed",
    "zip" => "application/zip",
    "npx" => "image/vnd.net-fpx",
    "xpr" => "application/vnd.is-xpr",
    "ppsm" => "application/vnd.ms-powerpoint.slideshow.macroenabled.12",
    "mft" => "application/rpki-manifest",
    "inkml" => "application/inkml+xml",
    "csh" => "application/x-csh",
    "btif" => "image/prs.btif",
    "gdl" => "model/vnd.gdl",
    "ftc" => "application/vnd.fluxtime.clip",
    "mts" => "model/vnd.mts",
    "ggb" => "application/vnd.geogebra.file",
    "def" => "text/plain",
    "ttf" => "application/x-font-ttf",
    "hpid" => "application/vnd.hp-hpid",
    "nbp" => "application/vnd.wolfram.player",
    "fm" => "application/vnd.framemaker",
    "otc" => "application/vnd.oasis.opendocument.chart-template",
    "xfdf" => "application/vnd.adobe.xfdf",
    "mgp" => "application/vnd.osgeo.mapguide.package",
    "vss" => "application/vnd.visio",
    "xpx" => "application/vnd.intercon.formnet",
    "lzh" => "application/x-lzh-compressed",
    "fli" => "video/x-fli",
    "twd" => "application/vnd.simtech-mindmapper",
    "fly" => "text/vnd.fly",
    "h" => "text/x-c",
    "mpga" => "audio/mpeg",
    "tiff" => "image/tiff",
    "esf" => "application/vnd.epson.esf",
    "cdmiq" => "application/cdmi-queue",
    "vsf" => "application/vnd.vsf",
    "link66" => "application/vnd.route66.link66+xml",
    "rpst" => "application/vnd.nokia.radio-preset",
    "txt" => "text/plain",
    "w3d" => "application/x-director",
    "ufdl" => "application/vnd.ufdl",
    "pwn" => "application/vnd.3m.post-it-notes",
    "svc" => "application/vnd.dvb.service",
    "pcx" => "image/x-pcx",
    "sbml" => "application/sbml+xml",
    "ser" => "application/java-serialized-object",
    "skp" => "application/vnd.koan",
    "mpg4" => "video/mp4",
    "metalink" => "application/metalink+xml",
    "ncx" => "application/x-dtbncx+xml",
    "avi" => "video/x-msvideo",
    "pps" => "application/vnd.ms-powerpoint",
    "java" => "text/x-java-source",
    "midi" => "audio/midi",
    "dump" => "application/octet-stream",
    "hdf" => "application/x-hdf",
    "xlf" => "application/x-xliff+xml",
    "see" => "application/vnd.seemail",
    "ghf" => "application/vnd.groove-help",
    "hqx" => "application/mac-binhex40",
    "lbe" => "application/vnd.llamagraphics.life-balance.exchange+xml",
    "sfv" => "text/x-sfv",
    "portpkg" => "application/vnd.macports.portpkg",
    "ez3" => "application/vnd.ezpix-package",
    "vrml" => "model/vrml",
    "m3u" => "audio/x-mpegurl",
    "viv" => "video/vnd.vivo",
    "jar" => "application/java-archive",
    "latex" => "application/x-latex",
    "xdm" => "application/vnd.syncml.dm+xml",
    "caf" => "audio/x-caf",
    "m1v" => "video/mpeg",
    "z2" => "application/x-zmachine",
    "jpe" => "image/jpeg",
    "rpss" => "application/vnd.nokia.radio-presets",
    "snd" => "audio/basic",
    "xhvml" => "application/xv+xml",
    "sgl" => "application/vnd.stardivision.writer-global",
    "gam" => "application/x-tads",
    "lbd" => "application/vnd.llamagraphics.life-balance.desktop",
    "wbs" => "application/vnd.criticaltools.wbs+xml",
    "cgm" => "image/cgm",
    "uvt" => "application/vnd.dece.ttml+xml",
    "setreg" => "application/set-registration-initiation",
    "sldx" => "application/vnd.openxmlformats-officedocument.presentationml.slide",
    "grxml" => "application/srgs+xml",
    "azw" => "application/vnd.amazon.ebook",
    "xla" => "application/vnd.ms-excel",
    "xsm" => "application/vnd.syncml+xml",
    "sema" => "application/vnd.sema",
    "iota" => "application/vnd.astraea-software.iota",
    "sda" => "application/vnd.stardivision.draw",
    "asm" => "text/x-asm",
    "kml" => "application/vnd.google-earth.kml+xml",
    "pdb" => "application/vnd.palm",
    "xo" => "application/vnd.olpc-sugar",
    "curl" => "text/vnd.curl"
])

const mime2fileending = let
    dict = Dict((
        mime => fe for
        (fe, mime) in known_mimetypes if !(fe in ("svgz", "mp4v", "mpg4"))
    ))
    dict["application/octet-stream"] = "bin" # default to bin ending for octet-stream
    dict
end

extension(f) = last(splitext(f))[2:end]

file_mimetype(filepath) = ext_to_mimetype(extension(filepath))

ext_to_mimetype(ext) = get(known_mimetypes, ext, "application/octet-stream")

mimetype_to_extension(mime) = get(mime2fileending, mime, "bin")

using .HTTPServer: Server
using HTTP.WebSockets

mutable struct DualWebsocket <: AbstractWebsocketConnection
    server::Server
    session::Union{Nothing,Session}
    low_latency::WebSocketHandler
    large_data::WebSocketHandler
end

DualWebsocket(proxy_callback::Function) = DualWebsocket(get_server(proxy_callback))
DualWebsocket() = DualWebsocket(get_server())
function DualWebsocket(server::Server)
    return DualWebsocket(server, nothing, WebSocketHandler(), WebSocketHandler())
end

Base.isopen(ws::DualWebsocket) = isopen(ws.low_latency)

function Base.write(ws::DualWebsocket, binary::AbstractVector{UInt8})
    write(ws.low_latency, binary)
end

function write_large(ws::DualWebsocket, binary)
    write(ws.large_data, binary)
end

function Base.close(ws::DualWebsocket)
    close(ws.low_latency)
    close(ws.large_data)
    if !isnothing(ws.session)
        session = ws.session
        delete_websocket_route!(ws.server, "/$(session.id)?low_latency")
        delete_websocket_route!(ws.server, "/$(session.id)?large_data")
    end
    return
end

"""
    handles a new websocket connection to a session
"""
function (connection::DualWebsocket)(context, websocket::WebSocket)
    request = context.request
    uri = URIs.URI(request.target)
    session_id = URIs.splitpath(uri.path)[1]
    @debug("WS session id: $(session_id)")
    session = connection.session
    if isnothing(session)
        error("Websocket connection skipped setup")
    end
    @assert session_id == session.id
    handler = uri.query == "low_latency" ? connection.low_latency : connection.large_data
    try
        run_connection_loop(session, handler, websocket)
    finally
        # This always needs to happen, which is why we need a try catch!
        if allow_soft_close(CLEANUP_POLICY[])
            @debug("Soft closing: $(session.id)")
            soft_close(session)
        else
            @debug("Closing: $(session.id)")
            # might as well close it immediately
            close(session)
        end
    end
end

function setup_connection(session::Session, connection::DualWebsocket)
    connection.session = session
    server = connection.server
    add_cleanup_task!(server)
    HTTPServer.websocket_route!(server, "/$(session.id)?low_latency" => connection)
    HTTPServer.websocket_route!(server, "/$(session.id)?large_data" => connection)
    external_url = HTTPServer.relative_url(server, "")
    js_ll = setup_websocket_connection_js(external_url, session; query="?low_latency")
    js_ld = setup_websocket_connection_js(external_url, session; query="?large_data", main_connection=false)
    return js"{
        $(js_ll)
        $(js_ld)
    }"
end

function setup_connection(session::Session{DualWebsocket})
    return setup_connection(session, session.connection)
end

using HTTP, URIs
import Base64
using MbedTLS
using Random

"""
    pbkdf2_simple(password::String, salt::Vector{UInt8}; iterations::Int=10_000) -> Vector{UInt8}

Simple PBKDF2-HMAC-SHA256 implementation using MbedTLS.

# Arguments
- `password::String`: The password to hash
- `salt::Vector{UInt8}`: Random salt (should be at least 16 bytes)
- `iterations::Int`: Number of iterations (default: 10,000)

# Returns
- `Vector{UInt8}`: Derived key (32 bytes)

This uses MbedTLS's HMAC-SHA256.
"""
function pbkdf2_simple(password::String, salt::Vector{UInt8}; iterations::Int=10_000)
    password_bytes = Vector{UInt8}(codeunits(password))

    # PBKDF2 with single block (32 bytes output from SHA256)
    # Block number as big-endian UInt32: 0x00000001
    block_num = reinterpret(UInt8, [hton(UInt32(1))])

    # U1 = HMAC(password, salt || block_num)
    u = MbedTLS.digest(MbedTLS.MD_SHA256, vcat(salt, block_num), password_bytes)
    result = copy(u)

    # U2...Uc = HMAC(password, U_{c-1})
    # XOR each iteration with the result
    for _ in 2:iterations
        u = MbedTLS.digest(MbedTLS.MD_SHA256, u, password_bytes)
        result .⊻= u  # XOR accumulation
    end

    return result
end

"""
    generate_salt(length::Int=16) -> Vector{UInt8}

Generate a cryptographically secure random salt.
"""
function generate_salt(length::Int=16)
    return rand(Random.RandomDevice(), UInt8, length)
end

#=============================================================================
Default Error Pages
=============================================================================#

"""
    default_auth_required_page() -> App

Default 401 Unauthorized page.
"""
function default_auth_required_page()
    return App() do
        return DOM.div(
            DOM.h1("401: Unauthorized"),
            DOM.p("This resource requires authentication. Please provide valid credentials.")
        )
    end
end

"""
    default_rate_limited_page() -> App

Default 429 Too Many Requests page.
"""
function default_rate_limited_page()
    return App() do
        return DOM.div(
            DOM.h1("429: Too Many Requests"),
            DOM.p("Too many failed authentication attempts. Please try again later.")
        )
    end
end

#=============================================================================
User and Password Store Abstractions
=============================================================================#

"""
    User

Represents a user with authentication credentials.

# Fields
- `username::String`: The username
- `password_hash::Vector{UInt8}`: PBKDF2 derived key
- `salt::Vector{UInt8}`: Random salt for password hashing
- `iterations::Int`: PBKDF2 iteration count
- `metadata::Dict{String, Any}`: Optional user metadata (roles, permissions, etc.)
"""
struct User
    username::String
    password_hash::Vector{UInt8}
    salt::Vector{UInt8}
    iterations::Int
    metadata::Dict{String, Any}
end

"""
    User(username::String, password::String; iterations::Int=10_000, metadata::Dict{String, Any}=Dict{String, Any}())

Create a new user with automatic password hashing using PBKDF2.
"""
function User(
    username::AbstractString,
    password::AbstractString;
              iterations::Int=10_000,
              metadata::Dict{String, Any}=Dict{String, Any}())
    salt = generate_salt(16)
    password_hash = pbkdf2_simple(password, salt; iterations=iterations)
    return User(username, password_hash, salt, iterations, metadata)
end

# Constant-time comparison to prevent timing attacks
# TODO, actually implement this?
# TODO, how important is this for now?
secure_compare(a, b) = a == b

"""
    authenticate(user::User, password::String) -> Bool

Authenticate a user with the provided password.
"""
function authenticate(user::User, password::AbstractString)
    provided_hash = pbkdf2_simple(String(password), user.salt; iterations=user.iterations)
    return secure_compare(provided_hash, user.password_hash)
end

"""
    AbstractPasswordStore

Abstract interface for password storage and authentication.

# Required Methods
- `get_user(store, username::String)::Union{User, Nothing}`: Retrieve user by username

# Provided Methods
- `authenticate(store, username::String, password::String)::Bool`: Verify credentials (implemented via get_user)

# Implementation Guide
Subtypes only need to implement `get_user()`. The `authenticate()` method will automatically:
1. Call `get_user()` to retrieve the user
2. Verify the password using the User's authenticate method
3. Return true if credentials match, false otherwise

For custom authentication logic (e.g., LDAP), you can override `authenticate()`.
"""
abstract type AbstractPasswordStore end

"""
    get_user(store::AbstractPasswordStore, username::String) -> Union{User, Nothing}

Retrieve a user by username from the password store.
Must be implemented by all AbstractPasswordStore subtypes.
"""
function get_user(store::AbstractPasswordStore, username::AbstractString)
    error("get_user not implemented for $(typeof(store))")
end

"""
    authenticate(store::AbstractPasswordStore, username::String, password::String) -> Bool

Authenticate user credentials against the password store.
Default implementation retrieves the user via get_user() and verifies the password.
Override this method only if you need custom authentication logic.
"""
function authenticate(
    store::AbstractPasswordStore,
    username::AbstractString,
    password::AbstractString,
)
    user = get_user(store, username)
    if isnothing(user)
        return false
    end
    return authenticate(user, password)
end

"""
    SingleUser <: AbstractPasswordStore

Simple password store for single-user authentication.

# Fields
- `user::User`: The single user
"""
struct SingleUser <: AbstractPasswordStore
    user::User
end

"""
    SingleUser(username::String, password::String; iterations::Int=10_000)

Create a single-user password store with automatic password hashing.

# Example
```julia
store = SingleUser("admin", "secret123")
authenticated = authenticate(store, "admin", "secret123")  # true
```
"""
function SingleUser(
    username::AbstractString, password::AbstractString; iterations::Int=10_000
)
    user = User(username, password; iterations=iterations)
    return SingleUser(user)
end

# Implement required interface: only get_user() is needed
function get_user(store::SingleUser, username::AbstractString)
    if secure_compare(username, store.user.username)
        return store.user
    end
    return nothing
end

# authenticate() is automatically provided by AbstractPasswordStore

"""
    ProtectedRoute{T, PS <: AbstractPasswordStore}

A wrapper that adds HTTP Basic Authentication to any type that implements `apply_handler`.
Can wrap Bonito.App, FolderServer, or any other handler type.

# Security Notes
- **REQUIRES HTTPS**: HTTP Basic Auth sends credentials with every request.
  Without HTTPS, credentials are transmitted in plaintext (Base64 is NOT encryption).
- **Experimental**: This is a simple implementation for basic use cases with no security guarantees.
- **Rate Limiting**: Built-in protection against brute force attacks (max 5 attempts per IP per minute).
- **PBKDF2 Password Hashing**: Uses PBKDF2-HMAC-SHA256 with 10,000 iterations and random salt.
- **Extensible**: Use custom AbstractPasswordStore implementations for multi-user or database-backed auth.

# Fields
- `handler::T`: The wrapped handler (e.g., Bonito.App, FolderServer, etc.)
- `password_store::PS`: Password store implementing AbstractPasswordStore interface
- `realm::String`: Authentication realm name (default: "Protected Area")
- `failed_attempts::Dict{String, Vector{Float64}}`: IP -> timestamps of failed attempts
- `max_attempts::Int`: Maximum failed attempts allowed (default: 5)
- `lockout_window::Float64`: Time window in seconds for rate limiting (default: 60.0)
- `auth_required_handler`: Handler for 401 responses (default: built-in HTML page)
- `rate_limited_handler`: Handler for 429 responses (default: built-in HTML page)

# Example
```julia
# Create app
app = App() do
    return DOM.h1("Hello World")
end

# Create password store
store = SingleUser("admin", "secret123")

# Create protected route
protected_app = ProtectedRoute(app, store)

# With custom error pages
auth_page = App() do
    return DOM.div(
        DOM.h1("Authentication Required"),
        DOM.p("Please log in to access this resource")
    )
end

rate_limit_page = App() do
    return DOM.div(
        DOM.h1("Too Many Attempts"),
        DOM.p("Please wait before trying again")
    )
end

protected_app = ProtectedRoute(app, store;
                               auth_required_handler=auth_page,
                               rate_limited_handler=rate_limit_page)

# Add to server (MUST use HTTPS in production!)
server = Bonito.Server("0.0.0.0", 8443)  # Use SSL/TLS
route!(server, "/" => protected_app)
```
"""
struct ProtectedRoute{T, PS <: AbstractPasswordStore, H}
    handler::T
    password_store::PS
    realm::String
    failed_attempts::Dict{String, Vector{Float64}}
    max_attempts::Int
    lockout_window::Float64
    auth_required_handler::H # For simplicity and performance, use same type her
    rate_limited_handler::H
end

# Main constructor
function ProtectedRoute(handler, password_store::AbstractPasswordStore;
                       realm::String="Protected Area",
                       max_attempts::Int=5,
                       lockout_window::Float64=60.0,
                       auth_required_handler=default_auth_required_page(),
                       rate_limited_handler=default_rate_limited_page())
    ProtectedRoute(handler, password_store, realm,
                  Dict{String, Vector{Float64}}(), max_attempts, lockout_window,
                  auth_required_handler, rate_limited_handler)
end


"""
    check_auth(request::HTTP.Request, password_store::AbstractPasswordStore) -> Bool

Check if the HTTP request contains valid Basic Authentication credentials.
Uses the password store's authenticate method.
"""
function check_auth(request::HTTP.Request, password_store::AbstractPasswordStore)
    auth_header = HTTP.header(request, "Authorization", "")

    # Check if Authorization header exists and starts with "Basic "
    if !startswith(auth_header, "Basic ")
        return false
    end

    try
        # Extract and decode the Base64 credentials
        encoded_credentials = auth_header[7:end]  # Remove "Basic " prefix
        decoded_credentials = String(Base64.base64decode(encoded_credentials))

        # Split username:password
        if ':' in decoded_credentials
            provided_username, provided_password = split(decoded_credentials, ':', limit=2)
            # Delegate to password store for authentication
            return authenticate(password_store, provided_username, provided_password)
        end
    catch e
        # Base64 decode failed or other error - log for security monitoring
        @warn "Authentication decode error" exception=e
        return false
    end

    return false
end

"""
    get_client_ip(request::HTTP.Request) -> String

Extract client IP address from request, checking X-Forwarded-For header first.
"""
function get_client_ip(request::HTTP.Request)
    # Check X-Forwarded-For header (for proxies/load balancers)
    forwarded = HTTP.header(request, "X-Forwarded-For", "")
    if !isempty(forwarded)
        # Take first IP in comma-separated list
        return String(split(forwarded, ',')[1])
    end
    # Fallback to direct connection (if available in context)
    return "unknown"
end

"""
    check_rate_limit(protected::ProtectedRoute, client_ip::String) -> Bool

Check if client has exceeded rate limit for failed authentication attempts.
Returns true if request should be allowed, false if rate limited.
"""
function check_rate_limit(protected::ProtectedRoute, client_ip::String)
    current_time = time()
    # Get failed attempts for this IP
    if haskey(protected.failed_attempts, client_ip)
        attempts = protected.failed_attempts[client_ip]

        # Remove old attempts outside the lockout window
        filter!(t -> (current_time - t) < protected.lockout_window, attempts)

        # Check if exceeded max attempts
        if length(attempts) >= protected.max_attempts
            @warn "Rate limit exceeded for IP" ip=client_ip attempts=length(attempts)
            return false
        end
    end

    return true
end

"""
    record_failed_attempt(protected::ProtectedRoute, client_ip::String)

Record a failed authentication attempt for rate limiting.
"""
function record_failed_attempt(protected::ProtectedRoute, client_ip::String)
    current_time = time()

    if !haskey(protected.failed_attempts, client_ip)
        protected.failed_attempts[client_ip] = Float64[]
    end

    push!(protected.failed_attempts[client_ip], current_time)

    # Log failed attempt for security monitoring
    @warn "Failed authentication attempt" ip=client_ip total_attempts=length(protected.failed_attempts[client_ip])
end

"""
    clear_failed_attempts(protected::ProtectedRoute, client_ip::String)

Clear failed attempts for a client after successful authentication.
"""
function clear_failed_attempts(protected::ProtectedRoute, client_ip::String)
    if haskey(protected.failed_attempts, client_ip)
        delete!(protected.failed_attempts, client_ip)
    end
end

"""
    create_auth_challenge(protected::ProtectedRoute, context) -> HTTP.Response

Create an HTTP 401 Unauthorized response with WWW-Authenticate header.
Renders the auth_required_handler App.
"""
function create_auth_challenge(protected::ProtectedRoute, context)
    # Render the custom handler
    response = Bonito.HTTPServer.apply_handler(protected.auth_required_handler, context)

    # Add WWW-Authenticate header and change status to 401
    headers = copy(response.headers)
    push!(headers, "WWW-Authenticate" => "Basic realm=\"$(protected.realm)\"")

    return HTTP.Response(401, headers, response.body)
end

"""
    create_rate_limit_response(protected::ProtectedRoute, context) -> HTTP.Response

Create an HTTP 429 Too Many Requests response.
Renders the rate_limited_handler App.
"""
function create_rate_limit_response(protected::ProtectedRoute, context)
    # Render the custom handler
    response = Bonito.HTTPServer.apply_handler(protected.rate_limited_handler, context)

    # Add Retry-After header and change status to 429
    headers = copy(response.headers)
    push!(headers, "Retry-After" => "60")

    return HTTP.Response(429, headers, response.body)
end

# Enable route!(server, "/" => protected_route)
function Bonito.HTTPServer.apply_handler(protected::ProtectedRoute, context)
    request = context.request
    client_ip = get_client_ip(request)

    # Check authentication first
    auth_valid = check_auth(request, protected.password_store)

    if auth_valid
        # Authentication successful - clear any failed attempts and allow through
        clear_failed_attempts(protected, client_ip)
        # Delegate to wrapped handler
        return Bonito.HTTPServer.apply_handler(protected.handler, context)
    end

    # Authentication failed - check if rate limited
    if !check_rate_limit(protected, client_ip)
        return create_rate_limit_response(protected, context)
    end

    # Record failed attempt and return auth challenge
    record_failed_attempt(protected, client_ip)
    return create_auth_challenge(protected, context)
end

using Bonito

# Javascript & CSS dependencies can be declared locally and
# freely interpolated in the DOM / js string, and will make sure it loads
# Note, that they will be a `Promise` though, so to use them you need to call `module.then(module=> ...)`.
const THREE = ES6Module("https://cdn.esm.sh/v66/three@0.136/es2021/three.js")

app = App() do session, request
    width = 500; height = 500
    dom = DOM.div(width = width, height = height)
    Bonito.onload(session, dom, js"""
        function (container){
            $(THREE).then(THREE=> {
                var renderer = new THREE.WebGLRenderer({antialias: true});
                renderer.setSize($width, $height);
                renderer.setClearColor("#ffffff");
                container.appendChild(renderer.domElement);
                var scene = new THREE.Scene();
                var camera = new THREE.PerspectiveCamera(75, $width / $height, 0.1, 1000);
                camera.position.z = 4;
                var ambientLight = new THREE.AmbientLight(0xcccccc, 0.4);
                scene.add(ambientLight);
                var pointLight = new THREE.PointLight(0xffffff, 0.8);
                camera.add(pointLight);
                scene.add(camera);
                var geometry = new THREE.SphereGeometry(1.0, 32, 32);
                var material = new THREE.MeshPhongMaterial({color: 0xffff00});
                var sphere = new THREE.Mesh(geometry, material);
                scene.add(sphere);
                renderer.render(scene, camera);
            })
        }
    """)
    return dom
end

struct SerializedObservable
    id::String
    value::Any
end

struct CacheKey
    key::String
end

"""
    TrackingOnly(key::String)

Represents a cache entry that only needs to be tracked in a session but already exists
in the global cache. When deserialized in JS, it self-registers the key to the session's
tracked objects without adding anything to the global cache.
"""
struct TrackingOnly
    key::String
end

struct Retain
    value::Union{Observable, SerializedObservable} # For now, restricted to observable!
end

function SessionCache(session::Session, objects::OrderedDict{String,Any})
    return SessionCache(
        session.id,
        objects,
        root_session(session) === session ? "root" : "sub",
    )
end

function SessionCache(session::Session, objects::AbstractDict{String,Any})
    # Convert to OrderedDict to preserve insertion order
    return SessionCache(session, OrderedDict{String,Any}(objects))
end

struct SerializedJSCode
    interpolated_objects::Dict{String, Any}
    source::String
    julia_file::String
end

# We want typed arrays to arrive as JS typed arrays
const JSTypedArrayEltypes = [Int8, UInt8, Int16, UInt16, Int32, UInt32, Float32, Float64]
const JSTypedNumber = Union{JSTypedArrayEltypes...}

const MSGPACK_NATIVE_TYPES = Union{
    CacheKey,
    Retain,
    SerializedJSCode,
    Observable,
    AbstractVector{<: JSTypedNumber}
}

function iterate_interpolations(source::String, result=Union{Expr,JSString,Symbol}[], text_func=JSString)
    lastidx = 1; i = 1; lindex = lastindex(source)
    isempty(source) && return result
    while true
        c = source[i]

        # Attempt to parse + interpolate all "$..." expressions, except for "${ ... }"
        # which is a template literal placeholder in Javascript.
        #
        # "{ ... }" is a deprecated syntax in Julia, so this is fine.
        if c == '$' && i != lindex && source[i + 1] != '{'
            # add elements before $
            if !isempty(lastidx:(i - 1))
                push!(result, text_func(source[lastidx:(i-1)]))
            end
            # parse the $ expression
            expr, i2 = Meta.parse(source, i + 1, greedy = false, raise = false)
            if i2 >= lindex && expr === nothing
                error("Invalid interpolation at index $(i)-$(lindex): $(source[i:lindex])")
            end
            i = i2
            push!(result, esc(expr))
            lastidx = i
            i > lindex && break
        else
            if i == lindex
                if !isempty(lastidx:lindex)
                    push!(result, text_func(source[lastidx:lindex]))
                end
                break
            end
            i = Base.nextind(source, i)
        end
    end
    return result
end

macro js_str(js_source)
    value_array = :([])
    append!(value_array.args, iterate_interpolations(js_source))
    return :(JSCode($value_array, $(string(__source__.file, ":", __source__.line))))
end

macro dom_str(str)
    result = iterate_interpolations(str, [], string)
    return :(DOM.div($(result...)))
end

JSCode(source::String) = JSCode([JSString(source)])

struct JSSourceContext
    session::Union{Nothing,Session}
    objects::IdDict
end

function JSSourceContext(session::Union{Nothing,Session}=nothing)
    return JSSourceContext(session, IdDict())
end

function Base.show(io::IO, jsc::JSCode)
    print_js_code(io, jsc, JSSourceContext())
end

function print_js_code(io::IO, @nospecialize(object), context::JSSourceContext)
    id = get!(() -> string(hash(object)), context.objects, object)
    print(io, "__lookup_interpolated('$(id)')")
    return context
end

function print_js_code(io::IO, x::Number, context::JSSourceContext)
    print(io, x)
    return context
end

function print_js_code(io::IO, x::Union{Symbol, AbstractString}, context::JSSourceContext)
    print(io, "'", x, "'")
    return context
end

function print_js_code(io::IO, jss::JSString, context::JSSourceContext)
    print(io, jss.source)
    return context
end

function print_js_code(io::IO, node::Node, context::JSSourceContext)
    session = context.session # can be nothing
    print(io, "document.querySelector('[data-jscall-id=\"$(uuid(session, node))\"]')")
    return context
end

function print_js_code(io::IO, jsc::JSCode, context::JSSourceContext)
    for elem in jsc.source
        print_js_code(io, elem, context)
    end
    return context
end

function print_js_code(io::IO, jsss::AbstractVector{JSCode}, context::JSSourceContext)
    for jss in jsss
        print_js_code(io, jss, context)
        println(io)
    end
    return context
end


function print_js_code(io::IO, asset::Union{Asset, BinaryAsset}, context::JSSourceContext)
    session = context.session
    if asset isa BinaryAsset || asset.es6module
        bundle!(asset) # no-op if not needed
        if !isnothing(session)
            import_in_js(io, session, session.asset_server, asset)
        else
            # This should be mainly for `print(jscode)`
            print(io, "import('$(get_path(asset))')")
        end
    elseif asset isa Asset && mediatype(asset) == :js
        # Non-module JS assets use load_script which returns a promise
        # asset.name is set automatically in the Asset constructor for JS assets
        # We use the lookup_interpolated, for base64 urls, which get cached this way
        resolved_url = url(session, asset)
        id = get!(() -> string(hash(asset)), context.objects, resolved_url)
        print(io, "Bonito.load_script(__lookup_interpolated('$(id)'), '$(asset.name)')")
    else
        id = get!(() -> string(hash(asset)), context.objects, asset)
        print(io, "__lookup_interpolated('$(id)')")
    end
    return context
end

function import_in_js(io::IO, session::Session, asset_server, asset::BinaryAsset)
    print(io, "Bonito.fetch_binary('$(url(session, asset))')")
end

function import_in_js(io::IO, session::Session, asset_server, asset::Asset)
    ref = import_js_url(asset_server, asset)
    if asset.es6module
        print(io, "import($(ref))")
    else
        print(io, "Bonito.fetch_binary($(ref))")
    end
end

# This works better with Pluto, which doesn't allow <script> the script </script>
# and only allows `<script src=url>  </script>`
# TODO, NoServer is kind of misussed here, since Pluto happens to use it
# I guess the best solution would be a trait system or some other config object
# for deciding how to inline code into pure HTML
function inline_code(::Session, noserver, source::String)
    return DOM.script(source; type="module")
end

function inline_code(session::Session, asset_server, js::JSCode)
    evaljs(session, js)
    # Print code while collecting all interpolated objects in an IdDict
    # context = JSSourceContext(session)
    # code = sprint() do io
    #     print_js_code(io, js, context)
    # end
    # if isempty(context.objects)
    #     src = code
    #     return inline_code(session, asset_server, src)
    # else
    #     # reverse lookup and serialize elements
    #     interpolated_objects = Dict(v => k for (k, v) in context.objects)
    #     binary = BinaryAsset(session, interpolated_objects)
    #     src = """
    #     // JSCode from $(js.file)
    #     Bonito.lock_loading(() => {
    #         return Bonito.fetch_binary('$(url(session, binary))').then(bin_messages=>{
    #             const objects = Bonito.decode_binary(bin_messages, $(session.compression_enabled));
    #             const __lookup_interpolated = (id) => objects[id]
    #             $code
    #         })
    #     })
    #     """
    #     binary = BinaryAsset(session, interpolated_objects)
    #     evaljs(session, JSCode(src))
    # end
    return
end

function jsrender(session::Session, js::JSCode)
    # Make how we inline the code conditional on the way we serve files!
    return inline_code(session, session.asset_server, js)
end

using Electron, Bonito
using Bonito.HTTP: Request
import Bonito.HTTPServer: start, isrunning
using Bonito: Session, @js_str, JSCode
import Bonito: evaljs, evaljs_value
using Bonito.Hyperscript: Node, HTMLSVG
using Bonito.DOM
using Base: RefValue
using Test

"""
    TestSession(handler)

Main construct, which will lunch an electron browser session, serving the application
created by `handler(testsession)::DOM.div`.
Can be used via the testsession function:
```julia
testsession(handler; url="0.0.0.0", port=8081, timeout=300)) do testsession
    # test code using testsession
end
```
This will ensure proper setup and teardown once done with the tests.
The testsession object allows to communicate with the browser session, run javascript
and get values from the html dom!
"""
mutable struct TestSession
    url::URI
    initialized::Bool
    error_in_handler::Any
    server::Bonito.Server
    window::Bonito.EWindow
    session::Session
    dom::Node{HTMLSVG}
    request::Request

    function TestSession(url::URI)
        return new(url, false, nothing)
    end

    function TestSession(url::URI, server::Bonito.Server, window::Bonito.EWindow, session::Session)
        testsession = new(url, true, nothing, server, window, session)
        return testsession
    end
end

Bonito.session(testsession::TestSession) = testsession.session

function Base.show(io::IO, testsession::TestSession)
    print(io, "TestSession")
end

function check_and_close_display()
    # For some reason, when running code in Atom, it happens very easily,
    # That Bonito display server gets started!
    # Maybe better to PR an option in Bonito to prohibit starting it in the first place
    if !isnothing(Bonito.GLOBAL_SERVER[]) && isrunning(Bonito.GLOBAL_SERVER[])
        @warn "closing Bonito display server, which interfers with testing!"
        close(Bonito.GLOBAL_SERVER[])
    end
end

function TestSession(handler; url="0.0.0.0", port=8081, timeout=300)
    check_and_close_display()
    app = App() do session, request
        try
            dom = handler(session, request)
            testsession.dom = dom
            testsession.session = session
            testsession.request = request
            return dom
        catch e
            testsession.error_in_handler = (e, Base.catch_backtrace())
        end
    end
    server = Bonito.Server(app, url, port)
    testsession = TestSession(URI(string("http://localhost:", server.port)))
    testsession.server = server
    try
        start(testsession; timeout=timeout)
        return testsession
    catch e
        close(testsession)
        rethrow(e)
    end
end

"""
```julia
    testsession(f, handler; url="0.0.0.0", port=8081, timeout=300)

testsession(handler; url="0.0.0.0", port=8081, timeout=300)) do testsession
    # test code using testsession
end
```
This function will ensure proper setup and teardown once done with the tests or whenever an error occurs.
The testsession object passed to `f` allows to communicate with the browser session, run javascript
and get values from the html dom!
"""
function testsession(f, handler; kw...)
    testsession = TestSession(handler; kw...)
    try
        f(testsession)
    catch e
        rethrow(e)
    finally
        close(testsession)
    end
end

function testsession(handler; kw...)
    return TestSession(handler; kw...)
end

"""
    wait(testsession::TestSession; timeout=300)

Wait for testsession to be fully loaded!
Note, if you call wait on a fully loaded test
"""
function Base.wait(testsession::TestSession; timeout=300)
    testsession.initialized && return true
    if !testsession.window.window.exists
        error("Window isn't open, can't wait for testsession to be initialized")
    end
    Electron.toggle_devtools(testsession.window.window)
    while testsession.window.window.exists
        # We done!
        isdefined(testsession, :session) && isopen(testsession.session) && break
        if testsession.error_in_handler !== nothing
            e, backtrace = testsession.error_in_handler
            Base.show_backtrace(stderr, backtrace)
            throw(e)
        end
        # Again, we need to sleep instead of just waiting on `take!`
        # But if we don't do this, on an error in serving, we'd wait indefinitely
        # even if the window gets closed...And since Julia can't deal with interrupting
        # Wait, that'd mean killing Julia completely
        yield()
    end
    if !isopen(testsession.session)
        error("Window closed before getting a message from serving request")
    end
    on_timeout = "Timed out when waiting for JS to being loaded! Likely an error happend on the JS side, or your testsession is taking longer than $(timeout) seconds. If no error in console, try increasing timeout!"
    tstart = time()
    while time() - tstart < timeout
        if isready(testsession.session)
            # Error on js during init! We can't continue like this :'(
            if testsession.session.init_error[] !== nothing
                throw(testsession.session.init_error[])
            end
            break
        end
        sleep(0.01)
    end
    testsession.initialized = true
    return true
end

"""
    reload!(testsession::TestSession)

Reloads the served application and waits untill all state is initialized.
"""
function reload!(testsession::TestSession; timeout=300)
    check_and_close_display()
    testsession.initialized = true # we need to put it to true, otherwise handler will block!
    # Make 100% sure we're serving something, since otherwise, well block forever
    @assert isrunning(testsession.server)
    # Extra long time out for compilation!
    response = Bonito.HTTP.get(string(testsession.url), readtimeout=500)
    @assert response.status == 200
    testsession.initialized = false
    testsession.error_in_handler = nothing
    Electron.load(testsession.window.window, testsession.url)
    wait(testsession; timeout=timeout)
    @assert testsession.initialized
    return true
end

"""
    start(testsession::TestSession)

Start the testsession and make sure everything is loaded correctly.
Will close all connections, if any error occurs!
"""
function start(testsession::TestSession; timeout=300)
    check_and_close_display()
    try
        if isrunning(testsession.server)
            start(testsession.server)
        end
        if !isdefined(testsession, :window) || !testsession.window.window.exists
            testsession.window = TestWindow()
        end
        reload!(testsession; timeout=timeout)
    catch e
        close(testsession)
        rethrow(e)
    end
    return true
end

"""
    close(testsession::TestSession)

Close the testsession and clean up the state!
"""
function Base.close(testsession::TestSession)
    if isdefined(testsession, :window)
        # testsession.window.app.exists && close(testsession.window.app)
        close(testsession.window)
    end
    testsession.initialized = false
    if isdefined(testsession, :server)
        close(testsession.server)
    end
end

"""
    evaljs(testsession::TestSession, js::JSCode)
Runs javascript code `js` in testsession.
Will return the return value of `js`. Might return garbage data, if return value
isn't json serializable.

Example:
```julia
evaljs(testsession, js"document.getElementById('the-id')")
```
"""
function evaljs(testsession::TestSession, js::JSCode)
    Bonito.evaljs_value(testsession.session, js)
end

"""
    wait_test(condition)
Waits for condition expression to become true and then tests it!
"""
macro wait_for(condition, timeout=5)
    return quote
        tstart = time()
        while !$(esc(condition)) && (time() - tstart) < $(timeout)
            sleep(0.001)
        end
        @test $(esc(condition))
    end
end

"""
    query_testid(id::String)
Returns a js string, that queries for `id`.
"""
function query_testid(id::String)
    query_str = "[data-test-id=$(repr(id))]"
    js"document.querySelector($(query_str))"
end

"""
    query_testid(testsession::TestSession, id::String)
Returns a JSObject representing the object found for `id`.
"""
function query_testid(testsession::TestSession, id::String)
    return evaljs_value(testsession, query_testid(id))
end

using Bonito: URI

mutable struct BrowserDisplay <: Base.Multimedia.AbstractDisplay
    server::Union{Nothing, Server}
    open_browser::Bool
    handler::Any
end

BrowserDisplay(; open_browser=true) = BrowserDisplay(nothing, open_browser, nothing)

function server(display::BrowserDisplay)
    if isnothing(display.server)
        display.server = get_server()
    end
    server = display.server
    start(server) # no-op if already running, makes sure server wasn't closed
    return server
end

function Base.close(display::BrowserDisplay)
    if !isnothing(display.server)
        close(display.server)
    end
    if !isnothing(display.handler)
        close(display.handler)
    end
    return
end



"""
    browser_display()
Forces Bonito.App to be displayed in a browser window that gets opened.
"""
function browser_display()
    displays = Base.Multimedia.displays
    if !isempty(displays) && last(displays) isa BrowserDisplay
        return
    end
    # if browserdisplay is anywhere not at the last position
    # remove it!
    filter!(x-> !(x isa BrowserDisplay), displays)
    # add it to end!
    Base.pushdisplay(BrowserDisplay())
    return
end

"""
    tryrun(cmd::Cmd)

Try to run a command. Return `true` if `cmd` runs and is successful (exits with a code of `0`).
Return `false` otherwise.
"""
function tryrun(cmd::Cmd)
    try
        return success(cmd)
    catch e
        return false
    end
end

function openurl(url::String)
    if Sys.isapple()
        tryrun(`open $url`) && return true
    elseif Sys.iswindows()
        tryrun(`powershell.exe start $url`) && return true
    elseif Sys.isunix()
        tryrun(`xdg-open $url`) && return true
        tryrun(`gnome-open $url`) && return true
    end
    tryrun(`python -mwebbrowser $(url)`) && return true
    # our last hope
    tryrun(`python3 -mwebbrowser $(url)`) && return true
    @warn("Can't find a way to open a browser, open $(url) manually!")
    return false
end

using ..Bonito: wait_for_ready, wait_for
using ..Bonito

function Base.display(display::BrowserDisplay, app::App)
    s = server(display)
    if isnothing(display.handler)
        display.handler = Bonito.DisplayHandler(s, app)
    end
    handler = display.handler
    needs_load = update_app!(handler, app)
    # Wait for app to be initialized and fully rendered
    if needs_load
        if display.open_browser
            success = openurl(online_url(handler.server, handler.route))
            if success
                handler.session.status = Bonito.DISPLAYED
                # if open_browser, we need to let the caller wait!
                wait_for(()-> isready(handler.session))
                wait_for_ready(app)
            end
        end
        return true
    else
        wait_for_ready(app)
        return false
    end
end

online_url(display::BrowserDisplay) = online_url(server(display), "/browser-display")

function has_html_display()
    for display in Base.Multimedia.displays
        # Ugh, why would textdisplay say it supports HTML??
        display isa TextDisplay && continue
        displayable(display, MIME"text/html"()) && return true
    end
    return false
end

# Poor mans Require.jl for Electron
const ELECTRON_PKG_ID = Base.PkgId(Base.UUID("a1bb12fb-d4d1-54b4-b10a-ee7951ef7ad3"), "Electron")

function Electron()
    if haskey(Base.loaded_modules, ELECTRON_PKG_ID)
        return Base.loaded_modules[ELECTRON_PKG_ID]
    else
        error("Please Load Electron, if you want to use it!")
    end
end

struct EWindow
    app
    window
end

struct ElectronDisplay <: Base.Multimedia.AbstractDisplay
    window::EWindow
    browserdisplay::BrowserDisplay
end

function default_electron_args()
    # Not an exhaustive check, but we can add if needed
    if haskey(ENV, "GITHUB_ACTIONS")
        return [
            # Security warning suppressions
            "--disable-web-security",
            "--allow-running-insecure-content",
            "--disable-features=VizDisplayCompositor",
            "--ignore-certificate-errors",
            "--ignore-ssl-errors",
            "--ignore-certificate-errors-spki-list",
            "--disable-extensions-http-throttling",
            # Logging suppression
            "--log-level=3",  # Only fatal errors
            "--disable-logging",
            "--silent-debugger-extension-api",
            "--no-sandbox",
            "--enable-logging",
            "--user-data-dir=$(mktempdir())",
            "--disable-features=AccessibilityObjectModel",
            "--enable-unsafe-swiftshader",        # ← allow SwiftShader fallback
            "--use-gl=swiftshader",               # ← explicitly request software GL
            "--disable-gpu",                      # ← disable GPU to avoid GPU errors
        ]
    else
        return ["--user-data-dir=$(mktempdir())"]
    end
end

function EWindow(args...; options=Dict{String, Any}(), electron_args=default_electron_args())
    app = Electron().Application(;
        additional_electron_args=electron_args,
    )
    if isempty(args)
        return EWindow(app, Electron().Window(app, options))
    else
        return EWindow(app, Electron().Window(app, args...; options=options))
    end
end

function ElectronDisplay(; options=Dict{String, Any}(), devtools = false, electron_args=default_electron_args())
    w = EWindow(; electron_args=electron_args, options=options)
    devtools && Electron().toggle_devtools(w.window)
    return ElectronDisplay(w, BrowserDisplay(; open_browser=false))
end

Base.displayable(d::ElectronDisplay, ::MIME{Symbol("text/html")}) = true

function Base.display(display::ElectronDisplay, app::App)
    needs_load = Base.display(display.browserdisplay, app)
    url = online_url(display.browserdisplay)
    if needs_load
        Electron().load(display.window.window, URI(url))
    end
    wait_for_ready(app)
    return display
end

function use_electron_display(; options=Dict{String, Any}(), devtools = false, electron_args=default_electron_args())
    disp = ElectronDisplay(; devtools = devtools, options=options, electron_args=electron_args)
    filter!(Base.Multimedia.displays) do x
        # remove all other ElectronDisplays
        if x isa ElectronDisplay
            close(x)
            return false
        else
            return true
        end
    end
    Base.Multimedia.pushdisplay(disp)
    return disp
end

function Base.run(win::EWindow, args...)
    run(win.window, args...)
end

function Base.close(win::EWindow)
    window = win.window
    if window.app.exists
        close(window.app)
    end
    if window.exists
        close(window)
    end
    if win.app.exists
        close(win.app)
    end
    if isopen(win.app.proc)
        kill(win.app.proc)
    end
    return
end

function Base.close(display::ElectronDisplay)
    close(display.window)
    close(display.browserdisplay)
    return nothing
end

using Bonito, WGLMakie, Makie, Colors, FileIO
using Bonito.DOM

function styled_slider(slider, value)
    rows(slider, DOM.span(value, class="p-1"), class="w-64 p-2 items-center")
end

columns(args...; class="") = DOM.div(args..., class=class * " flex flex-col")
rows(args...; class="") = DOM.div(args..., class=class * " flex flex-row")
css_color(c) = "background-color: #$(hex(c))"

# get a somewhat interesting point cloud:
cat = decompose(Point3f, FileIO.load(Makie.assetpath("cat.obj")))
# Create a little interactive app
app = App() do session
    markersize = Bonito.Slider(range(10, stop=100, length=100))
    hue_slider = Bonito.Slider(1:120)
    color = map(hue_slider) do hue
        HSV(hue, 0.5, 0.5)
    end
    f, ax, pl = scatter(cat, markersize=markersize.value, color=color, figure=(size=(800, 500),))
    m_slider = styled_slider(markersize, map(x -> round(x, digits=1), markersize.value))
    color_swatch = DOM.div(class="h-6 w-6 p-1 rounded dropshadow", style=map(css_color, color))
    h_slider = styled_slider(hue_slider, color_swatch)
    sliders = rows(m_slider, h_slider)
    dom = DOM.div(Bonito.Styling, Bonito.TailwindCSS, columns(sliders, f))
    return Bonito.record_states(session, dom)
end;


# mkdir("simple")
Bonito.export_static("simple.html", app)

using .HTTPServer: has_route, get_route, route!

mutable struct HTTPAssetServer <: AbstractAssetServer
    # Reference count the files/binary assets, so we can clean them up for child sessions
    registered_files::Dict{String,Tuple{Set{UInt}, AbstractAsset}}
    server::Server
    lock::ReentrantLock
end

# AssetServer that uses HTTPAssetServer to host the files
# We need to have this, to keep track of files that are registered by child sessions
# So we can clean them up if the child session gets closed.
# We track them in the parent via `registered_files::Dict{String,Tuple{Set{UInt},Union{String, BinaryAsset}}}`
# Where the Set{UInt} is the set of all ChildAssetServer's objectids that have registered the file
mutable struct ChildAssetServer <: AbstractAssetServer
    parent::HTTPAssetServer
end

const MATCH_HEX = r"[\da-f]"
const ASSET_ROUTE_REGEX = r"assets-(?:\d+){20}"
const UNIQUE_FILE_KEY_REGEX = MATCH_HEX^40 * r"-.*"
const ASSET_URL_REGEX =
    "/" * ASSET_ROUTE_REGEX * "/" * UNIQUE_FILE_KEY_REGEX * r"(/?(?:\d+){20})?"
const HTTP_ASSET_ROUTE_KEY = "/assets/" * UNIQUE_FILE_KEY_REGEX

HTTPAssetServer() = HTTPAssetServer(get_server())

function HTTPAssetServer(server::Server)
    # We only have one HTTPAssetServer per Server,
    # And always just hand out ChildAssetServer to the session.
    # It's a bit of an abuse of the constructor,
    # but the API for Session is to just call the constructor of the desired assset server
    key = HTTP_ASSET_ROUTE_KEY
    lock(server.routes.lock) do
        if has_route(server.routes, key)
            return ChildAssetServer(get_route(server.routes, key))
        else
            http = HTTPAssetServer(Dict{String,Tuple{Set{UInt},AbstractAsset}}(), server, ReentrantLock())
            route!(server, HTTP_ASSET_ROUTE_KEY => http)
            return ChildAssetServer(http)
        end
    end
end

Base.similar(s::HTTPAssetServer) = ChildAssetServer(s)
Base.similar(s::ChildAssetServer) = ChildAssetServer(s.parent)

function Base.close(server::HTTPAssetServer)
    @debug "Closing HTTPAssetServer"
    HTTPServer.delete_route!(server.server, HTTP_ASSET_ROUTE_KEY)
    empty!(server.registered_files)
end

function Base.close(server::ChildAssetServer)
    lock(server.parent.lock) do
        id = objectid(server)
        to_delete = Set{String}()
        reg_files = server.parent.registered_files
        for (key, (refs, _)) in reg_files
            delete!(refs, id)
            isempty(refs) && push!(to_delete, key)
        end
        foreach(key -> delete!(reg_files, key), to_delete)
    end
end

function refs_and_url(server, asset::AbstractAsset)
    key = "/assets/" * unique_file_key(asset)
    refs, _ = get!(server.registered_files, key) do
        return (Set{UInt}(), asset)
    end
    if asset isa Asset && asset.es6module
        key = key * "?" * asset.content_hash[]
    end
    return refs, HTTPServer.relative_url(server.server, key)
end

function url(server::HTTPAssetServer, asset::AbstractAsset)
    is_online(asset) && return online_path(asset)
    lock(server.lock) do
        return refs_and_url(server, asset)[2]
    end
end

function url(child::ChildAssetServer, asset::AbstractAsset)
    lock(child.parent.lock) do
        is_online(asset) && return online_path(asset)
        refs, _url = refs_and_url(child.parent, asset)
        push!(refs, objectid(child))
        return _url
    end
end

function js_to_local_url(server::HTTPAssetServer, url::AbstractString)
    m = match(ASSET_URL_REGEX, url)
    if isnothing(m) || isempty(m)
        return url
    else
        key = URIs.URI(m[1]).path
        _, asset = server.registered_files[string(key)]
        return local_path(asset) * ":" * m[2]
    end
end

function js_to_local_stacktrace(server::HTTPAssetServer, line::AbstractString)
    function to_url(matched_url)
        js_to_local_url(server, matched_url)
    end
    return replace(line, ASSET_URL_REGEX => to_url)
end

function (server::HTTPAssetServer)(context)
    path = URIs.URI(context.request.target).path
    rf = server.registered_files
    if haskey(rf, path)
        _, asset = rf[path]
        if asset isa BinaryAsset
            header = ["Access-Control-Allow-Origin" => "*",
                "Content-Type" => asset.mime]
            return HTTP.Response(200, header; body=asset.data)
        else
            data = nothing
            if !isempty(asset.bundle_data)
                data = asset.bundle_data
            else
                if isfile(local_path(asset))
                    data = read(local_path(asset))
                end
            end
            if !isnothing(data)
                header = ["Access-Control-Allow-Origin" => "*",
                    "Content-Type" => file_mimetype(local_path(asset)),
                ]
                return HTTP.Response(200, header, body = data)
            end
        end
    end

    return HTTP.Response(404)
end

setup_asset_server(::ChildAssetServer) = nothing
setup_asset_server(::HTTPAssetServer) = nothing

using HTTP.WebSockets: WebSocket, WebSocketError
using HTTP.WebSockets: receive, isclosed
using HTTP.WebSockets

mutable struct WebSocketHandler
    socket::Union{Nothing,WebSocket}
    lock::ReentrantLock
end

WebSocketHandler(socket) = WebSocketHandler(socket, ReentrantLock())
WebSocketHandler() = WebSocketHandler(nothing, ReentrantLock())

function ws_should_throw(e)
    WebSockets.isok(e) && return false
    e isa Union{Base.IOError,EOFError} && return false
    e isa ArgumentError && e.msg == "send() requires `!(ws.writeclosed)`" && return false
    return true
end

function safe_read(websocket)
    try
        # readavailable is what HTTP overloaded for websockets
        return receive(websocket)
    catch e
        ws_should_throw(e) && rethrow(e)
        return nothing
    end
end


function safe_write(websocket, binary)
    try
        # send is what HTTP overloaded for writing to a websocket
        send(websocket, binary)
        return true
    catch e
        ws_should_throw(e) && rethrow(e)
        return nothing
    end
end

function Base.isopen(ws::WebSocketHandler)
    lock(ws.lock) do
        isnothing(ws.socket) && return false
        # isclosed(ws.socket) returns readclosed && writeclosed
        # but we consider it closed if either is closed?
        if ws.socket.readclosed || ws.socket.writeclosed
            return false
        end
        # So, it turns out, ws connection where the tab gets closed
        # stay open indefinitely, but aren't writable anymore
        # TODO, figure out how to check for that
        return true
    end
end

function Base.write(ws::WebSocketHandler, binary::AbstractVector{UInt8})
    lock(ws.lock) do
        if isnothing(ws.socket)
            error("socket closed or not opened yet")
        end
        written = safe_write(ws.socket, binary)
        if written != true
            @debug "couldnt write, closing ws"
            close(ws)
        end
    end
end

function Base.close(ws::WebSocketHandler)
    lock(ws.lock) do
        isnothing(ws.socket) && return
        try
            socket = ws.socket
            ws.socket = nothing
            isclosed(socket) || close(socket)
        catch e
            ws_should_throw(e) && @warn "error while closing websocket" exception=e
        end
    end
end

"""
    runs the main connection loop for the websocket
"""
function run_connection_loop(session::Session, handler::WebSocketHandler, websocket::WebSocket)
    @debug("opening ws connection for session: $(session.id)")
    handler.socket = websocket
    if session.status == SOFT_CLOSED
        session.status = OPEN
    end
    while isopen(handler)
        bytes = safe_read(websocket)
        # nothing means the browser closed the connection so we're done
        isnothing(bytes) && break
        isopen(session.inbox) || break
        put!(session.inbox, bytes)
    end
end


"""
    returns the javascript snippet to setup the connection
"""
function setup_websocket_connection_js(
    proxy_url, session::Session; query="", main_connection=true)
    return js"""
        $(Websocket).then(WS => {
            WS.setup_connection({
                proxy_url: $(proxy_url),
                session_id: $(session.id),
                compression_enabled: $(session.compression_enabled),
                query: $(query),
                main_connection: $(main_connection)
            })
        })
    """
end

# Poor mans Require.jl for Deno
const DENO_PKG_ID = Base.PkgId(Base.UUID("04572ae6-984a-583e-9378-9577a1c2574d"), "Deno_jll")
try
    # since Deno doesn't seem to work on all platforms we put it in a try catch-.-
    # Note, that it's not required for most use cases
    using Deno_jll
catch e
    @warn "Can't load Deno, which is ok for non dev purposes" exception = e
end

function Deno()
    if haskey(Base.loaded_modules, DENO_PKG_ID)
        return Base.loaded_modules[DENO_PKG_ID]
    else
        return nothing
    end
end

function deno_bundle(path_to_js::AbstractString, output_file::String)
    iswriteable = filemode(output_file) & Base.S_IWUSR != 0
    # bundles shipped as part of a package end up as read only
    # So we can't overwrite them
    isfile(output_file) && !iswriteable && return false, "Output file is not writeable"
    Deno_jll = Deno()
    # We treat Deno as a development dependency,
    # so if deno isn't loaded, don't bundle!
    isnothing(Deno_jll) && return false, "Deno not loaded"
    exe = Deno_jll.deno()
    stdout = IOBuffer()
    err = IOBuffer()
    try
        run(pipeline(`$exe bundle $(path_to_js)`; stdout=stdout, stderr=err))
    catch e
        err_str = String(take!(err))
        return false, err_str
    end
    dir = dirname(output_file)
    !isdir(dir) && mkpath(dir)
    write(output_file, seekstart(stdout))
    return true, ""
end

# For Hyperscript integration
function attribute_render(session::Session, parent, attribute::String, css::CSS)
    if attribute != "style"
        error("`CSS(...)` can only be used for the style attribute! Found: $(attribute) with css:\n $(css)")
    end
    node_styles = get!(session.stylesheets, parent, OrderedSet{CSS}())
    push!(node_styles, css)
    return ""
end

function attribute_render(session::Session, parent, attribute::String, styles::Styles)
    if attribute != "style"
        error("`Styles(...)` can only be used for the style attribute! Found: $(attribute) with css:\n $(css)")
    end
    node_styles = get!(session.stylesheets, parent, OrderedSet{CSS}())
    union!(node_styles, values(styles.styles))
    return ""
end

function jsrender(session::Session, style::Styles)
    push!(session.global_stylesheets, style)
    return nothing
end

function to_string(session::Session, style::Styles)
    io = IOBuffer()
    for (_, css) in style.styles
        render_style(io, session, "", css)
    end
    return String(take!(io))
end

convert_css_attribute(asset::Asset) = asset
convert_css_attribute(nested::CSS) = nested
convert_css_attribute(attribute::String) = String(chomp(attribute))
convert_css_attribute(color::Symbol) = convert_css_attribute(string(color))
convert_css_attribute(@nospecialize(::Observable)) = error("Observable not supported in CSS attributes right now!")
convert_css_attribute(@nospecialize(any)) = string(any)

function convert_css_attribute(color::Colorant)
    rgba = convert(RGBA{Float64}, color)
    return "rgba($(rgba.r * 255), $(rgba.g * 255), $(rgba.b * 255), $(rgba.alpha))"
end

function render_element(io, session, key, value::String, nesting)
    return println(io, "  "^(nesting), key, ": ", value, ";")
end

function render_element(io, session, key, value::Asset, nesting)
    u = url(session, value)
    return render_element(io, session, key, "url($u)", nesting)
end


function render_element(io, session, key, css::CSS, nesting)
    return render_style(io, session, "", css, nesting + 1)
end

function render_style(io, session, prefix, css::CSS, nesting=1)
    println(io, "  "^(nesting-1), prefix, css.selector, " {")
    for (k, v) in css.attributes
        render_element(io, session, k, v, nesting)
    end
    println(io, "  "^(nesting-1), "}")
end

Base.show(io::IO, css::CSS) = show(io, MIME"text/plain"(), css)

function Base.show(io::IO, ::MIME"text/plain", css::CSS)
    render_style(io, Session(NoConnection(); asset_server=NoServer()), "", css)
end

Base.show(io::IO, styles::Styles) = show(io, MIME"text/plain"(), styles)
function Base.show(io::IO, ::MIME"text/plain", styles::Styles)
    for (selector, css) in styles.styles
        render_style(io, Session(NoConnection(); asset_server=NoServer()), "", css)
    end
end

function render_stylesheets!(root_session, session, stylesheets::OrderedDict{HTMLElement, OrderedSet{CSS}})
    combined = OrderedDict{CSS,Set{HTMLElement}}()
    for (node, styles) in stylesheets
        for css in styles
            if haskey(combined, css)
                push!(combined[css], node)
            else
                combined[css] = Set([node])
            end
        end
    end
    io = IOBuffer()
    for (css, nodes) in combined
        idx = root_session.style_counter += 1
        root_session.style_counter
        id = string("style_", idx)
        render_style(io, session, "." * id, css)
        for node in nodes
            attr = Hyperscript.attrs(node)
            attr["class"] = get!(attr, "class", "") * " " * id
        end
    end
    stylesheet = String(take!(io))
    return DOM.style(stylesheet)
end

function CSS(selector::String, args::CSS...)
    return CSS(selector, Dict{String,Any}((arg.selector => arg for arg in args)))
end

function CSS(selector::String, args::Pair...)
    return CSS(selector, Dict{String,Any}(args...))
end
CSS(args::Pair...) = CSS("", args...)


Styles() = Styles(OrderedDict{String,CSS}())
function Styles(css::CSS)
    d = OrderedDict{String,CSS}()
    d[css.selector] = css
    return Styles(d)
end

function Styles(csss::CSS...)
    result = Styles()
    for css in csss
        selector = css.selector
        if haskey(result.styles, selector)
            result.styles[selector] = merge(result.styles[selector], css)
        else
            result.styles[selector] = css
        end
    end
    return result
end

function Styles(css::CSS, pairs::Pair...)
    error("Style $(css) with $(pairs) unaccaptable!")
end
Styles(pairs::Pair...) = Styles(CSS(pairs...))
function Styles(first::Styles, rest...)
    # Build styles in order: first comes first, then rest are merged in order
    # The LAST argument takes precedence for value conflicts
    result = Styles(copy(first.styles))
    for style in rest
        if style isa Styles
            merge!(result, style)
        else
            # Handle other constructible types
            merge!(result, Styles(style))
        end
    end
    return result
end

Styles(first::Styles, second::Styles) = merge(first, second)

function Base.merge(defaults::Styles, priority::Styles) # second argument takes priority
    result = Styles(copy(defaults.styles))
    merge!(result, priority)
    return result
end

function Base.merge!(defaults::Styles, priority::Styles)
    for (selector, css) in priority.styles
        if haskey(defaults.styles, selector)
            defaults.styles[selector] = merge(defaults.styles[selector], css)
        else
            defaults.styles[selector] = css
        end
    end
end

function Base.merge(a::CSS, b::CSS)
    a.selector == b.selector || error("Can't merge CSS with different selectors: $(a.selector) != $(b.selector)")
    return CSS(a.selector, merge(a.attributes, b.attributes))
end

#=
Decided against this macro, since it adds little value
And only adds confusion, since there are two ways with it to define CSS attributes
Leaving it here in case we find really strong reasons to use it
Two of the main problems in my eyes:
1) Without using strings as keys we cant directly use attributes like `font-size` and need to have some rewriting logic e.g. from `font_size` to `font-size`.
2) With using strings we get super close to just the dict syntax of `Dict("font-size" => "12px")` and the macro is not really needed anymore.

macro CSS(curly)
    if  curly.head !== :bracescat
        error("use @CSS {...}")
    end
    css = Dict{String, Any}()
    for arg in curly.args
        if Meta.isexpr(arg, :call) && length(arg.args) !== 3 && arg.args[1] !== Symbol(":")
            error("use @CSS {key: value; key2: value2}")
        end
        key = replace(string(arg.args[2]), "_" => "-")
        value = arg.args[3]
        css[key] = value
    end
    return CSS(css)
end
=#

function electron_evaljs(window, js)
    js_str = sprint(show, js)
    return run(window, js_str)
end

function is_fully_loaded(window)
    return electron_evaljs(window, js"""(()=> {
        if (Bonito && Bonito.can_send_to_julia && Bonito.can_send_to_julia()){
            const elem = document.querySelectorAll('select')
            if (elem && elem.length == 2) {
                return true
            }
        }
        return false
    })()
    """)
end

function test_dom(window)
    # wait for everything to be ready
    while !is_fully_loaded(window)
        sleep(0.01)
    end
    electron_evaljs(window, js"document.querySelectorAll('select').length") == 2 || return false
    dropdown1 = js"document.querySelectorAll('select')[0]"
    dropdown2 = js"document.querySelectorAll('select')[1]"

    electron_evaljs(window, js"$(dropdown1).selectedIndex") == 0 || return false
    electron_evaljs(window, js"$(dropdown2).selectedIndex") == 1 || return false

    electron_evaljs(
        window,
        js"(()=> {
        const select = $(dropdown1)
        select.selectedIndex = 1;
        const event = new Event('change');
        select.dispatchEvent(event);
    })()")
    electron_evaljs(
        window,
        js"(()=> {
        const select = $(dropdown2)
        select.selectedIndex = 2;
        const event = new Event('change');
        select.dispatchEvent(event);
    })()")
    return true
    # TODO how to get these observables?
    # @test dropdown1_jl.value[] == "b"
    # @test dropdown2_jl.value[] == "c2"
end

# Disable cleanup wait so that we can test if all sessions close properly
# After closing the windows!
Bonito.set_cleanup_time!(0.0)
@testset "stresstest threading" begin
    app = App(threaded=true) do session
        dropdown1 = Bonito.Dropdown(["a", "b", "c"])
        dropdown2 = Bonito.Dropdown(["a2", "b2", "c2"]; index=2)
        img = Asset(joinpath(@__DIR__, "..", "docs", "src", "jupyterlab.png"))
        return DOM.div(dropdown1, dropdown2, img, js"""$(Bonito.BonitoLib).then(console.log)""")
    end
    server = Server(app, "0.0.0.0", 8888)

    nwindows = 4
    all_windows = Channel{Bonito.EWindow}(nwindows)
    created_windows = Bonito.EWindow[]
    # Create window options
    options = Dict{String, Any}(
        "show" => false,  # Don't show the window immediately
        "focusOnWebView" => false,  # Don't focus the webview
    )
    for i in 1:nwindows
        win = TestWindow()
        Electron.toggle_devtools(win.window)
        put!(all_windows, win)
        push!(created_windows, win)
    end
    url = URI(online_url(server, "/"))
    # Only use half of the available threads to not block the response because we hogged all threads
    results = asyncmap(1:100) do i
        window = take!(all_windows)
        try
            load(window.window, url)
            return test_dom(window)
        finally
            put!(all_windows, window)
        end
    end
    @test all(results)
    # It would be nice to close all opened windows, but somehow that seems to hang....
    for win in created_windows
        close(win)
    end
    empty!(created_windows)
    success = Bonito.wait_for(() -> isempty(server.websocket_routes.table), timeout=10)
    @test success == :success
    close(server)
end
Bonito.set_cleanup_time!(30/60/60)

using .HTTPServer: Server
using HTTP.WebSockets

mutable struct WebSocketConnection <: AbstractWebsocketConnection
    server::Server
    session::Union{Nothing,Session}
    handler::WebSocketHandler
end

WebSocketConnection(proxy_callback::Function) = WebSocketConnection(get_server(proxy_callback))
WebSocketConnection() = WebSocketConnection(get_server())
function WebSocketConnection(server::Server)
    return WebSocketConnection(server, nothing, WebSocketHandler())
end

Base.isopen(ws::WebSocketConnection) = isopen(ws.handler)

function Base.write(ws::WebSocketConnection, binary::AbstractVector{UInt8})
    write(ws.handler, binary)
end

function Base.close(ws::WebSocketConnection)
    close(ws.handler)
    if !isnothing(ws.session)
        session = ws.session
        delete_websocket_route!(ws.server, "/$(session.id)")
        close(session)
    end
    return
end

"""
    handles a new websocket connection to a session
"""
function (connection::WebSocketConnection)(context, websocket::WebSocket)
    request = context.request
    uri = URIs.URI(request.target)
    session_id = URIs.splitpath(uri.path)[1]
    @debug("WS session id: $(session_id)")
    session = connection.session
    if isnothing(session)
        error("Websocket connection skipped setup")
    end
    @assert session_id == session.id
    try
        run_connection_loop(session, connection.handler, websocket)
    finally
        # This always needs to happen, which is why we need a try catch!
        if allow_soft_close(CLEANUP_POLICY[])
            @debug("Soft closing: $(session.id)")
            soft_close(session)
        else
            @debug("Closing: $(session.id)")
            # might as well close it immediately
            close(session)
        end
    end
end


const SERVER_CLEANUP_TASKS = Dict{Server, Tuple{Task, Base.RefValue{Bool}}}()

"""
    abstract type CleanupPolicy end

You can create a custom cleanup policy by subclassing this type. Implementing
the `should_cleanup` and `allow_soft_close` methods is required. You can also
implement `set_cleanup_time!`if it makes sense for your policy.

    function should_cleanup(policy::MyCleanupPolicy, session::Session)

    function allow_soft_close(policy::MyCleanupPolicy)

    function set_cleanup_time!(policy::MyCleanupPolicy, time_in_hrs::Real)

This is quite low level, and you implementaiton should probably start by copying `DefaultCleanupPolicy`.
"""
abstract type CleanupPolicy end

"""
    mutable struct DefaultCleanupPolicy <: CleanupPolicy
        session_open_wait_time=30
        cleanup_time=0.0
    end

This is the default cleanup policy. It closes sessions after
`session_open_wait_time` seconds (default 30) if the browser didn't connect
back to the displayed session. It also closes sessions after `cleanup_time`
hours (default 0) if the session closes cleanly, indicating that the
browser may reconnect if a tab is later restored. It returns true for
allow_soft_close(...) when `cleanup_time` is non-zero.
"""
mutable struct DefaultCleanupPolicy <: CleanupPolicy
    session_open_wait_time::Real
    cleanup_time::Real
end

# 30 seconds as cleanup wait time
# Allowing to reconnect for 30s after any event killing the websocket connection
# Without closing the tab.
DefaultCleanupPolicy() = DefaultCleanupPolicy(30, 30 / 60 / 60)

"""
    set_cleanup_time!(time_in_hrs::Real)

Sets the time that sessions remain open after the browser tab is closed.
This allows reconnecting to the same session.
Only works for Websocket connection inside VSCode right now,
and will display the same App again from first display.
State that isn't stored in Observables inside that app is lost.
"""
function set_cleanup_time!(time_in_hrs::Real)
    set_cleanup_time!(CLEANUP_POLICY[], time_in_hrs)
end

function set_cleanup_time!(policy::DefaultCleanupPolicy, time_in_hrs::Real)
    policy.cleanup_time = time_in_hrs
end

"""
    set_cleanup_policy!(policy::CleanupPolicy)

You can set a custom cleanup policy by calling this function.
"""
function set_cleanup_policy!(policy::CleanupPolicy)
    CLEANUP_POLICY[] = policy
end

const CLEANUP_POLICY = Ref{CleanupPolicy}(DefaultCleanupPolicy())

function should_cleanup(policy::DefaultCleanupPolicy, session::Session)
    if session.status == SOFT_CLOSED
        age = time() - session.closing_time
        age_hours = age / 60 / 60
        if age_hours > policy.cleanup_time
            return true
        end
    elseif !isopen(session) && session.status == DISPLAYED
        # if the session is not SOFT_CLOSED,
        # closing time means time at which rendering was done and the html was send to the browser
        rendered_time_point = session.closing_time
        # If the browser didn't connect back to the displayed session after 30s
        # we assume displaying didn't work for whatever reason and close it.
        if time() - rendered_time_point > policy.session_open_wait_time
            return true
        end
    end
    return false
end

function allow_soft_close(policy::DefaultCleanupPolicy=CLEANUP_POLICY[])
    return policy.cleanup_time > 0.0
end

function cleanup_server(server::Server)
    remove = Set{FrontendConnection}()
    lock(server.websocket_routes.lock) do
        for (route, connection) in server.websocket_routes.table
            if connection isa FrontendConnection
                session = connection.session
                if isnothing(session) || should_cleanup(CLEANUP_POLICY[], session)
                    push!(remove, connection)
                end
            end
        end
        for connection in remove
            if !isnothing(connection.session)
                session = connection.session
                close(session)
            end
        end
    end
end

function add_cleanup_task!(server::Server)
    get!(SERVER_CLEANUP_TASKS, server) do
        close_ref = Base.RefValue(true)
        task = @async while close_ref[]
            try
                sleep(1)
                cleanup_server(server)
            catch e
                if !(e isa EOFError)
                    @warn "error while cleaning up server" exception=(e, Base.catch_backtrace())
                end
            end
        end
        return (task, close_ref)
    end
end

function setup_connection(session::Session, connection::WebSocketConnection)
    connection.session = session
    server = connection.server
    add_cleanup_task!(server)
    HTTPServer.websocket_route!(server, "/$(session.id)" => connection)
    proxy_url = HTTPServer.relative_url(server, "")
    return setup_websocket_connection_js(proxy_url, session)
end

function setup_connection(session::Session{WebSocketConnection})
    return setup_connection(session, session.connection)
end

"""
    jsrender([::Session], x::Any)

Internal render method to create a valid dom. Registers used observables with a session
And makes sure the dom only contains valid elements. Overload jsrender(::YourType)
To enable putting YourType into a dom element/div.
You can also overload it to take a session as first argument, to register
messages with the current web session (e.g. via onjs).
"""
jsrender(::Session, value::Union{String,Symbol}) = string(value)
jsrender(::Nothing) = DOM.span()
jsrender(@nospecialize(x)) = x

function render_mime(session::Session, m::MIME"text/html", @nospecialize(value))
    html = Base.invokelatest(repr, m, value; context=session.io_context[])
    return HTML{String}(html)
end

function render_mime(session::Session, m::Union{MIME"image/png", MIME"image/jpeg", MIME"image/svg+xml"}, @nospecialize(value))
    io = IOBuffer()
    ctx = session.io_context[]
    render_io = isnothing(ctx) ? io : IOContext(io, ctx)
    show(render_io, m, value)
    bindeps = BinaryAsset(take!(io), mime_string(m))
    return DOM.img(src=url(session, bindeps))
end

function render_mime(session::Session, m::MIME"text/latex", @nospecialize(value))
    tex_str = sprint() do io
        ctx = session.io_context[]
        render_io = isnothing(ctx) ? io : IOContext(io, ctx)
        show(render_io, m, value)
    end
    return jsrender(session, KaTeX(tex_str))
end

function render_mime(session::Session, m::MIME"text/plain", @nospecialize(value))
    if value isa AbstractString
        return DOM.span(convert(String, value))
    end
    if session.io_context[] isa Nothing
        ctx = IOContext(Base.stdout, :limit => true)
    else
        ctx = session.io_context[]
    end
    val = Base.invokelatest(repr, m, value; context=ctx)
    return DOM.span(val; style="white-space: pre-wrap", class="text-plain")
end

function jsrender(session::Session, @nospecialize(value))
    rendered = jsrender(value)
    if rendered === value
        mime = richest_mime(value)
        return render_mime(session, mime, value)
    else
        return rendered
    end
end

using Bonito, Observables, Markdown, Colors
using Bonito: Asset
style_obs = Observable((color = :red,))

slider = Bonito.Slider(1:10, class="slider m-4")


example_dom = DOM.div(
    DOM.h1("hi", style=style_obs),
    slider,
    DOM.div(js"""
        console.log("hello")
    """),
    DOM.img(src=Asset("/test.png")),
    rand(RGBA{Float32}, 10, 10),
    md"""
    # Hi this is a test
    ![]($(Asset(/test.png))
    """
)

session = Session()

Bonito.jsrender(session, example_dom)

obs_dom = Observable(example_dom)
obs_arrays = Observable(
    [
        rand(UInt8, 10),
        rand(Int32, 10),
        rand(UInt32, 10),
        rand(Float16, 10),
        rand(Float32, 10),
        rand(Float64, 10),
    ]
)

test_js = js"""
import * as TestMod from $(TestMod)

const dom_ref = $(existing_dom)
const new_dom = $(by_value(new_dom))
const obs_dom = $(obs_dom)
const obs_arrays = $(obs_arrays)
const obs_dict = $(obs)
"""

const GLOBAL_SERVER = Ref{Union{Server,Nothing}}(nothing)

const SERVER_CONFIGURATION = (
    # The URL used to which the default server listens to
    listen_url=Ref{Union{String,Nothing}}(nothing),
    # The Port to which the default server listens to
    listen_port=Ref(9384),
    # The url Javascript uses to connect to the websocket.
    # if empty, it will use:
    # `window.location.protocol + "//" + window.location.host`
    proxy_url=Ref(""),
    # Verbosity for logging!
    verbose=Ref(-1)
)

# Should only be called if IJulia is loaded!\

function jupyter_running_servers()
    jupyter = IJulia().JUPYTER
    # Man, whats up with jupyter??
    # They switched between versions from stdout to stderr, and also don't produce valid json as output -.-
    run_cmd(std, err) = run(pipeline(`$jupyter lab list --json`; stderr=err, stdout=std))
    json = sprint(io -> run_cmd(io, IOBuffer()))
    if isempty(json)
        json = sprint(io -> run_cmd(IOBuffer(), io))
        if isempty(json)
            # give up -.-
            return nothing
        end
    end
    json = replace(json, "[JupyterServerListApp] " => "")
    json = replace(json, r"[\r\n]+" => "\n")
    configs = JSON.parse.(split(json, "\n"; keepempty=false))
    return configs
end

function jupyterlab_proxy_url(port)
    config = jupyter_running_servers()
    if isnothing(config)
        @warn "could not automatically figure out jupyter proxy setup"
        return ""
    else
        # taking first kernel
        # TODO, how to match kernel?
        hostname = config[1]["hostname"]
        # TODO, this seems very fragile
        if haskey(ENV, "BONITO_JUPYTER_REMOTE_HOST")
            return string(ENV["BONITO_JUPYTER_REMOTE_HOST"], config[1]["base_url"], "proxy/", port)
        elseif hostname == "0.0.0.0" || hostname == "localhost"
            return string("http://", IJulia().profile["ip"], ":", config[1]["port"], config[1]["base_url"], "proxy/", port)
        else
            return ""
        end
    end
end

function find_proxy_in_environment()
    if !isempty(SERVER_CONFIGURATION.proxy_url[])
        return port-> SERVER_CONFIGURATION.proxy_url[]
    elseif haskey(ENV, "JH_APP_URL")
        # JuliaHub & VSCode
        return port-> ENV["JH_APP_URL"] * "proxy/$(port)"
    elseif haskey(ENV, "JULIA_WEBIO_BASEURL")
        # Possibly not working anymore, but used to be used in e.g. nextjournal for the proxy url
        return port-> ENV["JULIA_WEBIO_BASEURL"]
    elseif haskey(ENV, "BINDER_SERVICE_HOST")
        # binder
        return port -> ENV["BINDER_SERVICE_HOST"] * "proxy/$port"
    elseif haskey(ENV, "JPY_SESSION_NAME") && haskey(Base.loaded_modules, IJULIA_PKG_ID)
        # Jupyterhub works differently!
        # TODO, is JPY_SESSION_NAME reliably in the env for Jupyterlab? So far it seems so!
        # It definitely isn't there without Jupyterlab
        # jupyterlab
        return jupyterlab_proxy_url
    elseif haskey(ENV, "VSCODE_PROXY_URI")
        # If VSCode is proxying ports, default to using that, so that we can
        # work even in environments where we're using `code-server`, and we
        # may not have any port available other than https.
        return port -> replace(ENV["VSCODE_PROXY_URI"], "{{port}}" => port)
    else
        # TODO, when to use ip address?
        # Sockets.getipaddr()
        return nothing
    end
end

"""
    configure_server!(;
            listen_url::String=SERVER_CONFIGURATION.listen_url[],
            listen_port::Integer=SERVER_CONFIGURATION.listen_port[],
            forwarded_port::Integer=listen_port,
            proxy_url=nothing,
            content_delivery_url=nothing
        )

Configures the parameters for the automatically started server.

    Parameters:

    * listen_url=SERVER_CONFIGURATION.listen_url[]
        The address the server listens to.
        must be 0.0.0.0, 127.0.0.1, ::, ::1, or localhost.
        If not set differently by an ENV variable, will default to 127.0.0.1

    * listen_port::Integer=SERVER_CONFIGURATION.listen_port[],
        The Port to which the default server listens to
        If not set differently by an ENV variable, will default to 9384

    * forwarded_port::Integer=listen_port,
        if port gets forwarded to some other port, set it here!

    * proxy_url=nothing
        The url from which the server is reachable, used to declare resources in Bonitos HTML and to establish a websocket connection.
        Setting it to `""` or `nothing` will use the url the server listens to.
        So, if `listen_url="127.0.0.1"`, this will default to http://localhost:forwarded_port (same as `local_url(server, "")`).
        You can also set this to `"."` to use relative urls, e.g. for accessing the webpage on a local network, or when serving it online with your own server.
        This is the preferred option for serving a whole website via Bonito, where you dont know in advanced where the page will be served.
        If it's more complicated, e.g. when the HTML is served on a different url from the url to proxy through to the Bonito server,
         a full URL needs to set, e.g. `proxy_url=https://bonito.makie.org`.
"""
function configure_server!(;
        listen_url=nothing,
        listen_port::Integer=SERVER_CONFIGURATION.listen_port[],
        forwarded_port::Integer=listen_port,
        proxy_url=nothing,
    )

    if isnothing(listen_url)
        if !isnothing(proxy_url)
            # if we serve to an external url, server must listen to 0.0.0.0
            listen_url = "0.0.0.0"
        else
            listen_url = SERVER_CONFIGURATION.listen_url[]
        end
    end

    if isnothing(proxy_url)
        proxy_url = ""
    end
    # set the config!
    SERVER_CONFIGURATION.listen_url[] = listen_url
    SERVER_CONFIGURATION.proxy_url[] = proxy_url
    SERVER_CONFIGURATION.listen_port[] = listen_port
    return
end



function singleton_server(;
    listen_url = "127.0.0.1",
    listen_port=SERVER_CONFIGURATION.listen_port[],
    verbose=SERVER_CONFIGURATION.verbose[],
    proxy_url=SERVER_CONFIGURATION.proxy_url[])

    from_user = SERVER_CONFIGURATION.listen_url[]
    if !isnothing(from_user) # user set the listen url explicitely
        listen_url = from_user # and we respect that!
    end
    create() = Server(listen_url, listen_port; verbose=verbose)
    if isnothing(GLOBAL_SERVER[])
        GLOBAL_SERVER[] = create()
    else
        server = GLOBAL_SERVER[]
        # re-create if parameters have changed
        if server.url != listen_url  || !HTTPServer.isrunning(server)# && server.port == listen_port # leave out port since it matters listens
            close(server)
            GLOBAL_SERVER[] = create()
        end
    end
    GLOBAL_SERVER[].proxy_url = proxy_url
    return GLOBAL_SERVER[]
end

get_server() = get_server(find_proxy_in_environment())

function get_server(proxy_callback)
    # we have found nothing, so don't do any fancy setup
    if isnothing(proxy_callback)
        return singleton_server()
    else
        url = proxy_callback(8888) # call it with any port, to see if its empty and therefore no proxy is found/needed
        listen_url = isempty(url) ? "127.0.0.1" : "0.0.0.0" # we only need to serve on 0.0.0.0, if we proxy
        server = singleton_server(; listen_url=listen_url)
        real_port = server.port # can change if already in use
        server.proxy_url = proxy_callback(real_port) # which is why the url needs to be a callbacks
        return server
    end
end

using Bonito
using Bonito: onload, @js_str, Session, App
using Bonito.DOM

using Deno_jll # If you create your own javascript module, you need to include deno!

# First argument: Name of the Javascript module
# Second argument: Array of dependency. One needs to be the JavaScript file
# containing the module the others can be css files!
const JSModule = ES6Module(joinpath(@__DIR__, "JSModule.js"))

app = App() do session::Session
    hello_div = DOM.div("hello")
    # now, one can just use the module anywhere:
    onload(session, hello_div, js"""function (hello_div){
        $(JSModule).then(Module => {
            Module.set_global(27398);
            hello_div.innerText = Module.get_global();
        })
    }""")
    return hello_div
end

function update_route!(server, (route, app))
    old = route!(server, route => app)
    if old isa App && !isnothing(old.session[]) && isready(old.session[])
        try
            Bonito.evaljs(old.session[], js"window.location.reload()")
        catch e
            @warn "Failed to reload route $(route)" exception = e
        end
    end
end

const REVISE_LOOP = Base.RefValue(Base.RefValue(true))
const REVISE_SERVER = Base.RefValue{Union{Nothing, Server}}(nothing)

"""
    interactive_server(f, paths, modules=[]; url="127.0.0.1", port=8081, all=true)

Revise base server that will serve a static side based on Bonito and will update on any code change!

Usage:

```julia
using Revise, Website
using Website.Bonito

# Start the interactive server and develop your website!
routes, task, server = interactive_server(Website.asset_paths()) do
    return Routes(
        "/" => App(index, title="Makie"),
        "/team" => App(team, title="Team"),
        "/contact" => App(contact, title="Contact"),
        "/support" => App(support, title="Support")
    )
end

# Once everything looks good, export the static site
dir = joinpath(@__DIR__, "docs")
# only delete the bonito generated files
rm(joinpath(dir, "bonito"); recursive=true, force=true)
Bonito.export_static(dir, routes)
```
For the complete code, visit the Makie website repository which is using Bonito:
[MakieOrg/Website](https://github.com/MakieOrg/Website/blob/sd/bonito/make.jl)
"""
function interactive_server(f, paths, modules=[]; url="127.0.0.1", port=8081, all=true)
    if isnothing(REVISE_SERVER[])
        server = Server(url, port)
        REVISE_SERVER[] = server
    else
        server = REVISE_SERVER[]
    end
    if server.url != url && server.port != port
        close(server)
        server.url = url
        server.port = port
        HTTPServer.start(server)
    end
    if isdefined(Main, :Revise)
        Revise = Main.Revise
        # important to make `index = App(....)` work
        @eval Main __revise_mode__ = :evalassign
        returned_routes = nothing
        function update_routes()
            routes = Base.invokelatest(f)
            for (route, app) in routes.routes
                update_route!(server, (route, app))
            end
            # Update routes returned to the user, so they're up do date!
            if !isnothing(returned_routes)
                # TODO, could this be called from another task and needs a lock?
                empty!(returned_routes.routes)
                merge!(returned_routes.routes, routes.routes)
            end
            return routes
        end

        returned_routes = update_routes()
        Revise.add_callback(update_routes, paths, modules; all=true, key="bonito-revise")

        REVISE_LOOP[][] = false # stop any old loop
        run = Base.RefValue(true) # get us a new loop variable
        REVISE_LOOP[] = run
        task = @async begin
            while run[]
                wait(Revise.revision_event)
                Revise.revise()
            end
            @info("quitting revise loop")
        end
        errormonitor(task)
        route_dict = returned_routes.routes
        user_routes = keys(route_dict)
        server_routes = Set(first.(server.routes.table))
        if !Base.all(r -> r in server_routes, user_routes)
            # Sanity check, that all routes have been added to server. Not sure how this could fail, but better to check it!
            @warn "Not all routes in server. Required routes: $(user_routes). Routes in server: $(server_routes)"
        end
        startpage = haskey(route_dict, "/") ? "/" : first(route_dict)[1]
        HTTPServer.openurl(online_url(server, startpage))
        return returned_routes, task, server
    else
        error("Please load Revise into Main scope")
    end
end

using CSV, Shapefile
using Bonito, WGLMakie, Markdown
using Downloads: download
import Bonito.TailwindDashboard as D
using GeoInterfaceMakie
GeoInterfaceMakie.@enable Shapefile.Polygon

read_data(path) = open(path) do io
    # skip first line since it contains an invalid comment
    readuntil(io, "\n")
    CSV.File(io, delim=';')
end

function normalize_names(x)
    no_umlaut = replace(x, r"[üöä]" => (x)-> Dict("ü" => "ue", "ö"=>"ae", "ä"=>"oe")[x])
    bb = replace(no_umlaut, "Brandenburg/Berlin" => "Berlin")
    if any(y-> occursin(y, bb), ("Hamburg", "Bremen", "Niedersachsen"))
        return "Niedersachsen"
    end
    return bb
end

data_dir = joinpath(@__DIR__, "data")
mkdir(data_dir)
data_temp_path = joinpath(data_dir, "temperature.txt")
data_prec_path = joinpath(data_dir, "precipitation.txt")
download("https://opendata.dwd.de/climate_environment/CDC/regional_averages_DE/annual/air_temperature_mean/regional_averages_tm_year.txt", data_temp_path)
download("https://opendata.dwd.de/climate_environment/CDC/regional_averages_DE/annual/precipitation/regional_averages_rr_year.txt", data_prec_path)

temp_data = read_data(data_temp_path)
prec_data = read_data(data_prec_path)

url_gadm = "https://biogeo.ucdavis.edu/data/gadm3.6/shp/gadm36_DEU_shp.zip"
shape_path = joinpath(data_dir, "gadm36_DEU_1.shp")
shape_zip = joinpath(data_dir, "gadm36_DEU_1.zip")
download(url_gadm, shape_zip)
run(`unzip $shape_zip -d $data_dir`)
tbl_states = collect(Shapefile.Table(shape_path))

states = map(normalize_names, tbl_states.NAME_1)
states_geom_map = Dict(zip(map(normalize_names, tbl_states.NAME_1), tbl_states.NAME_1))
states_sym = propertynames(temp_data)[3:end]
statenames_to_sym = Dict(zip(normalize_names.(string.(states_sym)), states_sym))

states_to_plot = filter(states) do state
    haskey(statenames_to_sym, state)
end

function data_extrema(data)
    combinations = [(s, i) for s in states_to_plot, i in 1:length(data)]
    return extrema(map(combinations) do (state, idx)
        return data[idx][statenames_to_sym[state]]
    end)
end

function visualize_data(scene, data, cmap, colorrange, s)
    colormap = to_colormap(cmap)
    colors = map(s) do idx
        map(states_to_plot) do state
            datapoint = data[idx][statenames_to_sym[state]]
            return Makie.interpolated_getindex(colormap, datapoint, colorrange)
        end
    end

    polys = map(states_to_plot) do state
        idx = findfirst(x-> x.NAME_1 == states_geom_map[state], tbl_states)
        return tbl_states[idx].geometry
    end
    # Plot each state individually, so we can update one color per state
    for i in 1:length(states_to_plot)
        poly!(scene, polys[i], color=lift(x-> x[i], colors))
    end
    return scene
end

app = App() do session
    fig = Figure(resolution=(900, 700))
    to_plot = (
        (1, "Temperatur", temp_data, :heat),
        (2, "Regen", prec_data, :blues))
    s = Bonito.Slider(1:length(temp_data))

    for (i, title, data, cmap) in to_plot
        colorrange = data_extrema(data)
        ax = Axis(fig[1, i]; title=title)
        hidedecorations!(ax, grid=false)
        visualize_data(ax, data, cmap, colorrange, s)
        fig[2, i] = Colorbar(fig, colormap=cmap, limits=colorrange, vertical=false, height=30, labelvisible=false)
    end

    year = map(idx-> temp_data[idx].Jahr, s)

    markdown = md"""
    # Durchschnitts Temperatur per Bundesland

    ## Reise vom Jahr 1881 bis 2019
    $(styled_slider(s, year))

    $(fig)

    [Quelle: Deutscher Wetterdienst](https://opendata.dwd.de/climate_environment/CDC/regional_averages_DE/annual/)

    [Quellcode für Visualisierung](https://github.com/SimonDanisch/Bonito.jl/blob/master/examples/german_clima.jl)
    """

    dom = DOM.div(Bonito.MarkdownCSS, Bonito.TailwindCSS, Bonito.Styling, markdown)
    # return dom
    return Bonito.record_states(session, dom)
end;

# Either export standalone
mkpath("./dev/WGLDemos/")
Bonito.export_static("./dev/WGLDemos/german_heat.html", app)

# Or serve as a website!
# app = Bonito.Server(app, "0.0.0.0", 80)

using Test
using Bonito
using Bonito: pbkdf2_simple, generate_salt, User, SingleUser, ProtectedRoute
using Bonito: authenticate, get_user, check_auth, FolderServer
using Base64
using Dates

# Define LoggingHandler
struct LoggingHandler{T}
    handler::T
    log_file::String
end

function Bonito.HTTPServer.apply_handler(logger::LoggingHandler, context)
    request = context.request
    # Log the request
    open(logger.log_file, "a") do io
        println(io, "$(Dates.now()): $(request.method) $(request.target)")
    end
    # Delegate to wrapped handler
    return Bonito.HTTPServer.apply_handler(logger.handler, context)
end

@testset "Protected Route" begin
    @testset "PBKDF2 Basic Functionality" begin
        password = "test_password"
        salt = generate_salt(16)

        # Test that PBKDF2 produces consistent results
        hash1 = pbkdf2_simple(password, salt; iterations=100)
        hash2 = pbkdf2_simple(password, salt; iterations=100)
        @test hash1 == hash2

        # Test that different salts produce different hashes
        salt2 = generate_salt(16)
        hash3 = pbkdf2_simple(password, salt2; iterations=100)
        @test hash1 != hash3

        # Test that output is 32 bytes (SHA256)
        @test length(hash1) == 32
    end

    @testset "Salt Generation" begin
        salt1 = generate_salt(16)
        salt2 = generate_salt(16)

        @test length(salt1) == 16
        @test length(salt2) == 16
        @test salt1 != salt2  # Should be random

        # Test different lengths
        salt_small = generate_salt(8)
        salt_large = generate_salt(32)
        @test length(salt_small) == 8
        @test length(salt_large) == 32
    end

    @testset "User Creation and Authentication" begin
        # Create user with password
        user = User("alice", "secret123"; iterations=100)

        @test user.username == "alice"
        @test length(user.password_hash) == 32
        @test length(user.salt) == 16
        @test user.iterations == 100

        # Test successful authentication
        @test authenticate(user, "secret123") == true

        # Test failed authentication
        @test authenticate(user, "wrong_password") == false
        @test authenticate(user, "secret124") == false
        @test authenticate(user, "") == false
    end

    @testset "User with Metadata" begin
        metadata = Dict("role" => "admin", "id" => 42)
        user = User("bob", "pass456"; iterations=100, metadata=metadata)

        @test user.metadata["role"] == "admin"
        @test user.metadata["id"] == 42
    end

    @testset "SingleUser Password Store" begin
        store = SingleUser("alice", "secret123"; iterations=100)

        # Test get_user
        user = get_user(store, "alice")
        @test !isnothing(user)
        @test user.username == "alice"

        # Test get_user with wrong username
        user_wrong = get_user(store, "bob")
        @test isnothing(user_wrong)

        # Test authenticate via store
        @test authenticate(store, "alice", "secret123") == true
        @test authenticate(store, "alice", "wrong") == false
        @test authenticate(store, "bob", "secret123") == false
    end

    @testset "HTTP Basic Auth Parsing" begin
        # Create a test password store
        store = SingleUser("testuser", "testpass"; iterations=100)

        # Test with valid credentials
        valid_auth = "Basic " * base64encode("testuser:testpass")
        request_valid = HTTP.Request("GET", "/", ["Authorization" => valid_auth])
        @test check_auth(request_valid, store) == true

        # Test with invalid password
        invalid_auth = "Basic " * base64encode("testuser:wrongpass")
        request_invalid = HTTP.Request("GET", "/", ["Authorization" => invalid_auth])
        @test check_auth(request_invalid, store) == false

        # Test with invalid username
        invalid_user = "Basic " * base64encode("wronguser:testpass")
        request_wronguser = HTTP.Request("GET", "/", ["Authorization" => invalid_user])
        @test check_auth(request_wronguser, store) == false

        # Test with no authorization header
        request_no_auth = HTTP.Request("GET", "/", [])
        @test check_auth(request_no_auth, store) == false

        # Test with malformed authorization header
        request_malformed = HTTP.Request("GET", "/", ["Authorization" => "Bearer token123"])
        @test check_auth(request_malformed, store) == false
    end

    @testset "Password with Special Characters" begin
        # Test passwords with special characters
        passwords = [
            "pass:word",
            "p@ssw0rd!",
            "пароль",  # Cyrillic
            "密码",    # Chinese
            "pass word",  # Space
            "p\$\$w",
        ]

        for pass in passwords
            user = User("user", pass; iterations=100)
            @test authenticate(user, pass) == true
            @test authenticate(user, pass * "x") == false
        end
    end

    @testset "ProtectedRoute Construction" begin
        app = App() do
            return DOM.h1("Test App")
        end

        # Test with explicit store constructor
        store1 = SingleUser("admin", "secret"; iterations=100)
        protected1 = ProtectedRoute(app, store1)
        @test protected1.password_store === store1
        @test protected1.realm == "Protected Area"
        @test protected1.max_attempts == 5
        @test protected1.lockout_window == 60.0

        # Test with custom parameters
        store2 = SingleUser("user", "pass"; iterations=100)
        protected2 = ProtectedRoute(app, store2;
                                   realm="Admin Area",
                                   max_attempts=3,
                                   lockout_window=120.0)
        @test protected2.password_store === store2
        @test protected2.realm == "Admin Area"
        @test protected2.max_attempts == 3
        @test protected2.lockout_window == 120.0
    end

    @testset "Empty and Edge Cases" begin
        # Empty password
        user_empty = User("user", ""; iterations=100)
        @test authenticate(user_empty, "") == true
        @test authenticate(user_empty, "x") == false

        # Very long password
        long_pass = "a" ^ 1000
        user_long = User("user", long_pass; iterations=100)
        @test authenticate(user_long, long_pass) == true
        @test authenticate(user_long, long_pass * "x") == false

        # Username with special characters
        user_special = User("user@example.com", "pass"; iterations=100)
        @test user_special.username == "user@example.com"
        @test authenticate(user_special, "pass") == true
    end

    @testset "HTTP Server Integration" begin
        # Start server once for all HTTP tests
        port = rand(8000:9000)
        server = Bonito.Server("127.0.0.1", port)
        base_url = online_url(server, "/")

        try
            @testset "Basic Authentication Flow" begin
                # Create a simple app
                app = App() do
                    return DOM.div(
                        DOM.h1("Protected Content"),
                        DOM.p("You are authenticated!")
                    )
                end

                store = SingleUser("testuser", "testpass"; iterations=100)
                protected_app = ProtectedRoute(app, store)
                route!(server, "/" => protected_app)

                # Test 1: Request without authentication should get 401
                response_no_auth = HTTP.get(base_url; status_exception=false)
                @test response_no_auth.status == 401
                @test HTTP.header(response_no_auth, "WWW-Authenticate") == "Basic realm=\"Protected Area\""
                @test occursin("401", String(response_no_auth.body))

                # Test 2: Request with wrong credentials should get 401
                wrong_auth = "Basic " * base64encode("testuser:wrongpass")
                response_wrong = HTTP.get(base_url;
                                         headers=["Authorization" => wrong_auth],
                                         status_exception=false)
                @test response_wrong.status == 401

                # Test 3: Request with correct credentials should succeed
                valid_auth = "Basic " * base64encode("testuser:testpass")
                response_valid = HTTP.get(base_url;
                                         headers=["Authorization" => valid_auth],
                                         status_exception=false)
                @test response_valid.status == 200
                body_text = String(response_valid.body)
                @test occursin("Protected Content", body_text)
            end

            @testset "Rate Limiting" begin
                app = App() do
                    return DOM.h1("Content")
                end

                store = SingleUser("ratelimit", "test"; iterations=100)
                protected_app = ProtectedRoute(app, store; max_attempts=5)
                route!(server, "/" => protected_app)  # Overwrites previous route

                # Make 6 failed attempts
                for i in 1:6
                    HTTP.get(base_url;
                            headers=["Authorization" => "Basic " * base64encode("user:wrong")],
                            status_exception=false)
                end

                # Next request should be rate limited (429)
                response_limited = HTTP.get(base_url;
                                           headers=["Authorization" => "Basic " * base64encode("user:wrong")],
                                           status_exception=false)
                @test response_limited.status == 429
                @test HTTP.header(response_limited, "Retry-After") == "60"
                @test occursin("429", String(response_limited.body))
            end

            @testset "Custom Error Pages" begin
                # Create custom error pages
                custom_401 = App() do
                    return DOM.div(
                        DOM.h1("Custom 401 Page"),
                        DOM.p("Please login to continue")
                    )
                end

                custom_429 = App() do
                    return DOM.div(
                        DOM.h1("Custom 429 Page"),
                        DOM.p("You have been rate limited")
                    )
                end

                app = App() do
                    return DOM.h1("Main App Content")
                end

                store = SingleUser("user", "pass"; iterations=100)
                protected = ProtectedRoute(app, store;
                                           auth_required_handler=custom_401,
                                           rate_limited_handler=custom_429,
                                           max_attempts=2)
                route!(server, "/" => protected)  # Overwrites previous route

                # Test custom 401 page
                response_401 = HTTP.get(base_url; status_exception=false)
                @test response_401.status == 401
                body_401 = String(response_401.body)
                @test occursin("Custom 401 Page", body_401)
                @test occursin("Please login to continue", body_401)

                # Test custom 429 page after exceeding rate limit
                for i in 1:3
                    HTTP.get(base_url;
                            headers=["Authorization" => "Basic " * base64encode("user:wrongpass")],
                            status_exception=false)
                end
                response_429 = HTTP.get(base_url;
                                       headers=["Authorization" => "Basic " * base64encode("user:wrongpass")],
                                       status_exception=false)
                @test response_429.status == 429
                body_429 = String(response_429.body)
                @test occursin("Custom 429 Page", body_429)
                @test occursin("You have been rate limited", body_429)

                # Test that correct credentials still work
                valid_auth = "Basic " * base64encode("user:pass")
                response_success = HTTP.get(base_url;
                                           headers=["Authorization" => valid_auth],
                                           status_exception=false)
                @test response_success.status == 200
                body_success = String(response_success.body)
                @test occursin("Main App Content", body_success)
            end

        finally
            # Stop server once after all tests
            close(server.server)
        end
    end

    @testset "Combined Handlers" begin
        port = rand(8000:9000)
        server = Bonito.Server("127.0.0.1", port)
        base_url = online_url(server, "/")

        # Create test directories with files
        test_dir = mktempdir()
        public_dir = joinpath(test_dir, "public")
        private_dir = joinpath(test_dir, "private")
        mkdir(public_dir)
        mkdir(private_dir)

        # Create test files
        write(joinpath(public_dir, "index.html"), "<h1>Public Content</h1>")
        write(joinpath(public_dir, "about.html"), "<h1>About Us</h1>")
        write(joinpath(private_dir, "index.html"), "<h1>Private Content</h1>")
        write(joinpath(private_dir, "secret.html"), "<h1>Secret Data</h1>")

        try
            @testset "LoggingHandler" begin
                log_file = tempname()
                admin_app = App(DOM.h1("Super Secret Admin"))
                logged_app = LoggingHandler(admin_app, log_file)
                single_user = SingleUser("admin", "s3cr3t"; iterations=100)
                protected_app = ProtectedRoute(logged_app, single_user)

                route!(server, "/admin" => protected_app)

                # Test authenticated access
                valid_auth = "Basic " * base64encode("admin:s3cr3t")
                response = HTTP.get(base_url * "admin";
                                   headers=["Authorization" => valid_auth],
                                   status_exception=false)
                @test response.status == 200
                @test occursin("Super Secret Admin", String(response.body))

                # Verify logging happened
                @test isfile(log_file)
                log_content = read(log_file, String)
                @test occursin("GET /admin", log_content)

                rm(log_file)
            end

            @testset "FolderServer - Public" begin
                public_files = FolderServer(public_dir)
                route!(server, r"/public/.*" => public_files)

                # Test accessing public index
                response = HTTP.get(base_url * "public/"; status_exception=false)
                @test response.status == 200
                @test occursin("Public Content", String(response.body))

                # Test accessing public file
                response = HTTP.get(base_url * "public/about.html"; status_exception=false)
                @test response.status == 200
                @test occursin("About Us", String(response.body))

                # Test 404 for non-existent file
                response = HTTP.get(base_url * "public/nonexistent.html"; status_exception=false)
                @test response.status == 404
            end

            @testset "FolderServer - Protected" begin
                single_user = SingleUser("admin", "s3cr3t"; iterations=100)
                protected_files = ProtectedRoute(FolderServer(private_dir), single_user)
                route!(server, r"/private/.*" => protected_files)

                # Test accessing without auth
                response = HTTP.get(base_url * "private/"; status_exception=false)
                @test response.status == 401

                # Test accessing with wrong auth
                wrong_auth = "Basic " * base64encode("admin:wrong")
                response = HTTP.get(base_url * "private/";
                                   headers=["Authorization" => wrong_auth],
                                   status_exception=false)
                @test response.status == 401

                # Test accessing with correct auth
                valid_auth = "Basic " * base64encode("admin:s3cr3t")
                response = HTTP.get(base_url * "private/";
                                   headers=["Authorization" => valid_auth],
                                   status_exception=false)
                @test response.status == 200
                @test occursin("Private Content", String(response.body))

                # Test accessing specific file with auth
                response = HTTP.get(base_url * "private/secret.html";
                                   headers=["Authorization" => valid_auth],
                                   status_exception=false)
                @test response.status == 200
                @test occursin("Secret Data", String(response.body))
            end

        finally
            close(server.server)
            rm(test_dir; recursive=true)
        end
    end
end

using Dates, Test

function last_modified(path::String)
    return Dates.unix2datetime(Base.Filesystem.mtime(path))
end

function needs_bundling(path, bundled)
    !isfile(bundled) && return true
    # If bundled happen after last modification of asset
    return last_modified(path) > last_modified(bundled)
end

path = joinpath(@__DIR__, "..", "js_dependencies")
bundles(x) = (joinpath(path, x), joinpath(path, replace(x, ".js" => ".bundled.js")))
@test !needs_bundling(bundles("Bonito.js")...)
@test !needs_bundling(bundles("Websocket.js")...)
@test !needs_bundling(bundles("nouislider.min.js")...)

module TailwindDashboard

import ..Bonito
import ..Bonito: DOM, Session, Observable, @js_str, Asset
using Hyperscript
const TailwindMini = Asset(Bonito.dependency_path("tailwind.min.css"))

FlexGrid(elems...; class="", kwargs...) = DOM.div(elems...; class=join(["flex flex-wrap", class], " "), kwargs...)
Grid(elems...; class="", kwargs...) = DOM.div(elems...; class=join(["grid ", class], " "), kwargs...)

function FlexRow(args...; class="", attributes...)
    return DOM.div(
        TailwindMini,
        args...;
        attributes...,
        class="mx-2 flex flex-row $class",
    )
end

function FlexCol(args...; class="", attributes...)
    return DOM.div(
        TailwindMini,
        args...;
        attributes...,
        class="my-2 flex flex-col $class",
    )
end

function Card(content; class="", style="", width="fit-content", height="fit-content", attributes...)
    return DOM.div(
        TailwindMini,
        content;
        style="width: $(width); height: $(height); $(style)",
        class="rounded-md p-2 m-2 shadow $class",
        attributes...
    )
end

function WidgetContainer(title, widget; class="", attributes...)
    return DOM.div(title, widget; class="flex-row, mb-1 mt-1 $class", attributes...)
end

function Title(name; class="", attributes...)
    return DOM.h2(name; class="font-semibold $class", attributes...)
end

struct Slider
    widget::Bonito.Slider
    dom::Hyperscript.Node{Hyperscript.HTMLSVG}
end

function Slider(name, values::AbstractArray; container_class="", attributes...)
    s = Bonito.Slider(values; style="width: 100%;", attributes...)
    title = Title(DOM.div(name, DOM.div(s.value; class="float-right text-right text w-32")))
    return Slider(s, WidgetContainer(title, s; class=container_class))
end
Bonito.jsrender(session::Session, x::Slider) = Bonito.jsrender(session, x.dom)

Bonito.is_widget(::Slider) = true
Bonito.value_range(slider::Slider) = Bonito.value_range(slider.widget)
Bonito.update_value!(slider::Slider, idx) = Bonito.update_value!(slider.widget, idx)
Bonito.to_watch(slider::Slider) = Bonito.to_watch(slider.widget)

struct Dropdown
    widget::Bonito.Dropdown
    dom::Hyperscript.Node{Hyperscript.HTMLSVG}
end

function Dropdown(name, values::AbstractArray; class="", container_class="", attributes...)
    class = "$class focus:outline-none focus:shadow-outline focus:border-blue-300 bg-white bg-gray-100 hover:bg-white text-gray-800 font-semibold m-1 py-1 px-3 border border-gray-400 rounded shadow"
    dd = Bonito.Dropdown(values; class=class, attributes...)
    return Dropdown(dd, WidgetContainer(Title(name), dd; class=container_class))
end

Bonito.jsrender(session::Session, x::Dropdown) = Bonito.jsrender(session, x.dom)

Bonito.is_widget(::Dropdown) = true
Bonito.value_range(dropdown::Dropdown) = Bonito.value_range(dropdown.widget)
Bonito.update_value!(dropdown::Dropdown, idx) = Bonito.update_value!(dropdown.widget, idx)
Bonito.to_watch(dropdown::Dropdown) = Bonito.to_watch(dropdown.widget)

struct Checkbox
    widget::Bonito.Checkbox
    dom::Hyperscript.Node{Hyperscript.HTMLSVG}
end

function Checkbox(name, value::Bool; container_class="", attributes...)
    c = Bonito.Checkbox(value; attributes...)
    return Checkbox(c, WidgetContainer(Title(name), c; class=container_class))
end
Bonito.jsrender(session::Session, x::Checkbox) = Bonito.jsrender(session, x.dom)

Bonito.is_widget(::Checkbox) = true
Bonito.value_range(checkbox::Checkbox) = Bonito.value_range(checkbox.widget)
Bonito.update_value!(checkbox::Checkbox, idx) = Bonito.update_value!(checkbox.widget, idx)
Bonito.to_watch(checkbox::Checkbox) = Bonito.to_watch(checkbox.widget)

function Button(name; class="", attributes...)
    class = "$class focus:outline-none focus:shadow-outline focus:border-blue-300 bg-white bg-gray-100 hover:bg-white text-gray-800 font-semibold m-1 py-1 px-3 border border-gray-400 rounded shadow"
    return Bonito.Button(name; class=class, style=Bonito.Styles("min-width" => "8rem"), attributes...)
end

function TextField(content::String; class="", attributes...)
    class = "$class focus:outline-none focus:shadow-outline focus:border-blue-300 bg-white bg-gray-100 hover:bg-white text-gray-800 font-semibold m-1 py-1 px-3 border border-gray-400 rounded shadow"
    return Bonito.TextField(string(content); class=class, attributes...)
end

function NumberInput(number::Number; class="", attributes...)
    class = "$class focus:outline-none focus:shadow-outline focus:border-blue-300 bg-white bg-gray-100 hover:bg-white text-gray-800 font-semibold m-1 py-1 px-3 border border-gray-400 rounded shadow"
    return Bonito.NumberInput(number; class=class, attributes...)
end


Base.getproperty(x::Dropdown, f::Symbol) = f === :value ? x.widget.value : f === :option_index ? x.widget.option_index : getfield(x, f)
Base.getproperty(x::Checkbox, f::Symbol) = f === :value ? x.widget.value : getfield(x, f)
Base.getproperty(x::Slider, f::Symbol) = f === :value ? x.widget.value : getfield(x, f)

function FileInput()
    container_class = "flex justify-center"
    inner_class = "mb-3 w-96"
    label_class = "form-label inline-block mb-2 text-gray-700"
    input_class = "form-control
    block
    w-full
    py-1.5
    text-base
    font-normal
    text-gray-700
    bg-white bg-clip-padding
    border border-solid border-gray-300
    rounded
    transition
    ease-in-out
    m-0
    focus:text-gray-700 focus:bg-white focus:border-blue-600 focus:outline-none"
    label = DOM.label("Input"; )
    Hyperscript.attrs(label)["for"] = "formFile"

    return Bonito.FileInput()
end

end
using ..TailwindDashboard

using Bonito, Observables
using Bonito: @js_str, onjs, Button, TextField, Slider, linkjs, Session, App
using Bonito.DOM
using Hyperscript

app = App() do session::Session
    s1 = Slider(1:100)
    s2 = Slider(1:100)
    b = Button("hi")
    t = TextField("enter your text")
    on(println, s1.value)
    linkjs(session, s1.index, s2.index)
    test = [1,2,3]
    onjs(session, s1.value, js"(v)=> console.log($test)")
    on(t) do text
        println(text)
    end
    return DOM.div(s1, s2, b, t)
end

if isdefined(Main, :server)
    close(server)
end

server = Bonito.Server(app, "127.0.0.1", 8081)
# Important Note: You might want to set the keyword argument `proxy_url` above in case
# you have a reverse proxy (like nginx or caddy) in front of the Bonito instance.
Bonito.HTTPServer.start(server)
# Bonito.HTTPServer.route!(server, "/" => app) # Overwrite app after changing it
wait(server)

Base.close(::AbstractAssetServer) = nothing

include("asset.jl")
include("no-server.jl")
include("http.jl")

function import_js_url(asset_server::Nothing, asset::Asset)
    return "'$(url(asset_server, asset))'"
end

# Default implementation for AbstractAssetServer (like AssetFolder)
function import_js_url(asset_server::AbstractAssetServer, asset::Asset)
    ref = url(asset_server, asset)
    # Remove leading "./" if present
    if startswith(ref, "./")
        ref = ref[3:end]  # Remove "./" (3 characters)
    end

    # Handle absolute vs relative paths differently
    if startswith(ref, "/")
        # Absolute path - use as-is relative to origin
        return "new URL('$(ref)', window.location.origin).href"
    else
        # Relative path - use relative to current page directory (not parent)
        return "new URL('$(ref)', window.location.href).href"
    end
end

# Specific implementations for HTTP servers - handle relative URLs properly
function import_js_url(asset_server::Union{ChildAssetServer, HTTPAssetServer}, asset::Asset)
    ref = url(asset_server, asset)
    # If URL starts with "./" it needs special handling for proper resolution
    if startswith(ref, "./")
        # Remove leading "./"
        ref = ref[3:end]
        # Use relative to current page directory
        return "new URL('$(ref)', window.location.href).href"
    else
        # Absolute URLs or other formats work as-is
        return "'$(ref)'"
    end
end

function import_js_url(asset_server::DocumenterAssets, asset::Asset)
    if !isempty(asset.online_path)
        return import_js_url(nothing, asset)
    end
    path = url(asset_server, asset)
    # We write all javascript files into the same folder, so imports inside
    # JSCode, which get evaled from Bonito.js, should use "./js-dep.js"
    # since the url is relative to the module that imports
    rel_url = "./" * basename(path)
    return "'$(rel_url)'"
end


const JS_DEPENDENCIES = joinpath(@__DIR__, "..", "..", "js_dependencies")

"""
    dependency_path(paths...)

Path to serve downloaded dependencies
"""
dependency_path(paths...) = joinpath(JS_DEPENDENCIES, paths...)

const BonitoLib = ES6Module(dependency_path("Bonito.js"))
const Websocket = ES6Module(dependency_path("Websocket.js"))
const Styling = Asset(dependency_path("styling.css"))
const MarkdownCSS = Asset(dependency_path("markdown.css"))
const TailwindCSS = Asset("https://cdn.tailwindcss.com/3.3.1"; mediatype=:js) # For Development

using HTTP
using Bonito: App, Styles, Observable
using Bonito.DOM
using Random
using Colors
using Base.Threads: @spawn
using Dates: Dates


function html(app; kwargs...)
    io = IOBuffer()
    show_html(io, app; kwargs...)
    take!(io)
end

function main()
    # start a blocking server
    session_root_storage = Dict()
    rng = Random.default_rng()
    HTTP.listen() do http::HTTP.Stream
        HTTP.setstatus(http, 200)
        HTTP.startwrite(http)
        req_uri = HTTP.URI(http.message.target)
        if req_uri.path == "/fragment"
            params = HTTP.queryparams(req_uri)
            sid = params["sid"]
            session = session_root_storage[params["sid"]]
            color = rand(RGB{Float64})
            css = Styles(
                "background-color" => color,
            )
            app = App() do
                date_obs::Observable{String} = Observable("unset")
                @async begin
                    while true
                        date_obs[] = string(Dates.now())
                        sleep(1)
                    end
                end
                DOM.div(map(date -> "date: $(date); sid: $(sid)", date_obs), style=css)
            end
            app_html = html(app; parent=session)
            write(http, app_html)
        else
            root_app = App(_ -> DOM.div(""))
            app_html = html(root_app)
            session = root_app.session[]
            session_root_storage[session.id] = session
            write(http, "<html><body>")
            write(http, "<script src=\"https://unpkg.com/htmx.org@2.0.2\"></script>")
            write(http, "<h1>fragment insertion</h1>")
            write(http, "<button hx-get=\"/fragment?sid=$(session.id)\" hx-target=\"#results\">Click Me</button>")
            write(http, "<div id=\"results\">")
            write(http, app_html)
            write(http, "</div>")
            write(http, "</body></html>")
        end
    end
end

if abspath(PROGRAM_FILE) == @__FILE__
    main()
end

function show_session(io::IO, session::Session{T}) where T
    println(io, "Session{$T}:")
    println(io, "  id: $(session.id)")
    println(io, "  parent: $(typeof(session.parent))")
    println(io, "  status: $(session.status)")
    if !isempty(session.children)
        println(io, "children: $(length(session.children))")
    end
    println(io, "  connection: $(isopen(session.connection) ? "open" : "closed")")
    println(io, "  isready: $(isready(session))")
    println(io, "  asset_server: $(typeof(session.asset_server))")
    println(io, "  queued messages: $(length(session.message_queue))")
    if !isnothing(session.init_error[])
        println(io, "  session failed to initialize:")
        showerror(io, session.init_error[])
    end
end

Base.show(io::IO, ::MIME"text/plain", session::Session) = show_session(io, session)
Base.show(io::IO, session::Session) = show_session(io, session)

function wait_for_ready(session::Session; timeout=100)
    session.status === CLOSED && return false
    success = wait_for(timeout=timeout) do
        isclosed(session) && return :closed
        return isready(session)
    end
    return success
end

function init_session(session::Session)
    put!(session.connection_ready, true)
    # open the connection for e.g. subconnection, which just have an open flag
    open!(session.connection)
    @assert isopen(session)
    # We send all queued up messages once the onnection is open
    if !isempty(session.message_queue) || !isempty(session.on_document_load)
        send(session, fused_messages!(session))
    end
    session.status = OPEN
    return
end

session(session::Session) = session
Base.parent(session::Session) = session.parent
root_session(session::Session) = isnothing(parent(session)) ? session : root_session(parent(session))

"""
    get_metadata(session, key::Symbol)
    get_metadata(session, key::Symbol, default)

Get metadata from the root session. Returns `nothing` or the provided `default` if key doesn't exist.
Metadata is stored on the root session and shared across all child sessions.
"""
function get_metadata(session::Session, key::Symbol, default=nothing)
    root = root_session(session)
    return lock(root.deletion_lock) do
        get(root.metadata, key, default)
    end
end

"""
    set_metadata!(session, key::Symbol, value)

Set metadata on the root session. Returns the value.
Metadata is stored on the root session and shared across all child sessions.
"""
function set_metadata!(session::Session, key::Symbol, value)
    root = root_session(session)
    lock(root.deletion_lock) do
        root.metadata[key] = value
    end
    return value
end

function get_session(session::Session, id::String)
    session.id == id && return session
    if haskey(session.children, id)
        return session.children[id]
    end
    # recurse
    for (key, sub) in session.children
        s = get_session(sub, id)
        isnothing(s) || return s
    end
    # Nothing found...
    return nothing
end

function free(session::Session)
    # don't double free!
    session.status === CLOSED && return
    # unregister all cached objects from root session
    root = root_session(session)
    # If we're a child session, we need to remove all objects trackt in our root session:
    if session !== root
        # We need to remove our session from the parent first, otherwise `delete_cached!`
        # will think our session still holds the value, which would prevent it from deleting
        delete!(parent(session).children, session.id)
        for key in keys(session.session_objects)
            if haskey(root.session_objects, key)
                delete_cached!(root, session, key)
            end
        end
    else
        # If this is a root session, we don't do any refcounting anymore
        # Since if root is over, everything is over.
        # and just delete everything!
        for key in keys(session.session_objects)
            force_delete!(session, key)
        end
    end

    # delete_cached! only deletes in the root session so we need to still empty the session_objects:
    empty!(session.session_objects)
    empty!(session.on_document_load)
    empty!(session.message_queue)
    # remove all listeners that where created for this session
    foreach(off, session.deregister_callbacks)
    empty!(session.deregister_callbacks)
    session.status = CLOSED
    return
end

function soft_close(session::Session)
    session.status = SOFT_CLOSED
    session.closing_time = time()
end

function Base.close(session::Session)
    lock(root_session(session).deletion_lock) do
        session.status === CLOSED && return
        session.on_close[] = true
        while !isempty(session.children)
            close(last(first(session.children))) # child removes itself from parent!
        end
        free(session)
        # unregister all cached objects from parent session
        root = root_session(session)
        # If we're a child session, we need to remove all objects tracked in our root session:
        if session !== root
            # Close child session on js side as well
            # If not ready, we already lost connection to JS frontend, so no need to close things on the JS side
            isready(root) && evaljs(root, js"""Bonito.free_session($(session.id))""")
        end
        close(session.asset_server)
        Observables.clear(session.on_close)
        session.current_app[] = nothing
        session.io_context[] = nothing
        close(session.inbox)
        session.status = CLOSED
        close(session.connection)
    end
    return
end

"""
    send(session::Session; attributes...)

Send values to the frontend via MsgPack for now
"""
Sockets.send(session::Session; kw...) = send(session, Dict{Symbol, Any}(kw))

const COLLECT_MESSAGES = Threads.Atomic{Bool}(false)
const COLLECTED_MESSAGES = Dict{Symbol, Any}[]
const COLLECT_LOCK = Base.ReentrantLock()

function collect_message!(message)
    COLLECT_MESSAGES[] || return
    lock(COLLECT_LOCK) do
        if message isa SerializedMessage
            msg = decode_extension_and_addbits(deserialize(message))
        else
            msg = message
        end
        push!(COLLECTED_MESSAGES, (msg))
    end
end

function collect_messages(f)
    empty!(COLLECTED_MESSAGES)
    COLLECT_MESSAGES[] = true
    f()
    msgs = copy(COLLECTED_MESSAGES)
    len = length(msgs)
    s = Session(NoConnection(); asset_server=NoServer())
    total = mapreduce(+, msgs) do msg
        bytes = serialize_binary(s, msg)
        return sizeof(bytes)
    end
    msg = "Send $(len) messages with a total size of $(Base.format_bytes(total))"
    return msgs, msg
end

function Sockets.send(session::Session, message::SerializedMessage; large=false)
    collect_message!(message)
    _send(session, message, large)
end

function Sockets.send(session::Session, message::Dict{Symbol}; large=false)
    session.ignore_message[](message)::Bool && return
    collect_message!(message)
    _send(session, SerializedMessage(session, message), large)
end

# Backwards compatibility for connections that dont expect a SerializedMessage but Vector{UInt8}
Base.write(connection::FrontendConnection, sm::SerializedMessage) = write(connection, serialize_binary(sm))

function _send(session::Session, sm::SerializedMessage, large::Bool)
    if isready(session)
        if large
            write_large(session.connection, sm)
        else
            write(session.connection, sm)
        end
    else
        push!(session.message_queue, sm)
    end
end



function _send(session::Session, message::Dict, large::Bool)
    sm = SerializedMessage(session, message)
    _send(session, sm, large)
end

function HTTP.WebSockets.isclosed(session::Session)
    return session.status === CLOSED
end

Base.isopen(session::Session) = isopen(session.connection)

function Base.isready(session::Session)
    isclosed(session) && return false
    if !isnothing(session.init_error[])
        err = session.init_error[]
        session.init_error[] = nothing
        close(session)
        throw(err)
    end
    return isready(session.connection_ready) && isopen(session)
end

"""
    onjs(session::Session, obs::Observable, func::JSCode)

Register a javascript function with `session`, that get's called when `obs` gets a new value.
If the observable gets updated from the JS side, the calling of `func` will be triggered
entirely in javascript, without any communication with the Julia `session`.
"""
function onjs(session::Session, obs::Observable, func::JSCode)
    send(
        session;
        msg_type=OnjsCallback,
        obs=obs,
        # return is needed to since on the JS side this will be wrapped in a function
        payload=JSCode([JSString("return "), func], func.file)
    )
end

function onjs(has_session, obs::Observable, func::JSCode)
    onjs(session(has_session), obs, func)
end

"""
    onload(session::Session, node::Node, func::JSCode)

calls javascript `func` with node, once node has been displayed.
"""
function onload(session::Session, node::Node, func::JSCode)
    wrapped_func = js"($(func))($(node));"
    # preserver fun.file
    on_document_load(session, JSCode(wrapped_func.source, func.file))
end

"""
    on_document_load(session::Session, js::JSCode)

executes javascript after document is loaded
"""
function on_document_load(session::Session, js::JSCode)
    push!(session.on_document_load, js)
end

"""
    linkjs(session::Session, a::Observable, b::Observable)

for an open session, link a and b on the javascript side. This will also
Link the observables in Julia, but only as long as the session is active.
"""
function linkjs(session::Session, a::Observable, b::Observable)
    # register the callback with the JS session
    onjs(session, a, js"""(v) => {$(b).notify(v)}""")
end

function linkjs(has_session, a::Observable, b::Observable)
    linkjs(session(has_session), a, b)
end

"""
    evaljs(session::Session, jss::JSCode)

Evaluate a javascript script in `session`.
"""
function evaljs(session::Session, jss::JSCode)
    # TODO, should we error for the user, if they call evaljs on a closed session?
    send(session; msg_type=EvalJavascript, payload=jss)
end

function evaljs(has_session, jss::JSCode)
    evaljs(session(has_session), jss)
end

"""
    evaljs_value(session::Session, js::JSCode)

Evals `js` code and returns the jsonified value.
Blocks until value is returned. May block indefinitely, when called with a session
that doesn't have a connection to the browser.
"""
function evaljs_value(session::Session, js; error_on_closed=true, timeout=10.0)
    root = root_session(session)
    if !isready(root)
        if error_on_closed
            error("Session is not open and would result in this function to indefinitely block.
            It may unblock, if the browser is still connecting and opening the session later on. If this is expected,
            you may try setting `error_on_closed=false`")
        end
        return nothing
    end
    # For each request we need a new observable to have this thread safe
    # And multiple request not waiting on the same observable
    comm = Observable{Any}(nothing)

    js_with_result = js"""{
        const comm = $(comm);
        try{
            const maybe_promise = $(js);
            // support returning a promise:
            Promise.resolve(maybe_promise).then(result=> {
                comm.notify({result});
            })
        }catch(e){
            comm.notify({error: e.toString()});
        } finally {
            // manually delete!
            Bonito.lock_loading(() => {
                // we need to free the object, since it exists outside of the session lifetime
                // and we don't want to keep it around forever
                Bonito.Sessions.force_free_object(comm.id);
            });
        }
    }
    """

    evaljs(session, js_with_result)
    # TODO, have an on error callback, that triggers when evaljs goes wrong
    # (e.g. because of syntax error that isn't caught by the above try catch!)
    # TODO do this with channels, but we still dont have a way to timeout for wait(channel)... so...
    result = fetch(Threads.@spawn wait_for(timeout=timeout) do
        lock(root.deletion_lock) do
            Bonito.isclosed(session) && return :closed
            return !isnothing(comm[])
        end
    end)
    value = comm[]
    # manually free observable, since it exists outside session lifetimes
    lock(root.deletion_lock) do
        delete!(session.session_objects, comm.id)
        delete!(root.session_objects, comm.id)
    end
    Observables.clear(comm) # cleanup
    result == :closed && return
    if isnothing(value)
        error("Timed out")
    end
    if haskey(value, "error")
        error(value["error"])
    else
        return value["result"]
    end
end

function evaljs_value(with_session, js; error_on_closed=true, timeout=100.0)
    evaljs_value(session(with_session), js; error_on_closed=error_on_closed, timeout=timeout)
end

function session_dom(session::Session, app::App; init=true, html_document=false)
    dom = rendered_dom(session, app)
    # Ensure we have a valid DOM node (handles App(nothing; indicator=nothing))
    if isnothing(dom)
        dom = DOM.div()
    end
    return session_dom(session, dom; init=init, html_document=html_document)
end

isroot(session::Session) = session.parent === nothing

function push_dependencies!(childs, session::Session)
    require_off = DOM.script("""
        window.__define = window.define;
        window.__require = window.require;
        window.define = undefined;
        window.require = undefined;
    """)
    require_on = DOM.script("""
        window.define = window.__define;
        window.require = window.__require;
        window.__define = undefined;
        window.__require = undefined;
    """)
    if isroot(session)
        assets = session.imports
    else
        # only render the assets that aren't already in root session
        assets = setdiff(session.imports, root_session(session).imports)
    end

    assets_rendered = render_asset.(Ref(session), Ref(session.asset_server), assets)
    if any(x-> mediatype(x) == :js && !x.es6module, assets)
        # if a js non es6module is included, we may need to hack require... because JS! :(
        push!(childs, require_off)
        push!(childs, assets_rendered...)
        push!(childs, require_on)
    else
        push!(childs, assets_rendered...)
    end
end

function mark_displayed!(session::Session)
    session.status = DISPLAYED
    session.closing_time = time()
    return
end



function get_messages!(session::Session, messages=[])
    root = root_session(session)
    if root !== session
        get_messages!(root, messages)
    end
    append!(messages, session.message_queue)
    for js in session.on_document_load
        onload = Dict(:msg_type=>EvalJavascript, :payload=>js)
        push!(messages, SerializedMessage(session, onload))
    end
    empty!(session.on_document_load)
    empty!(session.message_queue)
    return messages
end

fused_messages!(session::Session) = Dict(:msg_type=>FusedMessage, :payload=>get_messages!(session))

function collect_session_objects!(session::Session, objects=Vector{Any}[])
    ob = []
    for msg in session.message_queue
        for (k, v) in msg.cache.objects
            push!(ob, [k, v])
        end
        empty!(msg.cache.objects)
    end
    typ = root_session(session) === session ? "root" : "sub"
    push!(objects, [session.id, ob, typ])
    for (k, child) in session.children
        collect_session_objects!(child, objects)
    end
    return objects
end


function session_dom(session::Session, dom::Node; init=true, html_document=false, dom_id=isroot(session) ? "root" : "subsession-application-dom")
    lock(root_session(session).deletion_lock) do
        # the dom we can render may be anything between a
        # dom fragment or a full page with head & body etc.
        # If we have a head & body, we want to append our initialization
        # code and dom nodes to the right places, so we need to extract those
        head, body, dom = find_head_body(dom)
        session_style = render_stylesheets!(root_session(session), session, session.stylesheets)
        global_styles = map(collect(session.global_stylesheets)) do styles
            DOM.style(to_string(session, styles))
        end
        issubsession = !isroot(session)

        # should never request full html_doc for subsession
        issubsession && @assert !html_document
        if issubsession && !isnothing(head) && !isnothing(body)
            @warn "Apps with head/body elements are not supported in subsessions, wrapping in a fragment"
            dom = page_to_fragment(head, body, dom)
            head = body = nothing
        end

        # if nothing is found, we just use one div and append to that
        if isnothing(head) && isnothing(body)
            if html_document
                # emit a whole html document
                body_dom = DOM.div(dom, id=session.id, dataJscallId=dom_id)
                head = Hyperscript.m("head",
                    Hyperscript.m(
                        "meta";
                        name="viewport", content="width=device-width, initial-scale=1.0"
                    ),
                    Hyperscript.m("meta"; charset="UTF-8"),
                    Hyperscript.m("title", session.title),
                    session_style, global_styles...
                )
                body = Hyperscript.m("body", body_dom)
                dom = Hyperscript.m("html", head, body; class="bonito-fragment")
            else
                # Emit a "fragment"
                head = DOM.div(session_style, global_styles...)
                body = DOM.div(dom)
                dom = DOM.div(
                    head, body; id=session.id, class="bonito-fragment", dataJscallId=dom_id
                )
            end
        else
            push!(children(head), session_style)
            append!(children(head), global_styles)
        end
        # first render BonitoLib
        Bonito_import = DOM.script(src=url(session, BonitoLib), type="module")
        init_server = setup_asset_server(session.asset_server)
        if !isnothing(init_server)
            pushfirst!(children(body), jsrender(session, init_server))
        end
        init_connection = setup_connection(session)
        if !isnothing(init_connection)
            pushfirst!(children(body), jsrender(session, init_connection))
        end

        push_dependencies!(children(head), session)

        if init
            msgs = get_messages!(session)
            type = issubsession ? "sub" : "root"
            binary = isempty(msgs) ? "null" : "Bonito.fetch_binary('$(url(session, BinaryAsset(session, msgs)))')"
            init_session = """
            Bonito.init_session($(repr(session.id)), $(binary), $(repr(type)), $(session.compression_enabled));
            """
            pushfirst!(children(body), inline_code(session, session.asset_server, init_session))
        end

        if !issubsession
            pushfirst!(children(head), Bonito_import)
        end
        session.status = RENDERED
        return dom
    end
end

function page_to_fragment(head, body, dom)
    _head = Hyperscript.Node(
        Hyperscript.context(head),
        "div",
        Hyperscript.children(head),
        Hyperscript.attrs(head)
    )
    _body = Hyperscript.Node(
        Hyperscript.context(body),
        "div",
        Hyperscript.children(body),
        Hyperscript.attrs(body)
    )
    return Hyperscript.Node(
        Hyperscript.context(dom),
        "div",
        [_head, _body],
        Hyperscript.attrs(dom)
    )
end

function render_subsession(p::Session, data; init=false)
    return render_subsession(p, App(DOM.span(data)); init=init)
end

function render_subsession(parent::Session, app::App; init=false)
    sub = Session(parent)
    return sub, session_dom(sub, app; init=init)
end

function render_subsession(parent::Session, dom::Node; init=false)
    sub = Session(parent)
    dom_rendered = jsrender(sub, dom)
    return sub, session_dom(sub, dom_rendered; init=init)
end

function update_session_dom!(parent::Session, node_uuid::String, app_or_dom; replace=true)
    if isclosed(parent)
        error("Updating the session dom for a closed session")
    end
    sub, html = render_subsession(parent, app_or_dom; init=false)
    # We need to manually do the serialization,
    # Since we send it via the parent, but serialization needs to happen
    # for `sub`.
    # sub is not open yet, and only opens if we send the below message for initialization
    # which is why we need to send it via the parent session
    UpdateSession = "12" # msg type
    session_update = Dict(
        "msg_type" => UpdateSession,
        "session_id" => sub.id,
        "session_status" => "sub",
        "messages" => get_messages!(sub),
        "html" => html,
        "replace" => replace,
        "dom_node_selector" => node_uuid
    )
    message = SerializedMessage(sub, session_update)
    send(root_session(parent), message)
    mark_displayed!(parent)
    mark_displayed!(sub)
    return sub
end

function dom_in_js(parent::Session,  new_html, js_func)
    if isclosed(parent)
        error("Updating the session dom for a closed session")
    end
    sub, html = render_subsession(parent, new_html; init=true)
    html_obs = Observable(html)
    update_dom = js"""($(js_func))($(html_obs).value)"""
    message = Bonito.SerializedMessage(
        sub, Dict(:msg_type => Bonito.EvalJavascript, :payload => update_dom)
    )
    Bonito.send(parent, message)
    mark_displayed!(parent)
    mark_displayed!(sub)
    return sub
end


function append_child(parent::Session, parent_node::HTMLElement, new_html)
    return dom_in_js(parent, new_html, js"""(elem) => {
        $(parent_node).appendChild(elem);
    }""")
end

function update_subsession_dom!(sub::Session, selector, app::App)
    html = session_dom(sub, app; init=false)
    # We need to manually do the serialization,
    # Since we send it via the parent, but serialization needs to happen
    # for `sub`.
    # sub is not open yet, and only opens if we send the below message for initialization
    # which is why we need to send it via the parent session
    UpdateSession = "12" # msg type
    session_update = Dict(
        "msg_type" => UpdateSession,
        "session_id" => sub.id,
        "messages" => get_messages!(sub),
        "html" => html,
        "replace" => true,
        "dom_node_selector" => selector
    )
    message = SerializedMessage(sub, session_update)
    send(root_session(sub), message)
    mark_displayed!(sub)
    return sub
end

@testset "style de-duplication" begin
    x = Styles(Styles(), "background-color" => "gray", "color" => "white")
    y = Styles(Styles(), "background-color" => "gray", "color" => "white")
    @test x.styles == y.styles

    x = Styles("background-color" => "gray", "color" => "white")
    y = Styles("background-color" => "gray", "color" => "white")
    @test x.styles == y.styles

    x = CSS("background-color" => "gray", "color" => "white")
    y = CSS("background-color" => "gray", "color" => "white")
    @test x.attributes == y.attributes


    x = CSS("background-color" => "gray", "color" => 1)
    y = CSS("background-color" => "gray", "color" => "1")
    @test x.attributes == y.attributes
end

@testset "deduplication in rendered dom" begin
    app = App(; indicator=nothing) do
        base = Styles("border" => "1px solid black", "padding" => "5px")
        days = map(1:31) do day
            DOM.div(day; style=Styles(base, "background-color" => "gray", "color" => "black"))
        end
        return DOM.div(days...)
    end
    # Use no connection, since otherwise the session will be added to
    # The global running HTTP server
    s = OfflineSession()
    Bonito.session_dom(s, app)
    all_css = Set([css for (n, set) in s.stylesheets for css in set])
    @test length(all_css) == 1
    css = CSS(
        "border" => "1px solid black",
        "padding" => "5px",
        "background-color" => "gray",
        "color" => "black",
    )
    @test first(all_css) == css
end

@testset "merge & hash" begin
    css1 = CSS(
        "border" => "1px solid black",
        "padding" => "5px",
        "background-color" => "gray",
        "color" => "black",
    )
    css2 = CSS(
        "border" => "1px solid black",
        "padding" => "5px",
        "background-color" => "gray",
        "color" => "black",
    )
    css3 = merge(css1, css2)

    @test css1 == css2
    @test css3 == css2

    @test hash(css1) == hash(css2)
    @test hash(css3) == hash(css2)
end

@testset "Styles preserves CSS rule order" begin
    # Create base styles with :root first
    base = Styles(CSS(":root", "color" => "black"))
    media = Styles(CSS("@media (max-width: 480px)", CSS(":root", "color" => "white")))

    # Merge - media should come after base
    combined = merge(base, media)

    selectors = collect(keys(combined.styles))
    @test selectors[1] == ":root"
    @test selectors[2] == "@media (max-width: 480px)"
end

@testset "Styles constructor with multiple args preserves order" begin
    style1 = Styles(CSS(":root", "color" => "black"))
    style2 = Styles(CSS(".navbar", "height" => "50px"))
    style3 = Styles(CSS("@media (max-width: 480px)", CSS(":root", "color" => "white")))

    # When constructing Styles(s1, s2, s3), s1 is priority and should come LAST
    # This is confusing behavior - first arg takes priority but comes last in merge
    combined = Styles(style1, style2, style3)

    selectors = collect(keys(combined.styles))
    # According to Styles(priority::Styles, defaults...)
    # It creates Styles(defaults...) then merges priority into it
    # So style2, style3 are created first, then style1 is merged in
    @test length(selectors) == 3
    # Check that we have all three selectors
    @test ":root" in selectors
    @test ".navbar" in selectors
    @test "@media (max-width: 480px)" in selectors

    # The first argument (style1) values should override when same selector exists
    # But order-wise, for OrderedDict, when does the key appear?
    # If :root already exists in defaults, merge! updates value but keeps position
    # If :root doesn't exist in defaults, it gets added at the end
end

@testset "Styles merging updates values but preserves key position" begin
    # Create style with :root at position 1
    base = Styles(CSS(":root", "color" => "black"))

    # Create another style with different selector at position 2
    extra = Styles(CSS(".class", "margin" => "10px"))

    # Merge them
    combined = merge(base, extra)
    @test collect(keys(combined.styles)) == [":root", ".class"]

    # Now merge in a style that updates :root
    override = Styles(CSS(":root", "color" => "white"))
    combined2 = merge(combined, override)

    # :root should still be at position 1, but with updated value
    selectors = collect(keys(combined2.styles))
    @test selectors[1] == ":root"
    @test combined2.styles[":root"].attributes["color"] == "white"
end

@testset "attribute_render maintains CSS order in stylesheets" begin
    # Test that when multiple CSS objects are added to a node's stylesheet,
    # the order is preserved in the session's stylesheets
    s = OfflineSession()
    parent = DOM.div()

    # Add CSS in specific order
    css1 = CSS("", "color" => "red")
    css2 = CSS("", "background" => "blue")
    css3 = CSS("", "padding" => "10px")

    Bonito.attribute_render(s, parent, "style", css1)
    Bonito.attribute_render(s, parent, "style", css2)
    Bonito.attribute_render(s, parent, "style", css3)

    # Get the styles for this node
    node_styles = s.stylesheets[parent]

    # PROBLEM: Set{CSS} doesn't preserve order!
    # This test will likely fail because Set iteration order is arbitrary
    styles_vec = collect(node_styles)
    @test length(styles_vec) == 3
    # We can't reliably test order with Set, this is the bug!
end

@testset "render_stylesheets! order with multiple nodes" begin
    # Test that render_stylesheets! maintains consistent CSS ordering
    # when multiple nodes share styles
    app = App(; indicator=nothing) do
        css_base = CSS("", "margin" => "5px")
        css_priority = CSS("", "padding" => "10px")

        # Create multiple divs with styles in specific order
        divs = [
            DOM.div("1"; style=Styles(css_base, css_priority)),
            DOM.div("2"; style=Styles(css_base, css_priority)),
            DOM.div("3"; style=Styles(css_base, css_priority))
        ]
        return DOM.div(divs...)
    end

    s = OfflineSession()
    dom = Bonito.session_dom(s, app)

    # The render should be deterministic
    # But with Dict/Set usage, the order might vary!
    # Let's at least check that styles are present
    @test length(s.stylesheets) > 0
end

@testset "CSS constructor with pairs preserves attribute order" begin
    # Test that CSS attributes maintain order when constructed
    css = CSS("",
        "z-index" => "1000",
        "position" => "absolute",
        "top" => "0",
        "left" => "0",
        "right" => "0"
    )

    # PROBLEM: Dict{String,Any} doesn't preserve order!
    # The attributes might not be in insertion order
    attrs = collect(keys(css.attributes))
    @test length(attrs) == 5
    # We can't reliably test the order because Dict is unordered
    @test "z-index" in attrs
    @test "position" in attrs
end

@testset "Styles(CSS...) constructor order" begin
    # Test that constructing Styles from multiple CSS maintains order
    css1 = CSS(":root", "color" => "black")
    css2 = CSS(".base", "margin" => "10px")
    css3 = CSS("@media screen", CSS(".base", "margin" => "20px"))

    styles = Styles(css1, css2, css3)

    # Order should be: css1, css2, css3
    selectors = collect(keys(styles.styles))
    @test length(selectors) == 3
    @test selectors[1] == ":root"
    @test selectors[2] == ".base"
    @test selectors[3] == "@media screen"
end

function get_base_css(in)
    s = OfflineSession()
    dom = Bonito.jsrender(s, in)
    return only(filter(x -> x.selector == "", s.stylesheets[dom]))
end

@testset "User styles override defaults in widgets/components" begin
    @testset "Button user style overrides default background-color" begin
        # BUTTON_STYLE has background-color: "white"
        user_style = Styles("background-color" => "red")
        button = Button("Test"; style=user_style)
        base_css = get_base_css(button)
        @test base_css !== nothing
        @test base_css.attributes["background-color"] == "red"
        # Default font-size should still be present
        @test base_css.attributes["font-size"] == "1rem"
    end

    @testset "TextField user style overrides default min-width" begin
        # BUTTON_STYLE has min-width: "8rem"
        user_style = Styles("min-width" => "20rem")
        textfield = TextField("test"; style=user_style)
        base_css = get_base_css(textfield)
        @test base_css.attributes["min-width"] == "20rem"
        # Default font-size should still be present
        @test base_css.attributes["font-size"] == "1rem"
    end

    @testset "Card user style overrides padding" begin
        # Card creates padding from keyword argument
        user_style = Styles("padding" => "100px")
        card = Card(DOM.h1("Test"); style=user_style, padding="10px")
        base_css = get_base_css(card)
        # User padding should override the keyword argument default
        @test base_css.attributes["padding"] == "100px"
        # Default width should still be present
        @test base_css.attributes["width"] == "auto"
    end

    @testset "Grid user style overrides display" begin
        # Grid creates display: "grid"
        user_style = Styles("display" => "flex")
        grid = Grid(DOM.div("Test"); style=user_style)
        base_css = get_base_css(grid)
        # User display should override default "grid"
        @test base_css.attributes["display"] == "flex"
        # Default width should still be present
        @test base_css.attributes["width"] == "100%"
    end

    @testset "Label user style overrides font-weight" begin
        # Label creates font-weight: 600
        user_style = Styles("font-weight" => 400)
        label = Bonito.Label("Test"; style=user_style)
        base_css = get_base_css(label)
        # User font-weight should override default 600 (converted to string "400")
        @test base_css.attributes["font-weight"] == "400"
        # Default font-size should still be present
        @test base_css.attributes["font-size"] == "1rem"
    end
end

import Bonito.HTTPServer: online_url, local_url, relative_url
Bonito.set_cleanup_time!(0.0)
@testset "server cleanup" begin
    Bonito.Bonito.set_cleanup_time!(5 / 60 / 60) # 1 second

    app = App() do session
        dropdown1 = Bonito.Dropdown(["a", "b", "c"])
        dropdown2 = Bonito.Dropdown(["a2", "b2", "c2"]; index=2)
        img = Asset(joinpath(@__DIR__, "..", "docs", "src", "jupyterlab.png"))
        return DOM.div(dropdown1, dropdown2, img, js"""$(Bonito.BonitoLib).then(console.log)""")
    end
    server = Server(app, "0.0.0.0", 8898)

    window = TestWindow()
    url = URI(online_url(server, "/"))
    @testset for i in 1:10
        load(window.window, url)
        @test test_dom(window) # re-use from threading.jl
    end
    if app.session[].connection isa Bonito.DualWebsocket
        @test length(server.websocket_routes.table) == 20
        success = Bonito.wait_for(()-> length(server.websocket_routes.table) == 2, timeout=10)
    else
        @test length(server.websocket_routes.table) == 10
        success = Bonito.wait_for(()-> length(server.websocket_routes.table) == 1, timeout=10)
    end
    @test success == :success
    close(window)
    success = Bonito.wait_for(() -> isempty(server.websocket_routes.table), timeout=10)
    @test success == :success
    close(server)
    Bonito.Bonito.set_cleanup_time!(0.0)
end

@testset "proxy_url" begin
    server = Server("0.0.0.0", 8787)
    port = server.port # just in case this 8787 is used already somehow
    @testset "default" begin
        @test server.proxy_url == ""
        @test online_url(server, "") == "http://localhost:$(port)"
        @test local_url(server, "") == "http://localhost:$(port)"
        @test relative_url(server, "") == "http://localhost:$(port)"
    end

    @testset "relative urls" begin
        server.proxy_url = "."
        @test online_url(server, "") == "http://localhost:$(port)"
        @test local_url(server, "") == "http://localhost:$(port)"
        @test relative_url(server, "") == "./"
    end
    @testset "absolute urls" begin
        server.proxy_url = "https://bonito.makie.org"
        @test online_url(server, "") == "https://bonito.makie.org/"
        @test local_url(server, "") == "http://localhost:$(port)"
        @test relative_url(server, "") == "https://bonito.makie.org/"
    end
    close(server)
end
Bonito.set_cleanup_time!(30/60/60)

using HTTP, Bonito, Observables
using HTTP.WebSockets: WebSocket, isclosed, receive, send

## Overloading Connection
mutable struct WSConnection <: Bonito.FrontendConnection
    socket::Union{Nothing, WebSocket}
end

# Overload basic function
function Base.write(ws::WSConnection, binary)
    HTTP.WebSockets.send(ws.socket, binary)
end
function Base.close(ws::WSConnection)
    close(ws.socket)
end
Base.isopen(ws::WSConnection) = !isnothing(ws.socket) && !isclosed(ws.socket)

# Setup the julia side of things
function Bonito.setup_connection(session::Session{WSConnection})
    connection = session.connection
    # TODO, just insert a route, or close/reopen webserver
    port = 8083
    url = "127.0.0.1"
    server = WebSockets.listen!(url, port) do websocket
        connection.socket = websocket # once we get the connection, set it!
        while !isclosed(websocket)
            bytes = receive(websocket)
            # process_message works with the bytes serialized by the frontend :)
            Bonito.process_message(session, bytes)
        end
    end

    # Return the javascript you need to set things up
    return js"""
    // Javascript needed to connect to
    const websocket = new WebSocket($("ws://$(url):$(port)"))
    websocket.binaryType = "arraybuffer";
    websocket.onopen = function () {
        console.log("CONNECTED!!");
        websocket.onmessage = function (evt) {
            new Promise(resolve => {
                const binary = new Uint8Array(evt.data);
                Bonito.process_message(Bonito.decode_binary(binary, $(session.compression_enabled)));
                resolve()
            })
        };
        Bonito.on_connection_open((binary_data) => {
            websocket.send(binary_data) // we serialize everything to binary (Uint8Array)
        });
    };
    """
end

# Register your connection
Bonito.register_connection!(WSConnection) do
    # This should REALLY be conditional, otherwise
    # you'll force every package to use your connection per default!
    # See documention of register_connection!
    return WSConnection(nothing)
end


## Overloading Server

struct FileServer <: Bonito.AbstractAssetServer
end

# Nothing really to setup, but if you use e.g. HTTP, this would be the place to insert routes etc
# Have a look at asset-servers/http.jl for more infos about how to implement an HTTP based asset server
Bonito.setup_asset_server(::FileServer) = nothing

function Bonito.url(::FileServer, asset::Bonito.Asset)
    return "file:///" * Bonito.local_path(asset)
end

# Register your file server
Bonito.register_asset_server!(FileServer) do
    return FileServer()
end

# Now, any created session should use your WSConnection!
x = Session()
@assert x.connection isa WSConnection
@assert x.asset_server isa FileServer

Bonito.browser_display() # Show the app in the browser, since e.g. plotpane won't allow to load from file urls
color = Observable("red")
color_css = map(x-> "color: $(x)", color)
App() do session::Session
    Bonito.evaljs(session, js"console.log('hi from JS')")
    return DOM.div("hii"; style=color_css)
end

color[] = "green" # Tadaa, your first div update with your own connection :)

CARD_EXAMPLE = """
    App() do
        Card(
            DOM.h1("This is a card");
            width="200px",
            height="200px",
            backgroundcolor="white",
            shadow_size="0 0 10px",
            shadow_color="blue",
            padding="20px",
            margin="20px",
            border_radius="20px",
            style = Styles(
                CSS("hover", "background-color" => "lightgray")
            )
        )
    end
"""

"""
    Card(
        content;
        style::Styles=Styles(),
        backgroundcolor=RGBA(1, 1, 1, 0.2),
        shadow_size="0 4px 8px",
        padding="12px",
        margin="2px",
        shadow_color=RGBA(0, 0, 0.2, 0.2),
        width="auto",
        height="auto",
        border_radius="10px",
        div_attributes...,
    )

A Card is a container with a shadow and rounded corners.
It is a good way to group elements together and make them stand out from the background.
One can easily style them via the above keyword arguments or via the `style` argument with any CSS attribute.

# Example

```@example
$(CARD_EXAMPLE)
```
"""
function Card(
    content;
    style::Styles=Styles(),
    backgroundcolor=RGBA(1, 1, 1, 0.2),
    shadow_size="0 4px 8px",
    padding="12px",
    margin="2px",
    shadow_color=RGBA(0, 0, 0.2, 0.2),
    width="auto",
    height="auto",
    border_radius="10px",
    div_attributes...,
)
    color = convert_css_attribute(shadow_color)
    default_style = Styles(
        "width" => width,
        "height" => height,
        "padding" => padding,
        "margin" => margin,
        "background-color" => backgroundcolor,
        "border-radius" => border_radius,
        "box-shadow" => "$(shadow_size) $(color)",
    )
    css = Styles(default_style, style)
    return DOM.div(content; style=css, div_attributes...)
end

"""
    Grid(
        elems...;
        gap="10px",
        width="100%",
        height="100%",
        # All below Attributes are set to the default CSS values:
        columns="none",
        rows="none",
        areas="none",
        justify_content="normal",
        justify_items="legacy",
        align_content="normal",
        align_items="legacy",
        style::Styles=Styles(),
        div_attributes...,
    )

A Grid is a container that lays out its children in a grid, based on the powerful css `display: grid` property.
"""
function Grid(
    elems...;
    gap="10px",
    width="100%",
    height="100%",
    # All below Attributes are set to the default CSS values:
    columns="none",
    rows="none",
    areas="none",
    justify_content="normal",
    justify_items="legacy",
    align_content="normal",
    align_items="legacy",
    style::Styles=Styles(),
    div_attributes...,
)
    default_style = Styles(
        "display" => "grid",
        "grid-template-columns" => columns,
        "grid-template-rows" => rows,
        "grid-gap" => gap,
        "grid-template-areas" => areas,
        "justify-content" => justify_content,
        "justify-items" => justify_items,
        "align-content" => align_content,
        "align-items" => align_items,
        "width" => width,
        "height" => height,
    )
    css = Styles(default_style, style)
    return DOM.div(elems...; style=css, div_attributes...)
end

"""
    Row(elems...; grid_attributes...)

Places objects in a row, based on `Grid`.
"""
function Row(args...; grid_attributes...)
    return Grid(
        args...; rows="1fr", columns="repeat($(length(args)), 1fr)", grid_attributes...
    )
end

"""
    Col(elems...; grid_attributes...)

Places objects in a column, based on `Grid`.
"""
function Col(args...; grid_attributes...)
    return Grid(args...; columns="1fr", grid_attributes...)
end

"""
    Centered(content; style=Styles(), grid_attributes...)

Creates an element where the content is centered via `Grid`.
"""
function Centered(content; style=Styles(), grid_attributes...)
    return Grid(
        content;
        justify_content=:center,
        justify_items=:center,
        align_content=:center,
        align_items=:center,
        columns="1fr",
        style=Styles(style),
        grid_attributes...,
    )
end

struct StylableSlider{T} <: AbstractSlider{T}
    values::Observable{Vector{T}}
    value::Observable{T}
    index::Observable{Int}
    style::Styles
    track_style::Styles
    thumb_style::Styles
    track_active_style::Styles
end


const STYLABLE_SLIDER_EXAMPLE = """
App() do
    Bonito.StylableSlider(
        1:10;
        value=5,
        slider_height=20,
        track_color="lightblue",
        track_active_color="#F0F8FF",
        thumb_color="#fff",
        style=Styles(
            CSS("hover", "background-color" => "lightgray"),
            CSS("border-radius" => "0px"),
        ),
        track_style=Styles(
            "border-radius" => "3px",
            "border" => "1px solid black",
        ),
        thumb_style=Styles(
            "border-radius" => "3px",
            "border" => "1px solid black",
        ),
    )
end
"""

"""
    StylableSlider(
        range::AbstractVector;
        value=first(range),
        slider_height=15,
        thumb_width=slider_height,
        thumb_height=slider_height,
        track_height=slider_height / 2,
        track_active_height=track_height + 2,
        backgroundcolor="transparent",
        track_color="#eee",
        track_active_color="#ddd",
        thumb_color="#fff",
        style::Styles=Styles(),
        track_style::Styles=Styles(),
        thumb_style::Styles=Styles(),
        track_active_style::Styles=Styles(),
    )

Creates a Stylable Slider, where the basic attributes are easily custimizable via keyword arguments,
while the more advanced details can be styled via the `style`, `track_style`, `thumb_style` and `track_active_style` arguments with the whole might of CSS.
This does not use `<input type="range">` but is a custom implementation using `<div>`s javascript,
since it is not easily possible to style the native slider in a cross-browser way.
For using pure HTML sliders, use `Bonito.Slider`.

# Example

```@example
$(STYLABLE_SLIDER_EXAMPLE)
```
"""
function StylableSlider(
    range::AbstractVector{T};
    index::Union{Nothing, Integer}=nothing,
    value=nothing,
    slider_height=15,
    thumb_width=slider_height,
    thumb_height=slider_height,
    track_height=slider_height / 2,
    track_active_height=track_height + 2,
    backgroundcolor="transparent",
    track_color="#eee",
    track_active_color="#ddd",
    thumb_color="#fff",
    style::Styles=Styles(),
    track_style::Styles=Styles(),
    thumb_style::Styles=Styles(),
    track_active_style::Styles=Styles(),
) where {T}
    half_thumb_width = thumb_width / 2

    default_style = Styles(
        "display" => "grid",
        "grid-template-columns" => "1fr",
        "grid-template-rows" => "$(slider_height)px",
        "align-items" => "center",
        "margin" => "$(slider_height ÷ 3)px",
        "position" => "relative",
        "padding-right" => "$(2 + half_thumb_width)px",
        "padding-left" => "$(2 + half_thumb_width)px",
        "background-color" => backgroundcolor,
    )
    style = Styles(default_style, style)

    default_track_style = Styles(
        "position" => "absolute",
        "width" => "100%",
        "height" => "$(track_height)px",
        "background-color" => track_color,
        "border-radius" => "3px",
        "border" => "1px solid #ccc",
    )
    track_style = Styles(default_track_style, track_style)

    default_track_active_style = Styles(
        "position" => "absolute",
        "width" => "0px",
        "height" => "$(track_active_height)px",
        "background-color" => track_active_color,
        "border-radius" => "3px",
        "border" => "1px solid #ccc",
    )
    track_active_style = Styles(default_track_active_style, track_active_style)

    default_thumb_style = Styles(
        "width" => "$(thumb_width)px",
        "height" => "$(thumb_height)px",
        "background-color" => "white",
        "border-radius" => "50%",
        "cursor" => "pointer",
        "position" => "absolute",
        "border" => "1px solid #ccc",
        "left" => "$(-half_thumb_width)px",
        "background-color" => thumb_color,
    )
    thumb_style = Styles(default_thumb_style, thumb_style)
    if !isnothing(value) && !isnothing(index)
        error("Values for value=$(value) and index=$(index) given, please only set one.")
    end
    if !isnothing(value) && isnothing(index)
        index = findfirst(isequal(value), range)
        index === nothing && error("value=$(value) not in range=$(range)")
    end
    if isnothing(value) && isnothing(index)
        index = 1
    end

    values = Observable{Vector{T}}(range; ignore_equal_values=true)
    index_obs = Observable{Int}(index; ignore_equal_values=true)
    value_obs = map(getindex, values, index_obs; ignore_equal_values=true)
    slider = StylableSlider(
        values,
        value_obs,
        index_obs,
        style,
        track_style,
        thumb_style,
        track_active_style,
    )
    return slider
end

function jsrender(session::Session, slider::StylableSlider)
    # Define the CSS styles
    container_style = slider.style

    track_style = slider.track_style

    track_active_style = slider.track_active_style

    thumb_style = slider.thumb_style

    # Create elements
    thumb = DOM.div(; style=thumb_style)
    track = DOM.div(; style=track_style)
    track_active = DOM.div(; style=track_active_style)
    container = DOM.div(track, track_active, thumb; style=container_style)

    # JavaScript for interactivity
    jscode = js"""
    (container)=> {
        const thumb = $(thumb);
        const track_active = $(track_active);
        const track = $(track);
        let isDragging = false;
        const nsteps_obs = $(map(length, slider.values))
        let last_index = -1;
        function set_thumb_index(index) {
            if (index === last_index) {
                return
            }
            last_index = index;
            const thumb_width = thumb.offsetWidth / 2;
            const nsteps = nsteps_obs.value;
            const step_width = track.offsetWidth / (nsteps-1);
            const new_left = (index - 1) * step_width;
            thumb.style.left = (new_left - thumb_width) + 'px';  // Update the left position of the thumb
            track_active.style.width = new_left + 'px';  // Update the active track
        }
        $(slider.index).on(idx=> set_thumb_index(idx));
        function set_thumb(e) {
            const nsteps = nsteps_obs.value;
            const thumb_width = thumb.offsetWidth / 2;
            const width = track.offsetWidth;
            const step_width = width / (nsteps - 1);
            let new_left = e.clientX - container.getBoundingClientRect().left;
            new_left = Math.max(new_left, 0);
            new_left = Math.min(new_left, width);
            new_left = Math.round(new_left / step_width) * step_width;
            thumb.style.left = (new_left - thumb_width) + 'px';  // Update the left position of the thumb
            track_active.style.width = new_left + 'px';  // Update the active track
            const index = Math.round((new_left / width) * (nsteps - 1));
            last_index = index;
            if (index !== $(slider.index).value) {
                $(slider.index).notify(index + 1);
            }
        }
        const set_thumb_throttled = Bonito.throttle_function(set_thumb, 100);
        const controller = new AbortController();
        document.addEventListener('mousedown', function (e) {
            if(e.target === thumb || e.target === track_active || e.target === track || e.targar === container){
                isDragging = true;
                set_thumb(e);
                e.preventDefault();  // Prevent default behavior
            }
        }, { signal: controller.signal});
        document.addEventListener('mouseup', function () {
            if (!document.body.contains(container)) {
                controller.abort();
            }
            isDragging = false;
        }, { signal: controller.signal });
        document.addEventListener('mousemove', function (e) {
            if (isDragging) {
                set_thumb(e);
            }
        }, { signal: controller.signal });
        set_thumb_index($(slider.index).value)
    }
    """
    onload(session, container, jscode)

    return jsrender(session, container)
end


"""
    Label(value; style=Styles(), attributes...)

A Label is a simple text element, with a bold font and a font size of 1rem.
"""
function Label(value; style=Styles(), attributes...)
    default_style = Styles("font-size" => "1rem", "font-weight" => 600)
    styled = Styles(default_style, style)
    return DOM.span(value; style=styled, attributes...)
end


const LABELED_EXAMPLE = """
App() do
    label_style = Styles(
        "color" => "white",
        "padding" => "3px",
        "font-size" => "1.5rem",
        "text-shadow" => "0px 0px 10px black, 1px 1px 3px black")
    slider = StylableSlider(1:10)
    Card(Labeled(slider, slider.value; label_style=label_style, width="auto"); backgroundcolor="gray")
end
"""

"""
    Labeled(object, label; label_style=Styles(), attributes...)

A Labeled container with a simople layout to put a label next to an object.

```@example
$(LABELED_EXAMPLE)
```
"""
function Labeled(object, label; label_style=Styles(), attributes...)
    return Grid(
        object,
        Label(label; style=label_style);
        rows="1fr",
        columns="1fr min-content",
        align_items="center",
        justify_items="stretch",
        attributes...,
    )
end



function LabelGrid(widget_pairs; label_style=Styles(), grid_kw...)
    elements = []
    for (name, widget) in widget_pairs
        push!(elements, Bonito.Label(name; style=label_style), widget)
    end
    return Grid(
        elements...;
        columns="min-content 1fr",
        justify_content="begin",
        align_items="center",
        grid_kw...,
    )
end


function VerticalSpinner(; width=80, nballs=3, gap=3)
    balls = (width) / (2nballs)
    positions = map(1:nballs) do i
        posi = i == 1 ? 2 : i
        pos = (((posi - 1) * 2balls) + (0.5balls))
        return CSS(
            ".lds-ellipsis div:nth-child($(i))",
            "left" => "$(pos)px",
            "animation" => "lds-ellipsis$(i) 1s infinite, color-change 1s infinite $((1/nballs) * (posi - 1))s",
        )
    end
    keyframes = map(1:nballs) do i
        if i == 1
            CSS(
                "@keyframes lds-ellipsis$(i)",
                CSS("0%", "transform" => "scale(0)"),
                CSS("100%", "transform" => "scale(1)"),
            )
        elseif i == nballs
            CSS(
                "@keyframes lds-ellipsis$(i)",
                CSS("0%", "transform" => "scale(1)"),
                CSS("100%", "transform" => "scale(0)"),
            )
        else
            CSS(
                "@keyframes lds-ellipsis$(i)",
                CSS("0%", "transform" => "translate(0, 0)"),
                CSS("100%", "transform" => "translate($(2balls)px, 0)"),
            )
        end
    end

    color_keyframes = CSS(
        "@keyframes color-change",
        CSS("0%", "background" => "currentColor"),
        CSS("100%", "background" => "silver"),
    )

    return DOM.div(
        DOM.div(; class="lds-ellipsis", fill(DOM.div(), nballs)...),
        Styles(
            CSS(".lds-ellipsis, .lds-ellipsis div", "box-sizing" => "border-box"),
            CSS(
                ".lds-ellipsis",
                "display" => "inline-block",
                "position" => "relative",
                "width" => "$(width)px",
            ),
            CSS(
                ".lds-ellipsis div",
                "position" => "absolute",
                "width" => "$(balls)px",
                "height" => "$(balls)px",
                "border-radius" => "50%",
                "background" => "currentColor",
                "animation-timing-function" => "cubic-bezier(0, 1, 1, 0)",
            ),
            positions...,
            keyframes...,
            color_keyframes,
        ),
    )
end

function RippleSpinner(; width=64, height=width, stroke=4, duration=1)
    max_size = max(width, height)
    half_size = max_size / (16 / 9)
    keyframes = CSS(
        "@keyframes lds-ripple",
        CSS(
            "0%",
            "top" => "$(half_size)px",
            "left" => "$(height / (16/9))px",
            "width" => "0",
            "height" => "0",
            "opacity" => "0",
        ),
        CSS(
            "4.9%",
            "top" => "$(half_size)px",
            "left" => "$(height / (16/9))px",
            "width" => "0",
            "height" => "0",
            "opacity" => "0",
        ),
        CSS(
            "5%",
            "top" => "$(half_size)px",
            "left" => "$(height / (16/9))px",
            "width" => "0",
            "height" => "0",
            "opacity" => "1",
        ),
        CSS(
            "100%",
            "top" => "0px",
            "left" => "0px",
            "width" => "$(max_size * 1.125)px",
            "height" => "$(height * 1.125)px",
            "opacity" => "0",
        ),
    )

    styles = Styles(
        CSS(
            ".lds-ripple",
            "display" => "inline-block",
            "position" => "relative",
            "width" => "$(width)px",
            "height" => "$(height)px",
        ),
        CSS(
            ".lds-ripple div",
            "position" => "absolute",
            "opacity" => "1",
            "border-radius" => "50%",
            "border" => "$(stroke)px solid currentColor",
            "animation" => "lds-ripple $(duration)s cubic-bezier(0, 0.2, 0.8, 1) infinite",
        ),
        CSS(".lds-ripple div:nth-child(2)", "animation-delay" => "-0.5s"),
        keyframes,
    )

    return DOM.div(styles, DOM.div(), DOM.div(); class="lds-ripple")
end

struct KaTeX
    source::String
    display::Bool
end

function KaTeX(source::String; display::Bool = false)
    # Normalize LaTeX delimiters for KaTeX
    source = replace(source, r"\$([\s\S]*?)\$" => s"\1")
    source = replace(source, r"\\\[([\s\S]*?)\\\]" => s"\1")
    return KaTeX(source, display)
end

@deprecate MathJax(source::String, config=Dict()) KaTeX(source)

const KaTeXCSS = Asset(dependency_path("katex.min.css"))
const KaTeXJS = ES6Module(dependency_path("katex.mjs"))

function jsrender(session::Session, katex::KaTeX)
    elem = DOM.span()
    render_script = js"""
    const elem = $(elem);
    // uh, observable has better escaping for strings instead of interpolating it directly
    const source = $(Observable(katex.source)).value;
    const displayMode = $(katex.display);
    $(KaTeXJS).then(Katex=> {
            Katex.default.render(source, elem, {displayMode: displayMode});
    }).catch(e => {
        console.warn("KaTeX loading error:", e);
        elem.textContent = source; // Fallback to plain text
    });
    """
    dom = DOM.span(KaTeXCSS, elem, render_script; class="katex-container")
    return jsrender(session, dom)
end

function handler(session, request)
    global test_observable
    test_observable = Observable(Dict{String, Any}())
    checkbox1 = Bonito.Checkbox(true)
    checkbox2 = Bonito.Checkbox(false)

    on(checkbox1) do value
        test_observable[] = Dict{String, Any}("checkbox1" => value)
    end
    on(checkbox2) do value
        test_observable[] = Dict{String, Any}("checkbox2" => value)
    end

    return DOM.div(checkbox1, checkbox2)
end

testsession(handler, port=8558) do app
    checkbox1_jl = children(app.dom)[1]
    checkbox2_jl = children(app.dom)[2]
    @test evaljs(app, js"document.querySelectorAll('input[type=\"checkbox\"]').length") == 2
    checkbox1 = js"document.querySelectorAll('input[type=\"checkbox\"]')[0]"
    checkbox2 = js"document.querySelectorAll('input[type=\"checkbox\"]')[1]"
    @test evaljs(app, js"$(checkbox1).checked") == true
    @test evaljs(app, js"$(checkbox2).checked") == false
    val = test_value(app, js"$(checkbox1).click()")
    @test val["checkbox1"] == false
    @test checkbox1_jl[] == false
    val = test_value(app, js"$(checkbox2).click()")
    @test val["checkbox2"] == true
    @test checkbox2_jl[] == true
    # button press from Julia
    checkbox1_jl[] = true # this won't trigger onchange!!!!
    @test evaljs(app, js"$(checkbox1).checked") == true
    checkbox2_jl[] = false
    @test evaljs(app, js"$(checkbox2).checked") == false
end


function dropdown_handler(session, request)
    global test_observable
    test_observable = Observable(Dict{String, Any}())
    global dropdown1 = Bonito.Dropdown(["a", "b", "c"])
    dropdown2 = Bonito.Dropdown(["a2", "b2", "c2"]; index=2)

    on(dropdown1.value) do value
        test_observable[] = Dict{String,Any}("dropdown1" => value)
    end
    on(dropdown2.value) do value
        test_observable[] = Dict{String,Any}("dropdown2" => value)
    end

    return DOM.div(dropdown1, dropdown2)
end

testsession(dropdown_handler, port=8558) do app
    dropdown1_jl = children(app.dom)[1]
    dropdown2_jl = children(app.dom)[2]
    @test evaljs(app, js"document.querySelectorAll('select').length") == 2
    dropdown1 = js"document.querySelectorAll('select')[0]"
    dropdown2 = js"document.querySelectorAll('select')[1]"

    @test evaljs(app, js"$(dropdown1).selectedIndex") == 0 # 0 indexed if directly accessed
    @test evaljs(app, js"$(dropdown2).selectedIndex") == 1

    evaljs(app, js"(()=> {
        const select = $(dropdown1)
        select.selectedIndex = 1;
        const event = new Event('change');
        select.dispatchEvent(event);
    })()")
    evaljs(app, js"(()=> {
        const select = $(dropdown2)
        select.selectedIndex = 2;
        const event = new Event('change');
        select.dispatchEvent(event);
    })()")
    @test dropdown1_jl.value[] == "b"
    @test dropdown2_jl.value[] == "c2"
end

# Table widget tests
function table_handler(session, request)
    # Create test data using vector of named tuples
    test_table_data = [
        (attribute="price", apartment_A=1200.0, apartment_B=950.0, apartment_C=1350.0),
        (attribute="area", apartment_A=75.5, apartment_B=65.2, apartment_C=85.0),
        (attribute="floor", apartment_A=3, apartment_B=2, apartment_C=4)
    ]

    # Test basic table
    basic_table = Bonito.Table(test_table_data)

    # Test table with custom class callback
    function test_class_callback(table, row, col, val)
        if col == 1  # First column (attributes)
            return "cell-default"
        elseif isa(val, Number) && val > 1000
            return "cell-good"
        elseif isa(val, Number) && val < 70
            return "cell-bad"
        else
            return "cell-neutral"
        end
    end

    # Test table with custom style callback
    function test_style_callback(table, row, col, val)
        if col == 1  # First column
            return "font-weight: bold;"
        elseif isa(val, Number) && val > 1000
            return "background-color: lightgreen;"
        else
            return ""
        end
    end

    custom_table = Bonito.Table(test_table_data;
                               class_callback=test_class_callback,
                               style_callback=test_style_callback)

    # Test table with sorting disabled
    no_sort_table = Bonito.Table(test_table_data;
                                allow_row_sorting=false,
                                allow_column_sorting=false)

    # Test table with custom CSS class
    styled_table = Bonito.Table(test_table_data;
                               class="my-custom-table")

    return DOM.div(
        DOM.div(basic_table; id="basic_table"),
        DOM.div(custom_table; id="custom_table"),
        DOM.div(no_sort_table; id="no_sort_table"),
        DOM.div(styled_table; id="styled_table")
    )
end

testsession(table_handler, port=8559) do app
    # Test that tables are rendered
    @test evaljs(app, js"document.querySelectorAll('table').length") == 4
    @test evaljs(app, js"document.querySelectorAll('.comparison-table').length") == 4

    # Test basic table structure
    basic_table = js"document.querySelector('#basic_table table')"
    @test evaljs(app, js"$(basic_table).querySelectorAll('th').length") == 4  # 4 columns
    @test evaljs(app, js"$(basic_table).querySelectorAll('tbody tr').length") == 3  # 3 rows

    # Test header content
    @test evaljs(app, js"$(basic_table).querySelectorAll('th')[0].textContent.trim()") == "attribute"
    @test evaljs(app, js"$(basic_table).querySelectorAll('th')[1].textContent.trim()") == "apartment_A"
    @test evaljs(app, js"$(basic_table).querySelectorAll('th')[2].textContent.trim()") == "apartment_B"
    @test evaljs(app, js"$(basic_table).querySelectorAll('th')[3].textContent.trim()") == "apartment_C"

    # Test data content
    first_row = js"$(basic_table).querySelectorAll('tbody tr')[0]"
    @test evaljs(app, js"$(first_row).querySelectorAll('td')[0].textContent.trim()") == "price"
    @test evaljs(app, js"$(first_row).querySelectorAll('td')[1].textContent.trim()") == "1200.0"
    @test evaljs(app, js"$(first_row).querySelectorAll('td')[2].textContent.trim()") == "950.0"
    @test evaljs(app, js"$(first_row).querySelectorAll('td')[3].textContent.trim()") == "1350.0"

    # Test custom table with class callbacks
    custom_table = js"document.querySelector('#custom_table table')"

    # Test that cells have correct classes applied
    first_cell = js"$(custom_table).querySelectorAll('tbody tr')[0].querySelectorAll('td')[0]"
    @test evaljs(app, js"$(first_cell).className.includes('cell-default')") == true

    high_value_cell = js"$(custom_table).querySelectorAll('tbody tr')[0].querySelectorAll('td')[1]"  # 1200.0
    @test evaljs(app, js"$(high_value_cell).className.includes('cell-good')") == true

    low_value_cell = js"$(custom_table).querySelectorAll('tbody tr')[1].querySelectorAll('td')[2]"  # 65.2
    @test evaljs(app, js"$(low_value_cell).className.includes('cell-bad')") == true

    # Test that style callback is applied
    styled_cell = js"$(custom_table).querySelectorAll('tbody tr')[0].querySelectorAll('td')[0]"
    @test evaljs(app, js"$(styled_cell).style.fontWeight") == "bold"

    high_value_styled = js"$(custom_table).querySelectorAll('tbody tr')[0].querySelectorAll('td')[1]"
    @test evaljs(app, js"$(high_value_styled).style.backgroundColor") == "lightgreen"

    # Test custom CSS class
    styled_table = js"document.querySelector('#styled_table table')"
    @test evaljs(app, js"$(styled_table).className.includes('my-custom-table')") == true

    # Test sorting functionality (on tables that have sorting enabled)
    # Test column header click (should have cursor pointer)
    basic_header = js"$(basic_table).querySelectorAll('th')[0]"
    @test evaljs(app, js"getComputedStyle($(basic_header)).cursor") == "pointer"

    # Test that no-sort table doesn't have clickable headers/cells
    no_sort_table = js"document.querySelector('#no_sort_table table')"
    no_sort_header = js"$(no_sort_table).querySelectorAll('th')[0]"
    # Note: The cursor style might still be set by CSS, but the click handlers shouldn't be attached

    # Test data attributes for sorting
    data_cell = js"$(basic_table).querySelectorAll('tbody tr')[0].querySelectorAll('td')[1]"
    @test evaljs(app, js"$(data_cell).getAttribute('data-value')") == "1200.0"
end


# Test table with empty data
function empty_table_handler(session, request)
    # Empty vector of named tuples
    empty_data = NamedTuple{(:col1, :col2), Tuple{String, Int}}[]
    empty_table = Bonito.Table(empty_data)
    return DOM.div(empty_table; id="empty_table")
end

testsession(empty_table_handler, port=8560) do app
    # Test that empty table is rendered with headers but no data rows
    empty_table = js"document.querySelector('#empty_table table')"
    @test evaljs(app, js"$(empty_table).querySelectorAll('th').length") == 2  # Headers still present
    @test evaljs(app, js"$(empty_table).querySelectorAll('tbody tr').length") == 0  # No data rows

    # Test header content
    @test evaljs(app, js"$(empty_table).querySelectorAll('th')[0].textContent.trim()") == "col1"
    @test evaljs(app, js"$(empty_table).querySelectorAll('th')[1].textContent.trim()") == "col2"
end

# Test table with missing values
function missing_values_table_handler(session, request)
    # Vector of named tuples with missing values
    data_with_missing = [
        (name="Alice", age=25, salary=50000.0),
        (name="Bob", age=missing, salary=60000.0),
        (name="Charlie", age=30, salary=missing)
    ]
    table_with_missing = Bonito.Table(data_with_missing)
    return DOM.div(table_with_missing; id="missing_table")
end

testsession(missing_values_table_handler, port=8561) do app
    # Test that missing values are handled properly
    missing_table = js"document.querySelector('#missing_table table')"

    # Test that missing values are rendered as "n/a" by default row_renderer
    missing_age_cell = js"$(missing_table).querySelectorAll('tbody tr')[1].querySelectorAll('td')[1]"
    @test evaljs(app, js"$(missing_age_cell).textContent.trim()") == "n/a"

    missing_salary_cell = js"$(missing_table).querySelectorAll('tbody tr')[2].querySelectorAll('td')[2]"
    @test evaljs(app, js"$(missing_salary_cell).textContent.trim()") == "n/a"

    # Test that non-missing values are rendered correctly
    valid_age_cell = js"$(missing_table).querySelectorAll('tbody tr')[0].querySelectorAll('td')[1]"
    @test evaljs(app, js"$(valid_age_cell).textContent.trim()") == "25"
end

# using Bonito, Markdown

function test_handler(session, req)
    global test_observable
    test_observable = Observable(Dict{String, Any}())
    test_session = session

    global s1 = Bonito.Slider(1:100)
    global s2 = Bonito.Slider(1:100)
    b = Bonito.Button("hi"; dataTestId="hi_button")

    clicks = Observable(0)
    on(b) do click
        clicks[] = clicks[] + 1
    end
    clicks_div = DOM.div(clicks, dataTestId="button_clicks")
    t = Bonito.TextField("Write!")

    linkjs(session, s1.index, s2.index)

    onjs(session, s1.value, js"""function (v){
        $(test_observable).notify({onjs: v});
    }""")

    on(t) do value
        test_observable[] = Dict{String, Any}("textfield" => value)
    end

    on(b) do value
        test_observable[] = Dict{String, Any}("button" => value)
    end

    textresult = DOM.div(t.value; dataTestId="text_result")
    sliderresult = DOM.div(s1.value; dataTestId="slider_result")

    number_input = Bonito.NumberInput(66.0)
    number_result = DOM.div(number_input.value, dataTestId="number_result")
    linked_value = DOM.div(s2.value, dataTestId="linked_value")

    dom = md"""
    # IS THIS REAL?

    My first slider: $(s1)

    My second slider: $(s2)

    Test: $(sliderresult)

    The BUTTON: $(b)

    $(clicks_div)

    # Number Input

    $(number_input)

    $(number_result)

    Type something for the list: $(t)

    some list $(textresult)
    $(linked_value)
    """
    return DOM.div(dom)
end

# App(test_handler)

function test_current_session(app)
    dom = children(app.dom)[1]
    @test evaljs(app, js"document.querySelectorAll('button').length") == 1
    @test evaljs(app, js"document.querySelectorAll('input[type=\"range\"]').length") == 2
    @test evaljs(app, js"document.querySelectorAll('button').length") == 1
    @test evaljs(app, js"document.querySelectorAll('input[type=\"range\"]').length") == 2

    @testset "button" begin
        # It's in the dom!
        @test evaljs(app, js"document.querySelectorAll('button').length") == 1
        bquery = query_testid("hi_button")
        # Spam the button press on the JS side a bit, to make sure we're not loosing events!
        for i in 1:100
            val = test_value(app, js"$(bquery).click()")
            @test val["button"] == true
        end
        button = query_testid("button_clicks")
        @test evaljs(app, js"$(button).innerText") == "100"
        button = dom.content[5].content[2]
        @test button.content[] == "hi"
        button.content[] = "new name"
        bquery = query_testid("hi_button")
        @test evaljs(app, js"$(bquery).innerText") == "new name"
        # button press from Julia
        val = test_value(app, ()-> (button.value[] = true))
        @test val["button"] == true
    end

    @testset "textfield" begin
        @test evaljs(app, js"document.querySelectorAll('input[type=\"textfield\"]').length") == 1
        # @test evaljs(app, js"document.querySelector('input[type=\"textfield\"]').value") == "Write!"
        # Spam the button press a bit!
        text_obs = children(dom.content[end].content[2])[1]
        textfield = dom.content[end-1].content[2]
        text_result = query_testid("text_result")
        @test evaljs(app, js"$(text_result).innerText") == "Write!"
        @testset "setting value from js" begin
            for i in 1:10
                str = randstring(10)
                do_input = js"""
                    var tfield = document.querySelector('input[type=\"textfield\"]');
                    tfield.value = $(str);
                    tfield.onchange({srcElement: tfield});
                """
                val = test_value(app, do_input)
                @test val["textfield"] == str
                @test text_obs[] == str
                evaljs(app, js"$(text_result).innerText") == str
                @test textfield[] == str
            end
        end
        @testset "setting value from julia" begin
            for i in 1:10
                str = randstring(10)
                val = test_value(app, ()-> textfield[] = str)
                @test val["textfield"] == str
                @test text_obs[] == str
                evaljs(app, js"$(text_result).innerText") == str
                @test textfield[] == str
            end
        end
    end

    @testset "slider" begin
        # We test with JSCall this time, to test it as well ;)
        slider1 = dom.content[2].content[2]
        slider2 = dom.content[3].content[2]
        slider1_js = js"document.querySelectorAll('input[type=\"range\"]')[0]"
        slider2_js = query_testid("linked_value")
        sliderresult = query_testid("slider_result")

        @testset "set via julia" begin
            for i in 1:2:100
                slider1[] = i
                @test evaljs(app, js"$(slider1_js).value") == "$i"
                # Test linkjs
                @test evaljs(app, js"$(slider2_js).innerText") == "$i"
                @test slider2[] == i
                evaljs(app, js"$(sliderresult).innerText") == "$i"
            end
        end
    end
end

global dom = nothing
inline_display = Bonito.App() do session, req
    global dom = test_handler(session, req)
    return dom
end;
Bonito.CURRENT_SESSION[] = nothing
display(edisplay, inline_display);
app = TestSession(URI("http://localhost:8555/show"),
    Bonito.GLOBAL_SERVER[], edisplay.window, inline_display.session[])
app.dom = dom;
app.initialized = false
wait(app)
Electron.toggle_devtools(app.window.window)
@testset "electron inline display" begin
    test_current_session(app)
end
close(app)

@testset "Electron standalone" begin
    testsession(test_handler, port=8555) do app
        test_current_session(app)
    end
end

@testset "markdown" begin
    function test_handler(session, req)
        global dom, test_session, test_observable
        test_session = session
        dom = md"""
        # More MD

        [Github-flavored Markdown info page](http://github.github.com/github-flavored-markdown/)

        [![Build Status](https://travis-ci.com/SimonDanisch/Bonito.jl.svg?branch=master)](https://travis-ci.com/SimonDanisch/Bonito.jl)

        Lalala
        ======

        Alt-H2
        ------

        Emphasis, aka italics, with *asterisks* or _underscores_.

        Strong emphasis, aka bold, with **asterisks** or __underscores__.

        Combined emphasis with **asterisks and _underscores_**.

        Strikethrough uses two tildes. ~~Scratch this.~~

        1. First ordered list item
        2. Another item
            * Unordered sub-list.
        1. Actual numbers don't matter, just that it's a number
            1. Ordered sub-list
        4. And another item.

        * Unordered list can use asterisks
        - Or minuses
        + Or pluses

        Inline `code` has `back-ticks around` it.

        ```julia
        test("haha")
        ```

        | Tables        | Are           | Cool  |
        | ------------- |:-------------:| -----:|
        | col 3 is      | right-aligned | $1600 |
        | col 2 is      | centered      |   $12 |
        | zebra stripes | are neat      |    $1 |

        > Blockquotes are very handy in email to emulate reply text.
        > This line is part of the same quote.

        Three or more...

        ---

        Hyphens[^1]

        ***

        Asterisks

        ___

        Underscores

        [^1]: This is the first footnote.
        """
        return DOM.div(Bonito.MarkdownCSS, dom)
    end

    testsession(test_handler, port=8555) do app
        id = app.session.id
        markdown_dom = js"document.querySelector('.markdown-body')"
        md_children = js"$(markdown_dom).children"
        @test evaljs(app, js"$(md_children).length") == 23
        @test occursin("This is the first footnote.", evaljs(app, js"$(md_children)[22].innerText"))
        @test evaljs(app, js"$(md_children)[2].children[0].children[0].tagName") == "IMG"
    end
end

"""
# Inteface for FrontendConnection

```julia
struct MyConnection <: FrontendConnection
end
```

Needs to have a constructor with 0 arguments:
```julia
MyConnection()
```

Needs to overload `Base.write` for sending binary data
```julia
Base.write(connection::MyConnection, bytes::AbstractVector{UInt8})
```

Needs to implement isopen to indicate status of connection
```julia
Base.isopen(c::MyConnection)
```

Setup connection will be called before rendering any dom with `session`.
The return value will be inserted into the DOM of the rendered App and can be used to
do the JS part of opening the connection.
```julia
Bonito.setup_connection(session::Session{IJuliaConnection})::Union{JSCode, Nothing}
```

One can overload `use_parent_session`, to turn on rendering dom objects inside sub-sessions while keeping one parent session
managing the connection alive.
This is handy for IJulia/Pluto, since the parent session just needs to be initialized one time and can stay active and globally store objects used multiple times across doms.
```Julia
Bonito.use_parent_session(::Session{MyConnection}) = false/false
```
"""
FrontendConnection

"""
Websocket based connection type
"""
abstract type AbstractWebsocketConnection <: FrontendConnection end

open!(connection) = nothing

# fallback for connections not supporting
# a slow / fast connection
function write_large(ws, binary)
    write(ws, binary)
end

include("sub-connection.jl")
include("websocket-handler.jl")
include("websocket.jl")
include("dual-websocket.jl")
include("ijulia.jl")
include("pluto.jl")
include("no-connection.jl")

"""
We don't serve files and include anything directly as raw bytes.
Interpolating the same asset many times, will only upload the file to JS one time though.
"""
struct NoServer <: AbstractAssetServer
end
Base.similar(asset::NoServer) = asset # no copy needed

function render_asset(session::Session, ::NoServer, asset::Asset)
    @assert mediatype(asset) in (:css, :js, :mjs) "Found: $(mediatype(asset)))"
    ref = url(session, asset)
    if mediatype(asset) == :js
        if asset.es6module
            return DOM.script("""
                // make sure BONITO_IMPORTS is initialized
                window.BONITO_IMPORTS = window.BONITO_IMPORTS || {};
                BONITO_IMPORTS['$(unique_key(asset))'] =  import('$(ref)');
                """
            )
        else
            return DOM.script(; src=ref)
        end
    elseif mediatype(asset) == :css
        return DOM.link(; href=ref, rel="stylesheet", type="text/css")
    end
end

function import_in_js(io::IO, session::Session, ns::NoServer, asset::Asset)
    if asset.es6module
        push!(session.imports, asset)
        print(io, "BONITO_IMPORTS['$(unique_key(asset))']")
    else
        error("Can only import es6 modules with NoServer right now.")
    end
end

# This is better for e.g. exporting static sides
# TODO make this more straightforward and easy to customize
# (this gets called/overloaded in js_source.jl)
function inline_code(session::Session, ::NoServer, source::String)
    return DOM.script(src=to_data_url(source, "application/javascript"); type="module")
end

setup_asset_server(::NoServer) = nothing

function url(::NoServer, asset::Asset)
    !isempty(asset.online_path) && return asset.online_path
    return to_data_url(local_path(asset))
end

function url(::NoServer, asset::BinaryAsset)
    return to_data_url(asset.data, asset.mime)
end

abstract type AbstractAssetFolder <: AbstractAssetServer end

mutable struct AssetFolder <: AbstractAssetFolder
    folder::String
    current_dir::String # The dir the current html page gets written out to
end
Base.similar(asset::AssetFolder) = asset # no copy needed

setup_asset_server(::AbstractAssetFolder) = nothing

subdir(asset::Union{BinaryAsset,Asset}) = string(mediatype(asset))

desired_location(assetfolder, asset::Link) = link.target
write_to_assetfolder(assetfolder, asset::Link) = link.target

function desired_location(assetfolder, asset)
    folder = abspath(assetfolder.folder)
    path = abspath(local_path(asset))
    if !occursin(folder, path)
        file = basename(path)
        sub = subdir(asset)
        name, ending = splitext(file)
        h = string(hash(read(path)))
        unique_name = string(name, h, ending)
        filepath = normpath(joinpath(folder, "bonito", sub, unique_name))
        return filepath
    end
    return path
end

function desired_location(assetfolder, asset::BinaryAsset)
    dir = folder(assetfolder)
    file = unique_file_key(asset)
    sub = subdir(asset)
    return normpath(joinpath(dir, "bonito", sub, file))
end

function write_to_assetfolder(assetfolder, asset)
    dir = folder(assetfolder)
    path = abspath(local_path(asset))
    if occursin(dir, path)
        return path
    else
        filepath = desired_location(assetfolder, asset)
        isdir(dirname(filepath)) || mkpath(dirname(filepath))
        cp(path, filepath; force=true)
        return filepath
    end
end

current_dir(assetfolder::AssetFolder) = assetfolder.current_dir
current_dir(assetfolder) = ""

to_unix_path(path) = replace(path, "\\" => "/")

function url(assetfolder::AbstractAssetFolder, asset::Link)
    is_online(asset.target) && return asset.target
    html_dir = to_unix_path(current_dir(assetfolder))
    root_dir = to_unix_path(folder(assetfolder))
    path_to_root = relpath(root_dir, html_dir)
    return to_unix_path(path_to_root * asset.target)
end

function url(assetfolder::AbstractAssetFolder, asset::Asset)
    if !isempty(asset.online_path)
        return asset.online_path
    end
    path = write_to_assetfolder(assetfolder, asset)
    html_dir = to_unix_path(current_dir(assetfolder))
    root_dir = to_unix_path(folder(assetfolder))
    target_dir = to_unix_path(dirname(path))
    relative = replace(target_dir, root_dir => "")
    path_to_root = relpath(root_dir, html_dir)
    patherino = to_unix_path(path_to_root * relative * "/" * basename(path))
    return patherino
end

folder(folder) = folder.folder
folder(assetfolder::AssetFolder) = abspath(assetfolder.folder)

function url(assetfolder::AbstractAssetFolder, asset::BinaryAsset)
    filepath = desired_location(assetfolder, asset)
    if !isfile(filepath)
        isdir(dirname(filepath)) || mkpath(dirname(filepath))
        write(filepath, asset.data)
    end
    return url(assetfolder, Asset(filepath))
end

struct DocumenterAssets <: AbstractAssetFolder
    folder::RefValue{String}
end
Base.similar(asset::DocumenterAssets) = asset # no copy needed

folder(assetfolder::DocumenterAssets) = abspath(assetfolder.folder[])

DocumenterAssets() = DocumenterAssets(RefValue{String}(""))

function url(assetfolder::DocumenterAssets, asset::Asset)
    if !isempty(asset.online_path)
        return asset.online_path
    end
    folder = abspath(assetfolder.folder[])
    path = write_to_assetfolder((; folder=assetfolder.folder[]), asset)
    # TODO, how to properly get the real relative path to assetfolder
    import_path = relpath(path, folder)
    return replace(import_path, "\\" => "/")
end

# Static Sites

There are several ways to generate static sites with Bonito.
The main one is:

```@docs
export_static
```

The simplest one, which also allows an interactive Revise based workflow is enabled by `interactive_server`:

```@docs
interactive_server
```

When exporting interactions defined within Julia not using Javascript, one can use, to cache all interactions:

```@docs
Bonito.record_states
```

# Deployment

Apps can be deployed in a wide variety of scenarios.

Lets start with a very simple example app and show how to deploy that App:

```@example 1
using Bonito
example_app = App(DOM.div("hello world"), title="hello world")
```

## Server

```julia
# Depending on your servers setup, you may need to listen on another port or URL
# But 0.0.0.0:80 is pretty standard for most server setups
port = 80
url = "0.0.0.0"
server = Bonito.Server(example_app, url, port)
```

Now, you should see the webpage at `http://0.0.0.0:80`.

### Proxy + Julia Hub

If the server is behind a proxy, you can set the proxy like this:

```@example 1
server = Bonito.Server(example_app, "0.0.0.0", 8080; proxy_url="https://my-domain.de/my-app");
# or set it later
# this can be handy for interactive use cases where one isn't sure which port is open, and let Bonito find a free port (which will then be different from the one created with, but is stored in `server.port`)
server.proxy_url = ".../$(server.port)"
```

You can also set the proxy_url to `"."` to use relative to the served page url.
This works well e.g. for accessing the webpage on a local network, or when serving it online with your own server.
This needs to support then establish the websocket connection via the same relative url (so if only the HTML is served via that URL, but not all requests are forwarded to the Bonito server, this won't work).

Bonito tries to do this for known environments like JuliaHub via `get_server()`.
This will find the most common proxy setup and return a started server:

```@example 1
server = Bonito.get_server()
# add a route to the server for root to point to our example app
route!(server, "/" => example_app)
```
The url which this site is now served on can be found via:

```@example 1
# Here in documenter, this will just return a localhost url
url_to_visit = online_url(server, "/")
```

Like this, one can also add multiple pages:
```@example 1
page_404 = App() do session, request
    return DOM.div("no page for $(request.target)")
end
# You can use string (paths), or a regex
route!(server, r".*" => page_404)
route!(server, "/my/nested/page" => App(DOM.div("nested")))
url_to_visit = online_url(server, "/my/nested/page")
```

### Secure HTTPS connections with SSL

If the boss insists your fancy webpage use the `https://` protocol, ask them
for the SSL certificate and key files, and then launch your Bonito App like
this:

```
using MbedTLS

sslconfig = MbedTLS.SSLConfig(<path-to-SSL-certificate-file>, <path-to-SSL-key-file>)
Bonito.Server(main, url, port, sslconfig=sslconfig)
```

### Logging requests

You want to see who accesses all of your hard work?  No problem!

```
using HTTP
access_log = HTTP.logfmt"[$time_iso8601] $remote_addr $request_uri"
Bonito.Server(main, url, port, access_log=access_log)
```

### nginx

If you need to re-route Bonito e.g. to host in parallel to PlutoSliderServer, you want a reverse-proxy like `nginx`. We did some testing with nginx and the following configuration worked for us:

```nginx
server {
    listen 8080;
    location /bonito/ {
        proxy_pass http://localhost:8081/;
        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "Upgrade";
        proxy_set_header Host $host;
    }
}
```

and the Bonito with:
```julia
    server = Server("127.0.0.1", 8081;proxy_url="https://www.abc.org/bonito/")
    route!(server,"/"=>app) # with app an Bonito app
    # close(server) # useful for debugging ;)
```
This would re-route `www.abc.org:8080/bonito/` to your local Bonito-Server.

If you get errors in your browser console relating to "GET", "MIME-TYPE"

1. First make sure that the URL of the assets is "correct", that is, there is no `//` somewhere in the domain, and in principle the client tries to find the correct target (`Server(...,verbose=1)` might help to see if requests arrive).
2. if the app shows up fine, but you get these errors (typically with `wss://` in the front, indicating some WebSocket issue), double check that all the slashes `/` in your configuration are set correct. That is all these 4 paths should have `/`'s at the end: `location /subfolder/`, `proxy_pass =.../`  `Server(...,proxy_url=".../")` and `route!(...,'/'=>app)`
3. If it still doesn't work, you might need to look into WebSocket forwarding - or you might have an intermediate reverse-proxy that blocks the WebSocket.

### Heroku

Deploying to Heroku with Bonito works pretty similar to this [blogpost](https://towardsdatascience.com/deploying-julia-projects-on-heroku-com-eb8da5248134).

```
mkdir my-app
cd my-app
julia --project=. -e 'using Pkg; Pkg.add("Bonito")' # and any other dependency
```

then create 2 files:

`app.jl`:
```julia
using Bonito
# The app you want to serve
#  Note: you can also add more pages with `route!(server, ...)` as explained aboce
my_app = App(DOM.div("hello world"))
port = parse(Int, ENV["PORT"])
# needs to match `heroku create - a example-app`,
# which we can ensure by using the env variable
# which is only available in review app, so one needs to fill this in manually for now
# https://devcenter.heroku.com/articles/github-integration-review-apps#injected-environment-variables
my_app_name = get(ENV, "HEROKU_APP_NAME", "example-app")
url = "https://$(my_app_name).herokuapp.com/"
wait(Bonito.Server(my_app, "0.0.0.0", port, proxy_url=url))
```

`Procfile`:
```
web: julia --project=. app.jl
```

and then to upload the app install the [heroku-cli](https://devcenter.heroku.com/articles/heroku-cli) and run as explained in the [heroku git deploy section](https://devcenter.heroku.com/articles/git):

```
$ cd my-app
$ git init
$ git add .
$ git commit -m "first commit"
$ heroku create -a example-app
$ heroku git:remote -a example-app
```
Which, after showing you the install logs, should print out the url to visit in the end.
You can see the full example here:

https://github.com/SimonDanisch/Bonito-heroku

## Terminal

If no HTML display is found in the Julia display stack, Bonito calls `Bonito.enable_browser_display()` in the `__init__` function.
This adds a display, that opens a browser window to display the app.
The loading of the `BrowserDisplay` happen in any kind of environment without html display, so this should also work in any kind of terminal or when evaluating a script.

```julia
> using Bonito
> example_app # just let the display system display it in a browser window
```

## VScode

VScode with enabled `Plot Pane` will display any `Bonito.App` in the HTML plotpane:
![](vscode.png)

If VSCode is used in a remote setting, VSCode may automatically forward the port so the plot pane can work out of the box.
If this doesn't happen for some reason (it has been reported to not always work), you can manually forward it via the command menu (ctr+shift+p) and `forward a port`, or just select the PORTS tab in the terminal view.


## Notebooks

Most common notebook systems should work out of the box.

### IJulia
![](ijulia.png)

### Jupyterlab
![](jupyterlab.png)

### Pluto
![](pluto.png)

## Electron

```julia
using Electron, Bonito
# Needs to be called after loading Electron
Bonito.use_electron_display()
# display(...) can be skipped in e.g. VSCode with disabled plotpane
display(example_app)
```
![](electron.png)

!!! note
    By default, `Bonito` will create the Electron window without showing the Developer
    Tools panel. You can control this behavior at
    window creation using the `devtools` keyword arg:
    ```
    display = Bonito.use_electron_display(devtools = true)
    ```
    Alternatively, you can toggle the Developer Tools at any later time using:
    ```
    Electron.toggle_devtools(display.window)
    ```

## Documenter

Bonito works in Documenter without additional setup.
But, one always needs to include a block like this before any other code block displaying Bonito Apps:

```julia
using Bonito
Page()
```
This is needed, since Bonito structures the dependencies and state per Page, which needs to be unique per documentation page.
One can use the Bonito documentation source to see an example.

## Static export

Bonito works also to create static sites, by using `Routes` and `export_static`.
```julia
routes = Routes(
    "/" => App(index_func, title="Makie"),
    "/team" => App(team_func, title="Team"),
    "/contact" => App(contact_func, title="Contact"),
    "/support" => App(support_func, title="Support")
)
Bonito.export_static("html/folder", routes)
```

!!! tip "Connection Indicator"
    If you enable the [connection indicator](@ref "Connection Indicator"), it will display a gray color in static exports to indicate that no Julia server connection is available.

Please visit [Static Sites](@ref) for more details.

## Anything else

Bonito overloads the `display`/`show` stack for the mime `"text/html"` so any other Software which is able to display html in Julia should work with Bonito.
If a use case is not supported, please open an issue.
One can also always directly call:
```julia
html_source = sprint(io-> show(io, MIME"text/html"(), example_app))
```
Do get the html source code as a string (or just write it to the io).

# Plotting

All plotting frameworks overloading the Julia display system should work out of the box and all Javascript plotting libraries should be easy to integrate!
The following example shows how to integrate popular libraries like Makie, Plotly and Gadfly.

```@example 1
using Bonito
using WGLMakie
import WGLMakie as W
import Gadfly as G
import PlotlyLight as PL

Page() # required for multi cell output inside documenter

function makie_plot()
    N = 10
    function xy_data(x, y)
        r = sqrt(x^2 + y^2)
        r == 0.0 ? 1.0f0 : (sin(r) / r)
    end
    l = range(-10, stop=10, length=N)
    z = Float32[xy_data(x, y) for x in l, y in l]
    W.surface(
        -1 .. 1, -1 .. 1, z,
        colormap=:Spectral,
        figure=(; size=(300, 300))
    )
end

# As far as I can tell, PlotlyLight doesn't handle require inside documenter correctly
# So we just use Bonito to do it correctly via `Asset`:
const Plotly = Bonito.Asset(PL.plotly.url)

function Bonito.jsrender(session::Session, plot::PL.Plot)
    # Pretty much copied from the PlotlyLight source to create the JS + div for creating the plot:
    div = DOM.div(style="width: 300px;height: 300px;")
    src = js"""
        Plotly.newPlot($(div), $(plot.data), $(plot.layout), $(plot.config))
    """
    return Bonito.jsrender(session, DOM.div(Plotly, div, src))
end

App() do
    p = PL.plot(x = 1:20, y = cumsum(randn(20)), type="scatter", mode="lines+markers")
    G.set_default_plot_size(300G.px, 300G.px)
    gp = G.plot([sin, cos], 0, 2pi)
    # The plots already leave lots of white space
    PCard(p) = Card(p, padding="0px", margin="0px")
    return Grid(
        PCard(gp),
        PCard(p),
        PCard(makie_plot());
        columns="repeat(auto-fit, minmax(300px, 1fr))", justify_items="center")
end
```

# Api

## Public Functions


```@autodocs
Modules = [Bonito]
Order   = [:module, :constant, :type, :function, :macro]
Public  = true
Private = false
```

## Private Functions

```@autodocs
Modules = [Bonito]
Order   = [:module, :constant, :type, :function, :macro]
Public  = false
Private = true
```

```@autodocs
Modules = [Bonito.HTTPServer]
Order   = [:module, :constant, :type, :function, :macro]
Public  = true
Private = true
```

# Layouting

The main layouting primitive Bonito offers is `Grid`, `Column` and `Row`.
They are all based on css `display: grid` and Bonito offers a small convenience wrapper around it.

We recommend reading through the great introduction to Styles grids by Josh Comeau: [interactive guide to grid](https://www.joshwcomeau.com/css/interactive-guide-to-grid), for a better understanding of how grids work. It's recommended to read this before following this tutorial, since the examples are styled much nicer and explain everything in much greater detail.

To easier apply the tutorial to Bonito, we ported all the examples of the tutorial, while only describing them with the bare minimum. To get the full picture, please refer to the linked, original tutorial!

Let's start with the docstring for `Grid`:

```@docs
Grid
```

It pretty much just sets the css attributes to some defaults, but everything can be overwritten or extended by passing your own `style=Styles(...)` object.
All Styles objects inside one App will be merged into a single stylesheet, so using many grids with the same keyword arguments will only generate one entry into the global stylesheet. You can read more about this in the styling section.

There's also `Row` and `Col` which uses `Grid` under the hood:

```@docs
Row
Col
```

```@setup 1
using Bonito
Page()
```

## Implicit Grids

If we don't specify any attributes for the `Grid`, the default will be one dynamic column, where every item gets their own row:

```@example 1


DemoCard(content=DOM.div(); style=Styles(), attributes...) = Card(content; backgroundcolor=:silver, border_radius="2px", style=Styles(style, "color" => :white),attributes...)


App() do sess
    s = Bonito.Slider(1:5)
    cards = map(s.value) do n
        cards = [DemoCard(height="50px", width="300px") for i in 1:n]
        return Grid(cards;)
    end
    return Bonito.record_states(sess, Grid(s, cards))
end
```

If we specify a height, while not specifying a height for the elements, the space will be partitioned for the n children:

```@example 1
App() do sess
    s = Bonito.Slider(1:5)
    cards = map(s.value) do n
        cards = [DemoCard(width="300px") for i in 1:n]
        Grid(cards; height="300px")
    end
    return Bonito.record_states(sess, Grid(s, cards))
end
```

To introduce new columns, we can specify a width for each column via the `column` keyword, which supports any css unit:

```@example 1
App() do
    grid = Grid(DemoCard(), DemoCard();
        height="300px", columns="25% 75%")
    return grid
end
```

Grid also introduced a new css unit namely `fr`, which represents the fraction of the leftover space in the grid container.

To see what that means, the below example shows how the percent based unit will shrink proportionally, while `fr` divides the space more evenly and can take the size of the content into it's constraint solver:

```@example 1
App() do sess
    container_width = Bonito.Slider(5:0.1:100)
    container_width[] = 100
    imstyle = Styles(
        "display" => :block, "position" => :relative, "width" => "100px",
        "max-width" => :none # needs to be set so it's not overwritten by others
    )
    img = DOM.img(; src="https://docs.makie.org/stable/logo.svg", style=imstyle)
    style = Styles("position" => :relative, "display" => :flex, "justify-content" => :center, "align-items" => :center)


    function example_grid(cols)
        grid = Grid(DemoCard(img; style=style), DemoCard(DOM.div(); style=style); columns=cols)
        container = DOM.div(grid; style=Styles("height" => "200px", "width" => "500px"))
        return Grid(container; rows="1fr", justify_content="center"), container
    end
    pgrid, p1 = example_grid("25% 75%")
    frgrid, p2 = example_grid("1fr 3fr")
    grid_percent = DOM.div(Grid(pgrid; rows="1fr"))
    grid_fr = DOM.div(Grid(frgrid; rows="1fr"))


    onjs(sess, container_width.value, js"w=> {$(p1).style.width = (5 * w) + 'px';}")
    onjs(sess, container_width.value, js"w=> {$(p2).style.width = (5 * w) + 'px';}")
    title_percent = DOM.h2("Grid(...; columns=\"25% 75%\")")
    title_fr = DOM.h2("Grid(...; columns=\"1fr 3fr\")")
    return Grid(container_width, title_percent, grid_percent, title_fr, grid_fr; columns="1fr")
end
```

Now, what happens if we add more then 2 items to a Grid with 2 columns?

```@example 1
# Little helper to create a Card with centered content
centered(c; style=Styles(), kw...) = DemoCard(Centered(DOM.h4(c; style=Styles("color" => :white))); style=style, kw...)


App() do
    cards = [centered(i) for i in 1:3]
    grid = Grid(cards...; columns="1fr 3fr")
    return DOM.div(grid; style=Styles("margin" => "20px"))
end
```

Specifying the size of the rows works exactly the same as with `columns`:

```@example 1
App() do
    cards = [centered(i) for i in 1:4]
    grid = Grid(cards...; columns="1fr 3fr", rows="5rem 1fr")
    return DOM.div(grid; style=Styles("width" => "400px", "height" => "300px", "margin" => "20px"))
end
```

Now, if we want to do something with lots of rows/columns, e.g. a calendar, it may get tiring to write those out, which is why css offers the `repeat` function:

```@example 1
App() do
    cards = [centered(i) for i in 1:31]
    grid = Grid(cards...; columns="repeat(7, 1fr)")
    return DOM.div(grid; style=Styles("width" => "400px", "margin" => "5px"))
end
```

## Assigning children

Children can be assigned slots in the layout explicitly, and it's also possible to assign them to multiple slots.
The css syntax for this is:

```julia
start_column = 1
end_column = 3
start_row = 1
end_row = 3


style = Styles(
    "grid-column" => "$start_column / $end_column",
    "grid-row" => "$start_row / $end_row"
)
child = DOM.div(style=style) # assign child from slot 1-2
```

To illustrate how this works, here is an interactive app where you can select the slots in the grid, and see the corresponding grid/column assignments:

```@example 1
function centered2d(i, j;)
    return Card(Centered("($i, $j)"; dataCol="$i,$j", style=Styles("user-select" => :none)))
end

App() do
    cards = [centered2d(i, j) for i in 1:4 for j in 1:4]


    hover_style = Styles(
        "background-color" => :blue,
        "opacity" => 0.2,
        "z-index" => 1,
        "display" => :none,
        "user-select" => :none,
    )


    hover = DOM.div(; style=hover_style)


    grid_style = Styles("position" => :absolute, "top" => 0, "left" => 0)
    size = "300px"
    background_grid = Grid(cards...; columns="repeat(4, 1fr)", gap="0px",
        style=grid_style, height=size, width=size)


    rows = [DOM.div() for i in 1:15]


    selected_grid = Grid(hover, rows...; columns="repeat(4, 1fr)", gap="0px",
        style=grid_style, height=size, width=size)


    style_display = centered("Styles(...)")


    hover_js = js"""
        const hover = $(hover);
        const grid = $(selected_grid);
        const style_display = $(style_display);
        const h2_node = style_display.children[0].children[0];


        let is_dragging = false;
        let start_position = null;
        function get_element(e) {
            const elements = document.elementsFromPoint(e.clientX, e.clientY);
            for (let i = 0; i < elements.length; i++) {
                const element = elements[i];
                if (element.getAttribute('data-col')) {
                    return element;
                }
            }
            return
        }


        function handle_click(current) {
            // Check if the current element is a child of the container
            const index = current.getAttribute('data-col')
            if (index) {
                const start = start_position.split(",").map(x=> parseInt(x))
                const end = index.split(",").map(x=> parseInt(x))


                const [start_row, end_row] = [start[0], end[0]].sort()
                const [start_col, end_col] = [start[1], end[1]].sort()
                const row = (start_row) + " / " + (end_row + 1)
                const col = (start_col) + " / " + (end_col + 1)
                hover.style["grid-row"] = row
                hover.style["grid-column"] = col
                const nelems = 16 - ((end_row - start_row+ 1) * (end_col - start_col+ 1))
                for (let i = 0; i < grid.children.length; i++) {
                    console.log(i)
                    const child = grid.children[i];
                    if (child == hover) {
                        continue
                    }
                    child.style.display = nelems >= i ? "block" : "none";
                }


                h2_node.innerText = 'Styles(\n\"grid-row\" => \"' + row + '\",\n \"grid-column\" => \"' + col + '\"\n)';
            }
        }


        grid.addEventListener('mousedown', (e) => {
            if (!hover) {
                return
            }
            is_dragging = true;
            const current = get_element(e);
            const index = current.getAttribute('data-col')
            if (!index) {
                return;
            }
            start_position = index
            hover.style.display = "block"; // unhide hover element
            handle_click(current);
        });


        grid.addEventListener('mousemove', (e) => {
            if (!is_dragging) return;
            const current = get_element(e);
            handle_click(current);
        });


        document.addEventListener('mouseup', () => {
            is_dragging = false;
        });


    """
    grids = DOM.div(background_grid, selected_grid, hover_js; style=Styles("position" => :relative, "height" => size))


    return Grid(style_display, grids; columns="1fr 2fr", width="100%")
end
```

## Grid areas

We can now easily create complex layouts like this:

```@example 1
App() do


    sidebar = DemoCard(
        "SIDEBAR",
        style = Styles(
            "grid-column" =>  "1",
            "grid-row" =>  "1 / 3",
        )
    )


    header = DemoCard(
        "HEADER",
        style = Styles(
            "grid-column" =>  "2",
            "grid-row" =>  "1",
        )
    )


    main = DemoCard(
        "MAIN",
        style = Styles(
            "grid-column" =>  "2",
            "grid-row" =>  "2",
        )
    )


    grid = Grid(
        sidebar, header, main,
        columns = "2fr 5fr",
        rows = "50px 1fr"
    )
    return DOM.div(grid; style=Styles("height" => "600px", "margin" => "20px", "position" => :relative))
end
```

With `areas`, in css `grid-template-areas` this can be made even simpler:

```@example 1
App() do


    sidebar = DemoCard(
        "SIDEBAR",
        style = Styles("grid-area" =>  "sidebar")
    )


    header = DemoCard(
        "HEADER",
        style = Styles("grid-area" =>  "header")
    )


    main = DemoCard(
        "MAIN",
        style = Styles("grid-area" =>  "main")
    )


    grid = Grid(
        sidebar, header, main,
        columns = "2fr 5fr",
        rows = "50px 1fr",
        areas = """
            'sidebar header'
            'sidebar main';
        """
    )
    return DOM.div(grid; style=Styles("height" => "600px", "margin" => "20px", "position" => :relative))
end
```

The syntax is quite similar to Julia's matrix syntax, just wrapping all rows into `'...row...'`!
To span multiple rows or columns, the name can be repeated multiple times.

## Alignment

```@example 1
App() do
    grid = Grid(
        DemoCard(), DemoCard(),
        columns = "90px 90px",
    )
    return DOM.div(grid; style=Styles("height" => "200px", "margin" => "20px", "position" => :relative, "background-color" => "#F88379", "padding" => "5px"))
end
```

```@example 1
App() do session
    justification = Bonito.Dropdown(["space-evenly", "center", "end", "space-between", "space-around", "space-evenly"], style=Styles("width" => "200px"))


    grid = Grid(
        DemoCard(), DemoCard(),
        columns = "90px 90px"
    )
    onjs(session, justification.option_index, js""" (idx) => {
        grid = $(grid)
        grid.style["justify-content"] = $(justification.options[])[idx-1]
    }""")
    area_style = Styles("height" => "200px", "width" => "600px", "margin" => "20px", "position" => :relative, "background-color" => "#F88379", "padding" => "5px")
    grid_area = DOM.div(grid; style=area_style)
    return Grid(justification, grid_area; justify_items="center")
end
```

```@example 1
App() do session
    content = Bonito.Dropdown(["space-evenly", "center", "end", "space-between", "space-around"])
    items = Bonito.Dropdown(["stretch", "start", "center", "end"])
    grid = Grid(
        DemoCard(), DemoCard(),
        DemoCard(), DemoCard(),
        columns = "90px 90px"
    )
    onjs(session, content.option_index, js""" (idx) => {
        grid = $(grid)
        const val = $(content.options[])[idx-1]
        grid.style["justify-content"] = val
    }""")
    onjs(session, items.option_index, js""" (idx) => {
        grid = $(grid)
        const val = $(items.options[])[idx-1]
        grid.style["justify-items"] = val
    }""")
    grid_area = DOM.div(grid; style=Styles("height" => "200px", "width" => "600px", "margin" => "20px", "position" => :relative, "background-color" => "#F88379", "padding" => "5px",
        "grid-column" => "1 / 3", "grid-row" => "2"))
    return Grid(content, items, grid_area; width="500px", justify_items="space-around")
end
```

```@example 1
App() do session
    content = Bonito.Dropdown(["space-evenly", "center", "end", "space-between", "space-around"])
    items = Bonito.Dropdown(["stretch", "start", "center", "end"])
    align_content = Bonito.Dropdown(["space-evenly", "center", "end", "space-between", "space-around"])
    align_items = Bonito.Dropdown(["stretch", "start", "center", "end"])
    grid_style = Styles("position" => :absolute, "top" => 0, "left" => 0)
    grid = Grid(
        centered("One"), centered("Two"),
        centered("Three"), centered("Four"),
        columns = "100px 100px",
        rows = "100px 100px",
        style=grid_style
    )


    grid_col() = DOM.div(style=Styles("border" => "2px dashed white", "width"=>"100px"))
    grid_row() = DOM.div(style=Styles("border" => "2px dashed white", "height"=>"100px"))


    shadow_cols = Grid(
        grid_col(), grid_col(),
        columns = "100px 100px",
        style=grid_style
    )
    shadow_rows = Grid(
        grid_row(), grid_row(),
        rows = "100px 100px",
        style=grid_style
    )


    onjs(session, content.option_index, js""" (idx) => {
        const grids = [$(grid), $(shadow_cols)]
        const val = $(content.options[])[idx-1]
        grids.forEach(x=> x.style["justify-content"] = val)
    }""")


    onjs(session, items.option_index, js""" (idx) => {
        const grids = [$(grid), $(shadow_cols)]
        const val = $(items.options[])[idx-1]
        grids.forEach(x=> x.style["justify-items"] = val)
    }""")


    onjs(session, align_content.option_index, js""" (idx) => {
        const grids = [$(grid), $(shadow_rows)]
        const val = $(align_content.options[])[idx-1]
        grids.forEach(x=> x.style["align-content"] = val)
    }""")


    onjs(session, align_items.option_index, js""" (idx) => {
        const grids = [$(grid), $(shadow_rows)]
        const val = $(align_items.options[])[idx-1]
        grids.forEach(x=> x.style["align-items"] = val)
    }""")


    grid_area = DOM.div(grid, shadow_cols, shadow_rows; style=Styles(
        "height" => "400px", "width" => "400px",
        "margin" => "20px",
        "padding" => "5px",
        "position" => :relative,
        "background-color" => "#F88379",
        "grid-column" => "1 / 3", "grid-row" => "4"))


    text(t) = DOM.div(t; style=Styles("font-size" => "1.3rem", "font-weight" => "bold"))
    final_grid = Grid(
        text("Row Alignment"), text("Col Justification"),
        align_content, content,
        align_items, items,
        grid_area;
        rows = "2rem 1rem 2rem 1fr",
        align_items = "center",
        justify_items="begin", justify_content="center",
        width="400px")


    return DOM.div(final_grid, style=Styles("padding" => "20px"))
end
```

# Widgets

```@setup 1
using Bonito
Page()
```

## All Available widgets

```@docs; canonical=false
Button
```

```@example 1
include_string(@__MODULE__, Bonito.BUTTON_EXAMPLE) # hide
```

```@docs; canonical=false
TextField
```
```@example 1
include_string(@__MODULE__, Bonito.TEXTFIELD_EXAMPLE) # hide
```

```@docs; canonical=false
NumberInput
```
```@example 1
include_string(@__MODULE__, Bonito.NUMBERINPUT_EXAMPLE) # hide
```

```@docs; canonical=false
Dropdown
```
```@example 1
include_string(@__MODULE__, Bonito.DROPDOWN_EXAMPLE) # hide
```

```@docs
Card
```
```@example 1
include_string(@__MODULE__, Bonito.CARD_EXAMPLE) # hide
```

```@docs
StylableSlider
```
```@example 1
include_string(@__MODULE__, Bonito.STYLABLE_SLIDER_EXAMPLE) # hide
```

```@docs; canonical=false
Bonito.Table
```

The `Table` widget provides an interactive way to display tabular data that conforms to the Tables.jl interface.
It supports custom styling, interactive sorting, and flexible cell rendering.

### Basic Usage

```@example 1

# Create sample data using named tuples
data = [
    (name="Alice", age=25, score=95.5),
    (name="Bob", age=30, score=87.2),
    (name="Charlie", age=22, score=92.8)
]

# Basic table
basic_table = Bonito.Table(data)
App(basic_table)
```

### Custom Cell Styling

You can provide custom class and style callbacks to control the appearance of individual cells:

```@example 1
# Color coding function based on values
function score_class_callback(table, row, col, val)
    # Color the score column based on value
    if col == 3 && isa(val, Number)  # Score column
        if val >= 90
            return "cell-good"
        elseif val >= 80
            return "cell-neutral"
        else
            return "cell-bad"
        end
    end
    return "cell-default"
end

# Style callback for additional formatting
function score_style_callback(table, row, col, val)
    if col == 3 && isa(val, Number)  # Score column
        return "font-weight: bold;"
    end
    return ""
end

styled_table = Bonito.Table(data;
                    class_callback=score_class_callback,
                    style_callback=score_style_callback)
App(styled_table)
```

### Sorting Options

Tables support interactive sorting by clicking on headers (column sorting) or first cells (row sorting):

```@example 1
# Table with only column sorting enabled
column_sort_table = Bonito.Table(data;
                         allow_row_sorting=false,
                         allow_column_sorting=true)

# Table with all sorting disabled
no_sort_table = Bonito.Table(data;
                     allow_row_sorting=false,
                     allow_column_sorting=false)
App() do
    DOM.div(column_sort_table, no_sort_table)
end
```

### Working with DataFrames

The Table widget works seamlessly with DataFrames and other Tables.jl-compatible structures:

```@example 1
using DataFrames

df = DataFrame(
    Product = ["Laptop", "Mouse", "Keyboard", "Monitor"],
    Price = [999.99, 29.99, 79.99, 299.99],
    Stock = [15, 120, 45, 8],
    Available = [true, true, false, true]
)

# Custom formatter for currency and boolean values
function product_class_callback(table, row, col, val)
    if col == 2  # Price column
        return val > 100 ? "cell-neutral" : "cell-good"
    elseif col == 4  # Available column
        return val ? "cell-good" : "cell-bad"
    end
    return "cell-default"
end

product_table = Bonito.Table(df; class_callback=product_class_callback)
App(product_table)
```

### Advanced Example: Financial Data

```@example 1
# Financial data with multiple metrics
financial_data = [
    (company="TechCorp", revenue=1.2e6, profit_margin=0.15, employees=150),
    (company="DataInc", revenue=2.8e6, profit_margin=0.08, employees=300),
    (company="CloudSys", revenue=0.9e6, profit_margin=0.22, employees=85),
    (company="WebFlow", revenue=1.8e6, profit_margin=0.12, employees=220)
]

function financial_class_callback(table, row, col, val)
    if col == 2  # Revenue column
        return val > 1.5e6 ? "cell-good" : "cell-neutral"
    elseif col == 3  # Profit margin column
        if val > 0.15
            return "cell-good"
        elseif val > 0.10
            return "cell-neutral"
        else
            return "cell-bad"
        end
    end
    return "cell-default"
end

function financial_style_callback(table, row, col, val)
    if col == 3  # Profit margin column
        return "font-family: monospace;"
    end
    return ""
end

financial_table = Bonito.Table(financial_data;
                       class_callback=financial_class_callback,
                       style_callback=financial_style_callback,
                       class="financial-data")
App(financial_table)
```


## Widgets in Layouts


There are a few helpers to e.g. put a label next to a widget:


```@docs
Labeled
```
```@example 1
include_string(@__MODULE__, Bonito.LABELED_EXAMPLE) # hide
```

To create more complex layouts, one should use e.g. [`Grid`](@ref), and visit the [Layouting](@ref) tutorial.


```@example 1

App() do session
    s = Bonito.StylableSlider(0:10;)
    d = Dropdown(["a", "b", "c"])
    ni = NumberInput(10.0)
    ti = Bonito.TextField("helo")
    button = Button("click")
    clicks = Observable(0)
    on(session, button.value) do bool
        clicks[] = clicks[] + 1
    end
    return Card(Grid(
            button, Bonito.Label(clicks),
            s, Bonito.Label(s.value),
            d, Bonito.Label(d.value),
            ni, Bonito.Label(ni.value),
            ti, Bonito.Label(ti.value);
            columns="1fr min-content",
            justify_content="begin",
            align_items="center",
        ); width="300px",)
end
```

## Editor

This editor works in pure Javascript, so feel free to try out editing the Javascript and clicking `eval` to see how the output changes.
In `Bonito/examples/editor.jl`, you will find a version that works with Julia code, but that requires a running Julia server of course.


```@example 1
using Bonito, Observables
src = """
(() => {
    const canvas = document.createElement("canvas");
    const context = canvas.getContext('2d');
    const width = 500
    const height = 400
    canvas.width = width;
    canvas.height = height;
    const gradient = context.createRadialGradient(200, 200, 0, 200, 200, 200);
    gradient.addColorStop("0", "magenta");
    gradient.addColorStop(".25", "blue");
    gradient.addColorStop(".50", "green");
    gradient.addColorStop(".75", "yellow");
    gradient.addColorStop("1.0", "red");
    context.fillStyle = gradient;
    context.fillRect(0, 0, width, height);
    return canvas;
})();
"""
App() do session::Session
    editor = CodeEditor("javascript"; initial_source=src, width=800, height=300)
    eval_button = Button("eval")
    output = DOM.div(DOM.span())
    Bonito.onjs(session, eval_button.value, js"""function (click){
        const js_src = $(editor.onchange).value;
        const result = new Function("return " + (js_src))()
        let dom;
        if (typeof result === 'object' && result.nodeName) {
            dom = result
        } else {
            const span = document.createElement("span")
            span.innerText = result;
            dom = span
        }
        Bonito.update_or_replace($(output), dom, false);
        return
    }
    """)
    notify(eval_button.value)
    return DOM.div(editor, eval_button, output)
end
```

## Tailwinddashboard

[`Styles`](@ref) is preferred to style components, but Bonito also includes some [Tailwind](https://tailwindcss.com/) based components.
They're from before `Styles` and will likely get removed in the future.


```@example 1
using Bonito
import Bonito.TailwindDashboard as D

function range_slider(orientation)
    range_slider = RangeSlider(1:100; value=[10, 80])
    range_slider.tooltips[] = true
    range_slider.ticks[] = Dict(
        "mode" => "range",
        "density" => 3
    )
    range_slider.orientation[] = orientation
    return range_slider
end

App() do
    button = D.Button("click")
    textfield = D.TextField("type in your text")
    numberinput = D.NumberInput(0.0)
    file_input = D.FileInput()
    on(file_input.value) do file
        @show file
    end
    slider = D.Slider("Test", 1:5)

    checkbox = D.Checkbox("check this", true)
    table = Bonito.Table([(a=22, b=33, c=44), (a=22, b=33, c=44)])

    source = """
    function test(a, b)
        return a + b
    end
    """
    editor = CodeEditor("julia"; initial_source=source, width=250, height=200, scrollPastEnd=false)
    dropdown = D.Dropdown("chose", ["option 1", "option 2", "option 3"])

    vrange_slider = range_slider(Bonito.WidgetsBase.vertical)

    hrange_slider = range_slider(Bonito.WidgetsBase.horizontal)


    return DOM.div(
        D.Card.([
            D.FlexRow(
                D.Card(D.FlexCol(
                    button,
                    textfield,
                    numberinput,
                    dropdown,
                    file_input,
                    slider,
                    checkbox,
                    class="items-start"
                )),
                D.Card(D.FlexCol(
                    D.Card(DOM.div(vrange_slider; style="height: 200px; padding: 1px 50px")),
                    D.Card(DOM.div(hrange_slider; style="width: 200px; padding: 50px 1px"),
                    )),
                )),
            D.FlexRow(
                D.Card.([

                    D.Card(table; class="w-64")
                    editor
                ])
            ),
        ])...
    )
end
```

# Interactions

Animations in Bonito are done via Observables.jl, much like it's the case for Makie.jl, so the same docs apply:

* [observables](https://docs.makie.org/stable/documentation/nodes/index.html)
* [animation](https://docs.makie.org/stable/documentation/animation/index.html)

But lets quickly get started with a Bonito specific example:

```@setup 1
using Bonito
Page()
```

```@example 1
App() do session
    s = Slider(1:3)
    value = map(s.value) do x
        return x ^ 2
    end
    # record_states captures widget interactions for static HTML export
    # This allows the slider to remain interactive even without a Julia backend!
    return Bonito.record_states(session, DOM.div(s, value))
end
```

The `s.value` is an `Observable` which can be `mapp'ed` to take on new values, and one can insert observables as an input to `DOM.tag` or as any attribute.
The value of the `observable` will be rendered via `jssrender(session, observable[])`, and then updated whenever the value changes.
So anything that supports being inserted into the `DOM` can be inside an observable, and the fallback is to use the display system (so plots etc. work as well).
This way, one can also return `DOM` elements as the result of an observable:

```@example 1
App() do session
    s = Slider(1:3)
    # use map!(result_observable, ...)
    # To use any as the result type, otherwise you can't return
    # different types from the map callback
    value = map!(Observable{Any}(), s.value) do x
        if x == 1
            return DOM.h1("hello from slider: $(x)")
        elseif x == 2
            return DOM.img(src="https://docs.makie.org/stable/logo.svg", width="200px")
        else
            return x^2
        end
    end
    return Bonito.record_states(session, DOM.div(s, value))
end
```

In other words, the whole app can just be one big observable:

```@example 1
import Bonito.TailwindDashboard as D
App() do session
    s = D.Slider("Slider: ", 1:3)
    checkbox = D.Checkbox("Chose:", true)
    menu = D.Dropdown("Menu: ", [sin, tan, cos])
    dependent = map(checkbox.widget.value, s.widget.value, menu.widget.value) do args...
        D.FlexCol(DOM.div.(args)...)
    end
    return Bonito.record_states(session, D.FlexRow(
        D.Card(D.FlexCol(checkbox, s, menu)),
        D.Card(D.FlexCol(D.Title("Independent (supported)"), checkbox.value, s.value, menu.value)),
        D.Card(D.FlexCol(D.Title("Dependent (not supported)"), dependent))
    ))
end
```

## Understanding `record_states` Limitations

The `record_states` function is designed to capture widget interactions for static HTML export. However, it has an important limitation: **only independent widget states are recorded**.

In the example above:
- **Independent widgets work**: The slider, checkbox, and dropdown values update correctly because they're displayed directly
- **Dependent observables don't work**: The `dependent` observable that combines multiple widget values won't update correctly in the exported HTML

This happens because `record_states` records each widget's states independently to avoid exponential growth in file size. For complex interactions, consider using JavaScript-based solutions (shown later in this guide).

## Creating Interactive Examples

Despite these limitations, you can still create engaging interactive examples:

```@example 1
import Bonito.TailwindDashboard as D

function create_svg(sl_nsamples, sl_sample_step, sl_phase, sl_radii, color)
    width, height = 900, 300
    cxs_unscaled = [i*sl_sample_step + sl_phase for i in 1:sl_nsamples]
    cys = sin.(cxs_unscaled) .* height/3 .+ height/2
    cxs = cxs_unscaled .* width/4pi
    rr = sl_radii
    # DOM.div/svg/etc is just a convenience in Bonito for using Hyperscript, but circle isn't wrapped like that yet
    geom = [SVG.circle(cx=cxs[i], cy=cys[i], r=rr, fill=color(i)) for i in 1:sl_nsamples[]]
    return SVG.svg(SVG.g(geom...);
        width=width, height=height
    )
end

app = App() do session
    colors = ["black", "gray", "silver", "maroon", "red", "olive", "yellow", "green", "lime", "teal", "aqua", "navy", "blue", "purple", "fuchsia"]
    color(i) = colors[i%length(colors)+1]
    sl_nsamples = D.Slider("nsamples", 1:200, value=100)
    sl_sample_step = D.Slider("sample step", 0.01:0.01:1.0, value=0.1)
    sl_phase = D.Slider("phase", 0.0:0.1:6.0, value=0.0)
    sl_radii = D.Slider("radii", 0.1:0.1:60, value=10.0)
    svg = map(create_svg, sl_nsamples.value, sl_sample_step.value, sl_phase.value, sl_radii.value, color)
    return DOM.div(D.FlexRow(D.FlexCol(sl_nsamples, sl_sample_step, sl_phase, sl_radii), svg))
end
```

As you notice, when exporting this example to the docs which get statically hosted, all interactions requiring Julia cease to exist.
One way to create interactive examples that stay active is to move the parts that need Julia to Javascript:

```@example 1
app = App() do session
    colors = ["black", "gray", "silver", "maroon", "red", "olive", "yellow", "green", "lime", "teal", "aqua", "navy", "blue", "purple", "fuchsia"]
    nsamples = D.Slider("nsamples", 1:200, value=100)
    nsamples.widget[] = 100
    sample_step = D.Slider("sample step", 0.01:0.01:1.0, value=0.1)
    sample_step.widget[] = 0.1
    phase = D.Slider("phase", 0.0:0.1:6.0, value=0.0)
    radii = D.Slider("radii", 0.1:0.1:60, value=10.0)
    radii.widget[] = 10
    svg = DOM.div()
    evaljs(session, js"""
        const [width, height] = [900, 300]
        const colors = $(colors)
        const observables = $([nsamples.value, sample_step.value, phase.value, radii.value])
        function update_svg(args) {
            const [nsamples, sample_step, phase, radii] = args;
            const svg = (tag, attr) => {
                const el = document.createElementNS('http://www.w3.org/2000/svg', tag);
                for (const key in attr) {
                    el.setAttributeNS(null, key, attr[key]);
                }
                return el
            }
            const color = (i) => colors[i % colors.length]
            const svg_node = svg('svg', {width: width, height: height});
            for (let i=0; i<nsamples; i++) {
                const cxs_unscaled = (i + 1) * sample_step + phase;
                const cys = Math.sin(cxs_unscaled) * (height / 3.0) + (height / 2.0);
                const cxs = cxs_unscaled * width / (4 * Math.PI);
                const circle = svg('circle', {cx: cxs, cy: cys, r: radii, fill: color(i)});
                svg_node.appendChild(circle);
            }
            $(svg).replaceChildren(svg_node);
        }
        Bonito.onany(observables, update_svg)
        update_svg(observables.map(x=> x.value))
        """)
    return DOM.div(D.FlexRow(D.FlexCol(nsamples, sample_step, phase, radii), svg))
end
```

This works, because the Javascript side of Bonito, will still update the observables in Javascript (which are mirrored from Julia), and therefore keep working without a running Julia process.
You can use `js_observable.on(value=> ....)` and `Bonito.onany(array_of_js_observables, values=> ...)` to create interactions, pretty similar to how you would work with Observables in Julia.

# App

The `App` type is the main entry point for creating Bonito applications. It wraps your content and handles the connection between Julia and the browser.

## Basic Usage

```julia
using Bonito

# Simple app with static content
app = App(DOM.div("Hello World"))

# App with session access
app = App() do session::Session
    button = Button("Click me")
    on(button.value) do _
        println("Button clicked!")
    end
    return button
end

# App with request access (useful for routing)
app = App() do session::Session, request::HTTP.Request
    path = request.target
    return DOM.div("You requested: $path")
end
```

## App Options

The `App` constructor accepts the following keyword arguments:

```julia
App(handler;
    title="Bonito App",  # Browser tab title
    indicator=nothing    # Connection status indicator (nothing by default)
)
```

## Connection Indicator

Bonito provides an optional LED-like indicator that can be displayed in the top-right corner to show the connection status to the Julia server:

- **Green**: Connected to the server
- **Yellow**: Connecting or reconnecting
- **Red**: Disconnected from the server
- **Gray**: No connection mode (static export)

### Enabling the Indicator

To show the connection indicator, pass a `ConnectionIndicator()` to your App:

```julia
App(; indicator=ConnectionIndicator()) do
    DOM.h1("App with connection indicator")
end
```

### Customizing Colors and Size

```julia
App(; indicator=ConnectionIndicator(
    connected_color="lime",
    connecting_color="orange",
    disconnected_color="red",
    no_connection_color="gray",
    size=15  # pixels
)) do
    DOM.h1("Custom indicator colors")
end
```

!!! note "Browser Display"
    When using browser display (e.g., displaying apps in VS Code or via `Server`), the indicator is rendered on the root session which persists across app updates. Changes to the `indicator` argument will not take effect until you refresh the browser page to create a new root session.

### Customizing Position

By default, the indicator is positioned in the top-right corner. You can change this:

```julia
# Bottom-left corner
App(; indicator=ConnectionIndicator(
    top="auto",
    right="auto",
    style=Styles(
        "bottom" => "10px",
        "left" => "10px"
    )
)) do
    DOM.h1("Indicator in bottom-left")
end

# Center-top with custom styling
App(; indicator=ConnectionIndicator(
    right="auto",
    style=Styles(
        "left" => "50%",
        "transform" => "translateX(-50%)",
        "border" => "2px solid white"
    )
)) do
    DOM.h1("Centered indicator")
end
```

### ConnectionIndicator Arguments

| Argument | Default | Description |
|----------|---------|-------------|
| `connected_color` | `"#22c55e"` | Color when connected (green) |
| `connecting_color` | `"#eab308"` | Color when connecting (yellow) |
| `disconnected_color` | `"#ef4444"` | Color when disconnected (red) |
| `no_connection_color` | `"#6b7280"` | Color for NoConnection mode (gray) |
| `size` | `10` | Diameter in pixels |
| `position` | `"fixed"` | CSS position property |
| `top` | `"10px"` | Distance from top |
| `right` | `"10px"` | Distance from right |
| `style` | `Styles()` | Additional CSS styles |

## Creating a Custom Indicator

For complete control over the indicator's appearance and behavior, you can create your own by subtyping `AbstractConnectionIndicator`:

```julia
using Bonito

struct TextIndicator <: AbstractConnectionIndicator
    font_size::Int
end

TextIndicator(; font_size=12) = TextIndicator(font_size)

function Bonito.jsrender(session::Session, indicator::TextIndicator)
    # Create the DOM element
    status_text = DOM.span("Connecting...";
        style=Styles(
            "position" => "fixed",
            "top" => "10px",
            "right" => "10px",
            "font-size" => "$(indicator.font_size)px",
            "font-family" => "monospace",
            "padding" => "4px 8px",
            "background" => "rgba(0,0,0,0.7)",
            "color" => "white",
            "border-radius" => "4px",
            "z-index" => "9999"
        )
    )

    # JavaScript to handle status changes
    init_script = js"""
    function initTextIndicator(element) {
        const messages = {
            connected: "✓ Connected",
            connecting: "◐ Connecting...",
            disconnected: "✗ Disconnected",
            no_connection: "○ Static Mode"
        };

        const colors = {
            connected: "#22c55e",
            connecting: "#eab308",
            disconnected: "#ef4444",
            no_connection: "#6b7280"
        };

        const indicator = {
            onStatusChange: function(status) {
                element.textContent = messages[status] || messages.disconnected;
                element.style.color = colors[status] || colors.disconnected;
            }
        };

        Bonito.register_connection_indicator(indicator);
    }
    """

    Bonito.onload(session, status_text, init_script)
    return Bonito.jsrender(session, status_text)
end

# Use it
App(; indicator=TextIndicator(font_size=14)) do
    DOM.h1("App with text-based indicator")
end
```

### JavaScript API for Custom Indicators

When creating a custom indicator, register it with Bonito using these JavaScript functions:

```javascript
// Register your indicator object
Bonito.register_connection_indicator({
    // Called when connection status changes
    onStatusChange: function(status) {
        // status: "connected" | "connecting" | "disconnected" | "no_connection"
    }
});

// Unregister the current indicator
Bonito.unregister_connection_indicator();

// Status constants (for comparison)
Bonito.ConnectionStatus.CONNECTED      // "connected"
Bonito.ConnectionStatus.CONNECTING     // "connecting"
Bonito.ConnectionStatus.DISCONNECTED   // "disconnected"
Bonito.ConnectionStatus.NO_CONNECTION  // "no_connection"
```

The indicator automatically shows the appropriate status based on the connection state, including "no_connection" for static exports.

# Javascript

## Wrapping Javascript Libraries

```@setup 1
using Bonito
Bonito.Page()
```

```@example 1
leafletjs = Bonito.ES6Module("https://esm.sh/v133/leaflet@1.9.4/es2022/leaflet.mjs")
leafletcss = Bonito.Asset("https://unpkg.com/leaflet@1.9.4/dist/leaflet.css")
struct LeafletMap
    position::NTuple{2,Float64}
    zoom::Int
end

function Bonito.jsrender(session::Session, map::LeafletMap)

    map_div = DOM.div(id="map"; style="height: 500px;")

    return Bonito.jsrender(session, DOM.div(
        leafletcss,
        leafletjs,
        map_div,
        js"""
            $(leafletjs).then(L=> {
                const map = L.map('map').setView($(map.position), $(map.zoom));
                L.tileLayer(
                    'https://tile.openstreetmap.org/{z}/{x}/{y}.png', {
                    maxZoom: 19,
                    attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
                }).addTo(map);
            })

        """
    ))
end


App() do
    return LeafletMap((51.505, -0.09), 13)
end
```

# Assets

Assets in Bonito represent external resources like JavaScript libraries, CSS files, images, and other files. They handle loading, bundling, and serving these resources efficiently across different deployment ways (Server/Plotpane/Notebooks/Static Site/Documenter).

## Basic Usage

Assets can reference local files or remote URLs and are automatically served with the appropriate URLs:

```@setup 1
using Bonito
Page()
```

```@example 1
using Bonito

# Load a local image
dashi_logo = Asset(joinpath(@__DIR__, "dashi.png"))

# Create an app that displays the image
app = App() do
    # Use CSS class selector to style child images of this specific container
    img_styles = Styles(CSS(".asset-container > img", "width" => "400px"))
    DOM.div(
        img_styles,
        DOM.div(
            DOM.h2("Asset Example"),
            DOM.p("Assets render automatically as the appropriate DOM element:"),
            dashi_logo,  # Automatically becomes DOM.img(src=url_to_asset)
            DOM.p("Or use assets as src attributes for more control:"),
            DOM.img(src=dashi_logo; width="400px");  # Asset URL is inserted as src
            class="asset-container"
        )
    )
end
```

## JavaScript Assets

JavaScript assets come in two flavors: ES6 modules and traditional scripts.

### ES6 Modules

```@docs
ES6Module
```

You can also use the convenient CDN helper (uses esm.sh):

```julia
THREE = CDNSource("three"; version="0.137.5")
```

### Traditional Scripts (Non-module)

For traditional JavaScript libraries that expose global variables (like jQuery, ACE editor, etc.):

```julia
# The Asset automatically infers the global name from the filename
ace = Asset("https://cdn.jsdelivr.net/ace-builds/src-min/ace.js")
# name is automatically set to "ace"

# Interpolating returns a Promise that resolves with the global object
js"""
$(ace).then(ace => {
    const editor = ace.edit(element);
})
"""
# Override the global name if needed
custom = Asset("https://example.com/library.js"; name="MyLib")
```

### Binary Assets

Non-JavaScript assets are loaded as raw bytes when interpolated into javascript:

```julia
image = Asset("path/to/image.png")

js"""
$(image).then(bytes => {
    // bytes is a Uint8Array
})
"""
```

Full ES6Module example creating a THREEJS visualization:

```@example 1
# Javascript & CSS dependencies can be declared locally and
# freely interpolated in the DOM / js string, and will make sure it loads
# Note, that they will be a `Promise` though, so to use them you need to call `module.then(module=> ...)`.
const THREE = ES6Module("https://cdn.esm.sh/v66/three@0.136/es2021/three.js")

app = App() do session, request
    width = 500; height = 500
    dom = DOM.div(width = width, height = height)
    Bonito.onload(session, dom, js"""
        function (container){
            $(THREE).then(THREE=> {
                var renderer = new THREE.WebGLRenderer({antialias: true});
                renderer.setSize($width, $height);
                renderer.setClearColor("#ffffff");
                container.appendChild(renderer.domElement);
                var scene = new THREE.Scene();
                var camera = new THREE.PerspectiveCamera(75, $width / $height, 0.1, 1000);
                camera.position.z = 4;
                var ambientLight = new THREE.AmbientLight(0xcccccc, 0.4);
                scene.add(ambientLight);
                var pointLight = new THREE.PointLight(0xffffff, 0.8);
                camera.add(pointLight);
                scene.add(camera);
                var geometry = new THREE.SphereGeometry(1.0, 32, 32);
                var material = new THREE.MeshPhongMaterial({color: 0xffff00});
                var sphere = new THREE.Mesh(geometry, material);
                scene.add(sphere);
                renderer.render(scene, camera);
            })
        }
    """)
    return dom
end
```

# Extending Bonito

## Connection

By default, Bonito uses its own WebSocket server to create the connection between Julia and JavaScript. By extending `Bonito.FrontendConnection`, you can create a new type of connection, e.g. using WebRTC to connect Julia and JavaScript.

Your new connection type should support bidirectional messages of binary data. 

```@setup 1
using Bonito
Bonito.Page()
```

```Julia
mutable struct MyConnection <: Bonito.FrontendConnection
    # TODO: your implementation here
    isopen::Bool
    socket
    blabla
    ...
end

function MyConnection()
    # If you need to do something like start an HTTP server, you can do it here, synchronously.
    
    
    return new(
        true,
        ...
    )
end

function Base.write(connection::MyConnection, binary)
    # TODO: send the data to JavaScript
    write(connection.socket, binary)
end

Base.isopen(connection::MyConnection) = connection.isopen
Base.close(connection::MyConnection) = (connection.isopen = false)
open!(connection::MyConnection) = (connection.isopen = true)

function setup_connection(session::Session{MyConnection})
    # If you need to do something specific for this new session, you can do it here.

    return js"""
    // TODO: create a connection
    create_connection(...).then((conn) => {
        
        // TODO: when your connection receives a message from Julia, relay the message to `Bonito.process_message(msg)`.
        conn.on_msg((msg) => {
            Bonito.process_message(msg)
        });
        
        // TODO: you need to define a JavaScript function that sends a given `binary_data` to Julia. On the Julia side, this should call `Bonito.process_message(connection.parent, binary_data)`.
        const send_to_julia = (binary_data) => conn.send(binary)
        
        // TODO: does your connection use Pako compression on its incoming and outgoing messages?
        const compression_enabled = false
        
        // Register your new connection
        Bonito.on_connection_open(send_to_julia, compression_enabled);
    })
    """
end
```


You can test your new connection like so:

```Julia
Bonito.register_connection!(MyConnection) do
    # you can make this registration conditional, e.g. only use the new connection type on Thursdays...
    if i_want_to_use_it
        return MyConnection()
    else
        return nothing
    end
end
```

## Managing your own WebSocket server

You should also extend `Bonito.FrontendConnection` in case you would like to make a WebSocket-based connection, but manage the server yourself, e.g. by registering a websocket route using a web framework. In this case, you can reuse some of Bonito's websocket handling code as long as your websocket is internally using `HTTP.WebSockets.WebSocket` objects.

You can do this using the `WebSocketHandler` type and forwarding your connection type's `isopen`, `write`, and `close` methods to it. You can then use the `setup_websocket_connection_js` to return the correct Javascript snippet in your `setup_connection` method and run the main I/O loop by calling `run_connection_loop` from your websocket handler. You will need to take care of saving the session in your `setup_connection` method and routing to the session in your handler, as well as cleaning up websocket sessions. You may need to use locks to accomplish some of these steps in a thread-safe manner.


```Julia
mutable struct MyWebSocketConnection <: Bonito.FrontendConnection
    # TODO: your implementation here
    blabla
    ...
    handler::WebSocketHandler
end

Base.isopen(ws::MyWebSocketConnection) = isopen(ws.handler)
Base.write(ws::MyWebSocketConnection, binary) = write(ws.handler, binary)
Base.close(ws::MyWebSocketConnection) = close(ws.handler)

function setup_connection(session::Session{MyWebSocketConnection})
    return setup_connection(session, session.connection)

    # TODO: Register the `session.id` as a route, and save it so it can be retrived in the handler
    # You could alternatively register a single route and multiplex using a dictionary
    # TODO: Start a cleanup task to remove routes/saved sessions when they are no longer open

    external_url = # TODO: Get the external URL, which session IDs will be appended to
    return setup_websocket_connection_js(external_url, session)
end

function my_web_framework_websocket_handler(my_web_framework_request)
    session = # TODO: retrieve the session based upon the session ID in the URL in `my_web_framework_request`
    websocket = # TODO: set up the websocket or retrive it from `my_web_framework_request`
    connection = session.connection

    try
        run_connection_loop(session, connection.handler, websocket)
    finally
        # TODO: Option 1: Immediately end the session with `close(session)`
        # You will also need to clean up the route/saved session
        
        # TODO: Option 2: Use `soft_close(session)`
        # This may allow for a temporary disconnected client to reconnect
        # You may have to prevent your webframework from trying to close the websocket
        # You will need to clean up the soft closed session and its route/saved session after some timeout in the cleanup task
    end
end

# Here is the cleanup task. You might choose to arrange for exactly one of these to be started at some appropriate time.
# You may like to handle errors so that it always remains running.
@async while true
    sleep(1)
    # Iterate through the sessions and routes that have been set up in `setup_connection`
    for (session, route) in my_route_data_structure
        # Apply some cleanup policy to closed or soft closed sessions
        if should_cleanup(session)
            # mark route for removeal
        end
    end
    # remove marked routes
end
```

You can get further details to guide your implementation by looking at Bonito's own implementation in `Bonito/src/connections/websocket.jl`.

Please read the next section for information about how to make use of Bonito's websocket cleanup policy in your cleanup task.

## Customising the websocket cleanup policy

You can create a custom cleanup policy by subclassing `CleanupPolicy`. For example, you may like to choose to evict sessions based upon the resources they are using, or whether users are authenticated or not or some other criteria.

Implementing the `should_cleanup` and `allow_soft_close` methods is required.

```julia
struct MyCleanupPolicy <: Bonito.CleanupPolicy end

function Bonito.should_cleanup(policy::MyCleanupPolicy, session::Session)
    ...
end

function Bonito.allow_soft_close(policy::MyCleanupPolicy)
    ...
end

Bonito.set_cleanup_policy!(MyCleanupPolicy())
```

You can also make use of cleanup policies including `DefaultCleanupPolicy()` if you manage your own websocket server as outlined in the previous section.

You can get further details to guide your implementation by looking at Bonito's own implementation in `Bonito/src/connections/websocket.jl`.

`Bonito.jl` is a pretty simple package allowing you to render HTML and serve it from within Julia and build up a communication bridge with the Browser. This allows to combine any of your Julia applications with libraries like [WGLMakie](https://docs.makie.org/dev/documentation/backends/wglmakie/index.html#export) and create interactive Dashboards like this:

![dashboard](https://user-images.githubusercontent.com/1010467/214651671-2f8174b6-48ab-4627-b15f-e19c35042faf.gif)

Bonito is tightly integrated with WGLMakie, which makes them a great pair for high performance, interactive visualizations.
If performance is not a high priority, many other plotting/visualization libraries which overload the Julia display system should work with `Bonito.jl` as well.

`Bonito.jl` itself tries to stay out of major choices like the HTML/CSS/Javascript framework to use for creating UIs and Dashboards. Instead, it allows to create modular components and makes it easy to use any CSS/Javascript library.

It uses plain HTML widgets for UI elements where it can, and there are a few styleable components like `Card`, `Grid`, `Row`, `Col` to make it easy to create some more complex dashboards out of the box.

If you look at the source of those components, one will see that they're very simple and easy to create, which should help to create a rich ecosystem of extensions around `Bonito.jl`.
Read more about it in [Components](@ref).

## Quickstart

```@setup 1
using Bonito
Bonito.Page()
```

At the core of Bonito you have `DOM` to create any HTML tag, `js"..."` to run Javascript, and `App` to wrap your creation and serve it anywhere:

```@example 1
using Bonito
app = App() do
    return DOM.div(DOM.h1("hello world"), js"""console.log('hello world')""")
end
```

App has three main signatures:
```julia
# The main signatures, all other signatures will end up calling:
App((session, request) -> DOM.div(...))
# Convenience constructors:
App((session::Session) -> DOM.div(...))
App((request::HTTP.Request) -> DOM.div(...))
App(() -> DOM.div(...))
App(DOM.div(...))
```

See [App](@ref) for all App options, including how to add a connection status indicator.

The app will be displayed by e.g. the VSCode plot pane, Jupyter/Pluto or any other framework that overloads the Julia display system for HTML display.
In the REPL or an environment without an HTML ready display, a browser should open to display it (enabled explicitly via `Bonito.browser_display()`), but one can also serve the App very easily:

```julia
server = Server(app, "0.0.0.0", 8080)
# This is the same as:
server = Server("0.0.0.0", 8080)
route!(server, "/" => app)
# So you can add many apps to one server, and even regexes are supported:
route!(server, r".*" => App(DOM.div("404, no content for this route")))
route!(server, "/some-app" => App(DOM.div("app")))
```

## Easy integration with existing JS + CSS libraries

It's quite easy to integrate existing Libraries into your Bonito App:

```@example 1
App() do
    js = ES6Module("https://esm.sh/v133/leaflet@1.9.4/es2022/leaflet.mjs")
    css = Asset("https://unpkg.com/leaflet@1.9.4/dist/leaflet.css")
    map_div = DOM.div(id="map"; style="height: 300px; width: 100%")
    return DOM.div(
        css, map_div,
        js"""
        $(js).then(L=> {
            const map = L.map('map').setView([51.505, -0.09], 13);
            L.tileLayer('https://tile.openstreetmap.org/{z}/{x}/{y}.png').addTo(map);
        })
        """
    )
end
```

Read more about wrapping libraries in [Javascript](@ref).

## Deploying

`Bonito.jl` wants to run everywhere, from Notebooks, IDEs, Electron, to being directly inserted into existing web pages.

![Bonito-wales](https://user-images.githubusercontent.com/1010467/214662497-a1a1c8e7-5f4d-4e57-b129-fdcc227253ca.gif)

Find out more about the different ways to serve your apps in [Deployment](@ref).

# Styling

## Basics

```@setup 1
using Bonito
Page()
```

The main type to style the DOM via css is `Style`:


```@docs; canonical=false
Styles
```

## Using CSS and pseudo classes

The `CSS` object allows to specify a selector, which will be used to apply the styling to a specific DOM node.
Since the main usage is to apply the `Style` object to a `DOM` node, the selector is usually empty and we use it mainly for pseudo classes like `:hover`:

```@example 1
App() do session
    return DOM.div(
        "This turns red on hover",
        style=Styles(
            CSS(":hover", "color" => "red", "text-size" => "2rem")
        )
    )
end
```

A more involved example is the style we use for `Button`:

```@example 1
App() do
    style = Styles(
        CSS(
            "font-weight" => 600,
            "border-width" => "1px",
            "border-color" => "#9CA3AF",
            "border-radius" => "0.25rem",
            "padding-left" => "0.75rem",
            "padding-right" => "0.75rem",
            "padding-top" => "0.25rem",
            "padding-bottom" => "0.25rem",
            "margin" => "0.25rem",
            "cursor" => "pointer",
            "min-width" => "8rem",
            "font-size" => "1rem",
            "background-color" => "white",
            "box-shadow" => "rgba(0, 0, 0, 0) 0px 0px 0px 0px, rgba(0, 0, 0, 0) 0px 0px 0px 0px, rgba(0, 0, 0, 0.1) 0px 1px 3px 0px, rgba(0, 0, 0, 0.1) 0px 1px 2px -1px";
        ),
        CSS(
            ":hover",
            "background-color" => "#F9FAFB",
            "box-shadow" => "rgba(0, 0, 0, 0) 0px 0px 0px 0px",
        ),
        CSS(
            ":focus",
            "outline" => "1px solid transparent",
            "outline-offset" => "1px",
            "box-shadow" => "rgba(66, 153, 225, 0.5) 0px 0px 0px 1px",
        ),
    )
    return DOM.div("Hello", style=style)
end
```
If we merged a complex `Style` like the above with a user given `Styles` object, it will merge all CSS objects with the same selector, allowing to easily overwrite all styling attributes.

This is how one can style a Button:

```@example 1
App() do
    style = Styles(
        CSS("font-weight" => "500"),
        CSS(":hover", "background-color" => "silver"),
        CSS(":focus", "box-shadow" => "rgba(0, 0, 0, 0.5) 0px 0px 5px"),
    )
    button = Button("Click me"; style=style)
    return button
end
```


## Using Styles as global Stylesheet

One can also define a global stylesheet with `Styles` using selectors to style parts of an HTML document.
This can be handy to set some global styling, but please be careful, since this will affect the whole document. That's also why we need to set a specific attribute selector for all, to not affect the whole documentation page.
This will not happen when assigning a style to `DOM.div(style=Styles(...))`, which will always just apply to that particular div and any other div assigned to.
Note, that a style object directly inserted into the DOM will be rendered exactly where it occurs without deduplication!

```@example 1
App() do
    style = Styles(
        CSS("*[our-style]", "font-style" => "italic"),
        CSS("p[our-style]", "color" => "red"),
        CSS(".myClass[our-style]", "text-decoration" => "underline"),
        CSS("#myId[our-style]", "font-family" => "monospace"),
        CSS("p.myClass#myId[our-style]", "font-size" => "1.5rem")
    )
    return DOM.div(
        style,
        DOM.div(ourStyle=1,
            DOM.p(class="myClass", id="myId", "I match everything.", ourStyle=1),
            DOM.p("I match the universal and type selectors only.", ourStyle=1)
        )
    )
end
```

# Handlers

Handlers are the building blocks for serving content in Bonito. Any type that implements the `apply_handler` interface can be used with `route!` to respond to HTTP requests. This makes Bonito's routing system highly extensible - you can wrap existing handlers to add functionality like authentication, rate limiting, or logging.

## Understanding Handlers

A handler is any type that implements the `apply_handler` method:

```julia
function Bonito.HTTPServer.apply_handler(handler::YourHandlerType, context)
    request = context.request
    # ... process the request and return HTTP.Response
    return HTTP.Response(200, "Hello World")
end
```

The `context` parameter provides access to:
- `context.request` - The HTTP request object
- `context.application` - The server instance
- `context.routes` - The routes table
- `context.match` - The pattern match result (string or regex match)

Bonito's built-in `App` type is itself a handler, which is why you can use `route!(server, "/" => app)` directly.

## Creating Custom Handlers

Here's a simple example of a custom handler that logs requests:

```@example 1
using Bonito, Dates

struct LoggingHandler{T}
    handler::T
    log_file::String
end

function Bonito.HTTPServer.apply_handler(logger::LoggingHandler, context)
    request = context.request
    # Log the request
    open(logger.log_file, "a") do io
        println(io, "$(now()): $(request.method) $(request.target)")
    end
    # Delegate to wrapped handler
    return Bonito.HTTPServer.apply_handler(logger.handler, context)
end

# Usage
app = App(DOM.div("Hello World"))
logged_app = LoggingHandler(app, "requests.log")
# route!(server, "/" => logged_app)
```

This pattern of wrapping handlers is similar to middleware in other web frameworks. You can chain multiple wrappers together:

```julia
protected_logged_app = ProtectedRoute(logged_app, password_store)
```

## Built-in Handlers

Bonito provides several ready-to-use handlers:

### FolderServer

```@docs; canonical=false
FolderServer
```

### ProtectedRoute


```@docs; canonical=false
ProtectedRoute
```

## Password Storage

```@docs; canonical=false
AbstractPasswordStore
```

### SingleUser

```@docs; canonical=false
SingleUser
```

### Custom Password Stores

To implement a custom password store, subtype `AbstractPasswordStore` and implement `get_user`:

```julia
using Bonito
using Bonito: User, AbstractPasswordStore

# Example: Database-backed password store
struct DatabasePasswordStore <: AbstractPasswordStore
    db_connection::DatabaseConnection
end

function Bonito.get_user(store::DatabasePasswordStore, username::String)
    # Query database for user
    result = query(store.db_connection,
                   "SELECT * FROM users WHERE username = ?", username)

    if isempty(result)
        return nothing
    end

    # Reconstruct User from database fields
    row = result[1]
    return User(
        row.username,
        row.password_hash,  # Already hashed in database
        row.salt,
        row.iterations,
        Dict("role" => row.role)  # Optional metadata
    )
end

# The authenticate() method is automatically provided
```

**Interface Requirements:**
- Implement `get_user(store, username)` which returns a `User` or `nothing`
- The `authenticate(store, username, password)` method is automatically implemented
- Only override `authenticate()` if you need custom authentication logic

**Creating Users Manually:**

```@docs; canonical=false
User
```

## Combining Handlers

Handlers can be composed to create complex behaviors:

```julia
# Multiple layers of protection
admin_app = App(DOM.h1("Super Secret Admin"))
logged_app = LoggingHandler(admin_app, "admin.log")
protected_app = ProtectedRoute(logged_app, admin_store)

# Different protection for different routes
public_files = FolderServer("public")
protected_files = ProtectedRoute(FolderServer("private"), file_store)

server = Bonito.Server("0.0.0.0", 8080)
# Use regex route to forward all file requests to FolderServer
route!(server, r"/public/.*" => public_files)
route!(server, "/private/.*" => protected_files)
route!(server, "/admin" => protected_app)
```


## Advanced: Handler Context

The `context` object passed to handlers is a NamedTuple with the following fields:

```julia
context = (
    request = HTTP.Request,      # The HTTP request
    application = Server,         # The server instance
    routes = Routes,              # The routes table
    match = Union{String, RegexMatch}  # The pattern match result
)
```

You can access request details like:

```julia
function Bonito.HTTPServer.apply_handler(handler::MyHandler, context)
    request = context.request

    # Request method (GET, POST, etc.)
    method = request.method

    # Request path
    path = request.target

    # Headers
    user_agent = HTTP.header(request, "User-Agent", "")

    # Query parameters
    uri = URIs.URI(request.target)
    query = URIs.queryparams(uri.query)

    # Access server info
    server = context.application
    server_url = online_url(server, "/")

    # Access regex capture groups if using regex pattern
    if context.match isa RegexMatch
        captured = context.match.captures
    end

    # ...
end
```

# Components

Components in Bonito are meant to be re-usable, easily shareable types and functions to create complex Bonito Apps.
We invite everyone to share their Components by turning them into a Julia library.

There are two ways of defining components in Bonito:

1. Write a function which returns `DOM` objects
2. Overload `jsrender` for a type

The first is a very lightweight form of defining reusable components, which should be preferred if possible.

But, for e.g. widgets the second form is unavoidable, since you will want to return a type that the user can register interactions with.
Also, the second form is great for integrating existing types into Bonito like plot objects.
How to do the latter for Plotly is described in [Plotting](@ref).

Let's start with the simple function based components that reuses existing Bonito components:

```@setup 1
using Bonito
Bonito.Page()
```

```@example 1
using Dates
function CurrentMonth(date=now(); style=Styles(), div_attributes...)
    current_day = Dates.day(date)
    month = Dates.monthname(date)
    ndays = Dates.daysinmonth(date)
    current_day_style = Styles(style, "background-color" => "gray", "color" => "white")
    days = map(1:ndays) do day
        if day == current_day
            return Card(Centered(day); style=current_day_style)
        else
            return Card(Centered(day); style=style)
        end
    end
    grid = Grid(days...; columns="repeat(7, 1fr)")
    return DOM.div(DOM.h2(month), grid; style=Styles("width" => "400px", "margin" => "5px"))
end


App(()-> CurrentMonth())
```

Now, we could define the same kind of rendering via overloading `jsrender`, if a date is spliced into a DOM:

```@example 1
function Bonito.jsrender(session::Session, date::DateTime)
    return Bonito.jsrender(session, CurrentMonth(date))
end
App() do
    DOM.div(now())
end
```

Please note, that `jsrender` is not applied recursively on its own, so one needs to apply it manually on the return value.
It's not needed for simple divs and other Hyperscript elements, but e.g. `Styles` requires a pass through `jsrender` to do the deduplication etc.
